create table dbo.auth_users(
  login_id varchar(64) not null,
  name varchar(100) not null,
  password varchar(100) not null,
  description varchar(500),
  constraint pk_auth_users primary key(login_id)
)
go

create table dbo.acl_roles(
  id int not null,
  name varchar(100) not null,
  parent_id int,
  left_side int,
  right_side int,
  description varchar(500),
  constraint pk_acl_roles primary key(id)
)
go

create table dbo.auth_users_roles(
  id int not null,
  login_id varchar(64) not null,
  acl_roles_id int,
  description varchar(500),
  constraint pk_auth_usesr_roles primary key(id)
)
go


CREATE TABLE [acl_resources] (
	[id] [int] NOT NULL ,
	[parent_id] [int] NULL ,
	[name] [varchar] (255) COLLATE Japanese_CI_AS NULL ,
	[left_side] [int] NULL ,
	[right_side] [int] NULL ,
	[description] [varchar] (255) COLLATE Japanese_CI_AS NULL ,
	CONSTRAINT [pk_acl_resources] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
) ON [PRIMARY]
GO




CREATE TABLE [acl_rules] (
	[id] [int] NOT NULL ,
	[resource_id] [int] NULL ,
	[role_id] [int] NULL ,
	[_create] [int] NULL ,
	[_read] [int] NULL ,
	[_update] [int] NULL ,
	[_delete] [int] NULL ,
	[description] [varchar] (255) COLLATE Japanese_CI_AS NULL ,
	CONSTRAINT [pk_acl_rules] PRIMARY KEY  CLUSTERED 
	(
		[id]
	)  ON [PRIMARY] 
) ON [PRIMARY]
GO



-- Tvf[^
-- users
insert into dbo.auth_users(login_id,name,password) values('admin','administrator','21232f297a57a5a743894a0e4a801fc3') -- pass md5(admin)
insert into dbo.auth_users(login_id,name,password) values('m-okada','michiaki okada','80ecbfc4f9ac535b12ec865735184993') -- pass md5(okada)
insert into dbo.auth_users(login_id,name,password) values('t-takahashi','touru takahashi','999765c5f20dfb9b43c5071d32710908') -- pass md5(takahashi)
insert into dbo.auth_users(login_id,name,password) values('m-itou','mitsunori itou','bb01effa2be3a33a6fd2e2cb90b62b23') -- pass md5(itou)
insert into dbo.auth_users(login_id,name,password) values('k-kim','keumil kim','fb1eaf2bd9f2a7013602be235c305e7a') -- pass md5(kim)

go

-- roles
insert into dbo.acl_roles (id,name,parent_id,left_side,right_side) values (1, 'anonymous', null,   1,   2)
insert into dbo.acl_roles (id,name,parent_id,left_side,right_side) values (2, 'admin',     null,   3,   4)
insert into dbo.acl_roles (id,name,parent_id,left_side,right_side) values (3, 'member',    null,   5,   20)
insert into dbo.acl_roles (id,name,parent_id,left_side,right_side) values (4, 'common',       3,   6,   7)

insert into dbo.acl_roles (id,name,parent_id,left_side,right_side) values (5, 'first developement div',  3,   8,   15)
insert into dbo.acl_roles (id,name,parent_id,left_side,right_side) values (6, 'logistics',  5,   9,   10)
insert into dbo.acl_roles (id,name,parent_id,left_side,right_side) values (7, 'education',  5,   11,   12)
insert into dbo.acl_roles (id,name,parent_id,left_side,right_side) values (8, 'finance',  5,   13,   14)

insert into dbo.acl_roles (id,name,parent_id,left_side,right_side) values (9, 'second developement div',  3,   16,   19)
insert into dbo.acl_roles (id,name,parent_id,left_side,right_side) values (10, 'travel',  8,   17,   18)


-- users - roles
insert into dbo.auth_users_roles(id,login_id,acl_roles_id) values(1,'admin',2)
insert into dbo.auth_users_roles(id,login_id,acl_roles_id) values(2,'m-okada',4)
insert into dbo.auth_users_roles(id,login_id,acl_roles_id) values(3,'m-okada',6)
insert into dbo.auth_users_roles(id,login_id,acl_roles_id) values(4,'t-takahashi',4)
insert into dbo.auth_users_roles(id,login_id,acl_roles_id) values(5,'t-takahashi',10)
insert into dbo.auth_users_roles(id,login_id,acl_roles_id) values(6,'m-itou',5)
insert into dbo.auth_users_roles(id,login_id,acl_roles_id) values(7,'k-kim',6)


-- resources
INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(1, null, 'cfw', 1, 2, 'ʊJ')

INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(2, null, 'travelsys', 3, 8, 's')

INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(3, 2, 'ATACS', 4, 5, 'ATACS')

INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(4, 2, 'SKYLINK', 6, 7, 'SKYLINK')

INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(5, null, 'logistics', 9, 12, 'VXe')

INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(6, 5, 'hazama', 10, 11, '͂܃VXe')

INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(7, null, 'ad', 13, 18, 'L')

INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(8, 7, 'DAC', 14, 15, 'DAC')

INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(9, 7, 'TINKLE', 16, 17, 'Ă񂭂')

INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(10, null, 'education', 19, 22, 'VXe')

INSERT INTO [okada].[dbo].[acl_resources]([id], [parent_id], [name], [left_side], [right_side], [description])
VALUES(11, 10, 'kyoumukun', 20, 21, '񂽂񋳖N')

--rules
INSERT INTO [okada].[dbo].[acl_rules]([id], [resource_id], [role_id], [_create], [_read], [_update], [_delete], [description])
VALUES(1, 1, 4, 1, 1, 1, 1, 'ʊJ - ʃo[ɃtANZX')

INSERT INTO [okada].[dbo].[acl_rules]([id], [resource_id], [role_id], [_create], [_read], [_update], [_delete], [description])
VALUES(2, 1,3, 0, 1, 0, 0, 'ʊJ - ʃo[ȊO͓ǂݎ̂')

INSERT INTO [okada].[dbo].[acl_rules]([id], [resource_id], [role_id], [_create], [_read], [_update], [_delete], [description])
VALUES(3, 2, 4, 0, 1, 0, 0, 's - ʃo[͓ǂݎ\')

INSERT INTO [okada].[dbo].[acl_rules]([id], [resource_id], [role_id], [_create], [_read], [_update], [_delete], [description])
VALUES(4, 10, 7, 1, 1, 1, 1, 'VXe - `[̓tANZX')

INSERT INTO [okada].[dbo].[acl_rules]([id], [resource_id], [role_id], [_create], [_read], [_update], [_delete], [description])
VALUES(5, 8, 6, 1, 1, 1, 1, 'DAC - `[̓tANZX')

INSERT INTO [okada].[dbo].[acl_rules]([id], [resource_id], [role_id], [_create], [_read], [_update], [_delete], [description])
VALUES(6, 8, 4, 0, 1, 1, 0, 'DAC - ʃ`[͓ǂݎAXV\A쐬͕s')

--role tree
-- rolez̑Srole
SELECT node.name
FROM acl_roles AS node,
acl_roles AS parent
WHERE node.left_side BETWEEN parent.left_side AND parent.right_side
AND parent.name  = 'member'
order by node.id

-- role̐e
SELECT parent.name
FROM acl_roles AS node,
acl_roles AS parent
WHERE node.left_side BETWEEN parent.left_side AND parent.right_side
AND node.name  = 'logistics'
order by node.id



