using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using OFW.Util;
using OFW.FieldProperties;
using OFW.Database;

namespace OFW.Acl.Models 
{
    /// <summary>
    /// AclResources f`
    /// </summary>
    [Serializable()]
	public class AclResourcesModel : TreeDataAccess<AclResourcesEntity,AclResourcesProperty>
	{
        /// <summary>
        /// default construct  
        /// </summary>
        public AclResourcesModel() : base()
        {
        }
        /// <summary>
        /// ̐ڑgp\z
        /// </summary>
        /// <param name="connection">̐ڑBJĂO</param>
        public AclResourcesModel(Connection connection) : base(connection)
        {
        }
        /// <summary>
        /// idZbg
        /// </summary>
        /// <param name="node"></param>
        protected override void setupId(ref AclResourcesEntity node)
        {
            string query = @"
if exists( select * from [{0}]  where name = @name ) begin
    select id from [{0}] where name = @name
end
else begin
    select isnull(max(id),0) + 1 from [{0}]
end
";
            Command command = new Command(string.Format(query,this.property.EntityName));
            command.SetParameter(new Parameter("@name", node.name));
            int newId = NumberUtil.Value<int>(connection.ExecuteScalar(command));
            node.id = newId;
            node.deleted = 0;
        }
       
	}

}