using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using OFW.Util;
using OFW.FieldProperties;
using OFW.Database;

namespace OFW.Acl.Models.Base
{
    /// <summary>
    /// table acl_resourcesɑΉtB[hvpeB
    /// </summary>
    [Serializable()]
    public class AclResourcesTableProperty : OFW.Models.EntityProperty
    {
		///<summary>[id]</summary>
		public FieldProperty id;
		///<summary>[name]</summary>
		public FieldProperty name;
		///<summary>[left_side]</summary>
		public FieldProperty leftSide;
		///<summary>[right_side]</summary>
		public FieldProperty rightSide;
		///<summary>[description]</summary>
		public FieldProperty description;
		///<summary>[deleted]</summary>
		public FieldProperty deleted;
		///<summary>[created_at]</summary>
		public FieldProperty createdAt;
		///<summary>[modified_at]</summary>
		public FieldProperty modifiedAt;
		

	    /// <summary>
	    /// default construct
	    /// </summary>
        public AclResourcesTableProperty()
        {
        	this.EntityName = "acl_resources";
        	this.ModifiedAtField = "UPDATE_DATE";
        	this.CreatedAtField = "CREATE_DATE";
        	
			id = FieldProperty.NewInstance("int", "acl_resources", "id","[id]", 4, 10, 0, false, 0,true);
			name = FieldProperty.NewInstance("varchar", "acl_resources", "name","[name]", 255, 255, 0, true, "",false);
			leftSide = FieldProperty.NewInstance("int", "acl_resources", "left_side","[left_side]", 4, 10, 0, true, null,false);
			rightSide = FieldProperty.NewInstance("int", "acl_resources", "right_side","[right_side]", 4, 10, 0, true, null,false);
			description = FieldProperty.NewInstance("varchar", "acl_resources", "description","[description]", 255, 255, 0, true, "",false);
			deleted = FieldProperty.NewInstance("int", "acl_resources", "deleted","[deleted]", 4, 10, 0, false, 0,false);
			createdAt = FieldProperty.NewInstance("datetime", "acl_resources", "created_at","[created_at]", 16, 23, 3, true, null,false);
			modifiedAt = FieldProperty.NewInstance("datetime", "acl_resources", "modified_at","[modified_at]", 16, 23, 3, true, null,false);
			
        }

        /// <summary>
        /// Ce[^\gĊOCe[^B
        /// </summary>
        /// <returns>Ce[^</returns>
        public override IEnumerable<FieldProperty> Fields()
        {
			yield return this.id;
			yield return this.name;
			yield return this.leftSide;
			yield return this.rightSide;
			yield return this.description;
			yield return this.deleted;
			yield return this.createdAt;
			yield return this.modifiedAt;
			
        }
        /// <summary>
        /// Ce[^\gĊOCe[^B
        /// </summary>
        /// <returns>Ce[^</returns>
        public override IEnumerable<FieldProperty> PrimaryKeys()
        {
            yield return  this.id;
            
        }
    }
}