using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using OFW.Util;
using OFW.FieldProperties;
using OFW.Database;

namespace OFW.Acl.Models.Base
{
    /// <summary>
    /// table acl_rulesɑΉtB[hvpeB
    /// </summary>
    [Serializable()]
    public class AclRulesTableProperty : OFW.Models.EntityProperty
    {
		///<summary>[id]</summary>
		public FieldProperty id;
		///<summary>[resource_id]</summary>
		public FieldProperty resourceId;
		///<summary>[role_id]</summary>
		public FieldProperty roleId;
		///<summary>[allow_create]</summary>
		public FieldProperty allowCreate;
		///<summary>[allow_read]</summary>
		public FieldProperty allowRead;
		///<summary>[allow_update]</summary>
		public FieldProperty allowUpdate;
		///<summary>[allow_delete]</summary>
		public FieldProperty allowDelete;
		///<summary>[description]</summary>
		public FieldProperty description;
		///<summary>[deleted]</summary>
		public FieldProperty deleted;
		///<summary>[created_at]</summary>
		public FieldProperty createdAt;
		///<summary>[modified_at]</summary>
		public FieldProperty modifiedAt;
		

	    /// <summary>
	    /// default construct
	    /// </summary>
        public AclRulesTableProperty()
        {
        	this.EntityName = "acl_rules";
        	this.ModifiedAtField = "UPDATE_DATE";
        	this.CreatedAtField = "CREATE_DATE";
        	
			id = FieldProperty.NewInstance("int", "acl_rules", "id","[id]", 4, 10, 0, false, 0,true);
			resourceId = FieldProperty.NewInstance("int", "acl_rules", "resource_id","[resource_id]", 4, 10, 0, false, 0,false);
			roleId = FieldProperty.NewInstance("int", "acl_rules", "role_id","[role_id]", 4, 10, 0, false, 0,false);
			allowCreate = FieldProperty.NewInstance("int", "acl_rules", "allow_create","[allow_create]", 4, 10, 0, false, 0,false);
			allowRead = FieldProperty.NewInstance("int", "acl_rules", "allow_read","[allow_read]", 4, 10, 0, false, 0,false);
			allowUpdate = FieldProperty.NewInstance("int", "acl_rules", "allow_update","[allow_update]", 4, 10, 0, false, 0,false);
			allowDelete = FieldProperty.NewInstance("int", "acl_rules", "allow_delete","[allow_delete]", 4, 10, 0, false, 0,false);
			description = FieldProperty.NewInstance("varchar", "acl_rules", "description","[description]", 255, 255, 0, true, "",false);
			deleted = FieldProperty.NewInstance("int", "acl_rules", "deleted","[deleted]", 4, 10, 0, false, 0,false);
			createdAt = FieldProperty.NewInstance("datetime", "acl_rules", "created_at","[created_at]", 16, 23, 3, true, null,false);
			modifiedAt = FieldProperty.NewInstance("datetime", "acl_rules", "modified_at","[modified_at]", 16, 23, 3, true, null,false);
			
        }

        /// <summary>
        /// Ce[^\gĊOCe[^B
        /// </summary>
        /// <returns>Ce[^</returns>
        public override IEnumerable<FieldProperty> Fields()
        {
			yield return this.id;
			yield return this.resourceId;
			yield return this.roleId;
			yield return this.allowCreate;
			yield return this.allowRead;
			yield return this.allowUpdate;
			yield return this.allowDelete;
			yield return this.description;
			yield return this.deleted;
			yield return this.createdAt;
			yield return this.modifiedAt;
			
        }
        /// <summary>
        /// Ce[^\gĊOCe[^B
        /// </summary>
        /// <returns>Ce[^</returns>
        public override IEnumerable<FieldProperty> PrimaryKeys()
        {
            yield return  this.id;
            
        }
    }
}