using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Data;

using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using OFW.Util;
using OFW.FieldProperties;
using OFW.MessageResources;
using OFW.Web;
using OFW.Web.Controls;
namespace OFW.AspxCommon
{
    /// <summary>
    /// [U[C^[tF[XwvNX
    /// </summary>
    public class UIHelper
    {
        /// <summary>
        /// RXgN^
        /// </summary>
        /// <remarks>CX^X͐łȂ</remarks>
        private UIHelper()
        {
        }

        /// <summary>
        /// y[W\tH[}bgĕԂ
        /// </summary>
        /// <remarks>"1 / 10 y[W"Ȃ </remarks>
        /// <param name="aTotal"></param>
        /// <param name="aOffset">Jnʒu</param>
        /// <param name="aLimit">y[W̌</param>
        /// <returns>tH[}bgςݕ</returns>
        /// <example>
        /// <code>
        /// //ʑs100AJnʒu1A1y[W20s\̏ꍇ
        /// PageNumberLabel.Text = UIHelper.GetPageNumberDisplay(100,1,20);
        /// </code>
        /// </example>
        public static string GetPageNumberDisplay(int aTotal, int aOffset, int aLimit)
        {
            string strRet = "";

            try
            {
                // [aTotal] [aOffset] - [(aOffset + aLimit - 1)]
                int totalPages = ((aTotal - 1) / aLimit) + 1;
                int currentPage = (aOffset / aLimit) + 1;
                strRet = currentPage.ToString() + "&nbsp;/&nbsp;" + totalPages.ToString() + "y[W";
            }
            catch
            {
                strRet = "";
            }
            finally
            {
            }
            
            return (strRet);
        }

        /// <summary>
        /// \tH[}bgĕԂ
        /// </summary>
        /// <remarks>[aTotal] [aOffset] - [(aOffset + aLimit - 1)]Ȃ</remarks>
        /// <param name="aTotal"></param>
        /// <param name="aOffset">Jnʒu</param>
        /// <param name="aLimit">y[W̌</param>
        /// <returns>tH[}bgςݕ</returns>
        /// <example>
        /// <code>
        /// //ʑs100AJnʒu1A1y[W20s\̏ꍇ
        /// ListCountLabel.Text = UIHelper.GetListCountDisplay(100,1,20);
        /// </code>
        /// </example>
        public static string GetListCountDisplay(int aTotal, int aOffset, int aLimit)
        {
            string strRet = "";

            try
            {
                // [aTotal] [aOffset] - [(aOffset + aLimit - 1)]
                int max = aLimit;
                if ((aOffset + max - 1) > aTotal)
                {
                    max = aTotal - aOffset + 1;
                }
                int lastNum = aOffset + max - 1;
                int offset = (aTotal == 0) ? 0 : aOffset;
                strRet ="S" + aTotal.ToString() + " " + offset.ToString() + " - " + lastNum.ToString() + "\Ă܂";
            }
            catch
            {
                strRet = "";
            }
            finally
            {
            }

            return (strRet);
        }
        /// <summary>
        /// y[W̌߂
        /// </summary>
        /// <remarks>"20"̕\̂ƂAc10Ȃ"10"ƕ\邽</remarks>
        /// <param name="aTotal"></param>
        /// <param name="aOffset">Jnʒu</param>
        /// <param name="aLimit">y[W̌</param>
        /// <returns>݈ʒuiōv𒴂Ȃől</returns>
        /// <example>
        /// <code>
        /// //ʑs100AJnʒu1A1y[W20s\̏ꍇ
        /// NextPageLink.Text = UIHelper.GetNextPageCount(100,1,20);
        /// </code>
        /// </example>
        public static int GetNextPageCount(int aTotal, int aOffset, int aLimit)
        {
            try
            {
                int nextOffset = aOffset + aLimit;
                int nextNextOffset = nextOffset + aLimit;
                int max = aLimit;
                if (nextNextOffset > aTotal)
                {
                    max = aTotal - nextOffset + 1;
                }
                return max;
            }
            catch
            {
            }
            finally
            {
            }

            return 0;
        }
        /// <summary>
        /// Oł̌߂
        /// </summary>
        /// <remarks>"O20"̕\̂ƂAc10Ȃ"O10"ƕ\邽</remarks>
        /// <param name="aTotal"></param>
        /// <param name="aOffset">Jnʒu</param>
        /// <param name="aLimit">y[W̌</param>
        /// <returns>݈ʒui0ȉɂȂȂŏl</returns>
        /// <example>
        /// <code>
        /// //ʑs100AJnʒu1A1y[W20s\̏ꍇ
        /// PrevPageLink.Text = UIHelper.GetNPrevPageCount(100,1,20);
        /// </code>
        /// </example>
        public static int GetPrevPageCount(int aTotal, int aOffset, int aLimit)
        {
            try
            {
                int lastNum = aOffset - aLimit;
                int max = aLimit;
                if (lastNum < 1)
                {
                    max = aOffset - 1;
                }
                return max;
            }
            catch
            {
            }
            finally
            {
            }

            return 0;
        }

        /// <summary>
        /// ő包AK{ڂȂǂToolTipgݗĂ
        /// </summary>
        /// <remarks>ʃTuVXê߂̃I[o[[h</remarks>
        /// <param name="aProperty">ڂ̑i[FieldProperty</param>
        /// <returns>͍ڂɕ\ToolTipԂ</returns>
        /// <example>
        /// <code>
        /// OfficialName.ToolTip = UIHelper.TipText(mMastClient.Properties.OfficialName, "ag", "ja");
        /// </code>
        /// </example>
        public static string TipText(FieldProperty aProperty)
        {
            return TipText(aProperty, "common", "",CharcterWidth.Default);
        }
        /// <summary>
        /// ő包AK{ڂȂǂToolTipgݗĂ
        /// </summary>
        /// <param name="aProperty"></param>
        /// <param name="charWidth"></param>
        /// <returns></returns>
        public static string TipText(FieldProperty aProperty,CharcterWidth charWidth)
        {
            return TipText(aProperty, "common", "", charWidth);
        }
        /// <summary>
        /// ő包AK{ڂȂǂToolTipgݗĂ
        /// </summary>
        /// <remarks>ʃTuVXê߂̃I[o[[h</remarks>
        /// <param name="aProperty">ڂ̑i[FieldProperty</param>
        /// <param name="aSubSystem">wTuVXe ag,es,...</param>
        /// <returns>͍ڂɕ\ToolTipԂ</returns>
        public static string TipText(FieldProperty aProperty, string aSubSystem)
        {
            return TipText(aProperty, aSubSystem, "", CharcterWidth.Default);
        }
        /// <summary>
        /// ő包AK{ڂȂǂToolTipgݗĂ
        /// </summary>
        /// <param name="aProperty">tB[hvpeB</param>
        /// <param name="aSubSystem">TuVXew</param>
        /// <param name="charWidth">Spw</param>
        /// <returns></returns>
        public static string TipText(FieldProperty aProperty, string aSubSystem, CharcterWidth charWidth)
        {
            return TipText(aProperty, aSubSystem, "", charWidth);
        }
        /// <summary>
        /// ő包AK{ڂȂǂToolTipgݗĂ
        /// </summary>
        /// <param name="aProperty">tB[hvpeB</param>
        /// <param name="aSubSystem">TuVXew</param>
        /// <param name="aLanguage"></param>
        /// <returns></returns>
        public static string TipText(FieldProperty aProperty, string aSubSystem, string aLanguage)
        {
            return TipText(aProperty, aSubSystem, aLanguage, CharcterWidth.Default);

        }
        /// <summary>
        /// ő包AK{ڂȂǂToolTipgݗĂ
        /// </summary>
        /// <remarks>ʃTuVXê߂̃I[o[[h</remarks>
        /// <param name="aProperty">ڂ̑i[FieldProperty</param>
        /// <param name="aSubSystem">wTuVXe ag,es,...</param>
        /// <param name="aLanguage">w ja({),kr(؍),fr(tX),en(p),</param>
        /// <param name="charWidth">Spw</param>
        /// <returns>͍ڂɕ\ToolTipԂ</returns>
        /// <example>
        /// <code>
        /// OfficialName.ToolTip = UIHelper.TipText(mMastClient.Properties.OfficialName, "ag", "ja");
        /// </code>
        /// </example>
        public static string TipText(FieldProperty aProperty, string aSubSystem, string aLanguage, CharcterWidth charWidth)
        {
            string strTip = "";
            string mrLengthKey = "" ;
            int len = 0;
            switch (charWidth)

            {
                case CharcterWidth.Single:
                    mrLengthKey = "TIPTEXT_STRING_LENGTH";
                    len = aProperty.Length;
                    break;
                case CharcterWidth.Double:
                    mrLengthKey = "TIPTEXT_STRING_LENGTH_DOUBLE";
                    len = aProperty.Length / 2;
                    break;
                case CharcterWidth.All:
                    mrLengthKey = "TIPTEXT_STRING_LENGTH_ALL";
                    len = aProperty.Length / 2;
                    break;
                default:
                    mrLengthKey = "TIPTEXT_STRING_LENGTH";
                    len = aProperty.Length;
                    break;
            }
            try
            {
                MessageResource mMessageResource = MessageResourceFactory.GetInstance(aSubSystem, aLanguage);

                if (!aProperty.IsNullable)
                {
                    //K{\
                    string strWork = mMessageResource.GetString("TIPTEXT_STRING_REQUIRED");
                    strTip += strWork;
                }

                if (aProperty.FieldType == typeof(string))
                {
                    //\
                    string strWork = mMessageResource.GetString(mrLengthKey);

                    strTip += String.Format(strWork, len.ToString());
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
            }

            return (strTip);
        }

        /// <summary>
        /// 镶KȒŐ؂hEEEhǉ
        /// </summary>
        /// <param name="aValue">Ώە</param>
        /// <param name="aLength">؂钷</param>
        /// <returns>w̒̕{hEEEh</returns>
        /// <example>
        /// <code>
        /// OfficialName.ToolTip = UIHelper.TipText(mMastClient.Properties.OfficialName, "ag", "ja");
        /// </code>
        /// </example>
        public static string ShortString(string aValue, int aLength)
        {
            string result = "";
            if (StringUtil.LengthB(aValue) > aLength)
            {
                result = StringUtil.LeftB(aValue, aLength) + "EEE";
            }
            else
            {
                result = aValue;
            }
            return result;
        }
        /// <summary>
        /// w(pƂSpƂ)
        /// </summary>
        public enum CharcterWidth
        {
            /// <summary>
            /// łӂ pƓ
            /// </summary>
            Default = 1,
            /// <summary>
            /// pŐ
            /// </summary>
            Single = 1,
            /// <summary>
            /// SpkŐ(2oCgP1)
            /// </summary>
            Double= 2,
            /// <summary>
            /// SpEp
            /// </summary>
            All = 3
        }
        /// <summary>
        /// ͍ڂ̊eݒ𓯎ɍs
        /// </summary>
        /// <param name="fp"></param>
        /// <param name="control"></param>
        /// <remarks>toolTip,onFocus,onmBlur,onChangeݒB<br />eLXg\͔pvZ </remarks>
        public static void InitFieldObject(FieldProperty fp, Control control)
        {
            InitFieldObject(fp, control, CharcterWidth.Default);
        }

        /// <summary>
        /// ͍ڂ̏
        /// </summary>
        /// <param name="fp">Ώۂ͍̓ڂɑΉvpeB</param>
        /// <param name="control">Ώۂ͍̓ڃRg[</param>
        /// <param name="charWidth">Spgp</param>
        /// <remarks>toolTip,onFocus,onmBlur,onChangeݒB<br />eLXg\DoublêƂpvZ̔ </remarks>
        public static void InitFieldObject(FieldProperty fp, Control control, CharcterWidth charWidth)
        {
            if (control is System.Web.UI.WebControls.TextBox)
            {
                TextBox tb = (TextBox)control;
                tb.MaxLength = fp.MaxLength;
                tb.ToolTip = TipText(fp,charWidth);
                tb.Attributes["onfocus"] = control.ID + "_onFocus(this)";
                if (fp is DecimalFieldProperty)
                {
                    DecimalFieldProperty dp = (DecimalFieldProperty)fp;
                    tb.Attributes["onblur"] = control.ID + String.Format( "_onBlur(this,{0},{1})",dp.Precision,dp.Scale);
                }
                else
                {
                    tb.Attributes["onblur"] = control.ID + "_onBlur(this)";
                }
                tb.Attributes["onchange"] = control.ID + "_onChange(this)";
                return;
            }
            if (control is System.Web.UI.WebControls.DropDownList)
            {
                DropDownList dl = (DropDownList)control;
                dl.ToolTip = TipText(fp, charWidth);
                dl.Attributes["onfocus"] = control.ID + "_onFocus(this)";
                dl.Attributes["onblur"] = control.ID + "_onBlur(this)";
                dl.Attributes["onclick"] = control.ID + "_onChange(this)";
                dl.Attributes["onchange"] = control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is System.Web.UI.WebControls.CheckBox)
            {
                CheckBox cb = (CheckBox)control;
                cb.ToolTip = TipText(fp, charWidth);
                cb.Attributes["onfocus"] = control.ID + "_onFocus(this)";
                cb.Attributes["onblur"] = control.ID + "_onBlur(this)";
                cb.Attributes["onclick"] = control.ID + "_onChange(this)";
                cb.Attributes["onchange"] = control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is System.Web.UI.WebControls.RadioButton)
            {
                RadioButton rb = (RadioButton)control;
                rb.ToolTip = TipText(fp, charWidth);
                rb.ToolTip = TipText(fp);
                rb.Attributes["onfocus"] = control.ID + "_onFocus(this)";
                rb.Attributes["onblur"] = control.ID + "_onBlur(this)";
                rb.Attributes["onclick"] = control.ID + "_onChange(this)";
                rb.Attributes["onchange"] = control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is System.Web.UI.WebControls.CheckBoxList)
            {
                CheckBoxList cb = (CheckBoxList)control;
                cb.ToolTip = TipText(fp, charWidth);
                cb.Attributes["onfocus"] = control.ID + "_onFocus(this)";
                cb.Attributes["onblur"] = control.ID + "_onBlur(this)";
                cb.Attributes["onclick"] = control.ID + "_onChange(this)";
                cb.Attributes["onchange"] = control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is System.Web.UI.WebControls.RadioButtonList)
            {
                RadioButtonList rb = (RadioButtonList)control;
                rb.ToolTip = TipText(fp, charWidth);
                rb.Attributes["onfocus"] = control.ID + "_onFocus(this)";
                rb.Attributes["onblur"] = control.ID + "_onBlur(this)";
                rb.Attributes["onclick"] = control.ID + "_onChange(this)";
                rb.Attributes["onchange"] = control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is OFW.Web.Controls.CheckBoxEx)
            {
                CheckBoxEx rb = (CheckBoxEx)control;
                //rb.ToolTip = TipText(fp);
                rb.Attributes["onfocus"] = control.ID + "_onFocus(this)";
                rb.Attributes["onblur"] = control.ID + "_onBlur(this)";
                rb.Attributes["onclick"] = control.ID + "_onChange(this)";
                rb.Attributes["onchange"] = control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is RadioButtonEx)
            {
                RadioButtonEx rb = (RadioButtonEx)control;
                //rb.ToolTip = TipText(fp);
                rb.Attributes["onfocus"] = control.ID + "_onFocus(this)";
                rb.Attributes["onblur"] = control.ID + "_onBlur(this)";
                rb.Attributes["onclick"] = control.ID + "_onChange(this)";
                rb.Attributes["onchange"] = control.ID + "_onChange(this)"; //KvB
                return;
            }

        }
        /// <summary>
        /// ftHgwRg[ɛz
        /// </summary>
        /// <param name="control"></param>
        /// <param name="clientNamespace"></param>
        /// <param name="fp"></param>
        /// <param name="charWidth"></param>
        public static void registerDefaultAttributes(Control control,string clientNamespace, FieldProperty fp, CharcterWidth charWidth)
        {
            string ns = "";
            if (clientNamespace != "") ns = clientNamespace + ".";
            if (control is System.Web.UI.WebControls.TextBox)
            {
                TextBox tb = (TextBox)control;
                tb.MaxLength = fp.MaxLength;
                tb.ToolTip = TipText(fp, charWidth);
                tb.Attributes["onfocus"] = ns + control.ID + "_onFocus(this)";
                if (fp is DecimalFieldProperty)
                {
                    DecimalFieldProperty dp = (DecimalFieldProperty)fp;
                    tb.Attributes["onblur"] = ns + control.ID + String.Format("_onBlur(this,{0},{1})", dp.Precision, dp.Scale);
                }
                else
                {
                    tb.Attributes["onblur"] = ns + control.ID + "_onBlur(this)";
                }
                tb.Attributes["onchange"] = ns + control.ID + "_onChange(this)";
                return;
            }
            if (control is System.Web.UI.WebControls.DropDownList)
            {
                DropDownList dl = (DropDownList)control;
                dl.ToolTip = TipText(fp, charWidth);
                dl.Attributes["onfocus"] = ns + control.ID + "_onFocus(this)";
                dl.Attributes["onblur"] = ns + control.ID + "_onBlur(this)";
                dl.Attributes["onclick"] = ns + control.ID + "_onChange(this)";
                dl.Attributes["onchange"] = ns + control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is System.Web.UI.WebControls.CheckBox)
            {
                CheckBox cb = (CheckBox)control;
                cb.ToolTip = TipText(fp, charWidth);
                cb.Attributes["onfocus"] = ns + control.ID + "_onFocus(this)";
                cb.Attributes["onblur"] = ns + control.ID + "_onBlur(this)";
                cb.Attributes["onclick"] = ns + control.ID + "_onChange(this)";
                cb.Attributes["onchange"] = ns + control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is System.Web.UI.WebControls.RadioButton)
            {
                RadioButton rb = (RadioButton)control;
                rb.ToolTip = TipText(fp, charWidth);
                rb.ToolTip = TipText(fp);
                rb.Attributes["onfocus"] = ns + control.ID + "_onFocus(this)";
                rb.Attributes["onblur"] = ns + control.ID + "_onBlur(this)";
                rb.Attributes["onclick"] = ns + control.ID + "_onChange(this)";
                rb.Attributes["onchange"] = ns + control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is System.Web.UI.WebControls.CheckBoxList)
            {
                CheckBoxList cb = (CheckBoxList)control;
                cb.ToolTip = TipText(fp, charWidth);
                cb.Attributes["onfocus"] = ns + control.ID + "_onFocus(this)";
                cb.Attributes["onblur"] = ns + control.ID + "_onBlur(this)";
                cb.Attributes["onclick"] = ns + control.ID + "_onChange(this)";
                cb.Attributes["onchange"] = ns + control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is System.Web.UI.WebControls.RadioButtonList)
            {
                RadioButtonList rb = (RadioButtonList)control;
                rb.ToolTip = TipText(fp, charWidth);
                rb.Attributes["onfocus"] = ns + control.ID + "_onFocus(this)";
                rb.Attributes["onblur"] = ns + control.ID + "_onBlur(this)";
                rb.Attributes["onclick"] = ns + control.ID + "_onChange(this)";
                rb.Attributes["onchange"] = ns + control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is CheckBoxEx)
            {
                CheckBoxEx rb = (CheckBoxEx)control;
                //rb.ToolTip = TipText(fp);
                rb.Attributes["onfocus"] = ns + control.ID + "_onFocus(this)";
                rb.Attributes["onblur"] = ns + control.ID + "_onBlur(this)";
                rb.Attributes["onclick"] = ns + control.ID + "_onChange(this)";
                rb.Attributes["onchange"] = ns + control.ID + "_onChange(this)"; //KvB
                return;
            }
            if (control is RadioButtonEx)
            {
                RadioButtonEx rb = (RadioButtonEx)control;
                //rb.ToolTip = TipText(fp);
                rb.Attributes["onfocus"] = ns + control.ID + "_onFocus(this)";
                rb.Attributes["onblur"] = ns + control.ID + "_onBlur(this)";
                rb.Attributes["onclick"] = ns + control.ID + "_onChange(this)";
                rb.Attributes["onchange"] = ns + control.ID + "_onChange(this)"; //KvB
                return;
            }

        }

        /// <summary>
        /// ͍ڃ}[J[(Opgif)K{/CӍڂŐ؂ւ
        /// </summary>
        /// <param name="property">ڑi[FieldProperty</param>
        /// <param name="markerLabel">͍ڃ}[J[(Opgif)̃Rg[</param>
        /// <example>
        /// <code>
        /// //HomePageURLɐݒ
        /// UIHelper.SetMarkerStyle(mMastClient.Properties.HomepageURL, HomepageMarker);
        /// </code>
        /// </example>
        public static void SetMarkerStyle(FieldProperty property, Image markerLabel)
        {
            //defaultcolorK{łȂقɂĂ΁AK{ԁA̔fł悢
            if (!property.IsNullable)
            {
                markerLabel.ImageUrl = "~/images/etc/pochi_red.gif";
            }
            else
            {
                markerLabel.ImageUrl = "~/images/etc/pochi.gif";
            }
        }
        /// <summary>
        /// NCAgڃ`FbN֐
        /// </summary>
        /// <param name="property">ڑi[FieldProperty</param>
        /// <param name="control">`FbNΏۂ̃T[o[Rg[</param>
        /// <returns>`FbNpNCAgXNvg֐</returns>
        /// <remarks>p~</remarks>
        public static string BuildFieldCheckScript(FieldProperty property, WebControl control)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append("function " + control.ClientID + "_check(){" + Environment.NewLine);
            builder.Append("        var obj = document.getElementById('" + control.ClientID + "');" + Environment.NewLine);

            if (!property.IsNullable)
            {
                builder.Append("    if(!CheckRequired(obj.value)){" + Environment.NewLine);
                builder.Append("        ValidationMessage += '" + property.DisplayName + "͕K{͂łB\\r\\n'; " + Environment.NewLine);
                builder.Append("        return false; " + Environment.NewLine);
                builder.Append("    }" + Environment.NewLine);

            }
            
            builder.Append("    obj.value = Trim(obj.value);" + Environment.NewLine);
            builder.Append("    if(obj.value =='') return true;" + Environment.NewLine);

            if (property.GetType() == typeof(IntFieldProperty))
            {
                builder.Append("    obj.value = ToNarrow(obj.value);" + Environment.NewLine);
                builder.Append("    if(!CheckDecimal(obj.value," + property.Precision + "," + property.Scale + ")){" + Environment.NewLine);
                builder.Append("        ValidationMessage += '" + property.DisplayName + "̓͂Ɍ肪܂B\\r\\n'; " + Environment.NewLine);
                builder.Append("        return false; " + Environment.NewLine);
                builder.Append("    }" + Environment.NewLine);
                builder.Append("    return true; " + Environment.NewLine);
            }
            if (property.GetType() == typeof(ByteFieldProperty))
            {
                builder.Append("    obj.value = ToNarrow(obj.value);" + Environment.NewLine);
                builder.Append("    if(!CheckDecimal(obj.value," + property.Precision + "," + property.Scale + ")){" + Environment.NewLine);
                builder.Append("        ValidationMessage += '" + property.DisplayName + "̓͂Ɍ肪܂B\\r\\n'; " + Environment.NewLine);
                builder.Append("        return false; " + Environment.NewLine);
                builder.Append("    }" + Environment.NewLine);
                builder.Append("    return true; " + Environment.NewLine);
            }
            if (property.GetType() == typeof(FloatFieldProperty))
            {
                builder.Append("    obj.value = ToNarrow(obj.value);" + Environment.NewLine);
                builder.Append("    if(!CheckDecimal(obj.value," + property.Precision + "," + property.Scale + ")){" + Environment.NewLine);
                builder.Append("        ValidationMessage += '" + property.DisplayName + "̓͂Ɍ肪܂B\\r\\n'; " + Environment.NewLine);
                builder.Append("        return false; " + Environment.NewLine);
                builder.Append("    }" + Environment.NewLine);
                builder.Append("    return true; " + Environment.NewLine);
            }
            if (property.GetType() == typeof(DecimalFieldProperty))
            {
                builder.Append("    obj.value = ToNarrow(obj.value);" + Environment.NewLine);
                builder.Append("    if(!CheckDecimal(obj.value," + property.Precision + "," + property.Scale + ")){" + Environment.NewLine);
                builder.Append("        ValidationMessage += '" + property.DisplayName + "̓͂Ɍ肪܂B\\r\\n'; " + Environment.NewLine);
                builder.Append("        return false; " + Environment.NewLine);
                builder.Append("    }" + Environment.NewLine);
                builder.Append("    return true; " + Environment.NewLine);
            }
            if (property.GetType() == typeof(DateFieldProperty))
            {
                builder.Append("    obj.value = ToNarrow(obj.value);" + Environment.NewLine);
                builder.Append("    if(!CheckDate(obj.value," + property.Precision + ")){" + Environment.NewLine);
                builder.Append("       ValidationMessage += '" + property.DisplayName + "̓͂Ɍ肪܂B\\r\\n'; " + Environment.NewLine);
                builder.Append("            return false; " + Environment.NewLine);
                builder.Append("    }" + Environment.NewLine);
                builder.Append("    return true; " + Environment.NewLine);
            }
            if (property.GetType() == typeof(StringFieldProperty))
            {
                builder.Append("    if(!CheckString(obj.value," + property.Precision + ")){" + Environment.NewLine);
                builder.Append("         ValidationMessage += '" + property.DisplayName + "̓͂܂B\\r\\n'; " + Environment.NewLine);
                builder.Append("            return false; " + Environment.NewLine);
                builder.Append("    }" + Environment.NewLine);
                builder.Append("    return true; " + Environment.NewLine);
            }

            builder.Append("}" + Environment.NewLine);
            return builder.ToString();
        }
        /// <summary>
        /// hbv_EXg̑Il̐ݒ
        /// </summary>
        /// <remarks></remarks>
        /// <param name="dropdown">hbv_ET[o[Rg[</param>
        /// <param name="val">IΏۂ"l"</param>
        /// <example>
        /// ƎR{Xg(BusinessKind)̏IlmMastClient.BussinessKindSeqɐݒ
        ///   UIHelper.SelectDropDown(BusinessKind,mMastClient.BussinessKindSeq);
        /// </example>
        public static void SelectDropDown(DropDownList dropdown, object val)
        {
            string sval = StringUtil.StringValue(val);
            ListItem li = dropdown.Items.FindByValue(sval);
            if (li != null)
            {
                dropdown.SelectedValue = sval;
            }
        }
        /// <summary>
        /// `FbN{bNXXgɑ΂đIԂݒ肷
        /// </summary>
        /// <param name="clist">`FbN{bNXXgT[o[Rg[</param>
        /// <param name="vlist">l̃Xg</param>
        public static void SetCheckBoxListChecked(CheckBoxList clist, List<int> vlist)
        {
            foreach (int i in vlist)
            {
                ListItem li = clist.Items.FindByValue(i.ToString());
                if (li != null)
                {
                    li.Selected = true;
                }
            }
        }
        /// <summary>
        /// `FbN{bNXXg̑̕IlXgŎ擾
        /// </summary>
        /// <param name="clist">`FbN{bNXXgT[o[Rg[</param>
        /// <returns>Iꂽl̃Xg</returns>
        public static List<int> GetCheckBoxListChecked(CheckBoxList clist)
        {
            List<int> result = new List<int>();
            foreach (ListItem li in clist.Items)
            {
                if (li.Selected)
                {
                    result.Add(NumberUtil.IntValue(li.Value));
                }
            }
            return result;
        }

        /// <summary>
        /// ₢킹[̑gݗ
        /// </summary>
        /// <param name="toAddr"></param>
        /// <param name="subject"></param>
        /// <param name="body"></param>
        /// <param name="ccAddr"></param>
        /// <param name="bccAddr"></param>
        /// <returns></returns>
        public static string BuildMailtoUrl(string toAddr, string subject, string body, string ccAddr, string bccAddr)
        {
            Encoding e = Encoding.GetEncoding("Shift_JIS");
            StringBuilder b = new StringBuilder();
            b.Append("mailto:");
            b.Append("?to=" + HttpUtility.UrlEncode( toAddr,e ));
            if(subject != "")
            {
                b.Append("&subject=" +HttpUtility.UrlEncode(  subject ,e));
            }
            if (body != "")
            {
                b.Append("&body=" + HttpUtility.UrlEncode( body ,e));
            }
            if (ccAddr != "")
            {
                b.Append("&cc=" + HttpUtility.UrlEncode( ccAddr,e ));
            }
            if (subject != "")
            {
                b.Append("&bcc=" + HttpUtility.UrlEncode( bccAddr,e ));
            }

            return b.ToString();
        }
    }

}
