using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Common;
using System.Reflection;
using CFW.Util;

namespace CFW.Database
{
    /// <summary>
    /// e[us^Cv̊{NX
    /// </summary>
    [Serializable]
    public abstract class AbstractTableRow : CFW.Models.IEntity,CFW.Models.ITypedSerializable
    {


        bool isNew;
        bool isModified;
        bool isDeleted;

        /// <summary>
        /// ftHg\z
        /// Ԃ͍sXe[^X=VK
        /// </summary>
        public AbstractTableRow()
        {
            isNew = true;
        }
        /// <summary>
        /// DataRowsf[^
        /// </summary>
        /// <param name="row">ɂȂsf[^</param>
        public virtual void FromDataRow(DataRow row)
        {
            this.FromDataRow(row, "");
        }

        /// <summary>
        /// DataRowsf[^
        /// </summary>
        /// <param name="row">ɂȂsf[^</param>
        /// <param name="alias">e[uʖ</param>
        public virtual void FromDataRow(DataRow row, string alias)
        {
            DataColumnCollection cols = row.Table.Columns;
            for (int c = 0; c < cols.Count; c++)
            {
                this.SetValue(GetFieldName(cols[c].ColumnName, alias), row[c]);

            }
        }
        /// <summary>
        /// DataReadersf[^
        /// </summary>
        /// <param name="reader">ɂȂreaderIuWFNg</param>
        public virtual void FromDataReader(DbDataReader reader)
        {
            this.FromDataReader(reader, "");
        }
        /// <summary>
        /// DataReadersf[^
        /// </summary>
        /// <param name="reader">ɂȂreaderIuWFNg</param>
        /// <param name="alias">e[uʖ</param>
        public virtual void FromDataReader(DbDataReader reader, string alias)
        {
            for (int c = 0; c < reader.FieldCount; c++)
            {
                this.SetValue(GetFieldName(reader.GetName(c),alias),reader.GetValue(c));
            }
        }
        /// <summary>
        /// nametB[hɒlZbg
        /// </summary>
        /// <param name="name"></param>
        /// <param name="value">l</param>
        public virtual void SetValue(string name, object value)
        {
        }
        /// <summary>
        /// nametB[h̒l
        /// </summary>
        /// <param name="name"></param>
        public virtual object GetValue(string name)
        {
            return null;
        }
        /// <summary>
        /// w񖼂ƃe[uʖɊÂtB[h擾
        /// </summary>
        /// <param name="columnName"></param>
        /// <param name="alias">e[uʖ</param>
        /// <returns>w񖼂ƃe[uʖɊÂtB[h</returns>
        protected string GetFieldName(string columnName,string alias)
        {
            if (alias == "")
            {
                int aliasLastPos = columnName.IndexOf("__");
                if (aliasLastPos > 0)
                {
                    return columnName.Substring(aliasLastPos + 2);
                }
                return columnName;
            }
            else
            {
                return columnName.Replace(alias + "__", "");
            }
        }
        /// <summary>
        /// e[uʖƗ񖼂IĂ̗͂̕ʖgݗ
        /// </summary>
        /// <param name="alias">e[uʖ</param>
        /// <param name="columnName">̗</param>
        /// <returns>̕ʖ</returns>
        protected string BuildColumnName(string alias, string columnName)
        {
            if (alias == "") return columnName;

            //Bstring.Format vs Z
            //return string.Format("{0}__{1}", alias, columnName);
            return alias + "__" + columnName;
        }
        /// <summary>
        /// 񑶍݃`FbN
        /// </summary>
        /// <param name="row">sf[^</param>
        /// <param name="colName"></param>
        /// <returns>sɗ񂪑݂鎞true</returns>
        protected bool ColumnExists(DataRow row, string colName)
        {
            return row.Table.Columns.Contains(colName);
        }
        /// <summary>
        /// ̍sVKs
        /// </summary>
        public bool IsNew
        {
            get {return this.isNew; }
            set { this.isNew = value; }
        }
        /// <summary>
        /// ̍sύXĂ邩
        /// </summary>
        public bool IsModified
        {
            get { return this.isModified; }
            set { this.isModified = value; }
            
        }
        /// <summary>
        /// ̍s폜Ă邩
        /// </summary>
        public bool IsDeleted
        {
            get { return this.isDeleted; }
            set { this.isDeleted = value; }
        }


        #region ITypedSerializable o
        /// <summary>
        /// ^(VACYp) 
        /// </summary>
        [System.Xml.Serialization.XmlAttribute]
        public virtual string __TypeName
        {
            get
            {
                Type t = this.GetType();
                string s = t.FullName + "," + t.Assembly.GetName().Name;
                return s;
            }
            set
            {
                //do nothing
            }
        }

        #endregion
    }
}
