using System;
using System.Collections.Generic;
using System.Text;

namespace OFW.Database.Config
{
    /// <summary>
    /// ڑݒ 
    /// </summary>
    public class ConnectionConfigFactory
    {
        /// <summary>
        /// wL[̃t@Ng[擾
        /// </summary>
        /// <param name="keys"></param>
        /// <returns></returns>
        public static ConnectionConfigElement GetConfig(params string[] keys)
        {
            return FindConfig(keys);
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="keys"></param>
        /// <returns></returns>
        public static ConnectionConfigElement FindConfig(params string[] keys)
        {
            ConnectionConfigSection section = (ConnectionConfigSection)OFW.Config.ConfigFactory.GetConfig().GetSection("dataAccess");
            if (section == null) return null;
            ConnectionConfigElement element = null;
            for (int length = keys.Length; length > 0; length--)
            {
                string configKey = BuildConfigKey(length, keys);
                element = section.ConnectionConfigs[configKey];
                if (element != null) break;

            }
            if (element == null)
            {
                return section.ConnectionConfigs["default"];
            }
            return element;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="depth">L[z̉܂Ŏg</param>
        /// <param name="keys"></param>
        /// <returns></returns>
        public static string BuildConfigKey(int depth,params string[] keys)
        {
            StringBuilder keyBuilder = new StringBuilder();
            for (int i = 0; i < depth; i++)
            {
                if (i > 0) keyBuilder.Append("/");
                keyBuilder.Append(keys[i]);

            }
            return keyBuilder.ToString();
        }

    }
}
