using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using OFW.Util;
using OFW.FieldProperties;

namespace OFW.Database.TableCommand
{
    /// <summary>
    /// ƂɑΉlɂ
    /// </summary>
    public class ColumnValueCondition : TableCommandCondition
    {
        /// <summary>
        /// 
        /// </summary>
        public TableCommandColumn Column;
        /// <summary>
        /// ɑ΂l̃p[^
        /// </summary>
        public List<Parameter> Parameters;
        /// <summary>
        /// Expression̉Zq
        /// </summary>
        public string Operator;


        #region constructors



        /// <summary>
        /// ō\z
        /// </summary>
        /// <param name="p">̃vpeB</param>
        /// <param name="value">񂪎ׂl</param>
        /// <param name="op">Zq</param>
        public ColumnValueCondition(FieldProperty p, object value, string op)
        {
            ConditionOperator = "";
            this.Column = new TableCommandColumn(p);
            this.Parameters = new List<Parameter>();
            Parameter param = new Parameter("@" + p.Alias(), p.SqlType(), value);
            param.Length = p.Length;
            param.Precision = p.Precision;
            param.Scale = p.Scale;

            this.Parameters.Add(param);
            Operator = op;
        }
        /// <summary>
        /// ō\z
        /// </summary>
        /// <param name="p">̃vpeB</param>
        /// <param name="values">񂪎ׂl̔z</param>
        /// <param name="op">Zq(IN ܂BETWEEN)</param>
        public ColumnValueCondition(FieldProperty p, object[] values, string op)
        {
            ConditionOperator = "";
            this.Column = new TableCommandColumn(p);
            this.Parameters = new List<Parameter>();

            for (int i = 0; i < values.Length; i++)
            {
                Parameter param = new Parameter("@" + p.Alias() + i.ToString(),p.SqlType(), values[i]);
                param.Length = p.Length;
                param.Precision = p.Precision;
                param.Scale = p.Scale;

                this.Parameters.Add(param);
            }

            Operator = op;
        }
        /// <summary>
        /// 񖼎w
        /// </summary>
        /// <param name="column"></param>
        /// <param name="expr">p[^</param>
        /// <param name="value">񂪎ׂl</param>
        /// <param name="op">Zq</param>
        public ColumnValueCondition(string column,string expr, object value, string op)
        {
            ConditionOperator = "";
            this.Column = new TableCommandColumn(column, column);
            this.Parameters = new List<Parameter>();
            Parameter param = new Parameter(expr, value);
            //͂Ȃ
            this.Parameters.Add(param);
            Operator = op;
        }
        /// <summary>
        /// 񖼎w
        /// </summary>
        /// <param name="column"></param>
        /// <param name="expr">p[^</param>
        /// <param name="values">񂪎ׂl</param>
        /// <param name="op">Zq</param>
        public ColumnValueCondition(string column, string expr, object[] values, string op)
        {
            ConditionOperator = "";
            this.Column = new TableCommandColumn(column, column);
            this.Parameters = new List<Parameter>();

            for (int i = 0; i < values.Length; i++)
            {
                Parameter param = new Parameter(expr, values[i]);

                this.Parameters.Add(param);
            }

            Operator = op;
        }
        /// <summary>
        /// ō\z
        /// </summary>
        /// <param name="p">̃vpeB</param>
        /// <param name="expr">p[^</param>
        /// <param name="value">񂪎ׂl</param>
        /// <param name="op">Zq</param>
        public ColumnValueCondition(FieldProperty p,string expr, object value, string op)
        {
            ConditionOperator = "";
            this.Column = new TableCommandColumn(p);
            this.Parameters = new List<Parameter>();
            Parameter param = new Parameter(expr, p.SqlType(), value);
            param.Length = p.Length;
            param.Precision = p.Precision;
            param.Scale = p.Scale;

            this.Parameters.Add(param);
            Operator = op;
        }
        /// <summary>
        /// ō\z
        /// </summary>
        /// <param name="p"></param>
        /// <param name="expr">p[^</param>
        /// <param name="values">񂪎ׂl̔z</param>
        /// <param name="op">Zq(IN ܂BETWEEN)</param>
        public ColumnValueCondition(FieldProperty p, string expr, object[] values, string op)
        {
            ConditionOperator = "";
            this.Column = new TableCommandColumn(p);
            this.Parameters = new List<Parameter>();

            for (int i = 0; i < values.Length; i++)
            {
                Parameter param = new Parameter(expr + i.ToString(), p.SqlType(), values[i]);
                param.Length = p.Length;
                param.Precision = p.Precision;
                param.Scale = p.Scale;

                this.Parameters.Add(param);
            }

            Operator = op;
        }
        #endregion
        /// <summary>
        /// Expressionioverridej
        /// </summary>
        /// <returns>̏\</returns>
        public override string BuildExpression()
        {

            string expr = "";
            expr = this.Column.FullName() + " " + Operator + " ";
            if (this.Operator == "IN" || this.Operator == "NOT IN")
            {
                expr += "(";
                for (int i = 0; i < this.Parameters.Count; i++)
                {
                    if (i > 0) expr += ",";
                    expr += this.Parameters[i].ParameterName;
                }
                expr += ")";
            }
            else if (this.Operator == "BETWEEN")
            {
                for (int i = 0; i < this.Parameters.Count; i++)
                {
                    if (i > 0) expr += " AND ";
                    expr += this.Parameters[i].ParameterName;
                }
            }
            else
            {
                expr += this.Parameters[0].ParameterName;
            }

            return expr;
        }
        /// <summary>
        /// ̏ɐݒ肳ꂽp[^
        /// </summary>
        /// <returns>̏ɐݒ肳ꂽp[^</returns>
        public override List<Parameter> GetParameters()
        {
            return this.Parameters;
        }
    }
}
