using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Common;
using OFW.Util;
using OFW.FieldProperties;
namespace OFW.Database.TableCommand
{
    /// <summary>
    /// TableCommand\
    /// </summary>
    public class TableCommandColumn
    {
        /// <summary>
        /// e[u
        /// </summary>
        public string TableName;
        /// <summary>
        /// 
        /// </summary>
        public string ColumnName;
        /// <summary>
        /// ̗킷
        /// </summary>
        public string Expression;

        /// <summary>
        /// ̃p[^`
        /// </summary>
        public List<Parameter> Parameters;
#region Constructor
        
        /// <summary>
        /// default construct
        /// </summary>
        public TableCommandColumn()
        {
            this.ColumnName = "";
            this.Expression = "";
            this.Parameters = new List<Parameter>();
        }
        /// <summary>
        /// Rs[RXgN^[
        /// </summary>
        /// <param name="c">Rs[̗`</param>
        /// <remarks>
        /// ɐĂ`eRs[č\zB<br />
        /// p[^͎QƂRs[
        /// </remarks>
        public TableCommandColumn(TableCommandColumn c)
        {
            this.TableName = c.TableName;
            this.ColumnName = c.ColumnName;
            this.Expression = c.Expression;
            this.Parameters = c.Parameters;
        }
        /// <summary>
        /// vpeBw肵č\z
        /// </summary>
        /// <param name="p"></param>
        /// <remarks>
        /// ȉ̏ō\z
        /// 񖼁FieldName
        ///  = @ + FieldName
        /// p[^ @ + FieldName
        /// 
        /// </remarks>
        public TableCommandColumn(FieldProperty p)
        {
            this.TableName = p.TableName;
            this.ColumnName = p.FieldName;
            this.Expression = "";
            this.Parameters = new List<Parameter>();

        }
        /// <summary>
        /// 񖼎w
        /// </summary>
        /// <param name="columnName"></param>
        /// <param name="expr">ɑ΂Đݒ肷鎮BƂgetdate()̂悤Ȃ́B</param>
        public TableCommandColumn(string columnName, string expr)
        {
            this.TableName = "";
            this.ColumnName = columnName;
            this.Expression = expr;
            this.Parameters = new List<Parameter>();


        }
        /// <summary>
        /// vpeBw肵č\z
        /// </summary>
        /// <param name="p">vpeB</param>
        /// <param name="expr"></param>
        /// <remarks>
        /// </remarks>
        public TableCommandColumn(FieldProperty p, string expr)
        {
            this.TableName = p.TableName;
            this.ColumnName = p.FieldName;
            this.Expression = expr;
            this.Parameters = new List<Parameter>();


        }
        /// <summary>
        /// vpeBw肵č\z
        /// </summary>
        /// <param name="p">vpeB</param>
        /// <param name="expr"></param>
        /// <param name="value">l</param>
        /// <remarks>
        /// </remarks>
        public TableCommandColumn(FieldProperty p,string expr, object value)
        {
            this.TableName = p.TableName;
            this.ColumnName = p.FieldName;
            this.Expression = expr;
            this.Parameters = new List<Parameter>();
            
            Parameter param = new Parameter(expr, p.SqlType(),value);
            param.Length = p.Length;
            param.Precision = p.Precision;
            param.Scale = p.Scale;
            this.Parameters.Add(param);

        }


#endregion

        #region public method

        /// <summary>
        /// p[^ǉ
        /// </summary>
        /// <param name="paramName">p[^</param>
        /// <param name="property">vpeB</param>
        /// <remarks></remarks>
        public void AddParameter(string paramName, FieldProperty property)
        {
            Parameter param = new Parameter(paramName, property.SqlType());
            param.Length = property.Length;
            param.Precision = property.Precision;
            param.Scale = property.Scale;
            this.Parameters.Add(param);

        }
        /// <summary>
        /// p[^ǉ
        /// </summary>
        /// <param name="paramName">p[^</param>
        /// <param name="property">vpeB</param>
        /// <param name="value">ݒ肷l</param>
        /// <remarks></remarks>
        public void AddParameter(string paramName, FieldProperty property, object value)
        {
            Parameter param = new Parameter(paramName, property.SqlType(),value);
            param.Length = property.Length;
            param.Precision = property.Precision;
            param.Scale = property.Scale;
            this.Parameters.Add(param);

        }
        /// <summary>
        /// ̃p[^ǉ
        /// </summary>
        /// <param name="param">parameter</param>
        /// <remarks></remarks>
        public void AddParameter(Parameter param)
        {
            this.Parameters.Add(param);
        }
        /// <summary>
        /// p[^ɒlZbg
        /// </summary>
        /// <param name="value">Zbgl</param>
        /// <remarks></remarks>
        public void SetParameterValue(object value)
        {
            if (this.Parameters.Count == 0)
            {
                return;
            }
            this.Parameters[0].ParameterValue = value;
        }
        /// <summary>
        /// p[^ɒlZbg
        /// </summary>
        /// <param name="value">l</param>
        /// <param name="p">p[^̈ʒu</param>
        /// <remarks></remarks>
        public void SetParameterValue(object value, int p)
        {
            if (this.Parameters.Count > p)
            {
                this.Parameters[p].ParameterValue = value;
            }
        }
        /// <summary>
        /// p[^ɒlZbg
        /// </summary>
        /// <param name="value">l</param>
        /// <param name="pname">p[^</param>
        /// <remarks></remarks>
        public void SetParameterValue(object value, string pname)
        {
            for (int i = 0; i < this.Parameters.Count; i++)
            {
                if (this.Parameters[i].ParameterName == pname)
                {
                    this.Parameters[i].ParameterValue = value;
                    break;
                }
            }
        }
        /// <summary>
        /// p[^SqlParameterɕϊĖ߂
        /// </summary>
        /// <returns></returns>
        public List<Parameter> GetParameters()
        {
            
            return this.Parameters;
        }
        /// <summary>
        /// ݒ肳Ăe[u̕ʖ
        /// </summary>
        /// <returns></returns>
        public string Alias()
        {
            if (this.TableName == "") return this.ColumnName;

            return this.TableName + "__" + this.ColumnName;
        }
        /// <summary>
        /// ݒ肳Ăe[u񖼂
        /// </summary>
        /// <returns></returns>
        public string FullName()
        {

            if (this.Expression != "") return this.Expression;
            if (this.TableName == "") return this.ColumnName;
            return this.TableName + "." + this.ColumnName;
        }
        #endregion
    }

}
