using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Common;

namespace CFW.common.tableCommand
{
    /// <summary>
    /// TableCommand\
    /// </summary>
    public class TableCommandColumn
    {
        /// <summary>
        /// 
        /// </summary>
        public string ColumnName;
        /// <summary>
        /// ̗̃vpeB
        /// </summary>
        public FieldProperty property;
        /// <summary>
        /// ̗ɐݒ肳鎮
        /// </summary>
        public string Expression;

        /// <summary>
        /// ̃p[^`
        /// </summary>
        public List<DbParameterBase> Parameters;
#region Constructor
        
        /// <summary>
        /// default construct
        /// </summary>
        public TableCommandColumn()
        {
            this.ColumnName = "";
            this.property = null;
            this.Expression = "";
            this.Parameters = new List<DbParameterBase>();
        }
        /// <summary>
        /// Rs[RXgN^[
        /// </summary>
        /// <param name="c">Rs[̗`</param>
        /// <remarks>
        /// ɐĂ`eRs[č\zB<br />
        /// p[^͎QƂRs[
        /// </remarks>
        public TableCommandColumn(TableCommandColumn c)
        {
            this.ColumnName = c.ColumnName;
            this.property = c.property;
            this.Expression = c.Expression;
            this.Parameters = c.Parameters;
        }
        /// <summary>
        /// 񖼂w
        /// </summary>
        /// <param name="columnName"></param>
        public TableCommandColumn(string columnName)
        {
            this.ColumnName = columnName;
            this.Parameters = new List<DbParameterBase>();
            this.Expression = "@" + columnName;

            this.Parameters = new List<DbParameterBase>();
            DbParameterBase param = new DbParameterBase(this.Expression);
            this.Parameters.Add(param);
        }
        /// <summary>
        /// 񖼂ƒlw
        /// </summary>
        /// <param name="columnName"></param>
        /// <param name="value">w肷l</param>
        public TableCommandColumn(string columnName,object value)
        {
            this.ColumnName = columnName;
            this.Parameters = new List<DbParameterBase>();
            this.Expression = "@" + columnName;

            this.Parameters = new List<DbParameterBase>();
            DbParameterBase param = new DbParameterBase(this.Expression);
            param.Value = value;
            this.Parameters.Add(param);
        }
        /// <summary>
        /// 񖼂ƌ^Alw
        /// </summary>
        /// <param name="columnName"></param>
        /// <param name="type"></param>
        /// <param name="value"></param>
        public TableCommandColumn(string columnName,DbType type, object value)
        {
            this.ColumnName = columnName;
            this.Parameters = new List<DbParameterBase>();
            this.Expression = "@" + columnName;

            this.Parameters = new List<DbParameterBase>();
            DbParameterBase param = new DbParameterBase(this.Expression,type);
            param.Value = value;
            this.Parameters.Add(param);
        }
        /// <summary>
        /// 񖼂ƌ^A\Alw
        /// </summary>
        /// <param name="columnName"></param>
        /// <param name="expr"></param>
        /// <param name="type"></param>
        /// <param name="value"></param>
        public TableCommandColumn(string columnName, DbType type,string expr, object value)
        {
            this.ColumnName = columnName;
            this.Parameters = new List<DbParameterBase>();
            this.Expression = expr;

            this.Parameters = new List<DbParameterBase>();
            DbParameterBase param = new DbParameterBase(this.Expression, type);
            param.Value = value;
            this.Parameters.Add(param);
        }

        /// <summary>
        /// vpeBw肵č\z
        /// </summary>
        /// <param name="p"></param>
        /// <remarks>
        /// ȉ̏ō\z
        /// 񖼁FieldName
        ///  = @ + FieldName
        /// p[^ @ + FieldName
        /// 
        /// </remarks>
        public TableCommandColumn(FieldProperty p)
        {
            this.property = p;

            this.ColumnName = p.FieldName;
            this.Expression = "@" + p.FieldName;

            this.Parameters = new List<DbParameterBase>();

            DbParameterBase param = new DbParameterBase(this.Expression, p.SqlType());

            this.Parameters.Add(param);

        }
        /// <summary>
        /// vpeBw肵č\z
        /// </summary>
        /// <param name="p">vpeB</param>
        /// <param name="value">l</param>
        /// <remarks>
        /// ȉ̏ō\z
        /// 񖼁FieldName
        ///  = @ + FieldName
        /// p[^ = @ + FieldName
        /// p[^̒l = value
        /// 
        /// </remarks>
        public TableCommandColumn(FieldProperty p, object value)
        {
            this.property = p;
            this.ColumnName = p.FieldName;
            this.Parameters = new List<DbParameterBase>();

            this.Expression = "@" + p.FieldName;
            DbParameterBase param = new DbParameterBase(this.Expression, p.SqlType());
            param.Value = DbAccessBase.FixValue( value );
            this.Parameters.Add(param);

        }
        /// <summary>
        /// vpeBw肵č\z
        /// </summary>
        /// <param name="p">vpeB</param>
        /// <param name="expr"></param>
        /// <param name="value">l</param>
        /// <remarks>
        /// ȉ̏ō\z
        /// 񖼁FieldName
        ///  = @ + FieldName
        /// p[^ = @ + FieldName
        /// p[^̒l = value
        /// 
        /// </remarks>
        public TableCommandColumn(FieldProperty p,string expr, object value)
        {
            this.property = p;
            this.ColumnName = p.FieldName;
            this.Parameters = new List<DbParameterBase>();

            this.Expression = expr;
            DbParameterBase param = new DbParameterBase(this.Expression, p.SqlType());
            param.Value = DbAccessBase.FixValue( value );
            this.Parameters.Add(param);

        }


#endregion

        #region public method

        /// <summary>
        /// p[^ǉ
        /// </summary>
        /// <param name="paramName">p[^</param>
        /// <param name="property">vpeB</param>
        /// <remarks></remarks>
        public void AddParameter(string paramName, FieldProperty property)
        {
            DbParameterBase param = new DbParameterBase(paramName, property.SqlType());
            this.Parameters.Add(param);

        }
        /// <summary>
        /// p[^ǉ
        /// </summary>
        /// <param name="paramName">p[^</param>
        /// <param name="property">vpeB</param>
        /// <param name="value">ݒ肷l</param>
        /// <remarks></remarks>
        public void AddParameter(string paramName, FieldProperty property, object value)
        {
            DbParameterBase param = new DbParameterBase(paramName, property.SqlType());
            param.Value = DbAccessBase.FixValue(value);
            this.Parameters.Add(param);

        }
        /// <summary>
        /// ̃p[^ǉ
        /// </summary>
        /// <param name="param">parameter</param>
        /// <remarks></remarks>
        public void AddParameter(DbParameterBase param)
        {
            this.Parameters.Add(param);
        }
        /// <summary>
        /// p[^ɒlZbg
        /// </summary>
        /// <param name="value">Zbgl</param>
        /// <remarks></remarks>
        public void SetParamValue(object value)
        {
            if (this.Parameters.Count == 0)
            {
                return;
            }
            this.Parameters[0].Value = DbAccessBase.FixValue( value );
        }
        /// <summary>
        /// p[^ɒlZbg
        /// </summary>
        /// <param name="value">l</param>
        /// <param name="p">p[^̈ʒu</param>
        /// <remarks></remarks>
        public void SetParamValue(object value, int p)
        {
            if (this.Parameters.Count > p)
            {
                this.Parameters[p].Value = DbAccessBase.FixValue( value );
            }
        }
        /// <summary>
        /// p[^ɒlZbg
        /// </summary>
        /// <param name="value">l</param>
        /// <param name="pname">p[^</param>
        /// <remarks></remarks>
        public void SetParamValue(object value, string pname)
        {
            for (int i = 0; i < this.Parameters.Count; i++)
            {
                if (this.Parameters[i].ParameterName == pname)
                {
                    this.Parameters[i].Value = DbAccessBase.FixValue( value );
                    break;
                }
            }
        }
        /// <summary>
        /// Expressionݒ
        /// </summary>
        /// <param name="expression"></param>
        public void SetExpression(string expression)
        {
            this.Expression = expression;
            this.Parameters = new List<DbParameterBase>();
        }

        /// <summary>
        /// p[^SqlParameterɕϊĖ߂
        /// </summary>
        /// <returns></returns>
        public List<DbParameterBase> GetSqlParams()
        {
            
            return this.Parameters;
        }
        #endregion
    }

}
