using System;
using System.Collections.Generic;
using System.Text;
using OFW.Forms;
using OFW.Forms.Filters;
using OFW.Util;
using OFW.Web.Auth.Model;

namespace OFW.Web.Auth.Model
{
    /// <summary>
    /// table auth_auto_login Field`
    /// </summary>
    public class AuthAutoLoginTableFormAdapter : OFW.Forms.FormAdapter
	{
		private AuthAutoLoginTableRow table;

		///<summary>[login_id]</summary>
		public FormAdapterElement LoginId;
		///<summary>[random_key]</summary>
		public FormAdapterElement RandomKey;
		///<summary>[identity_data_type]</summary>
		public FormAdapterElement IdentityDataType;
		///<summary>[identity_data]</summary>
		public FormAdapterElement IdentityData;
		///<summary>[expire_date]</summary>
		public FormAdapterElement ExpireDate;
		

		/// <summary>݂̃f[^\[X擾
		/// </summary>
        public override OFW.Models.Entity GetEntity()
        {
            return this.table;
        }
		/// <summary>\̍XV
		/// </summary>
        public override void RenderView()
        {
			this.LoginId.Render();
			this.RandomKey.Render();
			this.IdentityDataType.Render();
			this.IdentityData.Render();
			this.ExpireDate.Render();
			
        }

		/// <summary>̃A_v^[f[^ݒ
		/// </summary>
        /// <param name="entity">̃A_v^[f[^</param>
        public override void SetEntity(OFW.Models.Entity entity)
        {
        	this.table = (AuthAutoLoginTableRow)entity;
			this.LoginId.SetValue(this.table.LoginId);
			this.RandomKey.SetValue(this.table.RandomKey);
			this.IdentityDataType.SetValue(this.table.IdentityDataType);
			this.IdentityData.SetValue(this.table.IdentityData);
			this.ExpireDate.SetValue(this.table.ExpireDate);
			

        }

		/// <summary>UI͂ꂽef[^\[XɎ荞
		/// </summary>
        public override void UpdateEntity()
        {
			this.table.LoginId = StringUtil.StringValue(this.LoginId.GetValue());
			this.table.RandomKey = StringUtil.StringValue(this.RandomKey.GetValue());
			this.table.IdentityDataType = StringUtil.StringValue(this.IdentityDataType.GetValue());
			this.table.IdentityData = StringUtil.StringValue(this.IdentityData.GetValue());
			this.table.ExpireDate = DateUtil.DateValue(this.ExpireDate.GetValue());
			
        }

		/// <summary>UI͂ꂽe荞
		/// </summary>
        public override void UpdateFields()
        {
			this.LoginId.UpdateField();
			this.RandomKey.UpdateField();
			this.IdentityDataType.UpdateField();
			this.IdentityData.UpdateField();
			this.ExpireDate.UpdateField();
			
        }

		/// <summary>͓e؂
		/// ؃G[MessagesXgɑSẴG[B
		/// </summary>
        public override bool Validate()
        {
            bool valid = true;
			if(!this.LoginId.Validate()){
				valid = false;
				this.messages.Add(this.LoginId.ErrorMessage);
			}
			if(!this.RandomKey.Validate()){
				valid = false;
				this.messages.Add(this.RandomKey.ErrorMessage);
			}
			if(!this.IdentityDataType.Validate()){
				valid = false;
				this.messages.Add(this.IdentityDataType.ErrorMessage);
			}
			if(!this.IdentityData.Validate()){
				valid = false;
				this.messages.Add(this.IdentityData.ErrorMessage);
			}
			if(!this.ExpireDate.Validate()){
				valid = false;
				this.messages.Add(this.ExpireDate.ErrorMessage);
			}
			

            return valid;
        }
		
	}

}