using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Xml;
using System.Xml.Serialization;

namespace OFW.Web.Auth
{
    /// <summary>
    /// HttpSessionɔF؏ۑ
    /// </summary>
    public class SessionAuthStorage : OFW.Auth.AuthStorage
    {
        private object lockThis = new object();

        static List<string> invalidUsers;

        /// <summary>
        /// ftHg\z
        /// </summary>
        public SessionAuthStorage() : base()
        {

        }
        /// <summary>
        /// ݕێĂF؏擾
        /// </summary>
        /// <returns>ݕێĂF؏</returns>
        public override OFW.Auth.Identity GetIdentity()
        {
            string sessionName = this.config.sessionName;

            HttpContext context = HttpContext.Current;
            //sessionǂݍ
            OFW.Auth.Identity identity = (OFW.Auth.Identity)context.Session[sessionName];
            if (identity == null) return null;

            if (IsInvalid(identity.Name)) return null;

            //ۑȂ
            context.Session[sessionName] = identity;
            return identity;
        }
        /// <summary>
        /// F؂Ă邩̃`FbN
        /// </summary>
        /// <returns>F؂Ăΐ^</returns>
        public override bool IsAuthenticated()
        {
            string sessionName = this.config.sessionName;

            HttpContext context = HttpContext.Current;
            //sessionɑ݂Ȃ΁AF؂ĂȂ
            OFW.Auth.Identity identity = (OFW.Auth.Identity)context.Session[sessionName];
            if (identity == null) return false;
            if (IsInvalid(identity.Name)) return false;

            //ۑȂ
            context.Session[sessionName] = identity;
            return true;
        }

        /// <summary>
        /// F؏ۑ
        /// </summary>
        /// <param name="identity">F؂ꂽF؏</param>
        public override void SaveIdentity(OFW.Auth.Identity identity)
        {
            string sessionName = this.config.sessionName;

            HttpContext context = HttpContext.Current;
            context.Session[sessionName] = identity;
        }
        /// <summary>
        /// F؏jB
        /// </summary>
        public override void RemoveIdentity()
        {
            string sessionName = this.config.sessionName;
            HttpContext context = HttpContext.Current;
            context.Session.Remove(sessionName);
        }
        /// <summary>
        /// ̃IuWFNg̏
        /// (鎖͂Ȃ)
        /// </summary>
        public override void Init()
        {
            
        }
        /// <summary>
        /// w胍OCID̖
        /// </summary>
        /// <param name="loginId">ΏۃOCID</param>
        public override void Invalidate(string loginId)
        {
            lock (this.lockThis)
            {
                if (invalidUsers == null)
                {
                    invalidUsers = new List<string>();
                }
                invalidUsers.Add(loginId);
            }
        }
        /// <summary>
        /// w胍OCIDɂȂĂȂ`FbN
        /// </summary>
        /// <param name="loginId">`FbNΏۃOCID</param>
        /// <returns>OCIDɂȂĂTrue</returns>
        bool IsInvalid(string loginId)
        {
            if(invalidUsers == null) return false;
            int pos = invalidUsers.FindIndex(delegate(string s) { return (loginId == s); });
            if (pos < 0)
            {
                return false;
            }
            lock (this.lockThis)
            {
                invalidUsers.RemoveAt(pos);
            }
            return true;
        }
    }
}
