using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Text;
using System.IO;

using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using OFW.Util;
namespace OFW.Web.Util
{
    /// <summary>
    /// HTTP𗘗pt@C̃Abv[hA_E[h
    /// </summary>
    public class Download
    {

        Dictionary<string, string> mimeTypes;
        /// <summary>
        /// Rec̓Ytt@CƂă_E[h
        /// </summary>
        /// <param name="sourceFileName">_E[h</param>
        /// <param name="destinationFileName">NCAgɕ\t@C</param>
        /// <param name="response">_E[h{̂HttpResponse</param>
        /// <returns>MoCg</returns>
        /// <example>
        /// <code>
        /// //T[o["c:\document.txt""userfile.txt"Ƃă_E[h
        /// Download download = new Download();
        /// int rc = download.AsAttachment("c:\document.txt","userfile.txt",this.Request);
        /// </code>
        /// </example>
        /// <remarks>localł̃fobOł͓{t@CĂ܂BWebDev.WebServerResponse.HeaderEncoding܂ƂɏłȂB</remarks>
        public int AsAttachment(string sourceFileName, string destinationFileName, System.Web.HttpResponse response)
        {
            if (sourceFileName.Trim() == "") return 0;

            OFW.IO.FileSystem fs = OFW.IO.FileSystemFactory.GetInstance();


            if (!fs.FileExists(sourceFileName)) return 0;

            byte[] data = ReadBinary(sourceFileName, FileMode.Open);

            string filename = "";
            HttpRequest request = HttpContext.Current.Request;
            if (request.UserAgent.Contains("MSIE"))
            {
                //localł̃fobO͂܂oȂBWebDev.WebServer̃oOB
                response.HeaderEncoding = Encoding.GetEncoding("Shift_JIS");
                filename = destinationFileName;

            }
            else
            {
                filename = destinationFileName;
            }

            response.ContentType = "appliation/octet-stream";
            response.AppendHeader("Content-Disposition", "attachment;filename=" + filename + "");
            response.AppendHeader("content-length", data.Length.ToString());
            response.BinaryWrite(data);
            response.End();
            return (int)data.Length;
        }

		/// <summary>
        /// Rec{̂Ƃă_E[h
		/// </summary>
        /// <param name="sourceFileName">̃t@C</param>
        /// <param name="destinationFileName">_E[h̃t@CBtxtcsvA\Ƃƕsv̂͂</param>
        /// <param name="response">_E[h{̂HttpResponse</param>
        /// <returns>MoCg</returns>
        public int AsContent(string sourceFileName, string destinationFileName, System.Web.HttpResponse response)
		{
            if (sourceFileName.Trim() == "") return 0;

            OFW.IO.FileSystem fs = OFW.IO.FileSystemFactory.GetInstance();
            if (!fs.FileExists(sourceFileName)) return 0;
            byte[] data = ReadBinary(sourceFileName, FileMode.Open);

            response.ContentType = getContentType(destinationFileName);
            response.AppendHeader("content-length", data.Length.ToString());
            response.BinaryWrite(data);
            response.End();
			return (int)data.Length;
		}
        /// <summary>
        /// wt@Cmime type𔻒肵header:Content-Typeɐݒ肷ׂ擾B
        /// </summary>
        /// <param name="filename">t@Cw肷B</param>
        /// <returns>wt@CɑΉContent-Type̕</returns>
        string getContentType(string filename)
        {
            string contentType = "application/octet-stream";
            int lastExt = filename.LastIndexOf(".");
            if (lastExt < 0) return contentType;
            string ext = filename.Substring(lastExt + 1).ToLower();

            if (mimeTypes == null) loadMimeTypes();

            if (!mimeTypes.ContainsKey(ext)) return contentType;

            return mimeTypes[ext];
        }
        /// <summary>
        /// mime type̎[hB{Apachemime.typesgpB
        /// </summary>
        void loadMimeTypes()
        {
            mimeTypes = new Dictionary<string, string>();

            StreamReader reader = null;
            try
            {
                System.Reflection.Assembly myAssembly = System.Reflection.Assembly.GetExecutingAssembly();
                reader = new System.IO.StreamReader(
                    myAssembly.GetManifestResourceStream("OFW.Web.mime.types"),
                        System.Text.Encoding.GetEncoding("shift-jis"));

                while (!reader.EndOfStream)
                {
                    string s = reader.ReadLine().Trim();
                    if (s == "") continue;
                    if (s.StartsWith("#")) continue;

                    string[] ss = s.Split(new char[] { ' ', '\t' });
                    if (ss.Length > 1)
                    {
                        for (int i = 1; i < ss.Length; i++)
                        {
                            if (ss[i] == "") continue;
                            mimeTypes[ss[i]] = ss[0];
                        }
                    }
                }
            }
            catch (Exception)
            {

                throw;
            }
            finally
            {
                if (reader != null) reader.Close();
            }


        }

        /// <summary>
        /// t@CoCgzɓǂݍ
        /// </summary>
        /// <param name="path">ǂݍރt@Cw</param>
        /// <param name="mode">ǂݍ݃[h</param>
        /// <returns>t@C̓eێoCgz</returns>
        byte[] ReadBinary(string path, FileMode mode)
        {
            OFW.IO.FileSystem fs = OFW.IO.FileSystemFactory.GetInstance();
            byte[] buffer = fs.ReadBinary(path,mode);
            return buffer;

        }
    }
}
