using System;
using System.Collections.Generic;
using System.Text;
using OFW.Util;
using OFW.Forms.Filters;
using OFW.Validators;

namespace OFW.Windows.Forms.Adapters
{
    /// <summary>
    /// InputMan TextBox̂߂̃A_v^[
    /// </summary>
    public class GcTextBoxAdapterElement : OFW.Forms.FormAdapterElement
    {
        GrapeCity.Win.Editors.GcTextBox theControl;
        string outputFormat;
        /// <summary>
        /// ftHg
        /// </summary>
        public GcTextBoxAdapterElement()
        {

        }
        /// <summary>
        /// \z
        /// </summary>
        /// <param name="control">eLXg{bNX</param>
        /// <param name="filter">KptB^[</param>
        /// <param name="validator">Kpof[^</param>
        public GcTextBoxAdapterElement(GrapeCity.Win.Editors.GcTextBox control, Filter filter, FieldValidator validator)
        {
            this.theControl = control;
            if (filter == null) this.filter = new DefaultFilter();
            else this.filter = filter;

            if (validator == null) this.validator = new DefaultValidator();
            else this.validator = validator;

            this.outputFormat = "";
        }
        /// <summary>
        /// \z
        /// </summary>
        /// <param name="control">eLXg{bNX</param>
        /// <param name="filter">KptB^[</param>
        /// <param name="validator">Kpof[^</param>
        /// <param name="format">o̓tH[}bg</param>
        public GcTextBoxAdapterElement(GrapeCity.Win.Editors.GcTextBox control, Filter filter, FieldValidator validator, string format)
        {
            this.theControl = control;
            if (filter == null) this.filter = new DefaultFilter();
            else this.filter = filter;

            if (validator == null) this.validator = new DefaultValidator();
            else this.validator = validator;

            this.outputFormat = format;

        }
        /// <summary>
        /// l̎荞
        /// </summary>
        public override void UpdateField()
        {
            if (this.filter != null)
            {
                this.theValue = this.filter.FilterValue(this.theControl.Text);
            }
            else
            {
                this.theValue = this.theControl.Text;
            }
        }
        /// <summary>
        /// `
        /// </summary>
        public override void Render()
        {
            if (this.isValid)
            {
                if (this.outputFormat == "") this.theControl.Text = OFW.Util.StringUtil.StringValue(this.theValue);
                else
                {
                    string sfFormatString = "{0:" + this.outputFormat + "}";
                    string formated = string.Format(sfFormatString, this.theValue);
                    this.theControl.Text = formated;
                }
            }
            else
            {
                this.theControl.Text = OFW.Util.StringUtil.StringValue(this.theValue);
            }
        }
    }
}
