using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using OFW.Forms;
using OFW.Forms.Filters;
using OFW.FieldProperties;
using OFW.Validators;
using System.Reflection;


namespace OFW.Windows.Forms.Adapters
{
    /// <summary>
    /// hbv_EXg
    /// </summary>
    public class DropDownListAdapterElement : FormAdapterElement
    {
        /// <summary>
        /// drop down
        /// </summary>
        ComboBox theControl;

        string text;


        /// <summary>
        /// ftHg\z
        /// </summary>
        public DropDownListAdapterElement()
        {

        }
        /// <summary>
        /// ɂȂRg[AtB^[Aof[^w肵č\z
        /// </summary>
        /// <param name="control">ɂȂRg[</param>
        /// <param name="filter">KptB^[</param>
        /// <param name="validator">Kpof[^</param>
        public DropDownListAdapterElement(ComboBox control, Filter filter, FieldValidator validator)
        {
            this.theControl = control;
            this.filter = filter;
            this.validator = validator;
        }

        /// <summary>
        /// Rg[̒l荞
        /// </summary>
        public override void UpdateField()
        {
            if (this.theControl.SelectedIndex < 0)
            {
                this.theValue = null;
            }
            else
            {
                this.theValue = this.filter.FilterValue( this.theControl.SelectedValue );
                this.text = this.theControl.SelectedText;
            }

        }
        /// <summary>
        /// \
        /// </summary>
        public override void Render()
        {
            if (this.theValue == null)
            {
                this.theControl.SelectedIndex = -1;
            }
            else
            {
                this.theControl.SelectedIndex = find( theValue );
            }
        }
        private int find(object v)
        {
            Type t = null;
            PropertyInfo valueProperty = null;
            IEnumerator e = theControl.Items.GetEnumerator();
            int pos = 0;
            int result = -1;
            while (e.MoveNext())
            {
                if (t == null)
                {
                    t = e.Current.GetType();
                    valueProperty = t.GetProperty(theControl.ValueMember);
                    
                }
                object itemValue = valueProperty.GetValue(e.Current,null);
                int c = Comparer.Default.Compare(v, itemValue);
                if (c == 0)
                {
                    result = pos;
                    break;
                }
                pos++;
            }
            return result;
        }

    }
}
