using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace OFW.Windows.Forms
{
    /// <summary>
    /// c[ҏWtH[
    /// </summary>
    public partial class TreeViewEditForm : Form
    {
        OFW.Windows.Forms.Adapters.AbstractTreeViewAdapter adapter;
        /// <summary>
        /// \z
        /// </summary>
        public TreeViewEditForm()
        {
            InitializeComponent();

        }
        /// <summary>
        /// TreeViewAdaptergď
        /// </summary>
        /// <param name="adapter">TreeViewAdapter</param>
        public void Initialize(OFW.Windows.Forms.Adapters.AbstractTreeViewAdapter adapter)
        {
            this.adapter = adapter;
            this.adapter.Initialize(this.treeView1);
            this.Text = adapter.GetTitle();
            List<ToolStripMenuItem> extendMenus = this.adapter.GetExtendMenu();
            if (extendMenus.Count > 0)
            {
                this.NodeToolStripMenuItem.DropDown.Items.Insert(0, new ToolStripSeparator());
                for (int i = extendMenus.Count - 1; i >= 0; i--)
                {
                    this.NodeToolStripMenuItem.DropDown.Items.Insert(0, extendMenus[i]);
                }
            }

            //c[\z
            treeView1.Nodes.Clear();
            treeView1.Nodes.Add("");

            adapter.RenderNode(treeView1.Nodes[0], this.adapter.GetRoot());
            treeView1.Nodes[0].Expand();
        }
        /// <summary>
        /// c[m[hWJ
        /// qm[h̃f[^擾ăm[hB
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void treeView1_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            TreeNode node = e.Node;
            OFW.Models.ITreeNode nodeData = node.Tag as OFW.Models.ITreeNode;
            if (nodeData != null)
            {
                this.adapter.RenderNode(node, nodeData);
            }
        }

        /// <summary>
        /// I
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ExitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        /// <summary>
        /// ĕ\
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void RefreshViewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            adapter.RenderNode(treeView1.Nodes[0], this.adapter.GetRoot());

        }
        /// <summary>
        /// m[h폜
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DeleteNodeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            adapter.DeleteNode(treeView1.SelectedNode);

        }
        /// <summary>
        /// m[hҏW
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void EditNodeToolStripMenuItem3_Click(object sender, EventArgs e)
        {
            adapter.EditNode(treeView1.SelectedNode);

        }
        /// <summary>
        /// VKm[h
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NewNodeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            adapter.NewNode(treeView1.SelectedNode);

        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            TreeNode node = e.Node;
            OFW.Models.ITreeNode nodeData = node.Tag as OFW.Models.ITreeNode;
            if (nodeData != null)
            {
                if (nodeData.id == 0)
                {
                    DeleteNodeToolStripMenuItem.Enabled = false;
                    EditNodeToolStripMenuItem3.Enabled = false;
                }
                else
                {
                    DeleteNodeToolStripMenuItem.Enabled = true;
                    EditNodeToolStripMenuItem3.Enabled = true;
                }
            }

        }
    }
}