using System;
using System.Collections.Generic;
using System.Text;

namespace OFW.Auth
{
    /// <summary>
    /// pX[hnbV@̒` SaltedSHA
    /// </summary>
    public class PasswordHashSSHA : AbstractPasswordHash
    {
        /// <summary>
        /// \z
        /// </summary>
        public PasswordHashSSHA () : base()
	    {

	    }

        /// <summary>
        /// nbV𐶐B
        /// sha(input)
        /// </summary>
        /// <param name="input">͕</param>
        /// <returns>sha(input)̌</returns>
        public override string CreateHash(string input)
        {
            byte[] salt = OFW.Util.Hash.GenerateRandom(saltLength);
            byte[] bytes = System.Text.Encoding.ASCII.GetBytes(input);
            byte[] hashed = OFW.Util.Hash.SHA1(OFW.Util.Util.ConcatByteArray(bytes, salt));

            return this.Encode(OFW.Util.Util.ConcatByteArray(hashed, salt));
        }


        /// <summary>
        /// ͒l̃nbVƓ
        /// </summary>
        /// <param name="input">͒l</param>
        /// <param name="target">(nbVς)</param>
        /// <returns></returns>
        public override bool ValidateHash(string input, string target)
        {
            byte[] decoded = this.Decode(target);
            byte[] salt = OFW.Util.ByteArrayUtil.Slice(decoded, decoded.Length - saltLength, saltLength);

            byte[] inputBytes = OFW.Util.ByteArrayUtil.FromString(input);
            byte[] hashed = OFW.Util.Hash.SHA1(OFW.Util.Util.ConcatByteArray(inputBytes, salt));

            byte[] targetHash = OFW.Util.ByteArrayUtil.Slice(decoded, 0, decoded.Length - config.SaltLength);

            bool result = OFW.Util.ByteArrayUtil.Equals(hashed, targetHash);

            return result;
        }
    }
}
