using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.Specialized;
using System.Configuration; // remember to add reference in project
using System.Reflection;

namespace OFW.Config
{
    /// <summary>
    /// f[^ANZXݒZNV̒`
    /// </summary>
    public class DataAccessConfigSection : ConfigurationSection
    {
        /// <summary>
        /// ftHg\z
        /// </summary>
        public DataAccessConfigSection()
        {
        }

        /// <summary>
        /// ftHg̐ڑ^CAEg
        /// </summary>
        [ConfigurationProperty("defaultConnectionTimeout", DefaultValue = 15)]
        [IntegerValidator(MinValue = 0,MaxValue = 1800)]
        public int DefaultConnectionTimeout
        {
            get
            { return (int)this["defaultConnectionTimeout"]; }
            set
            { this["defaultConnectionTimeout"] = value; }
        }
        /// <summary>
        /// ftHg̃R}h^CAEg
        /// </summary>
        [ConfigurationProperty("defaultCommandTimeout", DefaultValue = 15)]
        [IntegerValidator(MinValue = 0, MaxValue = 1800)]
        public int DefaultCommandTimeout
        {
            get
            { return (int)this["defaultCommandTimeout"]; }
            set
            { this["defaultCommandTimeout"] = value; }
        }

        /// <summary>
        /// `ꂽf[^ANZXݒ̃RNV
        /// </summary>
        [ConfigurationProperty("", IsDefaultCollection = true)]
        [ConfigurationCollection(typeof(DataAccessConfigCollection),
         AddItemName = "add",
         ClearItemsName = "clear",
         RemoveItemName = "remove")]
        public DataAccessConfigCollection DataAccessConfigs
        {
            get
            { return (DataAccessConfigCollection)this[""]; }
        }
    }



    /// <summary>
    /// f[^ANZXݒ̃RNV`
    /// </summary>
    public class DataAccessConfigCollection : ConfigurationElementCollection
    {
        /// <summary>
        /// ftHg\z
        /// </summary>
        public DataAccessConfigCollection()
        { }
        /// <summary>
        /// RNV^Cv
        /// </summary>
        public override
            ConfigurationElementCollectionType CollectionType
        {
            get
            {
                return
                    ConfigurationElementCollectionType.AddRemoveClearMap;
                    //ConfigurationElementCollectionType.BasicMap;
            }
        }
        /// <summary>
        /// VKvf
        /// </summary>
        /// <returns></returns>
        protected override
            ConfigurationElement CreateNewElement()
        {
            return new DataAccessConfigElement();
        }



        /// <summary>
        /// vf̃L[擾
        /// </summary>
        /// <param name="element"></param>
        /// <returns></returns>
        protected override Object
            GetElementKey(ConfigurationElement element)
        {
            return ((DataAccessConfigElement)element).Name;
        }
        /// <summary>
        /// vf̌
        /// </summary>
        public new int Count
        {

            get { return base.Count; }

        }

        /// <summary>
        /// CfNT
        /// </summary>
        /// <param name="index"></param>
        /// <returns></returns>
        public DataAccessConfigElement this[int index]
        {
            get
            {
                return (DataAccessConfigElement)BaseGet(index);
            }
            set
            {
                if (BaseGet(index) != null)
                {
                    BaseRemoveAt(index);
                }
                BaseAdd(index, value);
            }
        }

        /// <summary>
        /// CfNT
        /// </summary>
        /// <param name="Name"></param>
        /// <returns></returns>
        new public DataAccessConfigElement this[string Name]
        {
            get
            {
                return (DataAccessConfigElement)BaseGet(Name);
            }
        }

        /// <summary>
        /// vfǉ
        /// </summary>
        public new string AddElementName
        {
            get
            { return base.AddElementName; }

            set
            { base.AddElementName = value; }

        }
        /// <summary>
        /// vfNA
        /// </summary>
        public new string ClearElementName
        {
            get
            { return base.ClearElementName; }

            set
            { base.AddElementName = value; }

        }
        /// <summary>
        /// vf폜
        /// </summary>
        public new string RemoveElementName
        {
            get
            { return base.RemoveElementName; }


        }
        /// <summary>
        /// vf̏
        /// </summary>
        /// <param name="cfg"></param>
        /// <returns></returns>
        public int IndexOf(DataAccessConfigElement cfg)
        {
            return BaseIndexOf(cfg);
        }
        /// <summary>
        /// vfǉ
        /// </summary>
        /// <param name="cfg"></param>
        public void Add(DataAccessConfigElement cfg)
        {
            BaseAdd(cfg);

            // Add custom code here.
        }
        /// <summary>
        /// vfǉ
        /// </summary>
        /// <param name="element"></param>
        protected override void
            BaseAdd(ConfigurationElement element)
        {
            BaseAdd(element, false);
            // Add custom code here.
        }
        /// <summary>
        /// vf폜
        /// </summary>
        /// <param name="cfg"></param>
        public void Remove(DataAccessConfigElement cfg)
        {
            if (BaseIndexOf(cfg) >= 0)
                BaseRemove(cfg.Name);
        }
        /// <summary>
        /// vf폜
        /// </summary>
        /// <param name="index"></param>
        public void RemoveAt(int index)
        {
            BaseRemoveAt(index);
        }
        /// <summary>
        /// vf폜
        /// </summary>
        /// <param name="name"></param>
        public void Remove(string name)
        {
            BaseRemove(name);
        }
        /// <summary>
        /// vfNA
        /// </summary>
        public void Clear()
        {
            BaseClear();
            // Add custom code here.
        }
    }

    /// <summary>
    /// f[^ANZXݒ̗vf
    /// </summary>
    public class DataAccessConfigElement : ConfigurationElement
    {
        /// <summary>
        /// ݒ薼
        /// </summary>
        [ConfigurationProperty("name", IsRequired = true)]
        public string Name
        {
            get
            { return (String)this["name"]; }
            set
            { this["name"] = value; }
        }
        /// <summary>
        /// gpf[^voC_[
        /// </summary>
        [ConfigurationProperty("providerName",DefaultValue="System.Data.SqlClient")]
        public string ProviderName
        {
            get
            { return (String)this["providerName"]; }
            set
            { this["providerName"] = value; }
        }
        /// <summary>
        /// ڑ
        /// </summary>
        [ConfigurationProperty("connectionString")]
        public string ConnectionString
        {
            get
            { return (String)this["connectionString"]; }
            set
            { this["connectionString"] = value; }
        }
        /// <summary>
        /// ڑ^CAEg
        /// </summary>
        [ConfigurationProperty("connectionTimeout",DefaultValue=0)]
        public int ConnectionTimeout
        {
            get
            {
                return (int)this["connectionTimeout"]; 
            }
            set
            { this["connectionTimeout"] = value; }
        }
        /// <summary>
        /// R}h^CAEg
        /// </summary>
        [ConfigurationProperty("commandTimeout", DefaultValue = 0)]
        public int CommandTimeout
        {
            get
            {
                return (int)this["commandTimeout"];
            }
            set
            { this["commandTimeout"] = value; }
        }
    }
}
