using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace OFW.Config
{
    /// <summary>
    /// GetPrivateProfile/SetPrivateProfilẽbp0
    /// </summary>
    public class PrivateProfile
    {
        string _FilePath;
        /// <summary>
        /// vt@C̏ꏊ擾Eݒ肷
        /// </summary>
        public string FilePath
        {
            get { return _FilePath; }
            set { _FilePath = value; }
        }
        /// <summary>
        /// ftHg\z
        /// </summary>
        public PrivateProfile()
        {
            FilePath = "";
        }
        /// <summary>
        /// w肵t@Cgp悤ɍ\z
        /// </summary>
        /// <param name="filePath"></param>
        public PrivateProfile(string filePath)
        {
            this.FilePath = filePath;
        }
        /// <summary>
        /// win32::GetPrivateProfileStrinǧĂяo
        /// init@CZNVAL[w肵StringBuilderɕԂ
        /// </summary>
        /// <param name="lpszSection"></param>
        /// <param name="lpszKey"></param>
        /// <param name="lpDefault"></param>
        /// <param name="lpReturnedString"></param>
        /// <param name="nSize"></param>
        /// <param name="lpFileName"></param>
        /// <returns></returns>
        [DllImport("KERNEL32.DLL")]
        public static extern uint GetPrivateProfileString(string lpszSection, string lpszKey, string lpDefault, StringBuilder lpReturnedString, uint nSize, string lpFileName);

        /// <summary>
        /// win32::GetPrivateProfileInťĂяo
        /// init@CZNVAL[w肵Đl𓾂
        /// </summary>
        /// <param name="lpAppNlpszSectioname"></param>
        /// <param name="lpszKey"></param>
        /// <param name="dwDefault"></param>
        /// <param name="lpFileName"></param>
        /// <returns></returns>
        [DllImport("KERNEL32.DLL")]
        public static extern uint GetPrivateProfileInt(string lpAppNlpszSectioname, string lpszKey, int dwDefault, string lpFileName);

        /// <summary>
        /// init@C
        /// ZNVƃL[w肵ĊYlԂ
        /// </summary>
        /// <param name="aSection"></param>
        /// <param name="aKey"></param>
        /// <returns></returns>
        public string GetKeyValue(string aSection, string aKey)
        {
            if (FilePath == "")
            {
                return ""; //ł悢̂
            }
            if (aSection == null)
            {
                return "";
            }
            if (aSection == "")
            {
                return "";
            }
            if (aKey == null)
            {
                return "";
            }
            if (aKey == "")
            {
                return "";
            }

            StringBuilder sb = new StringBuilder(1024);
            GetPrivateProfileString(aSection, aKey, "", sb, (uint)sb.Capacity, @FilePath);
            return sb.ToString();
        }

        /// <summary>
        /// iinit@CwZNVAL[̕o
        /// </summary>
        /// <param name="aSection"></param>
        /// <param name="aKey"></param>
        /// <param name="aDefaultValue"></param>
        /// <returns></returns>
        public string GetString(string aSection, string aKey, string aDefaultValue)
        {
            StringBuilder sb = new StringBuilder(1024);
            GetPrivateProfileString(aSection, aKey, aDefaultValue, sb, (uint)sb.Capacity, @FilePath);
            return sb.ToString();
        }
        /// <summary>
        /// init@CwZNVAL[̐o
        /// </summary>
        /// <param name="aSection"></param>
        /// <param name="aKey"></param>
        /// <param name="aDefaultValue"></param>
        /// <returns></returns>
        public int GetInt(string aSection, string aKey, int aDefaultValue)
        {
            return (int)GetPrivateProfileInt(aSection, aKey, aDefaultValue, @FilePath);
        }



    }
}
