using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
namespace OFW.IO
{
    /// <summary>
    /// ftHgt@CVXe
    /// </summary>
    public abstract class FileSystem
    {
        /// <summary>
        /// oCi[[h
        /// </summary>
        /// <param name="path"></param>
        /// <param name="buffer"></param>
        /// <param name="mode"></param>
        /// <returns></returns>
        public abstract int WriteBinary(string path,byte[] buffer, FileMode mode);
        /// <summary>
        /// eLXg[h
        /// </summary>
        /// <param name="path"></param>
        /// <param name="buffer"></param>
        /// <param name="mode"></param>
        /// <returns></returns>
        public abstract int WriteText(string path, string buffer,FileMode mode);
        /// <summary>
        /// eLXg[h
        /// </summary>
        /// <param name="path"></param>
        /// <param name="buffer"></param>
        /// <param name="mode"></param>
        /// <param name="encoding"></param>
        /// <returns></returns>
        public abstract int WriteText(string path, string buffer, FileMode mode,System.Text.Encoding encoding);
        /// <summary>
        /// eLXg[h
        /// </summary>
        /// <param name="path"></param>
        /// <param name="buffer"></param>
        /// <param name="mode"></param>
        /// <returns></returns>
        public abstract int WriteTextShiftJIS(string path, string buffer, FileMode mode);
        /// <summary>
        /// eLXg[hǂݍ
        /// </summary>
        /// <param name="path"></param>
        /// <param name="mode"></param>
        /// <returns></returns>
        public abstract string ReadText(string path, FileMode mode);
        /// <summary>
        /// eLXg[hǂݍ
        /// </summary>
        /// <param name="path"></param>
        /// <param name="mode"></param>
        /// <param name="encoding"></param>
        /// <returns></returns>
        public abstract string ReadText(string path, FileMode mode, System.Text.Encoding encoding);
        /// <summary>
        /// eLXg[hǂݍ
        /// </summary>
        /// <param name="path"></param>
        /// <param name="mode"></param>
        /// <returns></returns>
        public abstract string ReadTextShiftJIS(string path, FileMode mode);
        /// <summary>
        /// 
        /// </summary>
        /// <param name="path"></param>
        /// <param name="mode"></param>
        /// <returns></returns>
        public abstract byte[] ReadBinary(string path, FileMode mode);
        /// <summary>
        /// ݒ
        /// </summary>
        /// <param name="path"></param>
        /// <param name="attr"></param>
        public abstract void SetAttribute(string path,int attr);
        /// <summary>
        /// 擾
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract int GetAttribute(string path);
        /// <summary>
        /// 
        /// </summary>
        /// <param name="src"></param>
        /// <param name="dst"></param>
        public abstract void CopyFile(string src, string dst);
        /// <summary>
        /// t@CRs[
        /// </summary>
        /// <param name="src"></param>
        /// <param name="dst"></param>
        /// <param name="overwrite"></param>
        public abstract void CopyFile(string src, string dst, bool overwrite);
        /// <summary>
        /// t@C폜
        /// </summary>
        /// <param name="path"></param>
        public abstract void DeleteFile(string path);
        /// <summary>
        /// t@C݃`FbN
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract bool FileExists(string path);
        /// <summary>
        /// t@Cړ
        /// </summary>
        /// <param name="src"></param>
        /// <param name="dst"></param>
        public abstract void MoveFile(string src, string dst);
        /// <summary>
        /// fBNg쐬
        /// </summary>
        /// <param name="path">fBNg</param>
        /// <param name="spec">ǉvf</param>
        /// <returns>ŌɍfBNg</returns>
        public abstract string CreateDirectory(string path,params string[] spec);
        /// <summary>
        /// fBNgړ
        /// </summary>
        /// <param name="src"></param>
        /// <param name="dst"></param>
        public abstract void MoveDirectory(string src, string dst);
        /// <summary>
        /// fBNg폜
        /// </summary>
        /// <param name="path"></param>
        public abstract void DeleteDirectory(string path);
        /// <summary>
        /// ċAIfBNg폜
        /// </summary>
        /// <param name="path"></param>
        /// <param name="recursive"></param>
        public abstract void DeleteDirectory(string path,bool recursive);
        /// <summary>
        /// fBNg݃`FbN
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract bool DirectoryExists(string path);
        /// <summary>
        /// fBNgꗗ
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract string[] GetDirectories(string path);
        /// <summary>
        /// t@Cꗗ
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract string[] GetFiles(string path);
        /// <summary>
        /// pX̖O
        /// </summary>
        /// <param name="path1"></param>
        /// <param name="path2"></param>
        /// <returns></returns>
        public abstract string CombineName(string path1,string path2);
        /// <summary>
        /// fBNg؂蕶
        /// </summary>
        public virtual char DirectorySeparetorChar
        {
            get
            {
                return System.IO.Path.DirectorySeparatorChar;
            }
        }
        /// <summary>
        /// pathɊ܂܂path delimiter̂悤Ȃ̂oB
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        /// <remarks>\Ƀ`FbNĂ\ 
        /// Ȃ/TĂ/
        /// Ȃ\</remarks>
        public abstract string GetSeparator(string path);
        /// <summary>
        /// pX񂩂fBNg
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract string GetDirectoryName(string path);
        /// <summary>
        /// pX񂩂gq擾
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract string GetExtension(string path);
        /// <summary>
        /// pX񂩂t@C擾
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract string GetFileName(string path);
        /// <summary>
        /// tpX
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract string GetFullPath(string path);
        /// <summary>
        /// t@CTCY
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract long FileSize(string path);
        /// <summary>
        /// t@C
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public abstract FileInfo FileInfo(string path);
    }
}
