using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using OFW.Util;
using Newtonsoft.Json;
namespace OFW.Serializer
{
    /// <summary>
    /// IuWFNgJSONIuWFNgɕϊ<br />
    /// JSONIuWFNgC#IuWFNg𐶐
    /// </summary>
    public class JSONConverter
    {
        /// <summary>JSONf[^̃[gIuWFNg</summary>
        JavaScriptObject doc;
        ///<summary>
        /// ϊNX̃^Cv
        /// </summary>
        Type mType;

        List<Type> mTypeCache;
        /// <summary>
        /// ϊNXw肵č\z
        /// </summary>
        /// <param name="t">ϊNXType</param>
        public JSONConverter(Type t)
        {
            mType = t;
        }
        /// <summary>
        /// JSONIuWFNgrootB
        /// </summary>
        /// <param name="o">ϊΏۂ̃IuWFNg</param>
        /// <returns>ϊʂJSONIuWFNg</returns>
        public JavaScriptObject ToJSON(object o)
        {
            try
            {
                doc = (JavaScriptObject)CreateObjectElement(o, mType);
                
                return doc;
            }
            catch(Exception ex) {
                System.Diagnostics.Debug.WriteLine(ex.StackTrace);
            }
            finally
            {
            }
            return null;
        }
        /// <summary>
        /// IuWFNgċAIɏȂelementc[𐶐
        /// </summary>
        /// <param name="o">ΏۃIuWFNg</param>
        /// <param name="t">IuWFNg̒`^</param>
        /// <returns>ΏۃIuWFNg̕ϊ</returns>
        internal object CreateElementCore(object o,Type t)
        {

            if (o == null)
            {
                return null;
            }
            else if (o == DBNull.Value)
            {
                return null;
            }
            Type objectType = t;
            if (IsNullable(t))
            {
                objectType = t.GetGenericArguments()[0];
            }

            if (objectType.Name == "DateTime")
            {
                return o.ToString();
            }
            else if (objectType.Name == "String")
            {
                return o;
            }
            else if (objectType.Name == "Type")
            {
                return ((Type)o).FullName;
            }
            else if (objectType.IsEnum)
            {
                int i =(int) System.Convert.ChangeType(o, objectType);
                return i;
            }

            else if (objectType.IsPrimitive || objectType.IsValueType)
            {
                //TODO:objectɑ΂Č^ƒl킯ĕۑB
                if (objectType.Name == "Object")
                {
                    return CreateObjectElement(o, t);
                   

                }
                return o;
            }
            else
            {
                Type tt = o.GetType().GetInterface("System.Collections.ICollection");
                if (tt != null)
                {
                     return CreateArrayElement(o, t);
                }
                else
                {
                    return CreateObjectElement( o, t);
                }
            }

            
        }
        /// <summary>
        /// zAXgARNV
        /// </summary>
        /// <param name="o">zAXgARNV</param>
        /// <param name="t">zAXgARNV̌^</param>
        /// <returns>JSONArray</returns>
        private JavaScriptArray CreateArrayElement(object o, Type t)
        {
            JavaScriptArray element = new JavaScriptArray();
            if (o == null)
            {
                return element;
            }
            System.Collections.ICollection ic = (System.Collections.ICollection)o;
            System.Collections.IEnumerator e = ic.GetEnumerator();
            while (e.MoveNext())
            {
                Type childType = e.Current.GetType();
                object child = CreateElementCore(e.Current,childType);
                element.Add(child);
            }
            return element;
        }
        /// <summary>
        /// n^ł͂ȂIuWFNg
        /// </summary>
        /// <param name="o">ΏۃIuWFNg</param>
        /// <param name="t">ΏۃIuWFNg̒`^</param>
        /// <returns></returns>
        private JavaScriptObject CreateObjectElement(object o, Type t)
        {
            JavaScriptObject element = new JavaScriptObject();
            Type objectType = o.GetType();

            element.Add("__Type",o.GetType().FullName);
            if (objectType.Name =="String")
            {
                element.Add("__Value", o.ToString());
                return element;
            }
            if (objectType.Name == "DateTime")
            {
                element.Add("__Value", o.ToString());
                return element;
            }
            if (objectType.IsValueType || objectType.IsPrimitive)
            {
                element.Add("__Value", o.ToString());
                return element;
            }
            FieldInfo[] fis = objectType.GetFields();
            foreach (FieldInfo fi in fis)
            {
                object[] attrs = fi.GetCustomAttributes(typeof(JavaScriptSerializeIgnoreAttribute), true);
                if (attrs.Length > 0) continue;

                object childValue = fi.GetValue(o);
                Type childType = fi.FieldType;
                object child = CreateElementCore(childValue, childType);
                element.Add(fi.Name, child);
            }
            PropertyInfo[] pis = objectType.GetProperties();
            foreach (PropertyInfo pi in pis)
            {
                object[] attrs = pi.GetCustomAttributes(typeof(JavaScriptSerializeIgnoreAttribute), true);
                if (attrs.Length > 0) continue;

                object childValue = pi.GetValue(o,null);
                Type childType = pi.PropertyType;
                object child = CreateElementCore(childValue, childType);
                element.Add(pi.Name, child);
            }
            return element;
        }
        /// <summary>
        /// JSONIuWFNgC#IuWFNg𕜌
        /// </summary>
        /// <param name="doc">ƂJSONIuWFNg</param>
        /// <returns>IuWFNg</returns>
        public object FromJSON(JavaScriptObject doc)
        {
            object o = ParseObjectElement(doc,mType);


            return o;
        }
        /// <summary>
        /// n^ł͂ȂIuWFNg𕜌
        /// </summary>
        /// <param name="element">ΏJSONIuWFNg</param>
        /// <param name="t">IuWFNg̒`^</param>
        /// <returns>IuWFNg</returns>
        private object ParseObjectElement(JavaScriptObject element, Type t)
        {
            Type objectType;
            if (element.ContainsKey("__Type"))
            {
                string typeName = element["__Type"].ToString();
                objectType = this.GetType(typeName);
            }
            else
            {
                objectType = t;
            }
            if (objectType.Name == "String")
            {
                return ParseElementCore(element["__Value"], objectType);
            }
            if (objectType.IsValueType || objectType.IsPrimitive)
            {
                return ParseElementCore(element["__Value"],objectType);
            }

            object o = Activator.CreateInstance(objectType);
            Type tt = o.GetType();
            IEnumerator e = element.Keys.GetEnumerator();
            while(e.MoveNext())
            {

                FieldInfo fi = tt.GetField(e.Current.ToString());
                if (fi != null){
                    object[] attrs = fi.GetCustomAttributes(typeof(JavaScriptSerializeIgnoreAttribute), true);
                    if (attrs.Length > 0) continue;

                    object child = element[e.Current.ToString()];
                    object childObject = ParseElementCore(child,fi.FieldType);
                    fi.SetValue(o, childObject);
                    continue;
                }
                PropertyInfo pi = tt.GetProperty(e.Current.ToString());
                if (pi != null)
                {
                    object[] attrs = pi.GetCustomAttributes(typeof(JavaScriptSerializeIgnoreAttribute), true);
                    if (attrs.Length > 0) continue;

                    object child = element[e.Current.ToString()];
                    object childObject = ParseElementCore(child, pi.PropertyType);
                    pi.SetValue(o, childObject,null);
                    continue;
                }
            }
            return o;


        }
        /// <summary>
        /// ̒S
        /// </summary>
        /// <param name="element">Ώ</param>
        /// <param name="t">Ώۂ̒`^</param>
        /// <returns>IuWFNg܂͌n^f[^</returns>
        internal object ParseElementCore(object element,Type t)
        {
            Type objectType = t;
            bool isNullable = IsNullable(t);
            if (isNullable) objectType = t.GetGenericArguments()[0];


            if (element == null) return null;
            if (objectType == typeof(string))
            {
                
                return element.ToString();
            }
            
            if (objectType == typeof(int))
            {
                return  NumberUtil.IntValue(element);
            }
            if (objectType == typeof(byte))
            {
                return NumberUtil.ByteValue(element);
            }
            if (objectType == typeof(short))
            {
                return NumberUtil.ShortValue(element);
            }
            if (objectType == typeof(long))
            {
                return NumberUtil.LongValue(element);
            }
            if (objectType == typeof(bool))
            {
                return NumberUtil.BoolValue(element);
            }
            if (objectType == typeof(DateTime))
            {
                return Convert.ToDateTime(element);
            }
            if (objectType == typeof(decimal))
            {
                return NumberUtil.DecimalValue(element);
            }
            if (objectType == typeof(float))
            {
                return NumberUtil.FloatValue(element);
            }
            if (objectType == typeof(double))
            {
                return NumberUtil.DoubleValue(element);
            }
            if (objectType == typeof(Type))
            {
                return GetType(element.ToString());
            }
            if (t.IsEnum )
            {
                //enum̃o[ɕϊ鎖݂
                return Enum.Parse(t, element.ToString());
                //̂܂ܕԂ_Ȃ́H
                //return element;


            }
            if (t.IsPrimitive || t.IsValueType)
            {
                return element;
            }
            if (element is JavaScriptArray)
            {
                Type ilistType = objectType.GetInterface("System.Collections.IList");
                if (ilistType != null)
                {
                    if (objectType.IsArray)
                    {
                        return ParseArrayElement((JavaScriptArray)element, objectType);
                    }
                    if (objectType.IsGenericType)
                    {
                        return ParseListElement((JavaScriptArray)element, objectType);
                    }
                    System.Collections.IList dil = (System.Collections.IList)parseDefaultListElement((JavaScriptArray)element, objectType);
                    return dil;

                }
                return null;
            }
            if (element is JavaScriptObject)
            {
                return ParseObjectElement((JavaScriptObject)element, t);
            }

            return element.ToString();

        }
        /// <summary>
        /// z𕜌
        /// </summary>
        /// <param name="element">JSONz</param>
        /// <param name="t">ž^</param>
        /// <returns>z</returns>
        protected object ParseArrayElement(JavaScriptArray element, Type t)
        {

            Array a = (Array)Activator.CreateInstance(t, new object[] { element.Count });

            for (int i = 0; i < element.Count; i++)
            {
                object child = element[i];

                object childObject = ParseElementCore(child,child.GetType());
                a.SetValue(childObject, i);
            }
            return a;
        }
        /// <summary>
        /// Xg𕜌
        /// </summary>
        /// <param name="element">JSONz</param>
        /// <param name="t">郊Xǧ^</param>
        /// <returns>ꂽXg</returns>
        protected object ParseListElement(JavaScriptArray element, Type t)
        {
            Type d1 = typeof(List<>);
            Type d3 = t;
            Type d4 = d3.GetGenericTypeDefinition();
            Type[] typeArgs = t.GetGenericArguments();
            Type constructed = d1.MakeGenericType(typeArgs);

            System.Collections.IList il = (System.Collections.IList)Activator.CreateInstance(constructed);
            for (int i = 0; i < element.Count; i++)
            {
                object child = element[i];
                object childObject = ParseElementCore(child, child.GetType());

                constructed.InvokeMember("Add",BindingFlags.InvokeMethod,null,il,new object[]{childObject});
                
            }
            return il;
        }
        object parseDefaultListElement(JavaScriptArray element, Type t)
        {
            System.Collections.IList il = (System.Collections.IList)Activator.CreateInstance(t);
            for (int i = 0; i < element.Count; i++)
            {
                object child = element[i];
                object childObject = ParseElementCore(child, child.GetType());

                il.Add(childObject);
            }
            return il;



        }
        /// <summary>
        /// ^Cv^CvԂB
        /// 
        /// </summary>
        /// <param name="typeName"></param>
        /// <returns></returns>
        /// <remarks>
        /// PType.GetType()ł悳Ȃ̂Ȃ̂ɁAdllœƂɂ܂[hłȂB
        /// ŁAType.GetType()Ŏs猻݃[hĂAZuׂĂ^CvTB
        /// </remarks>
        private Type GetType(string typeName)
        {
            Type t = Type.GetType(typeName);
            if (t == null)
            {
                if(mTypeCache == null) mTypeCache = new List<Type>();

                for (int i = 0; i < mTypeCache.Count; i++)
                {
                    if (mTypeCache[i].FullName == typeName)
                    {
                        t = mTypeCache[i];

                        break;
                    }
                }

            }
            if (t == null)
            {
                AppDomain a = AppDomain.CurrentDomain;
                Assembly[] asms = a.GetAssemblies();
                for (int i = 0; i < asms.Length; i++)
                {
                    t = asms[i].GetType(typeName);

                    if (t != null)
                    {
                        mTypeCache.Add(t);
                        break;
                    }
                }
            }
            return t;
        }
        private string RootName(Type t)
        {
            string name = t.Name;
            if (name.IndexOf("`") >= 0) name = name.Replace("`", "_");

            return name;
        }

        /// <summary>
        /// ̃^CvNullableł邩
        /// </summary>
        /// <param name="type"></param>
        /// <returns></returns>
        bool IsNullable(Type type)
        {
            if (type.IsGenericType)
            {
                if (type.GetGenericTypeDefinition() ==
                    typeof(Nullable<>)) return true;
            }
            return false;
        }

    }
    /// <summary>
    /// VACYȂ(XmlIgnoreł܂Ȃ̂ŕsv)
    /// </summary>
    public class JavaScriptSerializeIgnoreAttribute : Attribute
    {

    }
}
