using System;
using System.Collections;
using System.Collections.Specialized;
using System.Collections.Generic;
using System.Text;

namespace OFW.Util
{
    /// <summary>
    /// R}hC
    /// </summary>
    public class CommandLineArgs
    {
        /// <summary>
        /// Ot
        /// </summary>
        List<KeyValuePair<string, string>> namedArguments;
        /// <summary>
        /// OȂ
        /// 
        /// ɑΏۃt@CƂ
        /// </summary>
        List<string> unnamedArguments;
        /// <summary>
        /// \z
        /// </summary>
        public CommandLineArgs()
        {
            namedArguments = new List<KeyValuePair<string, string>>();
            unnamedArguments = new List<string>();
        }
        /// <summary>
        /// 
        /// </summary>
        public void Parse()
        {
            string[] args = System.Environment.GetCommandLineArgs();
            for (int i = 1;i < args.Length;i++)
            {
                string arg = args[i];
                if (arg.StartsWith("/"))
                {
                    string[] kv = StringUtil.SplitKeyValue(arg, ":");
                    if (kv[0] == "") continue;
                    KeyValuePair<string, string> keyValue = new KeyValuePair<string, string>(kv[0], kv[1]);
                    this.namedArguments.Add(keyValue);
                }
                else
                {
                    this.unnamedArguments.Add(arg.Trim());
                }
            }

        }
        int IndexOf(string name)
        {
            int index = this.namedArguments.FindIndex(
                 delegate(KeyValuePair<string, string> kv)
                {
                    return (kv.Key == name);
                }
            );
            return index;
        }
        int IndexOf(string name, int start)
        {
            int index = this.namedArguments.FindIndex(start,
                 delegate(KeyValuePair<string, string> kv)
                 {
                     return (kv.Key == name);
                 }
                 
            );
            return index;
        }
        /// <summary>
        /// w̑݃`FbN
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        public bool ExistsName(string name)
        {
            return (IndexOf(name) >= 0);
        }
        /// <summary>
        /// w̒l擾
        /// </summary>
        /// <param name="name">w</param>
        /// <returns>wɊYl</returns>
        public string GetNamed(string name)
        {
            int index = IndexOf(name);
            if (index < 0) return "";
            return this.namedArguments[index].Value;
        }
        /// <summary>
        /// ÔȂ̒l擾
        /// </summary>
        /// <param name="index">ʒuw</param>
        /// <returns>wɊYl</returns>
        public string GetUnnamed(int index)
        {
            if (index < 0) return "";
            if (index > (this.unnamedArguments.Count - 1 )) return "";
            return this.unnamedArguments[index];
        }
        /// <summary>
        /// OȂ̐
        /// </summary>
        /// <returns>wɊYl</returns>
        public int GetUnnamedCount()
        {
            return this.unnamedArguments.Count;
        }
        /// <summary>
        /// w肳ꂽw̃Xg擾
        /// </summary>
        /// <param name="name"></param>
        /// <returns>wɊYSĂ̒l̃Xg</returns>
        public List<string> GetNamedList(string name)
        {
            List<string> list = new List<string>();
            //first
            int index = IndexOf(name,0);
            while (index >= 0)
            {
                list.Add(this.namedArguments[index].Value);

                //next
                index = IndexOf(name,index + 1);
            }
            return list;

        }
    }

}
