using System;
using System.Collections.Generic;
using System.Text;
using CFW.Forms;
using CFW.Forms.Filters;
using CFW.Util;
using CFW.Models;
using Sample.Data.Models.Base;

namespace Sample.Data.Windows.Forms.Adapters.Base
{
    /// <summary>
    /// table MAST_MANUSCRIPT Field`
    /// </summary>
    public class MastManuscriptTableFormAdapter : CFW.Forms.FormAdapter
	{
		private MastManuscriptTableRow theEntity;

		///<summary>[SITE_CODE]</summary>
		public FormAdapterElement siteCode;
		///<summary>[MENU_CODE]</summary>
		public FormAdapterElement menuCode;
		///<summary>[SEQ]</summary>
		public FormAdapterElement seq;
		///<summary>[FROM_DATE]</summary>
		public FormAdapterElement fromDate;
		///<summary>[END_DATE]</summary>
		public FormAdapterElement endDate;
		///<summary>[ADTYPE_CODE]</summary>
		public FormAdapterElement adtypeCode;
		///<summary>[AD_REPLACE_KIND]</summary>
		public FormAdapterElement adReplaceKind;
		///<summary>[AD_REPLACE_KIND_DIV]</summary>
		public FormAdapterElement adReplaceKindDiv;
		///<summary>[AD_REPLACE_KIND_SEQ]</summary>
		public FormAdapterElement adReplaceKindSeq;
		///<summary>[AD_REPLACE_REMARKS]</summary>
		public FormAdapterElement adReplaceRemarks;
		///<summary>[AD_REPLACE_PAY_FLAG]</summary>
		public FormAdapterElement adReplacePayFlag;
		///<summary>[SEND_AT_ONCE_KIND]</summary>
		public FormAdapterElement sendAtOnceKind;
		///<summary>[SEND_AT_ONCE_KIND_DIV]</summary>
		public FormAdapterElement sendAtOnceKindDiv;
		///<summary>[SEND_AT_ONCE_KIND_SEQ]</summary>
		public FormAdapterElement sendAtOnceKindSeq;
		///<summary>[SEND_AT_ONCE_REMARKS]</summary>
		public FormAdapterElement sendAtOnceRemarks;
		///<summary>[TOTAL_CAPACITY]</summary>
		public FormAdapterElement totalCapacity;
		///<summary>[TOTAL_CAPACITY_LIMIT]</summary>
		public FormAdapterElement totalCapacityLimit;
		///<summary>[TOTAL_CAPACITY_LIMIT_DIV]</summary>
		public FormAdapterElement totalCapacityLimitDiv;
		///<summary>[TOTAL_CAPACITY_LIMIT_SEQ]</summary>
		public FormAdapterElement totalCapacityLimitSeq;
		///<summary>[URL_COND_REMARKS]</summary>
		public FormAdapterElement urlCondRemarks;
		///<summary>[PHONETO_KIND]</summary>
		public FormAdapterElement phonetoKind;
		///<summary>[PHONETO_KIND_DIV]</summary>
		public FormAdapterElement phonetoKindDiv;
		///<summary>[PHONETO_KIND_SEQ]</summary>
		public FormAdapterElement phonetoKindSeq;
		///<summary>[MAILTO_KIND]</summary>
		public FormAdapterElement mailtoKind;
		///<summary>[MAILTO_KIND_DIV]</summary>
		public FormAdapterElement mailtoKindDiv;
		///<summary>[MAILTO_KIND_SEQ]</summary>
		public FormAdapterElement mailtoKindSeq;
		///<summary>[BADGE_FLAG]</summary>
		public FormAdapterElement badgeFlag;
		///<summary>[DEADLINE_DATE]</summary>
		public FormAdapterElement deadlineDate;
		///<summary>[DEADLINE_TIME]</summary>
		public FormAdapterElement deadlineTime;
		///<summary>[DEADLINE_REMARKS]</summary>
		public FormAdapterElement deadlineRemarks;
		///<summary>[DEADLINE2_DATE]</summary>
		public FormAdapterElement deadline2Date;
		///<summary>[DEADLINE2_TIME]</summary>
		public FormAdapterElement deadline2Time;
		///<summary>[DEADLINE2_REMARKS]</summary>
		public FormAdapterElement deadline2Remarks;
		///<summary>[CHECK_FLAG]</summary>
		public FormAdapterElement checkFlag;
		///<summary>[DOCUMENT_FLAG]</summary>
		public FormAdapterElement documentFlag;
		///<summary>[BROWSER_REMARKS]</summary>
		public FormAdapterElement browserRemarks;
		///<summary>[ADMISSION_FLAG]</summary>
		public FormAdapterElement admissionFlag;
		///<summary>[ADMISSION_MENU_CODE]</summary>
		public FormAdapterElement admissionMenuCode;
		///<summary>[PATTERN_REMARKS]</summary>
		public FormAdapterElement patternRemarks;
		///<summary>[PATTERN_CODE]</summary>
		public FormAdapterElement patternCode;
		///<summary>[REMARKS]</summary>
		public FormAdapterElement remarks;
		///<summary>[VALID_FLAG]</summary>
		public FormAdapterElement validFlag;
		///<summary>[INSERT_DATE_TIME]</summary>
		public FormAdapterElement insertDateTime;
		///<summary>[INSERT_OPERATOR_CODE]</summary>
		public FormAdapterElement insertOperatorCode;
		///<summary>[UPDATE_DATE_TIME]</summary>
		public FormAdapterElement updateDateTime;
		///<summary>[OPERATOR_CODE]</summary>
		public FormAdapterElement operatorCode;
		///<summary>[OLD_REMARKS]</summary>
		public FormAdapterElement oldRemarks;
		

		/// <summary>݂̃f[^\[X擾
		/// </summary>
        public override Entity GetEntity()
        {
            return this.theEntity;
        }
		/// <summary>\̍XV
		/// </summary>
        public override void RenderView()
        {
			if(this.siteCode != null) this.siteCode.Render();
			if(this.menuCode != null) this.menuCode.Render();
			if(this.seq != null) this.seq.Render();
			if(this.fromDate != null) this.fromDate.Render();
			if(this.endDate != null) this.endDate.Render();
			if(this.adtypeCode != null) this.adtypeCode.Render();
			if(this.adReplaceKind != null) this.adReplaceKind.Render();
			if(this.adReplaceKindDiv != null) this.adReplaceKindDiv.Render();
			if(this.adReplaceKindSeq != null) this.adReplaceKindSeq.Render();
			if(this.adReplaceRemarks != null) this.adReplaceRemarks.Render();
			if(this.adReplacePayFlag != null) this.adReplacePayFlag.Render();
			if(this.sendAtOnceKind != null) this.sendAtOnceKind.Render();
			if(this.sendAtOnceKindDiv != null) this.sendAtOnceKindDiv.Render();
			if(this.sendAtOnceKindSeq != null) this.sendAtOnceKindSeq.Render();
			if(this.sendAtOnceRemarks != null) this.sendAtOnceRemarks.Render();
			if(this.totalCapacity != null) this.totalCapacity.Render();
			if(this.totalCapacityLimit != null) this.totalCapacityLimit.Render();
			if(this.totalCapacityLimitDiv != null) this.totalCapacityLimitDiv.Render();
			if(this.totalCapacityLimitSeq != null) this.totalCapacityLimitSeq.Render();
			if(this.urlCondRemarks != null) this.urlCondRemarks.Render();
			if(this.phonetoKind != null) this.phonetoKind.Render();
			if(this.phonetoKindDiv != null) this.phonetoKindDiv.Render();
			if(this.phonetoKindSeq != null) this.phonetoKindSeq.Render();
			if(this.mailtoKind != null) this.mailtoKind.Render();
			if(this.mailtoKindDiv != null) this.mailtoKindDiv.Render();
			if(this.mailtoKindSeq != null) this.mailtoKindSeq.Render();
			if(this.badgeFlag != null) this.badgeFlag.Render();
			if(this.deadlineDate != null) this.deadlineDate.Render();
			if(this.deadlineTime != null) this.deadlineTime.Render();
			if(this.deadlineRemarks != null) this.deadlineRemarks.Render();
			if(this.deadline2Date != null) this.deadline2Date.Render();
			if(this.deadline2Time != null) this.deadline2Time.Render();
			if(this.deadline2Remarks != null) this.deadline2Remarks.Render();
			if(this.checkFlag != null) this.checkFlag.Render();
			if(this.documentFlag != null) this.documentFlag.Render();
			if(this.browserRemarks != null) this.browserRemarks.Render();
			if(this.admissionFlag != null) this.admissionFlag.Render();
			if(this.admissionMenuCode != null) this.admissionMenuCode.Render();
			if(this.patternRemarks != null) this.patternRemarks.Render();
			if(this.patternCode != null) this.patternCode.Render();
			if(this.remarks != null) this.remarks.Render();
			if(this.validFlag != null) this.validFlag.Render();
			if(this.insertDateTime != null) this.insertDateTime.Render();
			if(this.insertOperatorCode != null) this.insertOperatorCode.Render();
			if(this.updateDateTime != null) this.updateDateTime.Render();
			if(this.operatorCode != null) this.operatorCode.Render();
			if(this.oldRemarks != null) this.oldRemarks.Render();
			
        }

		/// <summary>̃A_v^[f[^ݒ
		/// </summary>
        /// <param name="dataSource">̃A_v^[f[^</param>
        public override void SetEntity(Entity entity)
        {
        	this.theEntity = (MastManuscriptTableRow)entity;
			if(this.siteCode != null) this.siteCode.SetValue(this.theEntity.siteCode);
			if(this.menuCode != null) this.menuCode.SetValue(this.theEntity.menuCode);
			if(this.seq != null) this.seq.SetValue(this.theEntity.seq);
			if(this.fromDate != null) this.fromDate.SetValue(this.theEntity.fromDate);
			if(this.endDate != null) this.endDate.SetValue(this.theEntity.endDate);
			if(this.adtypeCode != null) this.adtypeCode.SetValue(this.theEntity.adtypeCode);
			if(this.adReplaceKind != null) this.adReplaceKind.SetValue(this.theEntity.adReplaceKind);
			if(this.adReplaceKindDiv != null) this.adReplaceKindDiv.SetValue(this.theEntity.adReplaceKindDiv);
			if(this.adReplaceKindSeq != null) this.adReplaceKindSeq.SetValue(this.theEntity.adReplaceKindSeq);
			if(this.adReplaceRemarks != null) this.adReplaceRemarks.SetValue(this.theEntity.adReplaceRemarks);
			if(this.adReplacePayFlag != null) this.adReplacePayFlag.SetValue(this.theEntity.adReplacePayFlag);
			if(this.sendAtOnceKind != null) this.sendAtOnceKind.SetValue(this.theEntity.sendAtOnceKind);
			if(this.sendAtOnceKindDiv != null) this.sendAtOnceKindDiv.SetValue(this.theEntity.sendAtOnceKindDiv);
			if(this.sendAtOnceKindSeq != null) this.sendAtOnceKindSeq.SetValue(this.theEntity.sendAtOnceKindSeq);
			if(this.sendAtOnceRemarks != null) this.sendAtOnceRemarks.SetValue(this.theEntity.sendAtOnceRemarks);
			if(this.totalCapacity != null) this.totalCapacity.SetValue(this.theEntity.totalCapacity);
			if(this.totalCapacityLimit != null) this.totalCapacityLimit.SetValue(this.theEntity.totalCapacityLimit);
			if(this.totalCapacityLimitDiv != null) this.totalCapacityLimitDiv.SetValue(this.theEntity.totalCapacityLimitDiv);
			if(this.totalCapacityLimitSeq != null) this.totalCapacityLimitSeq.SetValue(this.theEntity.totalCapacityLimitSeq);
			if(this.urlCondRemarks != null) this.urlCondRemarks.SetValue(this.theEntity.urlCondRemarks);
			if(this.phonetoKind != null) this.phonetoKind.SetValue(this.theEntity.phonetoKind);
			if(this.phonetoKindDiv != null) this.phonetoKindDiv.SetValue(this.theEntity.phonetoKindDiv);
			if(this.phonetoKindSeq != null) this.phonetoKindSeq.SetValue(this.theEntity.phonetoKindSeq);
			if(this.mailtoKind != null) this.mailtoKind.SetValue(this.theEntity.mailtoKind);
			if(this.mailtoKindDiv != null) this.mailtoKindDiv.SetValue(this.theEntity.mailtoKindDiv);
			if(this.mailtoKindSeq != null) this.mailtoKindSeq.SetValue(this.theEntity.mailtoKindSeq);
			if(this.badgeFlag != null) this.badgeFlag.SetValue(this.theEntity.badgeFlag);
			if(this.deadlineDate != null) this.deadlineDate.SetValue(this.theEntity.deadlineDate);
			if(this.deadlineTime != null) this.deadlineTime.SetValue(this.theEntity.deadlineTime);
			if(this.deadlineRemarks != null) this.deadlineRemarks.SetValue(this.theEntity.deadlineRemarks);
			if(this.deadline2Date != null) this.deadline2Date.SetValue(this.theEntity.deadline2Date);
			if(this.deadline2Time != null) this.deadline2Time.SetValue(this.theEntity.deadline2Time);
			if(this.deadline2Remarks != null) this.deadline2Remarks.SetValue(this.theEntity.deadline2Remarks);
			if(this.checkFlag != null) this.checkFlag.SetValue(this.theEntity.checkFlag);
			if(this.documentFlag != null) this.documentFlag.SetValue(this.theEntity.documentFlag);
			if(this.browserRemarks != null) this.browserRemarks.SetValue(this.theEntity.browserRemarks);
			if(this.admissionFlag != null) this.admissionFlag.SetValue(this.theEntity.admissionFlag);
			if(this.admissionMenuCode != null) this.admissionMenuCode.SetValue(this.theEntity.admissionMenuCode);
			if(this.patternRemarks != null) this.patternRemarks.SetValue(this.theEntity.patternRemarks);
			if(this.patternCode != null) this.patternCode.SetValue(this.theEntity.patternCode);
			if(this.remarks != null) this.remarks.SetValue(this.theEntity.remarks);
			if(this.validFlag != null) this.validFlag.SetValue(this.theEntity.validFlag);
			if(this.insertDateTime != null) this.insertDateTime.SetValue(this.theEntity.insertDateTime);
			if(this.insertOperatorCode != null) this.insertOperatorCode.SetValue(this.theEntity.insertOperatorCode);
			if(this.updateDateTime != null) this.updateDateTime.SetValue(this.theEntity.updateDateTime);
			if(this.operatorCode != null) this.operatorCode.SetValue(this.theEntity.operatorCode);
			if(this.oldRemarks != null) this.oldRemarks.SetValue(this.theEntity.oldRemarks);
			

        }

		/// <summary>UI͂ꂽef[^\[XɎ荞
		/// </summary>
        public override void UpdateEntity()
        {
			if(this.siteCode != null) this.theEntity.siteCode = StringUtil.StringValue(this.siteCode.GetValue());
			if(this.menuCode != null) this.theEntity.menuCode = StringUtil.StringValue(this.menuCode.GetValue());
			if(this.seq != null) this.theEntity.seq = NumberUtil.Value<Int16>(this.seq.GetValue());
			if(this.fromDate != null) this.theEntity.fromDate = StringUtil.StringValue(this.fromDate.GetValue());
			if(this.endDate != null) this.theEntity.endDate = StringUtil.StringValue(this.endDate.GetValue());
			if(this.adtypeCode != null) this.theEntity.adtypeCode = StringUtil.StringValue(this.adtypeCode.GetValue());
			if(this.adReplaceKind != null) this.theEntity.adReplaceKind = StringUtil.StringValue(this.adReplaceKind.GetValue());
			if(this.adReplaceKindDiv != null) this.theEntity.adReplaceKindDiv = NumberUtil.Value<Int16?>(this.adReplaceKindDiv.GetValue());
			if(this.adReplaceKindSeq != null) this.theEntity.adReplaceKindSeq = NumberUtil.Value<Int16?>(this.adReplaceKindSeq.GetValue());
			if(this.adReplaceRemarks != null) this.theEntity.adReplaceRemarks = StringUtil.StringValue(this.adReplaceRemarks.GetValue());
			if(this.adReplacePayFlag != null) this.theEntity.adReplacePayFlag = NumberUtil.Value<Int16?>(this.adReplacePayFlag.GetValue());
			if(this.sendAtOnceKind != null) this.theEntity.sendAtOnceKind = StringUtil.StringValue(this.sendAtOnceKind.GetValue());
			if(this.sendAtOnceKindDiv != null) this.theEntity.sendAtOnceKindDiv = NumberUtil.Value<Int16?>(this.sendAtOnceKindDiv.GetValue());
			if(this.sendAtOnceKindSeq != null) this.theEntity.sendAtOnceKindSeq = NumberUtil.Value<Int16?>(this.sendAtOnceKindSeq.GetValue());
			if(this.sendAtOnceRemarks != null) this.theEntity.sendAtOnceRemarks = StringUtil.StringValue(this.sendAtOnceRemarks.GetValue());
			if(this.totalCapacity != null) this.theEntity.totalCapacity = NumberUtil.Value<Decimal?>(this.totalCapacity.GetValue());
			if(this.totalCapacityLimit != null) this.theEntity.totalCapacityLimit = StringUtil.StringValue(this.totalCapacityLimit.GetValue());
			if(this.totalCapacityLimitDiv != null) this.theEntity.totalCapacityLimitDiv = NumberUtil.Value<Int16?>(this.totalCapacityLimitDiv.GetValue());
			if(this.totalCapacityLimitSeq != null) this.theEntity.totalCapacityLimitSeq = NumberUtil.Value<Int16?>(this.totalCapacityLimitSeq.GetValue());
			if(this.urlCondRemarks != null) this.theEntity.urlCondRemarks = StringUtil.StringValue(this.urlCondRemarks.GetValue());
			if(this.phonetoKind != null) this.theEntity.phonetoKind = StringUtil.StringValue(this.phonetoKind.GetValue());
			if(this.phonetoKindDiv != null) this.theEntity.phonetoKindDiv = NumberUtil.Value<Int16?>(this.phonetoKindDiv.GetValue());
			if(this.phonetoKindSeq != null) this.theEntity.phonetoKindSeq = NumberUtil.Value<Int16?>(this.phonetoKindSeq.GetValue());
			if(this.mailtoKind != null) this.theEntity.mailtoKind = StringUtil.StringValue(this.mailtoKind.GetValue());
			if(this.mailtoKindDiv != null) this.theEntity.mailtoKindDiv = NumberUtil.Value<Int16?>(this.mailtoKindDiv.GetValue());
			if(this.mailtoKindSeq != null) this.theEntity.mailtoKindSeq = NumberUtil.Value<Int16?>(this.mailtoKindSeq.GetValue());
			if(this.badgeFlag != null) this.theEntity.badgeFlag = NumberUtil.Value<Int16?>(this.badgeFlag.GetValue());
			if(this.deadlineDate != null) this.theEntity.deadlineDate = StringUtil.StringValue(this.deadlineDate.GetValue());
			if(this.deadlineTime != null) this.theEntity.deadlineTime = StringUtil.StringValue(this.deadlineTime.GetValue());
			if(this.deadlineRemarks != null) this.theEntity.deadlineRemarks = StringUtil.StringValue(this.deadlineRemarks.GetValue());
			if(this.deadline2Date != null) this.theEntity.deadline2Date = StringUtil.StringValue(this.deadline2Date.GetValue());
			if(this.deadline2Time != null) this.theEntity.deadline2Time = StringUtil.StringValue(this.deadline2Time.GetValue());
			if(this.deadline2Remarks != null) this.theEntity.deadline2Remarks = StringUtil.StringValue(this.deadline2Remarks.GetValue());
			if(this.checkFlag != null) this.theEntity.checkFlag = NumberUtil.Value<Int16?>(this.checkFlag.GetValue());
			if(this.documentFlag != null) this.theEntity.documentFlag = NumberUtil.Value<Int16?>(this.documentFlag.GetValue());
			if(this.browserRemarks != null) this.theEntity.browserRemarks = StringUtil.StringValue(this.browserRemarks.GetValue());
			if(this.admissionFlag != null) this.theEntity.admissionFlag = NumberUtil.Value<Int16?>(this.admissionFlag.GetValue());
			if(this.admissionMenuCode != null) this.theEntity.admissionMenuCode = StringUtil.StringValue(this.admissionMenuCode.GetValue());
			if(this.patternRemarks != null) this.theEntity.patternRemarks = StringUtil.StringValue(this.patternRemarks.GetValue());
			if(this.patternCode != null) this.theEntity.patternCode = StringUtil.StringValue(this.patternCode.GetValue());
			if(this.remarks != null) this.theEntity.remarks = StringUtil.StringValue(this.remarks.GetValue());
			if(this.validFlag != null) this.theEntity.validFlag = NumberUtil.Value<Int16?>(this.validFlag.GetValue());
			if(this.insertDateTime != null) this.theEntity.insertDateTime = DateUtil.DateValue(this.insertDateTime.GetValue());
			if(this.insertOperatorCode != null) this.theEntity.insertOperatorCode = StringUtil.StringValue(this.insertOperatorCode.GetValue());
			if(this.updateDateTime != null) this.theEntity.updateDateTime = DateUtil.DateValue(this.updateDateTime.GetValue());
			if(this.operatorCode != null) this.theEntity.operatorCode = StringUtil.StringValue(this.operatorCode.GetValue());
			if(this.oldRemarks != null) this.theEntity.oldRemarks = StringUtil.StringValue(this.oldRemarks.GetValue());
			
        }

		/// <summary>UI͂ꂽe荞
		/// </summary>
        public override void UpdateFields()
        {
			if(this.siteCode != null) this.siteCode.UpdateField();
			if(this.menuCode != null) this.menuCode.UpdateField();
			if(this.seq != null) this.seq.UpdateField();
			if(this.fromDate != null) this.fromDate.UpdateField();
			if(this.endDate != null) this.endDate.UpdateField();
			if(this.adtypeCode != null) this.adtypeCode.UpdateField();
			if(this.adReplaceKind != null) this.adReplaceKind.UpdateField();
			if(this.adReplaceKindDiv != null) this.adReplaceKindDiv.UpdateField();
			if(this.adReplaceKindSeq != null) this.adReplaceKindSeq.UpdateField();
			if(this.adReplaceRemarks != null) this.adReplaceRemarks.UpdateField();
			if(this.adReplacePayFlag != null) this.adReplacePayFlag.UpdateField();
			if(this.sendAtOnceKind != null) this.sendAtOnceKind.UpdateField();
			if(this.sendAtOnceKindDiv != null) this.sendAtOnceKindDiv.UpdateField();
			if(this.sendAtOnceKindSeq != null) this.sendAtOnceKindSeq.UpdateField();
			if(this.sendAtOnceRemarks != null) this.sendAtOnceRemarks.UpdateField();
			if(this.totalCapacity != null) this.totalCapacity.UpdateField();
			if(this.totalCapacityLimit != null) this.totalCapacityLimit.UpdateField();
			if(this.totalCapacityLimitDiv != null) this.totalCapacityLimitDiv.UpdateField();
			if(this.totalCapacityLimitSeq != null) this.totalCapacityLimitSeq.UpdateField();
			if(this.urlCondRemarks != null) this.urlCondRemarks.UpdateField();
			if(this.phonetoKind != null) this.phonetoKind.UpdateField();
			if(this.phonetoKindDiv != null) this.phonetoKindDiv.UpdateField();
			if(this.phonetoKindSeq != null) this.phonetoKindSeq.UpdateField();
			if(this.mailtoKind != null) this.mailtoKind.UpdateField();
			if(this.mailtoKindDiv != null) this.mailtoKindDiv.UpdateField();
			if(this.mailtoKindSeq != null) this.mailtoKindSeq.UpdateField();
			if(this.badgeFlag != null) this.badgeFlag.UpdateField();
			if(this.deadlineDate != null) this.deadlineDate.UpdateField();
			if(this.deadlineTime != null) this.deadlineTime.UpdateField();
			if(this.deadlineRemarks != null) this.deadlineRemarks.UpdateField();
			if(this.deadline2Date != null) this.deadline2Date.UpdateField();
			if(this.deadline2Time != null) this.deadline2Time.UpdateField();
			if(this.deadline2Remarks != null) this.deadline2Remarks.UpdateField();
			if(this.checkFlag != null) this.checkFlag.UpdateField();
			if(this.documentFlag != null) this.documentFlag.UpdateField();
			if(this.browserRemarks != null) this.browserRemarks.UpdateField();
			if(this.admissionFlag != null) this.admissionFlag.UpdateField();
			if(this.admissionMenuCode != null) this.admissionMenuCode.UpdateField();
			if(this.patternRemarks != null) this.patternRemarks.UpdateField();
			if(this.patternCode != null) this.patternCode.UpdateField();
			if(this.remarks != null) this.remarks.UpdateField();
			if(this.validFlag != null) this.validFlag.UpdateField();
			if(this.insertDateTime != null) this.insertDateTime.UpdateField();
			if(this.insertOperatorCode != null) this.insertOperatorCode.UpdateField();
			if(this.updateDateTime != null) this.updateDateTime.UpdateField();
			if(this.operatorCode != null) this.operatorCode.UpdateField();
			if(this.oldRemarks != null) this.oldRemarks.UpdateField();
			
        }

		/// <summary>͓e؂
		/// ؃G[MessagesXgɑSẴG[B
		/// </summary>
        public override bool Validate()
        {
            bool valid = true;
			
			if(this.siteCode != null){
			    if(!this.siteCode.Validate()){
				    valid = false;
				    this.messages.Add(this.siteCode.ErrorMessage);
			    }
			}
			
			if(this.menuCode != null){
			    if(!this.menuCode.Validate()){
				    valid = false;
				    this.messages.Add(this.menuCode.ErrorMessage);
			    }
			}
			
			if(this.seq != null){
			    if(!this.seq.Validate()){
				    valid = false;
				    this.messages.Add(this.seq.ErrorMessage);
			    }
			}
			
			if(this.fromDate != null){
			    if(!this.fromDate.Validate()){
				    valid = false;
				    this.messages.Add(this.fromDate.ErrorMessage);
			    }
			}
			
			if(this.endDate != null){
			    if(!this.endDate.Validate()){
				    valid = false;
				    this.messages.Add(this.endDate.ErrorMessage);
			    }
			}
			
			if(this.adtypeCode != null){
			    if(!this.adtypeCode.Validate()){
				    valid = false;
				    this.messages.Add(this.adtypeCode.ErrorMessage);
			    }
			}
			
			if(this.adReplaceKind != null){
			    if(!this.adReplaceKind.Validate()){
				    valid = false;
				    this.messages.Add(this.adReplaceKind.ErrorMessage);
			    }
			}
			
			if(this.adReplaceKindDiv != null){
			    if(!this.adReplaceKindDiv.Validate()){
				    valid = false;
				    this.messages.Add(this.adReplaceKindDiv.ErrorMessage);
			    }
			}
			
			if(this.adReplaceKindSeq != null){
			    if(!this.adReplaceKindSeq.Validate()){
				    valid = false;
				    this.messages.Add(this.adReplaceKindSeq.ErrorMessage);
			    }
			}
			
			if(this.adReplaceRemarks != null){
			    if(!this.adReplaceRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.adReplaceRemarks.ErrorMessage);
			    }
			}
			
			if(this.adReplacePayFlag != null){
			    if(!this.adReplacePayFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.adReplacePayFlag.ErrorMessage);
			    }
			}
			
			if(this.sendAtOnceKind != null){
			    if(!this.sendAtOnceKind.Validate()){
				    valid = false;
				    this.messages.Add(this.sendAtOnceKind.ErrorMessage);
			    }
			}
			
			if(this.sendAtOnceKindDiv != null){
			    if(!this.sendAtOnceKindDiv.Validate()){
				    valid = false;
				    this.messages.Add(this.sendAtOnceKindDiv.ErrorMessage);
			    }
			}
			
			if(this.sendAtOnceKindSeq != null){
			    if(!this.sendAtOnceKindSeq.Validate()){
				    valid = false;
				    this.messages.Add(this.sendAtOnceKindSeq.ErrorMessage);
			    }
			}
			
			if(this.sendAtOnceRemarks != null){
			    if(!this.sendAtOnceRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.sendAtOnceRemarks.ErrorMessage);
			    }
			}
			
			if(this.totalCapacity != null){
			    if(!this.totalCapacity.Validate()){
				    valid = false;
				    this.messages.Add(this.totalCapacity.ErrorMessage);
			    }
			}
			
			if(this.totalCapacityLimit != null){
			    if(!this.totalCapacityLimit.Validate()){
				    valid = false;
				    this.messages.Add(this.totalCapacityLimit.ErrorMessage);
			    }
			}
			
			if(this.totalCapacityLimitDiv != null){
			    if(!this.totalCapacityLimitDiv.Validate()){
				    valid = false;
				    this.messages.Add(this.totalCapacityLimitDiv.ErrorMessage);
			    }
			}
			
			if(this.totalCapacityLimitSeq != null){
			    if(!this.totalCapacityLimitSeq.Validate()){
				    valid = false;
				    this.messages.Add(this.totalCapacityLimitSeq.ErrorMessage);
			    }
			}
			
			if(this.urlCondRemarks != null){
			    if(!this.urlCondRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.urlCondRemarks.ErrorMessage);
			    }
			}
			
			if(this.phonetoKind != null){
			    if(!this.phonetoKind.Validate()){
				    valid = false;
				    this.messages.Add(this.phonetoKind.ErrorMessage);
			    }
			}
			
			if(this.phonetoKindDiv != null){
			    if(!this.phonetoKindDiv.Validate()){
				    valid = false;
				    this.messages.Add(this.phonetoKindDiv.ErrorMessage);
			    }
			}
			
			if(this.phonetoKindSeq != null){
			    if(!this.phonetoKindSeq.Validate()){
				    valid = false;
				    this.messages.Add(this.phonetoKindSeq.ErrorMessage);
			    }
			}
			
			if(this.mailtoKind != null){
			    if(!this.mailtoKind.Validate()){
				    valid = false;
				    this.messages.Add(this.mailtoKind.ErrorMessage);
			    }
			}
			
			if(this.mailtoKindDiv != null){
			    if(!this.mailtoKindDiv.Validate()){
				    valid = false;
				    this.messages.Add(this.mailtoKindDiv.ErrorMessage);
			    }
			}
			
			if(this.mailtoKindSeq != null){
			    if(!this.mailtoKindSeq.Validate()){
				    valid = false;
				    this.messages.Add(this.mailtoKindSeq.ErrorMessage);
			    }
			}
			
			if(this.badgeFlag != null){
			    if(!this.badgeFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.badgeFlag.ErrorMessage);
			    }
			}
			
			if(this.deadlineDate != null){
			    if(!this.deadlineDate.Validate()){
				    valid = false;
				    this.messages.Add(this.deadlineDate.ErrorMessage);
			    }
			}
			
			if(this.deadlineTime != null){
			    if(!this.deadlineTime.Validate()){
				    valid = false;
				    this.messages.Add(this.deadlineTime.ErrorMessage);
			    }
			}
			
			if(this.deadlineRemarks != null){
			    if(!this.deadlineRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.deadlineRemarks.ErrorMessage);
			    }
			}
			
			if(this.deadline2Date != null){
			    if(!this.deadline2Date.Validate()){
				    valid = false;
				    this.messages.Add(this.deadline2Date.ErrorMessage);
			    }
			}
			
			if(this.deadline2Time != null){
			    if(!this.deadline2Time.Validate()){
				    valid = false;
				    this.messages.Add(this.deadline2Time.ErrorMessage);
			    }
			}
			
			if(this.deadline2Remarks != null){
			    if(!this.deadline2Remarks.Validate()){
				    valid = false;
				    this.messages.Add(this.deadline2Remarks.ErrorMessage);
			    }
			}
			
			if(this.checkFlag != null){
			    if(!this.checkFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.checkFlag.ErrorMessage);
			    }
			}
			
			if(this.documentFlag != null){
			    if(!this.documentFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.documentFlag.ErrorMessage);
			    }
			}
			
			if(this.browserRemarks != null){
			    if(!this.browserRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.browserRemarks.ErrorMessage);
			    }
			}
			
			if(this.admissionFlag != null){
			    if(!this.admissionFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.admissionFlag.ErrorMessage);
			    }
			}
			
			if(this.admissionMenuCode != null){
			    if(!this.admissionMenuCode.Validate()){
				    valid = false;
				    this.messages.Add(this.admissionMenuCode.ErrorMessage);
			    }
			}
			
			if(this.patternRemarks != null){
			    if(!this.patternRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.patternRemarks.ErrorMessage);
			    }
			}
			
			if(this.patternCode != null){
			    if(!this.patternCode.Validate()){
				    valid = false;
				    this.messages.Add(this.patternCode.ErrorMessage);
			    }
			}
			
			if(this.remarks != null){
			    if(!this.remarks.Validate()){
				    valid = false;
				    this.messages.Add(this.remarks.ErrorMessage);
			    }
			}
			
			if(this.validFlag != null){
			    if(!this.validFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.validFlag.ErrorMessage);
			    }
			}
			
			if(this.insertDateTime != null){
			    if(!this.insertDateTime.Validate()){
				    valid = false;
				    this.messages.Add(this.insertDateTime.ErrorMessage);
			    }
			}
			
			if(this.insertOperatorCode != null){
			    if(!this.insertOperatorCode.Validate()){
				    valid = false;
				    this.messages.Add(this.insertOperatorCode.ErrorMessage);
			    }
			}
			
			if(this.updateDateTime != null){
			    if(!this.updateDateTime.Validate()){
				    valid = false;
				    this.messages.Add(this.updateDateTime.ErrorMessage);
			    }
			}
			
			if(this.operatorCode != null){
			    if(!this.operatorCode.Validate()){
				    valid = false;
				    this.messages.Add(this.operatorCode.ErrorMessage);
			    }
			}
			
			if(this.oldRemarks != null){
			    if(!this.oldRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.oldRemarks.ErrorMessage);
			    }
			}
			

            return valid;
        }
		
	}
/* 
    // initialize code sample
    // Form̃o[ɈȉǉB
    //     private MastManuscriptFormAdapter formAdapter;
    //     private MastManuscriptProperty property;
    //     private MastManuscriptEntity property;
    // tB[hƓ̓Rg[킹B
    // 2(tB^[)͓KXtB[hɍ킹ĕύX
    formAdapter = new MastManuscriptFormAdapter();

	
    formAdapter.siteCode= new TextBoxAdapterElement(
        siteCode,
        new CFW.Forms.Filters.StringFilter(property.siteCode),
        CFW.Validators.FieldValidator.GetInstance(property.siteCode)
    );
	
    formAdapter.menuCode= new TextBoxAdapterElement(
        menuCode,
        new CFW.Forms.Filters.StringFilter(property.menuCode),
        CFW.Validators.FieldValidator.GetInstance(property.menuCode)
    );
	
    formAdapter.seq= new TextBoxAdapterElement(
        seq,
        new CFW.Forms.Filters.StringFilter(property.seq),
        CFW.Validators.FieldValidator.GetInstance(property.seq)
    );
	
    formAdapter.fromDate= new TextBoxAdapterElement(
        fromDate,
        new CFW.Forms.Filters.StringFilter(property.fromDate),
        CFW.Validators.FieldValidator.GetInstance(property.fromDate)
    );
	
    formAdapter.endDate= new TextBoxAdapterElement(
        endDate,
        new CFW.Forms.Filters.StringFilter(property.endDate),
        CFW.Validators.FieldValidator.GetInstance(property.endDate)
    );
	
    formAdapter.adtypeCode= new TextBoxAdapterElement(
        adtypeCode,
        new CFW.Forms.Filters.StringFilter(property.adtypeCode),
        CFW.Validators.FieldValidator.GetInstance(property.adtypeCode)
    );
	
    formAdapter.adReplaceKind= new TextBoxAdapterElement(
        adReplaceKind,
        new CFW.Forms.Filters.StringFilter(property.adReplaceKind),
        CFW.Validators.FieldValidator.GetInstance(property.adReplaceKind)
    );
	
    formAdapter.adReplaceKindDiv= new TextBoxAdapterElement(
        adReplaceKindDiv,
        new CFW.Forms.Filters.StringFilter(property.adReplaceKindDiv),
        CFW.Validators.FieldValidator.GetInstance(property.adReplaceKindDiv)
    );
	
    formAdapter.adReplaceKindSeq= new TextBoxAdapterElement(
        adReplaceKindSeq,
        new CFW.Forms.Filters.StringFilter(property.adReplaceKindSeq),
        CFW.Validators.FieldValidator.GetInstance(property.adReplaceKindSeq)
    );
	
    formAdapter.adReplaceRemarks= new TextBoxAdapterElement(
        adReplaceRemarks,
        new CFW.Forms.Filters.StringFilter(property.adReplaceRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.adReplaceRemarks)
    );
	
    formAdapter.adReplacePayFlag= new TextBoxAdapterElement(
        adReplacePayFlag,
        new CFW.Forms.Filters.StringFilter(property.adReplacePayFlag),
        CFW.Validators.FieldValidator.GetInstance(property.adReplacePayFlag)
    );
	
    formAdapter.sendAtOnceKind= new TextBoxAdapterElement(
        sendAtOnceKind,
        new CFW.Forms.Filters.StringFilter(property.sendAtOnceKind),
        CFW.Validators.FieldValidator.GetInstance(property.sendAtOnceKind)
    );
	
    formAdapter.sendAtOnceKindDiv= new TextBoxAdapterElement(
        sendAtOnceKindDiv,
        new CFW.Forms.Filters.StringFilter(property.sendAtOnceKindDiv),
        CFW.Validators.FieldValidator.GetInstance(property.sendAtOnceKindDiv)
    );
	
    formAdapter.sendAtOnceKindSeq= new TextBoxAdapterElement(
        sendAtOnceKindSeq,
        new CFW.Forms.Filters.StringFilter(property.sendAtOnceKindSeq),
        CFW.Validators.FieldValidator.GetInstance(property.sendAtOnceKindSeq)
    );
	
    formAdapter.sendAtOnceRemarks= new TextBoxAdapterElement(
        sendAtOnceRemarks,
        new CFW.Forms.Filters.StringFilter(property.sendAtOnceRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.sendAtOnceRemarks)
    );
	
    formAdapter.totalCapacity= new TextBoxAdapterElement(
        totalCapacity,
        new CFW.Forms.Filters.StringFilter(property.totalCapacity),
        CFW.Validators.FieldValidator.GetInstance(property.totalCapacity)
    );
	
    formAdapter.totalCapacityLimit= new TextBoxAdapterElement(
        totalCapacityLimit,
        new CFW.Forms.Filters.StringFilter(property.totalCapacityLimit),
        CFW.Validators.FieldValidator.GetInstance(property.totalCapacityLimit)
    );
	
    formAdapter.totalCapacityLimitDiv= new TextBoxAdapterElement(
        totalCapacityLimitDiv,
        new CFW.Forms.Filters.StringFilter(property.totalCapacityLimitDiv),
        CFW.Validators.FieldValidator.GetInstance(property.totalCapacityLimitDiv)
    );
	
    formAdapter.totalCapacityLimitSeq= new TextBoxAdapterElement(
        totalCapacityLimitSeq,
        new CFW.Forms.Filters.StringFilter(property.totalCapacityLimitSeq),
        CFW.Validators.FieldValidator.GetInstance(property.totalCapacityLimitSeq)
    );
	
    formAdapter.urlCondRemarks= new TextBoxAdapterElement(
        urlCondRemarks,
        new CFW.Forms.Filters.StringFilter(property.urlCondRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.urlCondRemarks)
    );
	
    formAdapter.phonetoKind= new TextBoxAdapterElement(
        phonetoKind,
        new CFW.Forms.Filters.StringFilter(property.phonetoKind),
        CFW.Validators.FieldValidator.GetInstance(property.phonetoKind)
    );
	
    formAdapter.phonetoKindDiv= new TextBoxAdapterElement(
        phonetoKindDiv,
        new CFW.Forms.Filters.StringFilter(property.phonetoKindDiv),
        CFW.Validators.FieldValidator.GetInstance(property.phonetoKindDiv)
    );
	
    formAdapter.phonetoKindSeq= new TextBoxAdapterElement(
        phonetoKindSeq,
        new CFW.Forms.Filters.StringFilter(property.phonetoKindSeq),
        CFW.Validators.FieldValidator.GetInstance(property.phonetoKindSeq)
    );
	
    formAdapter.mailtoKind= new TextBoxAdapterElement(
        mailtoKind,
        new CFW.Forms.Filters.StringFilter(property.mailtoKind),
        CFW.Validators.FieldValidator.GetInstance(property.mailtoKind)
    );
	
    formAdapter.mailtoKindDiv= new TextBoxAdapterElement(
        mailtoKindDiv,
        new CFW.Forms.Filters.StringFilter(property.mailtoKindDiv),
        CFW.Validators.FieldValidator.GetInstance(property.mailtoKindDiv)
    );
	
    formAdapter.mailtoKindSeq= new TextBoxAdapterElement(
        mailtoKindSeq,
        new CFW.Forms.Filters.StringFilter(property.mailtoKindSeq),
        CFW.Validators.FieldValidator.GetInstance(property.mailtoKindSeq)
    );
	
    formAdapter.badgeFlag= new TextBoxAdapterElement(
        badgeFlag,
        new CFW.Forms.Filters.StringFilter(property.badgeFlag),
        CFW.Validators.FieldValidator.GetInstance(property.badgeFlag)
    );
	
    formAdapter.deadlineDate= new TextBoxAdapterElement(
        deadlineDate,
        new CFW.Forms.Filters.StringFilter(property.deadlineDate),
        CFW.Validators.FieldValidator.GetInstance(property.deadlineDate)
    );
	
    formAdapter.deadlineTime= new TextBoxAdapterElement(
        deadlineTime,
        new CFW.Forms.Filters.StringFilter(property.deadlineTime),
        CFW.Validators.FieldValidator.GetInstance(property.deadlineTime)
    );
	
    formAdapter.deadlineRemarks= new TextBoxAdapterElement(
        deadlineRemarks,
        new CFW.Forms.Filters.StringFilter(property.deadlineRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.deadlineRemarks)
    );
	
    formAdapter.deadline2Date= new TextBoxAdapterElement(
        deadline2Date,
        new CFW.Forms.Filters.StringFilter(property.deadline2Date),
        CFW.Validators.FieldValidator.GetInstance(property.deadline2Date)
    );
	
    formAdapter.deadline2Time= new TextBoxAdapterElement(
        deadline2Time,
        new CFW.Forms.Filters.StringFilter(property.deadline2Time),
        CFW.Validators.FieldValidator.GetInstance(property.deadline2Time)
    );
	
    formAdapter.deadline2Remarks= new TextBoxAdapterElement(
        deadline2Remarks,
        new CFW.Forms.Filters.StringFilter(property.deadline2Remarks),
        CFW.Validators.FieldValidator.GetInstance(property.deadline2Remarks)
    );
	
    formAdapter.checkFlag= new TextBoxAdapterElement(
        checkFlag,
        new CFW.Forms.Filters.StringFilter(property.checkFlag),
        CFW.Validators.FieldValidator.GetInstance(property.checkFlag)
    );
	
    formAdapter.documentFlag= new TextBoxAdapterElement(
        documentFlag,
        new CFW.Forms.Filters.StringFilter(property.documentFlag),
        CFW.Validators.FieldValidator.GetInstance(property.documentFlag)
    );
	
    formAdapter.browserRemarks= new TextBoxAdapterElement(
        browserRemarks,
        new CFW.Forms.Filters.StringFilter(property.browserRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.browserRemarks)
    );
	
    formAdapter.admissionFlag= new TextBoxAdapterElement(
        admissionFlag,
        new CFW.Forms.Filters.StringFilter(property.admissionFlag),
        CFW.Validators.FieldValidator.GetInstance(property.admissionFlag)
    );
	
    formAdapter.admissionMenuCode= new TextBoxAdapterElement(
        admissionMenuCode,
        new CFW.Forms.Filters.StringFilter(property.admissionMenuCode),
        CFW.Validators.FieldValidator.GetInstance(property.admissionMenuCode)
    );
	
    formAdapter.patternRemarks= new TextBoxAdapterElement(
        patternRemarks,
        new CFW.Forms.Filters.StringFilter(property.patternRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.patternRemarks)
    );
	
    formAdapter.patternCode= new TextBoxAdapterElement(
        patternCode,
        new CFW.Forms.Filters.StringFilter(property.patternCode),
        CFW.Validators.FieldValidator.GetInstance(property.patternCode)
    );
	
    formAdapter.remarks= new TextBoxAdapterElement(
        remarks,
        new CFW.Forms.Filters.StringFilter(property.remarks),
        CFW.Validators.FieldValidator.GetInstance(property.remarks)
    );
	
    formAdapter.validFlag= new TextBoxAdapterElement(
        validFlag,
        new CFW.Forms.Filters.StringFilter(property.validFlag),
        CFW.Validators.FieldValidator.GetInstance(property.validFlag)
    );
	
    formAdapter.insertDateTime= new TextBoxAdapterElement(
        insertDateTime,
        new CFW.Forms.Filters.StringFilter(property.insertDateTime),
        CFW.Validators.FieldValidator.GetInstance(property.insertDateTime)
    );
	
    formAdapter.insertOperatorCode= new TextBoxAdapterElement(
        insertOperatorCode,
        new CFW.Forms.Filters.StringFilter(property.insertOperatorCode),
        CFW.Validators.FieldValidator.GetInstance(property.insertOperatorCode)
    );
	
    formAdapter.updateDateTime= new TextBoxAdapterElement(
        updateDateTime,
        new CFW.Forms.Filters.StringFilter(property.updateDateTime),
        CFW.Validators.FieldValidator.GetInstance(property.updateDateTime)
    );
	
    formAdapter.operatorCode= new TextBoxAdapterElement(
        operatorCode,
        new CFW.Forms.Filters.StringFilter(property.operatorCode),
        CFW.Validators.FieldValidator.GetInstance(property.operatorCode)
    );
	
    formAdapter.oldRemarks= new TextBoxAdapterElement(
        oldRemarks,
        new CFW.Forms.Filters.StringFilter(property.oldRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.oldRemarks)
    );
	
    formAdapter.SetEntity(entity);
    formAdapter.RenderView();
	

*/	

}