using System;
using System.Collections.Generic;
using System.Text;
using CFW.Forms;
using CFW.Forms.Filters;
using CFW.Util;
using CFW.Models;
using Sample.Data.Models.Base;

namespace Sample.Data.Windows.Forms.Adapters.Base
{
    /// <summary>
    /// table MAST_MENU Field`
    /// </summary>
    public class MastMenuTableFormAdapter : CFW.Forms.FormAdapter
	{
		private MastMenuTableRow theEntity;

		///<summary>[SITE_CODE]</summary>
		public FormAdapterElement siteCode;
		///<summary>[MENU_CODE]</summary>
		public FormAdapterElement menuCode;
		///<summary>[SORT_SEQ]</summary>
		public FormAdapterElement sortSeq;
		///<summary>[OPEN_DATE]</summary>
		public FormAdapterElement openDate;
		///<summary>[CLOSE_DATE]</summary>
		public FormAdapterElement closeDate;
		///<summary>[MENU_GROUP_CODE]</summary>
		public FormAdapterElement menuGroupCode;
		///<summary>[NAME]</summary>
		public FormAdapterElement name;
		///<summary>[ANK_NAME]</summary>
		public FormAdapterElement ankName;
		///<summary>[DEVICE_CODE]</summary>
		public FormAdapterElement deviceCode;
		///<summary>[MENU_DEVICE_CODE]</summary>
		public FormAdapterElement menuDeviceCode;
		///<summary>[MENU_ADTYPE_CODE]</summary>
		public FormAdapterElement menuAdtypeCode;
		///<summary>[OPTIN_TYPE]</summary>
		public FormAdapterElement optinType;
		///<summary>[MANAGEMENT_CODE]</summary>
		public FormAdapterElement managementCode;
		///<summary>[GUARANTEE_CODE]</summary>
		public FormAdapterElement guaranteeCode;
		///<summary>[MENU_CATEGORY1]</summary>
		public FormAdapterElement menuCategory1;
		///<summary>[MENU_CATEGORY2]</summary>
		public FormAdapterElement menuCategory2;
		///<summary>[LIST_CODE]</summary>
		public FormAdapterElement listCode;
		///<summary>[FLAME_COUNT]</summary>
		public FormAdapterElement flameCount;
		///<summary>[FLAME_COUNT_KIND]</summary>
		public FormAdapterElement flameCountKind;
		///<summary>[ROTATION_FLAME_COUNT]</summary>
		public FormAdapterElement rotationFlameCount;
		///<summary>[FLAME_SELECT_FLAG]</summary>
		public FormAdapterElement flameSelectFlag;
		///<summary>[GOODS_CATEGORY_CODE]</summary>
		public FormAdapterElement goodsCategoryCode;
		///<summary>[PAYMENT_COMPANY]</summary>
		public FormAdapterElement paymentCompany;
		///<summary>[SP_OPEN_FLAG]</summary>
		public FormAdapterElement spOpenFlag;
		///<summary>[PM_OPEN_FLAG]</summary>
		public FormAdapterElement pmOpenFlag;
		///<summary>[AD_GUIDE_OPEN_FLAG]</summary>
		public FormAdapterElement adGuideOpenFlag;
		///<summary>[REGULATION_GUIDE_FLAG]</summary>
		public FormAdapterElement regulationGuideFlag;
		///<summary>[IO_OPEN_FLAG]</summary>
		public FormAdapterElement ioOpenFlag;
		///<summary>[ES_AUDIENCE_FLAG]</summary>
		public FormAdapterElement esAudienceFlag;
		///<summary>[ES_PERFORMANCE_FLAG]</summary>
		public FormAdapterElement esPerformanceFlag;
		///<summary>[ES_REACH_FLAG]</summary>
		public FormAdapterElement esReachFlag;
		///<summary>[SEARCH_URL_FLAG]</summary>
		public FormAdapterElement searchUrlFlag;
		///<summary>[PACKAGE_FLAG]</summary>
		public FormAdapterElement packageFlag;
		///<summary>[MENU_SELECTION_COUNT]</summary>
		public FormAdapterElement menuSelectionCount;
		///<summary>[CARRIER_CODE1]</summary>
		public FormAdapterElement carrierCode1;
		///<summary>[CARRIER_CODE2]</summary>
		public FormAdapterElement carrierCode2;
		///<summary>[CARRIER_CODE3]</summary>
		public FormAdapterElement carrierCode3;
		///<summary>[CARRIER_CODE4]</summary>
		public FormAdapterElement carrierCode4;
		///<summary>[PAGE_REMARKS]</summary>
		public FormAdapterElement pageRemarks;
		///<summary>[REMARKS]</summary>
		public FormAdapterElement remarks;
		///<summary>[DAC_REMARKS]</summary>
		public FormAdapterElement dacRemarks;
		///<summary>[B_STATUS]</summary>
		public FormAdapterElement bStatus;
		///<summary>[D_STATUS]</summary>
		public FormAdapterElement dStatus;
		///<summary>[P_STATUS]</summary>
		public FormAdapterElement pStatus;
		///<summary>[P_CAMPAIGN_STATUS_FROM]</summary>
		public FormAdapterElement pCampaignStatusFrom;
		///<summary>[P_CAMPAIGN_STATUS_TO]</summary>
		public FormAdapterElement pCampaignStatusTo;
		///<summary>[M_STATUS]</summary>
		public FormAdapterElement mStatus;
		///<summary>[T_STATUS]</summary>
		public FormAdapterElement tStatus;
		///<summary>[TOTAL_STATUS]</summary>
		public FormAdapterElement totalStatus;
		///<summary>[TOTAL_STATUS_TO]</summary>
		public FormAdapterElement totalStatusTo;
		///<summary>[COUNT_URL_KIND]</summary>
		public FormAdapterElement countUrlKind;
		///<summary>[COUNT_URL]</summary>
		public FormAdapterElement countUrl;
		///<summary>[REPORT_KIND]</summary>
		public FormAdapterElement reportKind;
		///<summary>[REPORT_DETAIL]</summary>
		public FormAdapterElement reportDetail;
		///<summary>[REPORT_RECEIVE]</summary>
		public FormAdapterElement reportReceive;
		///<summary>[SEGMENT_EQUAL_FLAG]</summary>
		public FormAdapterElement segmentEqualFlag;
		///<summary>[STOCK_FLAG]</summary>
		public FormAdapterElement stockFlag;
		///<summary>[STOCK_COUNT]</summary>
		public FormAdapterElement stockCount;
		///<summary>[CAPTURE_SEQ]</summary>
		public FormAdapterElement captureSeq;
		///<summary>[AG_COMPANY_CODE]</summary>
		public FormAdapterElement agCompanyCode;
		///<summary>[INSIDE_OPEN_LEVEL]</summary>
		public FormAdapterElement insideOpenLevel;
		///<summary>[OUTSIDE_OPEN_LEVEL]</summary>
		public FormAdapterElement outsideOpenLevel;
		///<summary>[LIMIT_OPEN_REMARKS]</summary>
		public FormAdapterElement limitOpenRemarks;
		///<summary>[PUBLISH_PAGE_FLAG]</summary>
		public FormAdapterElement publishPageFlag;
		///<summary>[ES_REMARKS]</summary>
		public FormAdapterElement esRemarks;
		///<summary>[MENU_FRAME_CODE]</summary>
		public FormAdapterElement menuFrameCode;
		///<summary>[FRAME_NAME_REFRECT_FLAG]</summary>
		public FormAdapterElement frameNameRefrectFlag;
		///<summary>[DELIVERY_OPTION_NAME]</summary>
		public FormAdapterElement deliveryOptionName;
		///<summary>[GET_REPORT_DESTINATION]</summary>
		public FormAdapterElement getReportDestination;
		///<summary>[REPORT_TREAT_KIND_SEQ]</summary>
		public FormAdapterElement reportTreatKindSeq;
		///<summary>[USE_SITE_LIMIT_OPEN_FLAG]</summary>
		public FormAdapterElement useSiteLimitOpenFlag;
		///<summary>[USE_SITE_CARRIER_FLAG]</summary>
		public FormAdapterElement useSiteCarrierFlag;
		///<summary>[COST_MENU_FLAG]</summary>
		public FormAdapterElement costMenuFlag;
		///<summary>[CHECK_NAME]</summary>
		public FormAdapterElement checkName;
		///<summary>[PRICE_GROUP_FROM_DATE]</summary>
		public FormAdapterElement priceGroupFromDate;
		///<summary>[MANUSCRIPT_FROM_DATE]</summary>
		public FormAdapterElement manuscriptFromDate;
		///<summary>[PRICE_COST_FROM_DATE]</summary>
		public FormAdapterElement priceCostFromDate;
		///<summary>[TRANSMIT_FROM_DATE]</summary>
		public FormAdapterElement transmitFromDate;
		///<summary>[REFER_SITE_PRICE_COST_FLAG]</summary>
		public FormAdapterElement referSitePriceCostFlag;
		///<summary>[TEAM_CODE]</summary>
		public FormAdapterElement teamCode;
		///<summary>[VALID_FLAG]</summary>
		public FormAdapterElement validFlag;
		///<summary>[BASE_UPDATE_DATE_TIME]</summary>
		public FormAdapterElement baseUpdateDateTime;
		///<summary>[INSERT_DATE_TIME]</summary>
		public FormAdapterElement insertDateTime;
		///<summary>[INSERT_OPERATOR_CODE]</summary>
		public FormAdapterElement insertOperatorCode;
		///<summary>[UPDATE_DATE_TIME]</summary>
		public FormAdapterElement updateDateTime;
		///<summary>[OPERATOR_CODE]</summary>
		public FormAdapterElement operatorCode;
		

		/// <summary>݂̃f[^\[X擾
		/// </summary>
        public override Entity GetEntity()
        {
            return this.theEntity;
        }
		/// <summary>\̍XV
		/// </summary>
        public override void RenderView()
        {
			if(this.siteCode != null) this.siteCode.Render();
			if(this.menuCode != null) this.menuCode.Render();
			if(this.sortSeq != null) this.sortSeq.Render();
			if(this.openDate != null) this.openDate.Render();
			if(this.closeDate != null) this.closeDate.Render();
			if(this.menuGroupCode != null) this.menuGroupCode.Render();
			if(this.name != null) this.name.Render();
			if(this.ankName != null) this.ankName.Render();
			if(this.deviceCode != null) this.deviceCode.Render();
			if(this.menuDeviceCode != null) this.menuDeviceCode.Render();
			if(this.menuAdtypeCode != null) this.menuAdtypeCode.Render();
			if(this.optinType != null) this.optinType.Render();
			if(this.managementCode != null) this.managementCode.Render();
			if(this.guaranteeCode != null) this.guaranteeCode.Render();
			if(this.menuCategory1 != null) this.menuCategory1.Render();
			if(this.menuCategory2 != null) this.menuCategory2.Render();
			if(this.listCode != null) this.listCode.Render();
			if(this.flameCount != null) this.flameCount.Render();
			if(this.flameCountKind != null) this.flameCountKind.Render();
			if(this.rotationFlameCount != null) this.rotationFlameCount.Render();
			if(this.flameSelectFlag != null) this.flameSelectFlag.Render();
			if(this.goodsCategoryCode != null) this.goodsCategoryCode.Render();
			if(this.paymentCompany != null) this.paymentCompany.Render();
			if(this.spOpenFlag != null) this.spOpenFlag.Render();
			if(this.pmOpenFlag != null) this.pmOpenFlag.Render();
			if(this.adGuideOpenFlag != null) this.adGuideOpenFlag.Render();
			if(this.regulationGuideFlag != null) this.regulationGuideFlag.Render();
			if(this.ioOpenFlag != null) this.ioOpenFlag.Render();
			if(this.esAudienceFlag != null) this.esAudienceFlag.Render();
			if(this.esPerformanceFlag != null) this.esPerformanceFlag.Render();
			if(this.esReachFlag != null) this.esReachFlag.Render();
			if(this.searchUrlFlag != null) this.searchUrlFlag.Render();
			if(this.packageFlag != null) this.packageFlag.Render();
			if(this.menuSelectionCount != null) this.menuSelectionCount.Render();
			if(this.carrierCode1 != null) this.carrierCode1.Render();
			if(this.carrierCode2 != null) this.carrierCode2.Render();
			if(this.carrierCode3 != null) this.carrierCode3.Render();
			if(this.carrierCode4 != null) this.carrierCode4.Render();
			if(this.pageRemarks != null) this.pageRemarks.Render();
			if(this.remarks != null) this.remarks.Render();
			if(this.dacRemarks != null) this.dacRemarks.Render();
			if(this.bStatus != null) this.bStatus.Render();
			if(this.dStatus != null) this.dStatus.Render();
			if(this.pStatus != null) this.pStatus.Render();
			if(this.pCampaignStatusFrom != null) this.pCampaignStatusFrom.Render();
			if(this.pCampaignStatusTo != null) this.pCampaignStatusTo.Render();
			if(this.mStatus != null) this.mStatus.Render();
			if(this.tStatus != null) this.tStatus.Render();
			if(this.totalStatus != null) this.totalStatus.Render();
			if(this.totalStatusTo != null) this.totalStatusTo.Render();
			if(this.countUrlKind != null) this.countUrlKind.Render();
			if(this.countUrl != null) this.countUrl.Render();
			if(this.reportKind != null) this.reportKind.Render();
			if(this.reportDetail != null) this.reportDetail.Render();
			if(this.reportReceive != null) this.reportReceive.Render();
			if(this.segmentEqualFlag != null) this.segmentEqualFlag.Render();
			if(this.stockFlag != null) this.stockFlag.Render();
			if(this.stockCount != null) this.stockCount.Render();
			if(this.captureSeq != null) this.captureSeq.Render();
			if(this.agCompanyCode != null) this.agCompanyCode.Render();
			if(this.insideOpenLevel != null) this.insideOpenLevel.Render();
			if(this.outsideOpenLevel != null) this.outsideOpenLevel.Render();
			if(this.limitOpenRemarks != null) this.limitOpenRemarks.Render();
			if(this.publishPageFlag != null) this.publishPageFlag.Render();
			if(this.esRemarks != null) this.esRemarks.Render();
			if(this.menuFrameCode != null) this.menuFrameCode.Render();
			if(this.frameNameRefrectFlag != null) this.frameNameRefrectFlag.Render();
			if(this.deliveryOptionName != null) this.deliveryOptionName.Render();
			if(this.getReportDestination != null) this.getReportDestination.Render();
			if(this.reportTreatKindSeq != null) this.reportTreatKindSeq.Render();
			if(this.useSiteLimitOpenFlag != null) this.useSiteLimitOpenFlag.Render();
			if(this.useSiteCarrierFlag != null) this.useSiteCarrierFlag.Render();
			if(this.costMenuFlag != null) this.costMenuFlag.Render();
			if(this.checkName != null) this.checkName.Render();
			if(this.priceGroupFromDate != null) this.priceGroupFromDate.Render();
			if(this.manuscriptFromDate != null) this.manuscriptFromDate.Render();
			if(this.priceCostFromDate != null) this.priceCostFromDate.Render();
			if(this.transmitFromDate != null) this.transmitFromDate.Render();
			if(this.referSitePriceCostFlag != null) this.referSitePriceCostFlag.Render();
			if(this.teamCode != null) this.teamCode.Render();
			if(this.validFlag != null) this.validFlag.Render();
			if(this.baseUpdateDateTime != null) this.baseUpdateDateTime.Render();
			if(this.insertDateTime != null) this.insertDateTime.Render();
			if(this.insertOperatorCode != null) this.insertOperatorCode.Render();
			if(this.updateDateTime != null) this.updateDateTime.Render();
			if(this.operatorCode != null) this.operatorCode.Render();
			
        }

		/// <summary>̃A_v^[f[^ݒ
		/// </summary>
        /// <param name="dataSource">̃A_v^[f[^</param>
        public override void SetEntity(Entity entity)
        {
        	this.theEntity = (MastMenuTableRow)entity;
			if(this.siteCode != null) this.siteCode.SetValue(this.theEntity.siteCode);
			if(this.menuCode != null) this.menuCode.SetValue(this.theEntity.menuCode);
			if(this.sortSeq != null) this.sortSeq.SetValue(this.theEntity.sortSeq);
			if(this.openDate != null) this.openDate.SetValue(this.theEntity.openDate);
			if(this.closeDate != null) this.closeDate.SetValue(this.theEntity.closeDate);
			if(this.menuGroupCode != null) this.menuGroupCode.SetValue(this.theEntity.menuGroupCode);
			if(this.name != null) this.name.SetValue(this.theEntity.name);
			if(this.ankName != null) this.ankName.SetValue(this.theEntity.ankName);
			if(this.deviceCode != null) this.deviceCode.SetValue(this.theEntity.deviceCode);
			if(this.menuDeviceCode != null) this.menuDeviceCode.SetValue(this.theEntity.menuDeviceCode);
			if(this.menuAdtypeCode != null) this.menuAdtypeCode.SetValue(this.theEntity.menuAdtypeCode);
			if(this.optinType != null) this.optinType.SetValue(this.theEntity.optinType);
			if(this.managementCode != null) this.managementCode.SetValue(this.theEntity.managementCode);
			if(this.guaranteeCode != null) this.guaranteeCode.SetValue(this.theEntity.guaranteeCode);
			if(this.menuCategory1 != null) this.menuCategory1.SetValue(this.theEntity.menuCategory1);
			if(this.menuCategory2 != null) this.menuCategory2.SetValue(this.theEntity.menuCategory2);
			if(this.listCode != null) this.listCode.SetValue(this.theEntity.listCode);
			if(this.flameCount != null) this.flameCount.SetValue(this.theEntity.flameCount);
			if(this.flameCountKind != null) this.flameCountKind.SetValue(this.theEntity.flameCountKind);
			if(this.rotationFlameCount != null) this.rotationFlameCount.SetValue(this.theEntity.rotationFlameCount);
			if(this.flameSelectFlag != null) this.flameSelectFlag.SetValue(this.theEntity.flameSelectFlag);
			if(this.goodsCategoryCode != null) this.goodsCategoryCode.SetValue(this.theEntity.goodsCategoryCode);
			if(this.paymentCompany != null) this.paymentCompany.SetValue(this.theEntity.paymentCompany);
			if(this.spOpenFlag != null) this.spOpenFlag.SetValue(this.theEntity.spOpenFlag);
			if(this.pmOpenFlag != null) this.pmOpenFlag.SetValue(this.theEntity.pmOpenFlag);
			if(this.adGuideOpenFlag != null) this.adGuideOpenFlag.SetValue(this.theEntity.adGuideOpenFlag);
			if(this.regulationGuideFlag != null) this.regulationGuideFlag.SetValue(this.theEntity.regulationGuideFlag);
			if(this.ioOpenFlag != null) this.ioOpenFlag.SetValue(this.theEntity.ioOpenFlag);
			if(this.esAudienceFlag != null) this.esAudienceFlag.SetValue(this.theEntity.esAudienceFlag);
			if(this.esPerformanceFlag != null) this.esPerformanceFlag.SetValue(this.theEntity.esPerformanceFlag);
			if(this.esReachFlag != null) this.esReachFlag.SetValue(this.theEntity.esReachFlag);
			if(this.searchUrlFlag != null) this.searchUrlFlag.SetValue(this.theEntity.searchUrlFlag);
			if(this.packageFlag != null) this.packageFlag.SetValue(this.theEntity.packageFlag);
			if(this.menuSelectionCount != null) this.menuSelectionCount.SetValue(this.theEntity.menuSelectionCount);
			if(this.carrierCode1 != null) this.carrierCode1.SetValue(this.theEntity.carrierCode1);
			if(this.carrierCode2 != null) this.carrierCode2.SetValue(this.theEntity.carrierCode2);
			if(this.carrierCode3 != null) this.carrierCode3.SetValue(this.theEntity.carrierCode3);
			if(this.carrierCode4 != null) this.carrierCode4.SetValue(this.theEntity.carrierCode4);
			if(this.pageRemarks != null) this.pageRemarks.SetValue(this.theEntity.pageRemarks);
			if(this.remarks != null) this.remarks.SetValue(this.theEntity.remarks);
			if(this.dacRemarks != null) this.dacRemarks.SetValue(this.theEntity.dacRemarks);
			if(this.bStatus != null) this.bStatus.SetValue(this.theEntity.bStatus);
			if(this.dStatus != null) this.dStatus.SetValue(this.theEntity.dStatus);
			if(this.pStatus != null) this.pStatus.SetValue(this.theEntity.pStatus);
			if(this.pCampaignStatusFrom != null) this.pCampaignStatusFrom.SetValue(this.theEntity.pCampaignStatusFrom);
			if(this.pCampaignStatusTo != null) this.pCampaignStatusTo.SetValue(this.theEntity.pCampaignStatusTo);
			if(this.mStatus != null) this.mStatus.SetValue(this.theEntity.mStatus);
			if(this.tStatus != null) this.tStatus.SetValue(this.theEntity.tStatus);
			if(this.totalStatus != null) this.totalStatus.SetValue(this.theEntity.totalStatus);
			if(this.totalStatusTo != null) this.totalStatusTo.SetValue(this.theEntity.totalStatusTo);
			if(this.countUrlKind != null) this.countUrlKind.SetValue(this.theEntity.countUrlKind);
			if(this.countUrl != null) this.countUrl.SetValue(this.theEntity.countUrl);
			if(this.reportKind != null) this.reportKind.SetValue(this.theEntity.reportKind);
			if(this.reportDetail != null) this.reportDetail.SetValue(this.theEntity.reportDetail);
			if(this.reportReceive != null) this.reportReceive.SetValue(this.theEntity.reportReceive);
			if(this.segmentEqualFlag != null) this.segmentEqualFlag.SetValue(this.theEntity.segmentEqualFlag);
			if(this.stockFlag != null) this.stockFlag.SetValue(this.theEntity.stockFlag);
			if(this.stockCount != null) this.stockCount.SetValue(this.theEntity.stockCount);
			if(this.captureSeq != null) this.captureSeq.SetValue(this.theEntity.captureSeq);
			if(this.agCompanyCode != null) this.agCompanyCode.SetValue(this.theEntity.agCompanyCode);
			if(this.insideOpenLevel != null) this.insideOpenLevel.SetValue(this.theEntity.insideOpenLevel);
			if(this.outsideOpenLevel != null) this.outsideOpenLevel.SetValue(this.theEntity.outsideOpenLevel);
			if(this.limitOpenRemarks != null) this.limitOpenRemarks.SetValue(this.theEntity.limitOpenRemarks);
			if(this.publishPageFlag != null) this.publishPageFlag.SetValue(this.theEntity.publishPageFlag);
			if(this.esRemarks != null) this.esRemarks.SetValue(this.theEntity.esRemarks);
			if(this.menuFrameCode != null) this.menuFrameCode.SetValue(this.theEntity.menuFrameCode);
			if(this.frameNameRefrectFlag != null) this.frameNameRefrectFlag.SetValue(this.theEntity.frameNameRefrectFlag);
			if(this.deliveryOptionName != null) this.deliveryOptionName.SetValue(this.theEntity.deliveryOptionName);
			if(this.getReportDestination != null) this.getReportDestination.SetValue(this.theEntity.getReportDestination);
			if(this.reportTreatKindSeq != null) this.reportTreatKindSeq.SetValue(this.theEntity.reportTreatKindSeq);
			if(this.useSiteLimitOpenFlag != null) this.useSiteLimitOpenFlag.SetValue(this.theEntity.useSiteLimitOpenFlag);
			if(this.useSiteCarrierFlag != null) this.useSiteCarrierFlag.SetValue(this.theEntity.useSiteCarrierFlag);
			if(this.costMenuFlag != null) this.costMenuFlag.SetValue(this.theEntity.costMenuFlag);
			if(this.checkName != null) this.checkName.SetValue(this.theEntity.checkName);
			if(this.priceGroupFromDate != null) this.priceGroupFromDate.SetValue(this.theEntity.priceGroupFromDate);
			if(this.manuscriptFromDate != null) this.manuscriptFromDate.SetValue(this.theEntity.manuscriptFromDate);
			if(this.priceCostFromDate != null) this.priceCostFromDate.SetValue(this.theEntity.priceCostFromDate);
			if(this.transmitFromDate != null) this.transmitFromDate.SetValue(this.theEntity.transmitFromDate);
			if(this.referSitePriceCostFlag != null) this.referSitePriceCostFlag.SetValue(this.theEntity.referSitePriceCostFlag);
			if(this.teamCode != null) this.teamCode.SetValue(this.theEntity.teamCode);
			if(this.validFlag != null) this.validFlag.SetValue(this.theEntity.validFlag);
			if(this.baseUpdateDateTime != null) this.baseUpdateDateTime.SetValue(this.theEntity.baseUpdateDateTime);
			if(this.insertDateTime != null) this.insertDateTime.SetValue(this.theEntity.insertDateTime);
			if(this.insertOperatorCode != null) this.insertOperatorCode.SetValue(this.theEntity.insertOperatorCode);
			if(this.updateDateTime != null) this.updateDateTime.SetValue(this.theEntity.updateDateTime);
			if(this.operatorCode != null) this.operatorCode.SetValue(this.theEntity.operatorCode);
			

        }

		/// <summary>UI͂ꂽef[^\[XɎ荞
		/// </summary>
        public override void UpdateEntity()
        {
			if(this.siteCode != null) this.theEntity.siteCode = StringUtil.StringValue(this.siteCode.GetValue());
			if(this.menuCode != null) this.theEntity.menuCode = StringUtil.StringValue(this.menuCode.GetValue());
			if(this.sortSeq != null) this.theEntity.sortSeq = NumberUtil.Value<Int16?>(this.sortSeq.GetValue());
			if(this.openDate != null) this.theEntity.openDate = StringUtil.StringValue(this.openDate.GetValue());
			if(this.closeDate != null) this.theEntity.closeDate = StringUtil.StringValue(this.closeDate.GetValue());
			if(this.menuGroupCode != null) this.theEntity.menuGroupCode = NumberUtil.Value<Int16?>(this.menuGroupCode.GetValue());
			if(this.name != null) this.theEntity.name = StringUtil.StringValue(this.name.GetValue());
			if(this.ankName != null) this.theEntity.ankName = StringUtil.StringValue(this.ankName.GetValue());
			if(this.deviceCode != null) this.theEntity.deviceCode = NumberUtil.Value<Int16>(this.deviceCode.GetValue());
			if(this.menuDeviceCode != null) this.theEntity.menuDeviceCode = NumberUtil.Value<Int16?>(this.menuDeviceCode.GetValue());
			if(this.menuAdtypeCode != null) this.theEntity.menuAdtypeCode = NumberUtil.Value<Int16?>(this.menuAdtypeCode.GetValue());
			if(this.optinType != null) this.theEntity.optinType = NumberUtil.Value<Int16?>(this.optinType.GetValue());
			if(this.managementCode != null) this.theEntity.managementCode = NumberUtil.Value<Int16>(this.managementCode.GetValue());
			if(this.guaranteeCode != null) this.theEntity.guaranteeCode = NumberUtil.Value<Int16>(this.guaranteeCode.GetValue());
			if(this.menuCategory1 != null) this.theEntity.menuCategory1 = NumberUtil.Value<Int16?>(this.menuCategory1.GetValue());
			if(this.menuCategory2 != null) this.theEntity.menuCategory2 = NumberUtil.Value<Int16?>(this.menuCategory2.GetValue());
			if(this.listCode != null) this.theEntity.listCode = NumberUtil.Value<Int16?>(this.listCode.GetValue());
			if(this.flameCount != null) this.theEntity.flameCount = NumberUtil.Value<Int16?>(this.flameCount.GetValue());
			if(this.flameCountKind != null) this.theEntity.flameCountKind = NumberUtil.Value<Int16>(this.flameCountKind.GetValue());
			if(this.rotationFlameCount != null) this.theEntity.rotationFlameCount = NumberUtil.Value<Int16?>(this.rotationFlameCount.GetValue());
			if(this.flameSelectFlag != null) this.theEntity.flameSelectFlag = NumberUtil.Value<Int16?>(this.flameSelectFlag.GetValue());
			if(this.goodsCategoryCode != null) this.theEntity.goodsCategoryCode = NumberUtil.Value<Int16?>(this.goodsCategoryCode.GetValue());
			if(this.paymentCompany != null) this.theEntity.paymentCompany = StringUtil.StringValue(this.paymentCompany.GetValue());
			if(this.spOpenFlag != null) this.theEntity.spOpenFlag = NumberUtil.Value<Int16?>(this.spOpenFlag.GetValue());
			if(this.pmOpenFlag != null) this.theEntity.pmOpenFlag = NumberUtil.Value<Int16?>(this.pmOpenFlag.GetValue());
			if(this.adGuideOpenFlag != null) this.theEntity.adGuideOpenFlag = NumberUtil.Value<Int16?>(this.adGuideOpenFlag.GetValue());
			if(this.regulationGuideFlag != null) this.theEntity.regulationGuideFlag = NumberUtil.Value<Int16?>(this.regulationGuideFlag.GetValue());
			if(this.ioOpenFlag != null) this.theEntity.ioOpenFlag = NumberUtil.Value<Int16?>(this.ioOpenFlag.GetValue());
			if(this.esAudienceFlag != null) this.theEntity.esAudienceFlag = NumberUtil.Value<Int16?>(this.esAudienceFlag.GetValue());
			if(this.esPerformanceFlag != null) this.theEntity.esPerformanceFlag = NumberUtil.Value<Int16?>(this.esPerformanceFlag.GetValue());
			if(this.esReachFlag != null) this.theEntity.esReachFlag = NumberUtil.Value<Int16?>(this.esReachFlag.GetValue());
			if(this.searchUrlFlag != null) this.theEntity.searchUrlFlag = NumberUtil.Value<Int16?>(this.searchUrlFlag.GetValue());
			if(this.packageFlag != null) this.theEntity.packageFlag = NumberUtil.Value<Int16?>(this.packageFlag.GetValue());
			if(this.menuSelectionCount != null) this.theEntity.menuSelectionCount = NumberUtil.Value<Int16?>(this.menuSelectionCount.GetValue());
			if(this.carrierCode1 != null) this.theEntity.carrierCode1 = NumberUtil.Value<Int16?>(this.carrierCode1.GetValue());
			if(this.carrierCode2 != null) this.theEntity.carrierCode2 = NumberUtil.Value<Int16?>(this.carrierCode2.GetValue());
			if(this.carrierCode3 != null) this.theEntity.carrierCode3 = NumberUtil.Value<Int16?>(this.carrierCode3.GetValue());
			if(this.carrierCode4 != null) this.theEntity.carrierCode4 = NumberUtil.Value<Int16?>(this.carrierCode4.GetValue());
			if(this.pageRemarks != null) this.theEntity.pageRemarks = StringUtil.StringValue(this.pageRemarks.GetValue());
			if(this.remarks != null) this.theEntity.remarks = StringUtil.StringValue(this.remarks.GetValue());
			if(this.dacRemarks != null) this.theEntity.dacRemarks = StringUtil.StringValue(this.dacRemarks.GetValue());
			if(this.bStatus != null) this.theEntity.bStatus = StringUtil.StringValue(this.bStatus.GetValue());
			if(this.dStatus != null) this.theEntity.dStatus = StringUtil.StringValue(this.dStatus.GetValue());
			if(this.pStatus != null) this.theEntity.pStatus = StringUtil.StringValue(this.pStatus.GetValue());
			if(this.pCampaignStatusFrom != null) this.theEntity.pCampaignStatusFrom = StringUtil.StringValue(this.pCampaignStatusFrom.GetValue());
			if(this.pCampaignStatusTo != null) this.theEntity.pCampaignStatusTo = StringUtil.StringValue(this.pCampaignStatusTo.GetValue());
			if(this.mStatus != null) this.theEntity.mStatus = StringUtil.StringValue(this.mStatus.GetValue());
			if(this.tStatus != null) this.theEntity.tStatus = StringUtil.StringValue(this.tStatus.GetValue());
			if(this.totalStatus != null) this.theEntity.totalStatus = StringUtil.StringValue(this.totalStatus.GetValue());
			if(this.totalStatusTo != null) this.theEntity.totalStatusTo = StringUtil.StringValue(this.totalStatusTo.GetValue());
			if(this.countUrlKind != null) this.theEntity.countUrlKind = NumberUtil.Value<Int16?>(this.countUrlKind.GetValue());
			if(this.countUrl != null) this.theEntity.countUrl = StringUtil.StringValue(this.countUrl.GetValue());
			if(this.reportKind != null) this.theEntity.reportKind = NumberUtil.Value<Int16>(this.reportKind.GetValue());
			if(this.reportDetail != null) this.theEntity.reportDetail = StringUtil.StringValue(this.reportDetail.GetValue());
			if(this.reportReceive != null) this.theEntity.reportReceive = StringUtil.StringValue(this.reportReceive.GetValue());
			if(this.segmentEqualFlag != null) this.theEntity.segmentEqualFlag = NumberUtil.Value<Int16?>(this.segmentEqualFlag.GetValue());
			if(this.stockFlag != null) this.theEntity.stockFlag = NumberUtil.Value<Int16?>(this.stockFlag.GetValue());
			if(this.stockCount != null) this.theEntity.stockCount = NumberUtil.Value<Int16?>(this.stockCount.GetValue());
			if(this.captureSeq != null) this.theEntity.captureSeq = StringUtil.StringValue(this.captureSeq.GetValue());
			if(this.agCompanyCode != null) this.theEntity.agCompanyCode = StringUtil.StringValue(this.agCompanyCode.GetValue());
			if(this.insideOpenLevel != null) this.theEntity.insideOpenLevel = NumberUtil.Value<Int16?>(this.insideOpenLevel.GetValue());
			if(this.outsideOpenLevel != null) this.theEntity.outsideOpenLevel = NumberUtil.Value<Int16?>(this.outsideOpenLevel.GetValue());
			if(this.limitOpenRemarks != null) this.theEntity.limitOpenRemarks = StringUtil.StringValue(this.limitOpenRemarks.GetValue());
			if(this.publishPageFlag != null) this.theEntity.publishPageFlag = NumberUtil.Value<Int16?>(this.publishPageFlag.GetValue());
			if(this.esRemarks != null) this.theEntity.esRemarks = StringUtil.StringValue(this.esRemarks.GetValue());
			if(this.menuFrameCode != null) this.theEntity.menuFrameCode = StringUtil.StringValue(this.menuFrameCode.GetValue());
			if(this.frameNameRefrectFlag != null) this.theEntity.frameNameRefrectFlag = NumberUtil.Value<Int16?>(this.frameNameRefrectFlag.GetValue());
			if(this.deliveryOptionName != null) this.theEntity.deliveryOptionName = StringUtil.StringValue(this.deliveryOptionName.GetValue());
			if(this.getReportDestination != null) this.theEntity.getReportDestination = StringUtil.StringValue(this.getReportDestination.GetValue());
			if(this.reportTreatKindSeq != null) this.theEntity.reportTreatKindSeq = NumberUtil.Value<Int16?>(this.reportTreatKindSeq.GetValue());
			if(this.useSiteLimitOpenFlag != null) this.theEntity.useSiteLimitOpenFlag = NumberUtil.Value<Int16?>(this.useSiteLimitOpenFlag.GetValue());
			if(this.useSiteCarrierFlag != null) this.theEntity.useSiteCarrierFlag = NumberUtil.Value<Int16?>(this.useSiteCarrierFlag.GetValue());
			if(this.costMenuFlag != null) this.theEntity.costMenuFlag = NumberUtil.Value<Int16?>(this.costMenuFlag.GetValue());
			if(this.checkName != null) this.theEntity.checkName = StringUtil.StringValue(this.checkName.GetValue());
			if(this.priceGroupFromDate != null) this.theEntity.priceGroupFromDate = StringUtil.StringValue(this.priceGroupFromDate.GetValue());
			if(this.manuscriptFromDate != null) this.theEntity.manuscriptFromDate = StringUtil.StringValue(this.manuscriptFromDate.GetValue());
			if(this.priceCostFromDate != null) this.theEntity.priceCostFromDate = StringUtil.StringValue(this.priceCostFromDate.GetValue());
			if(this.transmitFromDate != null) this.theEntity.transmitFromDate = StringUtil.StringValue(this.transmitFromDate.GetValue());
			if(this.referSitePriceCostFlag != null) this.theEntity.referSitePriceCostFlag = NumberUtil.Value<Int16?>(this.referSitePriceCostFlag.GetValue());
			if(this.teamCode != null) this.theEntity.teamCode = NumberUtil.Value<Int16?>(this.teamCode.GetValue());
			if(this.validFlag != null) this.theEntity.validFlag = NumberUtil.Value<Int16?>(this.validFlag.GetValue());
			if(this.baseUpdateDateTime != null) this.theEntity.baseUpdateDateTime = DateUtil.DateValue(this.baseUpdateDateTime.GetValue());
			if(this.insertDateTime != null) this.theEntity.insertDateTime = DateUtil.DateValue(this.insertDateTime.GetValue());
			if(this.insertOperatorCode != null) this.theEntity.insertOperatorCode = StringUtil.StringValue(this.insertOperatorCode.GetValue());
			if(this.updateDateTime != null) this.theEntity.updateDateTime = DateUtil.DateValue(this.updateDateTime.GetValue());
			if(this.operatorCode != null) this.theEntity.operatorCode = StringUtil.StringValue(this.operatorCode.GetValue());
			
        }

		/// <summary>UI͂ꂽe荞
		/// </summary>
        public override void UpdateFields()
        {
			if(this.siteCode != null) this.siteCode.UpdateField();
			if(this.menuCode != null) this.menuCode.UpdateField();
			if(this.sortSeq != null) this.sortSeq.UpdateField();
			if(this.openDate != null) this.openDate.UpdateField();
			if(this.closeDate != null) this.closeDate.UpdateField();
			if(this.menuGroupCode != null) this.menuGroupCode.UpdateField();
			if(this.name != null) this.name.UpdateField();
			if(this.ankName != null) this.ankName.UpdateField();
			if(this.deviceCode != null) this.deviceCode.UpdateField();
			if(this.menuDeviceCode != null) this.menuDeviceCode.UpdateField();
			if(this.menuAdtypeCode != null) this.menuAdtypeCode.UpdateField();
			if(this.optinType != null) this.optinType.UpdateField();
			if(this.managementCode != null) this.managementCode.UpdateField();
			if(this.guaranteeCode != null) this.guaranteeCode.UpdateField();
			if(this.menuCategory1 != null) this.menuCategory1.UpdateField();
			if(this.menuCategory2 != null) this.menuCategory2.UpdateField();
			if(this.listCode != null) this.listCode.UpdateField();
			if(this.flameCount != null) this.flameCount.UpdateField();
			if(this.flameCountKind != null) this.flameCountKind.UpdateField();
			if(this.rotationFlameCount != null) this.rotationFlameCount.UpdateField();
			if(this.flameSelectFlag != null) this.flameSelectFlag.UpdateField();
			if(this.goodsCategoryCode != null) this.goodsCategoryCode.UpdateField();
			if(this.paymentCompany != null) this.paymentCompany.UpdateField();
			if(this.spOpenFlag != null) this.spOpenFlag.UpdateField();
			if(this.pmOpenFlag != null) this.pmOpenFlag.UpdateField();
			if(this.adGuideOpenFlag != null) this.adGuideOpenFlag.UpdateField();
			if(this.regulationGuideFlag != null) this.regulationGuideFlag.UpdateField();
			if(this.ioOpenFlag != null) this.ioOpenFlag.UpdateField();
			if(this.esAudienceFlag != null) this.esAudienceFlag.UpdateField();
			if(this.esPerformanceFlag != null) this.esPerformanceFlag.UpdateField();
			if(this.esReachFlag != null) this.esReachFlag.UpdateField();
			if(this.searchUrlFlag != null) this.searchUrlFlag.UpdateField();
			if(this.packageFlag != null) this.packageFlag.UpdateField();
			if(this.menuSelectionCount != null) this.menuSelectionCount.UpdateField();
			if(this.carrierCode1 != null) this.carrierCode1.UpdateField();
			if(this.carrierCode2 != null) this.carrierCode2.UpdateField();
			if(this.carrierCode3 != null) this.carrierCode3.UpdateField();
			if(this.carrierCode4 != null) this.carrierCode4.UpdateField();
			if(this.pageRemarks != null) this.pageRemarks.UpdateField();
			if(this.remarks != null) this.remarks.UpdateField();
			if(this.dacRemarks != null) this.dacRemarks.UpdateField();
			if(this.bStatus != null) this.bStatus.UpdateField();
			if(this.dStatus != null) this.dStatus.UpdateField();
			if(this.pStatus != null) this.pStatus.UpdateField();
			if(this.pCampaignStatusFrom != null) this.pCampaignStatusFrom.UpdateField();
			if(this.pCampaignStatusTo != null) this.pCampaignStatusTo.UpdateField();
			if(this.mStatus != null) this.mStatus.UpdateField();
			if(this.tStatus != null) this.tStatus.UpdateField();
			if(this.totalStatus != null) this.totalStatus.UpdateField();
			if(this.totalStatusTo != null) this.totalStatusTo.UpdateField();
			if(this.countUrlKind != null) this.countUrlKind.UpdateField();
			if(this.countUrl != null) this.countUrl.UpdateField();
			if(this.reportKind != null) this.reportKind.UpdateField();
			if(this.reportDetail != null) this.reportDetail.UpdateField();
			if(this.reportReceive != null) this.reportReceive.UpdateField();
			if(this.segmentEqualFlag != null) this.segmentEqualFlag.UpdateField();
			if(this.stockFlag != null) this.stockFlag.UpdateField();
			if(this.stockCount != null) this.stockCount.UpdateField();
			if(this.captureSeq != null) this.captureSeq.UpdateField();
			if(this.agCompanyCode != null) this.agCompanyCode.UpdateField();
			if(this.insideOpenLevel != null) this.insideOpenLevel.UpdateField();
			if(this.outsideOpenLevel != null) this.outsideOpenLevel.UpdateField();
			if(this.limitOpenRemarks != null) this.limitOpenRemarks.UpdateField();
			if(this.publishPageFlag != null) this.publishPageFlag.UpdateField();
			if(this.esRemarks != null) this.esRemarks.UpdateField();
			if(this.menuFrameCode != null) this.menuFrameCode.UpdateField();
			if(this.frameNameRefrectFlag != null) this.frameNameRefrectFlag.UpdateField();
			if(this.deliveryOptionName != null) this.deliveryOptionName.UpdateField();
			if(this.getReportDestination != null) this.getReportDestination.UpdateField();
			if(this.reportTreatKindSeq != null) this.reportTreatKindSeq.UpdateField();
			if(this.useSiteLimitOpenFlag != null) this.useSiteLimitOpenFlag.UpdateField();
			if(this.useSiteCarrierFlag != null) this.useSiteCarrierFlag.UpdateField();
			if(this.costMenuFlag != null) this.costMenuFlag.UpdateField();
			if(this.checkName != null) this.checkName.UpdateField();
			if(this.priceGroupFromDate != null) this.priceGroupFromDate.UpdateField();
			if(this.manuscriptFromDate != null) this.manuscriptFromDate.UpdateField();
			if(this.priceCostFromDate != null) this.priceCostFromDate.UpdateField();
			if(this.transmitFromDate != null) this.transmitFromDate.UpdateField();
			if(this.referSitePriceCostFlag != null) this.referSitePriceCostFlag.UpdateField();
			if(this.teamCode != null) this.teamCode.UpdateField();
			if(this.validFlag != null) this.validFlag.UpdateField();
			if(this.baseUpdateDateTime != null) this.baseUpdateDateTime.UpdateField();
			if(this.insertDateTime != null) this.insertDateTime.UpdateField();
			if(this.insertOperatorCode != null) this.insertOperatorCode.UpdateField();
			if(this.updateDateTime != null) this.updateDateTime.UpdateField();
			if(this.operatorCode != null) this.operatorCode.UpdateField();
			
        }

		/// <summary>͓e؂
		/// ؃G[MessagesXgɑSẴG[B
		/// </summary>
        public override bool Validate()
        {
            bool valid = true;
			
			if(this.siteCode != null){
			    if(!this.siteCode.Validate()){
				    valid = false;
				    this.messages.Add(this.siteCode.ErrorMessage);
			    }
			}
			
			if(this.menuCode != null){
			    if(!this.menuCode.Validate()){
				    valid = false;
				    this.messages.Add(this.menuCode.ErrorMessage);
			    }
			}
			
			if(this.sortSeq != null){
			    if(!this.sortSeq.Validate()){
				    valid = false;
				    this.messages.Add(this.sortSeq.ErrorMessage);
			    }
			}
			
			if(this.openDate != null){
			    if(!this.openDate.Validate()){
				    valid = false;
				    this.messages.Add(this.openDate.ErrorMessage);
			    }
			}
			
			if(this.closeDate != null){
			    if(!this.closeDate.Validate()){
				    valid = false;
				    this.messages.Add(this.closeDate.ErrorMessage);
			    }
			}
			
			if(this.menuGroupCode != null){
			    if(!this.menuGroupCode.Validate()){
				    valid = false;
				    this.messages.Add(this.menuGroupCode.ErrorMessage);
			    }
			}
			
			if(this.name != null){
			    if(!this.name.Validate()){
				    valid = false;
				    this.messages.Add(this.name.ErrorMessage);
			    }
			}
			
			if(this.ankName != null){
			    if(!this.ankName.Validate()){
				    valid = false;
				    this.messages.Add(this.ankName.ErrorMessage);
			    }
			}
			
			if(this.deviceCode != null){
			    if(!this.deviceCode.Validate()){
				    valid = false;
				    this.messages.Add(this.deviceCode.ErrorMessage);
			    }
			}
			
			if(this.menuDeviceCode != null){
			    if(!this.menuDeviceCode.Validate()){
				    valid = false;
				    this.messages.Add(this.menuDeviceCode.ErrorMessage);
			    }
			}
			
			if(this.menuAdtypeCode != null){
			    if(!this.menuAdtypeCode.Validate()){
				    valid = false;
				    this.messages.Add(this.menuAdtypeCode.ErrorMessage);
			    }
			}
			
			if(this.optinType != null){
			    if(!this.optinType.Validate()){
				    valid = false;
				    this.messages.Add(this.optinType.ErrorMessage);
			    }
			}
			
			if(this.managementCode != null){
			    if(!this.managementCode.Validate()){
				    valid = false;
				    this.messages.Add(this.managementCode.ErrorMessage);
			    }
			}
			
			if(this.guaranteeCode != null){
			    if(!this.guaranteeCode.Validate()){
				    valid = false;
				    this.messages.Add(this.guaranteeCode.ErrorMessage);
			    }
			}
			
			if(this.menuCategory1 != null){
			    if(!this.menuCategory1.Validate()){
				    valid = false;
				    this.messages.Add(this.menuCategory1.ErrorMessage);
			    }
			}
			
			if(this.menuCategory2 != null){
			    if(!this.menuCategory2.Validate()){
				    valid = false;
				    this.messages.Add(this.menuCategory2.ErrorMessage);
			    }
			}
			
			if(this.listCode != null){
			    if(!this.listCode.Validate()){
				    valid = false;
				    this.messages.Add(this.listCode.ErrorMessage);
			    }
			}
			
			if(this.flameCount != null){
			    if(!this.flameCount.Validate()){
				    valid = false;
				    this.messages.Add(this.flameCount.ErrorMessage);
			    }
			}
			
			if(this.flameCountKind != null){
			    if(!this.flameCountKind.Validate()){
				    valid = false;
				    this.messages.Add(this.flameCountKind.ErrorMessage);
			    }
			}
			
			if(this.rotationFlameCount != null){
			    if(!this.rotationFlameCount.Validate()){
				    valid = false;
				    this.messages.Add(this.rotationFlameCount.ErrorMessage);
			    }
			}
			
			if(this.flameSelectFlag != null){
			    if(!this.flameSelectFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.flameSelectFlag.ErrorMessage);
			    }
			}
			
			if(this.goodsCategoryCode != null){
			    if(!this.goodsCategoryCode.Validate()){
				    valid = false;
				    this.messages.Add(this.goodsCategoryCode.ErrorMessage);
			    }
			}
			
			if(this.paymentCompany != null){
			    if(!this.paymentCompany.Validate()){
				    valid = false;
				    this.messages.Add(this.paymentCompany.ErrorMessage);
			    }
			}
			
			if(this.spOpenFlag != null){
			    if(!this.spOpenFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.spOpenFlag.ErrorMessage);
			    }
			}
			
			if(this.pmOpenFlag != null){
			    if(!this.pmOpenFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.pmOpenFlag.ErrorMessage);
			    }
			}
			
			if(this.adGuideOpenFlag != null){
			    if(!this.adGuideOpenFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.adGuideOpenFlag.ErrorMessage);
			    }
			}
			
			if(this.regulationGuideFlag != null){
			    if(!this.regulationGuideFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.regulationGuideFlag.ErrorMessage);
			    }
			}
			
			if(this.ioOpenFlag != null){
			    if(!this.ioOpenFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.ioOpenFlag.ErrorMessage);
			    }
			}
			
			if(this.esAudienceFlag != null){
			    if(!this.esAudienceFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.esAudienceFlag.ErrorMessage);
			    }
			}
			
			if(this.esPerformanceFlag != null){
			    if(!this.esPerformanceFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.esPerformanceFlag.ErrorMessage);
			    }
			}
			
			if(this.esReachFlag != null){
			    if(!this.esReachFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.esReachFlag.ErrorMessage);
			    }
			}
			
			if(this.searchUrlFlag != null){
			    if(!this.searchUrlFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.searchUrlFlag.ErrorMessage);
			    }
			}
			
			if(this.packageFlag != null){
			    if(!this.packageFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.packageFlag.ErrorMessage);
			    }
			}
			
			if(this.menuSelectionCount != null){
			    if(!this.menuSelectionCount.Validate()){
				    valid = false;
				    this.messages.Add(this.menuSelectionCount.ErrorMessage);
			    }
			}
			
			if(this.carrierCode1 != null){
			    if(!this.carrierCode1.Validate()){
				    valid = false;
				    this.messages.Add(this.carrierCode1.ErrorMessage);
			    }
			}
			
			if(this.carrierCode2 != null){
			    if(!this.carrierCode2.Validate()){
				    valid = false;
				    this.messages.Add(this.carrierCode2.ErrorMessage);
			    }
			}
			
			if(this.carrierCode3 != null){
			    if(!this.carrierCode3.Validate()){
				    valid = false;
				    this.messages.Add(this.carrierCode3.ErrorMessage);
			    }
			}
			
			if(this.carrierCode4 != null){
			    if(!this.carrierCode4.Validate()){
				    valid = false;
				    this.messages.Add(this.carrierCode4.ErrorMessage);
			    }
			}
			
			if(this.pageRemarks != null){
			    if(!this.pageRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.pageRemarks.ErrorMessage);
			    }
			}
			
			if(this.remarks != null){
			    if(!this.remarks.Validate()){
				    valid = false;
				    this.messages.Add(this.remarks.ErrorMessage);
			    }
			}
			
			if(this.dacRemarks != null){
			    if(!this.dacRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.dacRemarks.ErrorMessage);
			    }
			}
			
			if(this.bStatus != null){
			    if(!this.bStatus.Validate()){
				    valid = false;
				    this.messages.Add(this.bStatus.ErrorMessage);
			    }
			}
			
			if(this.dStatus != null){
			    if(!this.dStatus.Validate()){
				    valid = false;
				    this.messages.Add(this.dStatus.ErrorMessage);
			    }
			}
			
			if(this.pStatus != null){
			    if(!this.pStatus.Validate()){
				    valid = false;
				    this.messages.Add(this.pStatus.ErrorMessage);
			    }
			}
			
			if(this.pCampaignStatusFrom != null){
			    if(!this.pCampaignStatusFrom.Validate()){
				    valid = false;
				    this.messages.Add(this.pCampaignStatusFrom.ErrorMessage);
			    }
			}
			
			if(this.pCampaignStatusTo != null){
			    if(!this.pCampaignStatusTo.Validate()){
				    valid = false;
				    this.messages.Add(this.pCampaignStatusTo.ErrorMessage);
			    }
			}
			
			if(this.mStatus != null){
			    if(!this.mStatus.Validate()){
				    valid = false;
				    this.messages.Add(this.mStatus.ErrorMessage);
			    }
			}
			
			if(this.tStatus != null){
			    if(!this.tStatus.Validate()){
				    valid = false;
				    this.messages.Add(this.tStatus.ErrorMessage);
			    }
			}
			
			if(this.totalStatus != null){
			    if(!this.totalStatus.Validate()){
				    valid = false;
				    this.messages.Add(this.totalStatus.ErrorMessage);
			    }
			}
			
			if(this.totalStatusTo != null){
			    if(!this.totalStatusTo.Validate()){
				    valid = false;
				    this.messages.Add(this.totalStatusTo.ErrorMessage);
			    }
			}
			
			if(this.countUrlKind != null){
			    if(!this.countUrlKind.Validate()){
				    valid = false;
				    this.messages.Add(this.countUrlKind.ErrorMessage);
			    }
			}
			
			if(this.countUrl != null){
			    if(!this.countUrl.Validate()){
				    valid = false;
				    this.messages.Add(this.countUrl.ErrorMessage);
			    }
			}
			
			if(this.reportKind != null){
			    if(!this.reportKind.Validate()){
				    valid = false;
				    this.messages.Add(this.reportKind.ErrorMessage);
			    }
			}
			
			if(this.reportDetail != null){
			    if(!this.reportDetail.Validate()){
				    valid = false;
				    this.messages.Add(this.reportDetail.ErrorMessage);
			    }
			}
			
			if(this.reportReceive != null){
			    if(!this.reportReceive.Validate()){
				    valid = false;
				    this.messages.Add(this.reportReceive.ErrorMessage);
			    }
			}
			
			if(this.segmentEqualFlag != null){
			    if(!this.segmentEqualFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.segmentEqualFlag.ErrorMessage);
			    }
			}
			
			if(this.stockFlag != null){
			    if(!this.stockFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.stockFlag.ErrorMessage);
			    }
			}
			
			if(this.stockCount != null){
			    if(!this.stockCount.Validate()){
				    valid = false;
				    this.messages.Add(this.stockCount.ErrorMessage);
			    }
			}
			
			if(this.captureSeq != null){
			    if(!this.captureSeq.Validate()){
				    valid = false;
				    this.messages.Add(this.captureSeq.ErrorMessage);
			    }
			}
			
			if(this.agCompanyCode != null){
			    if(!this.agCompanyCode.Validate()){
				    valid = false;
				    this.messages.Add(this.agCompanyCode.ErrorMessage);
			    }
			}
			
			if(this.insideOpenLevel != null){
			    if(!this.insideOpenLevel.Validate()){
				    valid = false;
				    this.messages.Add(this.insideOpenLevel.ErrorMessage);
			    }
			}
			
			if(this.outsideOpenLevel != null){
			    if(!this.outsideOpenLevel.Validate()){
				    valid = false;
				    this.messages.Add(this.outsideOpenLevel.ErrorMessage);
			    }
			}
			
			if(this.limitOpenRemarks != null){
			    if(!this.limitOpenRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.limitOpenRemarks.ErrorMessage);
			    }
			}
			
			if(this.publishPageFlag != null){
			    if(!this.publishPageFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.publishPageFlag.ErrorMessage);
			    }
			}
			
			if(this.esRemarks != null){
			    if(!this.esRemarks.Validate()){
				    valid = false;
				    this.messages.Add(this.esRemarks.ErrorMessage);
			    }
			}
			
			if(this.menuFrameCode != null){
			    if(!this.menuFrameCode.Validate()){
				    valid = false;
				    this.messages.Add(this.menuFrameCode.ErrorMessage);
			    }
			}
			
			if(this.frameNameRefrectFlag != null){
			    if(!this.frameNameRefrectFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.frameNameRefrectFlag.ErrorMessage);
			    }
			}
			
			if(this.deliveryOptionName != null){
			    if(!this.deliveryOptionName.Validate()){
				    valid = false;
				    this.messages.Add(this.deliveryOptionName.ErrorMessage);
			    }
			}
			
			if(this.getReportDestination != null){
			    if(!this.getReportDestination.Validate()){
				    valid = false;
				    this.messages.Add(this.getReportDestination.ErrorMessage);
			    }
			}
			
			if(this.reportTreatKindSeq != null){
			    if(!this.reportTreatKindSeq.Validate()){
				    valid = false;
				    this.messages.Add(this.reportTreatKindSeq.ErrorMessage);
			    }
			}
			
			if(this.useSiteLimitOpenFlag != null){
			    if(!this.useSiteLimitOpenFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.useSiteLimitOpenFlag.ErrorMessage);
			    }
			}
			
			if(this.useSiteCarrierFlag != null){
			    if(!this.useSiteCarrierFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.useSiteCarrierFlag.ErrorMessage);
			    }
			}
			
			if(this.costMenuFlag != null){
			    if(!this.costMenuFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.costMenuFlag.ErrorMessage);
			    }
			}
			
			if(this.checkName != null){
			    if(!this.checkName.Validate()){
				    valid = false;
				    this.messages.Add(this.checkName.ErrorMessage);
			    }
			}
			
			if(this.priceGroupFromDate != null){
			    if(!this.priceGroupFromDate.Validate()){
				    valid = false;
				    this.messages.Add(this.priceGroupFromDate.ErrorMessage);
			    }
			}
			
			if(this.manuscriptFromDate != null){
			    if(!this.manuscriptFromDate.Validate()){
				    valid = false;
				    this.messages.Add(this.manuscriptFromDate.ErrorMessage);
			    }
			}
			
			if(this.priceCostFromDate != null){
			    if(!this.priceCostFromDate.Validate()){
				    valid = false;
				    this.messages.Add(this.priceCostFromDate.ErrorMessage);
			    }
			}
			
			if(this.transmitFromDate != null){
			    if(!this.transmitFromDate.Validate()){
				    valid = false;
				    this.messages.Add(this.transmitFromDate.ErrorMessage);
			    }
			}
			
			if(this.referSitePriceCostFlag != null){
			    if(!this.referSitePriceCostFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.referSitePriceCostFlag.ErrorMessage);
			    }
			}
			
			if(this.teamCode != null){
			    if(!this.teamCode.Validate()){
				    valid = false;
				    this.messages.Add(this.teamCode.ErrorMessage);
			    }
			}
			
			if(this.validFlag != null){
			    if(!this.validFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.validFlag.ErrorMessage);
			    }
			}
			
			if(this.baseUpdateDateTime != null){
			    if(!this.baseUpdateDateTime.Validate()){
				    valid = false;
				    this.messages.Add(this.baseUpdateDateTime.ErrorMessage);
			    }
			}
			
			if(this.insertDateTime != null){
			    if(!this.insertDateTime.Validate()){
				    valid = false;
				    this.messages.Add(this.insertDateTime.ErrorMessage);
			    }
			}
			
			if(this.insertOperatorCode != null){
			    if(!this.insertOperatorCode.Validate()){
				    valid = false;
				    this.messages.Add(this.insertOperatorCode.ErrorMessage);
			    }
			}
			
			if(this.updateDateTime != null){
			    if(!this.updateDateTime.Validate()){
				    valid = false;
				    this.messages.Add(this.updateDateTime.ErrorMessage);
			    }
			}
			
			if(this.operatorCode != null){
			    if(!this.operatorCode.Validate()){
				    valid = false;
				    this.messages.Add(this.operatorCode.ErrorMessage);
			    }
			}
			

            return valid;
        }
		
	}
/* 
    // initialize code sample
    // Form̃o[ɈȉǉB
    //     private MastMenuFormAdapter formAdapter;
    //     private MastMenuProperty property;
    //     private MastMenuEntity property;
    // tB[hƓ̓Rg[킹B
    // 2(tB^[)͓KXtB[hɍ킹ĕύX
    formAdapter = new MastMenuFormAdapter();

	
    formAdapter.siteCode= new TextBoxAdapterElement(
        siteCode,
        new CFW.Forms.Filters.StringFilter(property.siteCode),
        CFW.Validators.FieldValidator.GetInstance(property.siteCode)
    );
	
    formAdapter.menuCode= new TextBoxAdapterElement(
        menuCode,
        new CFW.Forms.Filters.StringFilter(property.menuCode),
        CFW.Validators.FieldValidator.GetInstance(property.menuCode)
    );
	
    formAdapter.sortSeq= new TextBoxAdapterElement(
        sortSeq,
        new CFW.Forms.Filters.StringFilter(property.sortSeq),
        CFW.Validators.FieldValidator.GetInstance(property.sortSeq)
    );
	
    formAdapter.openDate= new TextBoxAdapterElement(
        openDate,
        new CFW.Forms.Filters.StringFilter(property.openDate),
        CFW.Validators.FieldValidator.GetInstance(property.openDate)
    );
	
    formAdapter.closeDate= new TextBoxAdapterElement(
        closeDate,
        new CFW.Forms.Filters.StringFilter(property.closeDate),
        CFW.Validators.FieldValidator.GetInstance(property.closeDate)
    );
	
    formAdapter.menuGroupCode= new TextBoxAdapterElement(
        menuGroupCode,
        new CFW.Forms.Filters.StringFilter(property.menuGroupCode),
        CFW.Validators.FieldValidator.GetInstance(property.menuGroupCode)
    );
	
    formAdapter.name= new TextBoxAdapterElement(
        name,
        new CFW.Forms.Filters.StringFilter(property.name),
        CFW.Validators.FieldValidator.GetInstance(property.name)
    );
	
    formAdapter.ankName= new TextBoxAdapterElement(
        ankName,
        new CFW.Forms.Filters.StringFilter(property.ankName),
        CFW.Validators.FieldValidator.GetInstance(property.ankName)
    );
	
    formAdapter.deviceCode= new TextBoxAdapterElement(
        deviceCode,
        new CFW.Forms.Filters.StringFilter(property.deviceCode),
        CFW.Validators.FieldValidator.GetInstance(property.deviceCode)
    );
	
    formAdapter.menuDeviceCode= new TextBoxAdapterElement(
        menuDeviceCode,
        new CFW.Forms.Filters.StringFilter(property.menuDeviceCode),
        CFW.Validators.FieldValidator.GetInstance(property.menuDeviceCode)
    );
	
    formAdapter.menuAdtypeCode= new TextBoxAdapterElement(
        menuAdtypeCode,
        new CFW.Forms.Filters.StringFilter(property.menuAdtypeCode),
        CFW.Validators.FieldValidator.GetInstance(property.menuAdtypeCode)
    );
	
    formAdapter.optinType= new TextBoxAdapterElement(
        optinType,
        new CFW.Forms.Filters.StringFilter(property.optinType),
        CFW.Validators.FieldValidator.GetInstance(property.optinType)
    );
	
    formAdapter.managementCode= new TextBoxAdapterElement(
        managementCode,
        new CFW.Forms.Filters.StringFilter(property.managementCode),
        CFW.Validators.FieldValidator.GetInstance(property.managementCode)
    );
	
    formAdapter.guaranteeCode= new TextBoxAdapterElement(
        guaranteeCode,
        new CFW.Forms.Filters.StringFilter(property.guaranteeCode),
        CFW.Validators.FieldValidator.GetInstance(property.guaranteeCode)
    );
	
    formAdapter.menuCategory1= new TextBoxAdapterElement(
        menuCategory1,
        new CFW.Forms.Filters.StringFilter(property.menuCategory1),
        CFW.Validators.FieldValidator.GetInstance(property.menuCategory1)
    );
	
    formAdapter.menuCategory2= new TextBoxAdapterElement(
        menuCategory2,
        new CFW.Forms.Filters.StringFilter(property.menuCategory2),
        CFW.Validators.FieldValidator.GetInstance(property.menuCategory2)
    );
	
    formAdapter.listCode= new TextBoxAdapterElement(
        listCode,
        new CFW.Forms.Filters.StringFilter(property.listCode),
        CFW.Validators.FieldValidator.GetInstance(property.listCode)
    );
	
    formAdapter.flameCount= new TextBoxAdapterElement(
        flameCount,
        new CFW.Forms.Filters.StringFilter(property.flameCount),
        CFW.Validators.FieldValidator.GetInstance(property.flameCount)
    );
	
    formAdapter.flameCountKind= new TextBoxAdapterElement(
        flameCountKind,
        new CFW.Forms.Filters.StringFilter(property.flameCountKind),
        CFW.Validators.FieldValidator.GetInstance(property.flameCountKind)
    );
	
    formAdapter.rotationFlameCount= new TextBoxAdapterElement(
        rotationFlameCount,
        new CFW.Forms.Filters.StringFilter(property.rotationFlameCount),
        CFW.Validators.FieldValidator.GetInstance(property.rotationFlameCount)
    );
	
    formAdapter.flameSelectFlag= new TextBoxAdapterElement(
        flameSelectFlag,
        new CFW.Forms.Filters.StringFilter(property.flameSelectFlag),
        CFW.Validators.FieldValidator.GetInstance(property.flameSelectFlag)
    );
	
    formAdapter.goodsCategoryCode= new TextBoxAdapterElement(
        goodsCategoryCode,
        new CFW.Forms.Filters.StringFilter(property.goodsCategoryCode),
        CFW.Validators.FieldValidator.GetInstance(property.goodsCategoryCode)
    );
	
    formAdapter.paymentCompany= new TextBoxAdapterElement(
        paymentCompany,
        new CFW.Forms.Filters.StringFilter(property.paymentCompany),
        CFW.Validators.FieldValidator.GetInstance(property.paymentCompany)
    );
	
    formAdapter.spOpenFlag= new TextBoxAdapterElement(
        spOpenFlag,
        new CFW.Forms.Filters.StringFilter(property.spOpenFlag),
        CFW.Validators.FieldValidator.GetInstance(property.spOpenFlag)
    );
	
    formAdapter.pmOpenFlag= new TextBoxAdapterElement(
        pmOpenFlag,
        new CFW.Forms.Filters.StringFilter(property.pmOpenFlag),
        CFW.Validators.FieldValidator.GetInstance(property.pmOpenFlag)
    );
	
    formAdapter.adGuideOpenFlag= new TextBoxAdapterElement(
        adGuideOpenFlag,
        new CFW.Forms.Filters.StringFilter(property.adGuideOpenFlag),
        CFW.Validators.FieldValidator.GetInstance(property.adGuideOpenFlag)
    );
	
    formAdapter.regulationGuideFlag= new TextBoxAdapterElement(
        regulationGuideFlag,
        new CFW.Forms.Filters.StringFilter(property.regulationGuideFlag),
        CFW.Validators.FieldValidator.GetInstance(property.regulationGuideFlag)
    );
	
    formAdapter.ioOpenFlag= new TextBoxAdapterElement(
        ioOpenFlag,
        new CFW.Forms.Filters.StringFilter(property.ioOpenFlag),
        CFW.Validators.FieldValidator.GetInstance(property.ioOpenFlag)
    );
	
    formAdapter.esAudienceFlag= new TextBoxAdapterElement(
        esAudienceFlag,
        new CFW.Forms.Filters.StringFilter(property.esAudienceFlag),
        CFW.Validators.FieldValidator.GetInstance(property.esAudienceFlag)
    );
	
    formAdapter.esPerformanceFlag= new TextBoxAdapterElement(
        esPerformanceFlag,
        new CFW.Forms.Filters.StringFilter(property.esPerformanceFlag),
        CFW.Validators.FieldValidator.GetInstance(property.esPerformanceFlag)
    );
	
    formAdapter.esReachFlag= new TextBoxAdapterElement(
        esReachFlag,
        new CFW.Forms.Filters.StringFilter(property.esReachFlag),
        CFW.Validators.FieldValidator.GetInstance(property.esReachFlag)
    );
	
    formAdapter.searchUrlFlag= new TextBoxAdapterElement(
        searchUrlFlag,
        new CFW.Forms.Filters.StringFilter(property.searchUrlFlag),
        CFW.Validators.FieldValidator.GetInstance(property.searchUrlFlag)
    );
	
    formAdapter.packageFlag= new TextBoxAdapterElement(
        packageFlag,
        new CFW.Forms.Filters.StringFilter(property.packageFlag),
        CFW.Validators.FieldValidator.GetInstance(property.packageFlag)
    );
	
    formAdapter.menuSelectionCount= new TextBoxAdapterElement(
        menuSelectionCount,
        new CFW.Forms.Filters.StringFilter(property.menuSelectionCount),
        CFW.Validators.FieldValidator.GetInstance(property.menuSelectionCount)
    );
	
    formAdapter.carrierCode1= new TextBoxAdapterElement(
        carrierCode1,
        new CFW.Forms.Filters.StringFilter(property.carrierCode1),
        CFW.Validators.FieldValidator.GetInstance(property.carrierCode1)
    );
	
    formAdapter.carrierCode2= new TextBoxAdapterElement(
        carrierCode2,
        new CFW.Forms.Filters.StringFilter(property.carrierCode2),
        CFW.Validators.FieldValidator.GetInstance(property.carrierCode2)
    );
	
    formAdapter.carrierCode3= new TextBoxAdapterElement(
        carrierCode3,
        new CFW.Forms.Filters.StringFilter(property.carrierCode3),
        CFW.Validators.FieldValidator.GetInstance(property.carrierCode3)
    );
	
    formAdapter.carrierCode4= new TextBoxAdapterElement(
        carrierCode4,
        new CFW.Forms.Filters.StringFilter(property.carrierCode4),
        CFW.Validators.FieldValidator.GetInstance(property.carrierCode4)
    );
	
    formAdapter.pageRemarks= new TextBoxAdapterElement(
        pageRemarks,
        new CFW.Forms.Filters.StringFilter(property.pageRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.pageRemarks)
    );
	
    formAdapter.remarks= new TextBoxAdapterElement(
        remarks,
        new CFW.Forms.Filters.StringFilter(property.remarks),
        CFW.Validators.FieldValidator.GetInstance(property.remarks)
    );
	
    formAdapter.dacRemarks= new TextBoxAdapterElement(
        dacRemarks,
        new CFW.Forms.Filters.StringFilter(property.dacRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.dacRemarks)
    );
	
    formAdapter.bStatus= new TextBoxAdapterElement(
        bStatus,
        new CFW.Forms.Filters.StringFilter(property.bStatus),
        CFW.Validators.FieldValidator.GetInstance(property.bStatus)
    );
	
    formAdapter.dStatus= new TextBoxAdapterElement(
        dStatus,
        new CFW.Forms.Filters.StringFilter(property.dStatus),
        CFW.Validators.FieldValidator.GetInstance(property.dStatus)
    );
	
    formAdapter.pStatus= new TextBoxAdapterElement(
        pStatus,
        new CFW.Forms.Filters.StringFilter(property.pStatus),
        CFW.Validators.FieldValidator.GetInstance(property.pStatus)
    );
	
    formAdapter.pCampaignStatusFrom= new TextBoxAdapterElement(
        pCampaignStatusFrom,
        new CFW.Forms.Filters.StringFilter(property.pCampaignStatusFrom),
        CFW.Validators.FieldValidator.GetInstance(property.pCampaignStatusFrom)
    );
	
    formAdapter.pCampaignStatusTo= new TextBoxAdapterElement(
        pCampaignStatusTo,
        new CFW.Forms.Filters.StringFilter(property.pCampaignStatusTo),
        CFW.Validators.FieldValidator.GetInstance(property.pCampaignStatusTo)
    );
	
    formAdapter.mStatus= new TextBoxAdapterElement(
        mStatus,
        new CFW.Forms.Filters.StringFilter(property.mStatus),
        CFW.Validators.FieldValidator.GetInstance(property.mStatus)
    );
	
    formAdapter.tStatus= new TextBoxAdapterElement(
        tStatus,
        new CFW.Forms.Filters.StringFilter(property.tStatus),
        CFW.Validators.FieldValidator.GetInstance(property.tStatus)
    );
	
    formAdapter.totalStatus= new TextBoxAdapterElement(
        totalStatus,
        new CFW.Forms.Filters.StringFilter(property.totalStatus),
        CFW.Validators.FieldValidator.GetInstance(property.totalStatus)
    );
	
    formAdapter.totalStatusTo= new TextBoxAdapterElement(
        totalStatusTo,
        new CFW.Forms.Filters.StringFilter(property.totalStatusTo),
        CFW.Validators.FieldValidator.GetInstance(property.totalStatusTo)
    );
	
    formAdapter.countUrlKind= new TextBoxAdapterElement(
        countUrlKind,
        new CFW.Forms.Filters.StringFilter(property.countUrlKind),
        CFW.Validators.FieldValidator.GetInstance(property.countUrlKind)
    );
	
    formAdapter.countUrl= new TextBoxAdapterElement(
        countUrl,
        new CFW.Forms.Filters.StringFilter(property.countUrl),
        CFW.Validators.FieldValidator.GetInstance(property.countUrl)
    );
	
    formAdapter.reportKind= new TextBoxAdapterElement(
        reportKind,
        new CFW.Forms.Filters.StringFilter(property.reportKind),
        CFW.Validators.FieldValidator.GetInstance(property.reportKind)
    );
	
    formAdapter.reportDetail= new TextBoxAdapterElement(
        reportDetail,
        new CFW.Forms.Filters.StringFilter(property.reportDetail),
        CFW.Validators.FieldValidator.GetInstance(property.reportDetail)
    );
	
    formAdapter.reportReceive= new TextBoxAdapterElement(
        reportReceive,
        new CFW.Forms.Filters.StringFilter(property.reportReceive),
        CFW.Validators.FieldValidator.GetInstance(property.reportReceive)
    );
	
    formAdapter.segmentEqualFlag= new TextBoxAdapterElement(
        segmentEqualFlag,
        new CFW.Forms.Filters.StringFilter(property.segmentEqualFlag),
        CFW.Validators.FieldValidator.GetInstance(property.segmentEqualFlag)
    );
	
    formAdapter.stockFlag= new TextBoxAdapterElement(
        stockFlag,
        new CFW.Forms.Filters.StringFilter(property.stockFlag),
        CFW.Validators.FieldValidator.GetInstance(property.stockFlag)
    );
	
    formAdapter.stockCount= new TextBoxAdapterElement(
        stockCount,
        new CFW.Forms.Filters.StringFilter(property.stockCount),
        CFW.Validators.FieldValidator.GetInstance(property.stockCount)
    );
	
    formAdapter.captureSeq= new TextBoxAdapterElement(
        captureSeq,
        new CFW.Forms.Filters.StringFilter(property.captureSeq),
        CFW.Validators.FieldValidator.GetInstance(property.captureSeq)
    );
	
    formAdapter.agCompanyCode= new TextBoxAdapterElement(
        agCompanyCode,
        new CFW.Forms.Filters.StringFilter(property.agCompanyCode),
        CFW.Validators.FieldValidator.GetInstance(property.agCompanyCode)
    );
	
    formAdapter.insideOpenLevel= new TextBoxAdapterElement(
        insideOpenLevel,
        new CFW.Forms.Filters.StringFilter(property.insideOpenLevel),
        CFW.Validators.FieldValidator.GetInstance(property.insideOpenLevel)
    );
	
    formAdapter.outsideOpenLevel= new TextBoxAdapterElement(
        outsideOpenLevel,
        new CFW.Forms.Filters.StringFilter(property.outsideOpenLevel),
        CFW.Validators.FieldValidator.GetInstance(property.outsideOpenLevel)
    );
	
    formAdapter.limitOpenRemarks= new TextBoxAdapterElement(
        limitOpenRemarks,
        new CFW.Forms.Filters.StringFilter(property.limitOpenRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.limitOpenRemarks)
    );
	
    formAdapter.publishPageFlag= new TextBoxAdapterElement(
        publishPageFlag,
        new CFW.Forms.Filters.StringFilter(property.publishPageFlag),
        CFW.Validators.FieldValidator.GetInstance(property.publishPageFlag)
    );
	
    formAdapter.esRemarks= new TextBoxAdapterElement(
        esRemarks,
        new CFW.Forms.Filters.StringFilter(property.esRemarks),
        CFW.Validators.FieldValidator.GetInstance(property.esRemarks)
    );
	
    formAdapter.menuFrameCode= new TextBoxAdapterElement(
        menuFrameCode,
        new CFW.Forms.Filters.StringFilter(property.menuFrameCode),
        CFW.Validators.FieldValidator.GetInstance(property.menuFrameCode)
    );
	
    formAdapter.frameNameRefrectFlag= new TextBoxAdapterElement(
        frameNameRefrectFlag,
        new CFW.Forms.Filters.StringFilter(property.frameNameRefrectFlag),
        CFW.Validators.FieldValidator.GetInstance(property.frameNameRefrectFlag)
    );
	
    formAdapter.deliveryOptionName= new TextBoxAdapterElement(
        deliveryOptionName,
        new CFW.Forms.Filters.StringFilter(property.deliveryOptionName),
        CFW.Validators.FieldValidator.GetInstance(property.deliveryOptionName)
    );
	
    formAdapter.getReportDestination= new TextBoxAdapterElement(
        getReportDestination,
        new CFW.Forms.Filters.StringFilter(property.getReportDestination),
        CFW.Validators.FieldValidator.GetInstance(property.getReportDestination)
    );
	
    formAdapter.reportTreatKindSeq= new TextBoxAdapterElement(
        reportTreatKindSeq,
        new CFW.Forms.Filters.StringFilter(property.reportTreatKindSeq),
        CFW.Validators.FieldValidator.GetInstance(property.reportTreatKindSeq)
    );
	
    formAdapter.useSiteLimitOpenFlag= new TextBoxAdapterElement(
        useSiteLimitOpenFlag,
        new CFW.Forms.Filters.StringFilter(property.useSiteLimitOpenFlag),
        CFW.Validators.FieldValidator.GetInstance(property.useSiteLimitOpenFlag)
    );
	
    formAdapter.useSiteCarrierFlag= new TextBoxAdapterElement(
        useSiteCarrierFlag,
        new CFW.Forms.Filters.StringFilter(property.useSiteCarrierFlag),
        CFW.Validators.FieldValidator.GetInstance(property.useSiteCarrierFlag)
    );
	
    formAdapter.costMenuFlag= new TextBoxAdapterElement(
        costMenuFlag,
        new CFW.Forms.Filters.StringFilter(property.costMenuFlag),
        CFW.Validators.FieldValidator.GetInstance(property.costMenuFlag)
    );
	
    formAdapter.checkName= new TextBoxAdapterElement(
        checkName,
        new CFW.Forms.Filters.StringFilter(property.checkName),
        CFW.Validators.FieldValidator.GetInstance(property.checkName)
    );
	
    formAdapter.priceGroupFromDate= new TextBoxAdapterElement(
        priceGroupFromDate,
        new CFW.Forms.Filters.StringFilter(property.priceGroupFromDate),
        CFW.Validators.FieldValidator.GetInstance(property.priceGroupFromDate)
    );
	
    formAdapter.manuscriptFromDate= new TextBoxAdapterElement(
        manuscriptFromDate,
        new CFW.Forms.Filters.StringFilter(property.manuscriptFromDate),
        CFW.Validators.FieldValidator.GetInstance(property.manuscriptFromDate)
    );
	
    formAdapter.priceCostFromDate= new TextBoxAdapterElement(
        priceCostFromDate,
        new CFW.Forms.Filters.StringFilter(property.priceCostFromDate),
        CFW.Validators.FieldValidator.GetInstance(property.priceCostFromDate)
    );
	
    formAdapter.transmitFromDate= new TextBoxAdapterElement(
        transmitFromDate,
        new CFW.Forms.Filters.StringFilter(property.transmitFromDate),
        CFW.Validators.FieldValidator.GetInstance(property.transmitFromDate)
    );
	
    formAdapter.referSitePriceCostFlag= new TextBoxAdapterElement(
        referSitePriceCostFlag,
        new CFW.Forms.Filters.StringFilter(property.referSitePriceCostFlag),
        CFW.Validators.FieldValidator.GetInstance(property.referSitePriceCostFlag)
    );
	
    formAdapter.teamCode= new TextBoxAdapterElement(
        teamCode,
        new CFW.Forms.Filters.StringFilter(property.teamCode),
        CFW.Validators.FieldValidator.GetInstance(property.teamCode)
    );
	
    formAdapter.validFlag= new TextBoxAdapterElement(
        validFlag,
        new CFW.Forms.Filters.StringFilter(property.validFlag),
        CFW.Validators.FieldValidator.GetInstance(property.validFlag)
    );
	
    formAdapter.baseUpdateDateTime= new TextBoxAdapterElement(
        baseUpdateDateTime,
        new CFW.Forms.Filters.StringFilter(property.baseUpdateDateTime),
        CFW.Validators.FieldValidator.GetInstance(property.baseUpdateDateTime)
    );
	
    formAdapter.insertDateTime= new TextBoxAdapterElement(
        insertDateTime,
        new CFW.Forms.Filters.StringFilter(property.insertDateTime),
        CFW.Validators.FieldValidator.GetInstance(property.insertDateTime)
    );
	
    formAdapter.insertOperatorCode= new TextBoxAdapterElement(
        insertOperatorCode,
        new CFW.Forms.Filters.StringFilter(property.insertOperatorCode),
        CFW.Validators.FieldValidator.GetInstance(property.insertOperatorCode)
    );
	
    formAdapter.updateDateTime= new TextBoxAdapterElement(
        updateDateTime,
        new CFW.Forms.Filters.StringFilter(property.updateDateTime),
        CFW.Validators.FieldValidator.GetInstance(property.updateDateTime)
    );
	
    formAdapter.operatorCode= new TextBoxAdapterElement(
        operatorCode,
        new CFW.Forms.Filters.StringFilter(property.operatorCode),
        CFW.Validators.FieldValidator.GetInstance(property.operatorCode)
    );
	
    formAdapter.SetEntity(entity);
    formAdapter.RenderView();
	

*/	

}