using System;
using System.Collections.Generic;
using System.Text;
using CFW.Forms;
using CFW.Forms.Filters;
using CFW.Util;
using CFW.Models;
using Sample.Data.Models.Base;

namespace Sample.Data.Windows.Forms.Adapters.Base
{
    /// <summary>
    /// table MAST_SITE Field`
    /// </summary>
    public class MastSiteTableFormAdapter : CFW.Forms.FormAdapter
	{
		private MastSiteTableRow theEntity;

		///<summary>[SITE_CODE]</summary>
		public FormAdapterElement siteCode;
		///<summary>[OPEN_DATE]</summary>
		public FormAdapterElement openDate;
		///<summary>[CLOSE_DATE]</summary>
		public FormAdapterElement closeDate;
		///<summary>[SORT_SEQ]</summary>
		public FormAdapterElement sortSeq;
		///<summary>[NAME]</summary>
		public FormAdapterElement name;
		///<summary>[ANK_NAME]</summary>
		public FormAdapterElement ankName;
		///<summary>[COMPANY_CODE]</summary>
		public FormAdapterElement companyCode;
		///<summary>[SITE_URL]</summary>
		public FormAdapterElement siteUrl;
		///<summary>[SITE_URL_OTHER]</summary>
		public FormAdapterElement siteUrlOther;
		///<summary>[SITE_CATEGORY1]</summary>
		public FormAdapterElement siteCategory1;
		///<summary>[SITE_CATEGORY2]</summary>
		public FormAdapterElement siteCategory2;
		///<summary>[DEVICE_CODE]</summary>
		public FormAdapterElement deviceCode;
		///<summary>[MENU_DEVICE_CODE]</summary>
		public FormAdapterElement menuDeviceCode;
		///<summary>[MENU_ADTYPE_CODE]</summary>
		public FormAdapterElement menuAdtypeCode;
		///<summary>[GOODS_CATEGORY_CODE]</summary>
		public FormAdapterElement goodsCategoryCode;
		///<summary>[CARRIER_CODE1]</summary>
		public FormAdapterElement carrierCode1;
		///<summary>[CARRIER_CODE2]</summary>
		public FormAdapterElement carrierCode2;
		///<summary>[CARRIER_CODE3]</summary>
		public FormAdapterElement carrierCode3;
		///<summary>[CARRIER_CODE4]</summary>
		public FormAdapterElement carrierCode4;
		///<summary>[MEDIA_COST_RATE]</summary>
		public FormAdapterElement mediaCostRate;
		///<summary>[AGENCY_MARGIN_RATE]</summary>
		public FormAdapterElement agencyMarginRate;
		///<summary>[SP_OPEN_FLAG]</summary>
		public FormAdapterElement spOpenFlag;
		///<summary>[PM_OPEN_FLAG]</summary>
		public FormAdapterElement pmOpenFlag;
		///<summary>[IO_OPEN_FLAG]</summary>
		public FormAdapterElement ioOpenFlag;
		///<summary>[AD_GUIDE_OPEN_FLAG]</summary>
		public FormAdapterElement adGuideOpenFlag;
		///<summary>[IMPRESSION]</summary>
		public FormAdapterElement impression;
		///<summary>[IMPRESSION_TERM]</summary>
		public FormAdapterElement impressionTerm;
		///<summary>[IMPRESSION_TOPPAGE]</summary>
		public FormAdapterElement impressionToppage;
		///<summary>[IMPRESSION_TOPPAGE_TERM]</summary>
		public FormAdapterElement impressionToppageTerm;
		///<summary>[UNIQUE_USER]</summary>
		public FormAdapterElement uniqueUser;
		///<summary>[UNIQUE_USER_TERM]</summary>
		public FormAdapterElement uniqueUserTerm;
		///<summary>[UNIQUE_USER_TOPPAGE]</summary>
		public FormAdapterElement uniqueUserToppage;
		///<summary>[UNIQUE_USER_TOPPAGE_TERM]</summary>
		public FormAdapterElement uniqueUserToppageTerm;
		///<summary>[MALE_RATE]</summary>
		public FormAdapterElement maleRate;
		///<summary>[FEMALE_RATE]</summary>
		public FormAdapterElement femaleRate;
		///<summary>[PUBLISHED_YEAR]</summary>
		public FormAdapterElement publishedYear;
		///<summary>[PUBLISHED_MONTH]</summary>
		public FormAdapterElement publishedMonth;
		///<summary>[PUBLISHED_DAY]</summary>
		public FormAdapterElement publishedDay;
		///<summary>[PUBLISHED_DATA_KIND]</summary>
		public FormAdapterElement publishedDataKind;
		///<summary>[UPPER_SITE_CODE]</summary>
		public FormAdapterElement upperSiteCode;
		///<summary>[PAYMENT_COMPANY]</summary>
		public FormAdapterElement paymentCompany;
		///<summary>[BUSINESS_DIRECT_FLAG]</summary>
		public FormAdapterElement businessDirectFlag;
		///<summary>[ADSERVER_FLAG]</summary>
		public FormAdapterElement adserverFlag;
		///<summary>[SPECIALMENU_FLAG]</summary>
		public FormAdapterElement specialmenuFlag;
		///<summary>[TOP_OPEN_FLAG]</summary>
		public FormAdapterElement topOpenFlag;
		///<summary>[OPEN_MENU_COUNT]</summary>
		public FormAdapterElement openMenuCount;
		///<summary>[MAKE_DATE]</summary>
		public FormAdapterElement makeDate;
		///<summary>[DOCUMENT_ADDRESS]</summary>
		public FormAdapterElement documentAddress;
		///<summary>[AG_COMPANY_CODE]</summary>
		public FormAdapterElement agCompanyCode;
		///<summary>[INSIDE_OPEN_LEVEL]</summary>
		public FormAdapterElement insideOpenLevel;
		///<summary>[OUTSIDE_OPEN_LEVEL]</summary>
		public FormAdapterElement outsideOpenLevel;
		///<summary>[HOME_RATE]</summary>
		public FormAdapterElement homeRate;
		///<summary>[WORK_RATE]</summary>
		public FormAdapterElement workRate;
		///<summary>[OVERLAP_RATE]</summary>
		public FormAdapterElement overlapRate;
		///<summary>[BUSINESS_REP_DIRECT_FLAG]</summary>
		public FormAdapterElement businessRepDirectFlag;
		///<summary>[CLIENT_SITE_FLAG]</summary>
		public FormAdapterElement clientSiteFlag;
		///<summary>[PRINT_UPPER_SITE_CODE]</summary>
		public FormAdapterElement printUpperSiteCode;
		///<summary>[TEAM_CODE]</summary>
		public FormAdapterElement teamCode;
		///<summary>[CHECK_NAME]</summary>
		public FormAdapterElement checkName;
		///<summary>[PRICE_COST_FROM_DATE]</summary>
		public FormAdapterElement priceCostFromDate;
		///<summary>[VALID_FLAG]</summary>
		public FormAdapterElement validFlag;
		///<summary>[INSERT_DATE_TIME]</summary>
		public FormAdapterElement insertDateTime;
		///<summary>[INSERT_OPERATOR_CODE]</summary>
		public FormAdapterElement insertOperatorCode;
		///<summary>[UPDATE_DATE_TIME]</summary>
		public FormAdapterElement updateDateTime;
		///<summary>[OPERATOR_CODE]</summary>
		public FormAdapterElement operatorCode;
		

		/// <summary>݂̃f[^\[X擾
		/// </summary>
        public override Entity GetEntity()
        {
            return this.theEntity;
        }
		/// <summary>\̍XV
		/// </summary>
        public override void RenderView()
        {
			if(this.siteCode != null) this.siteCode.Render();
			if(this.openDate != null) this.openDate.Render();
			if(this.closeDate != null) this.closeDate.Render();
			if(this.sortSeq != null) this.sortSeq.Render();
			if(this.name != null) this.name.Render();
			if(this.ankName != null) this.ankName.Render();
			if(this.companyCode != null) this.companyCode.Render();
			if(this.siteUrl != null) this.siteUrl.Render();
			if(this.siteUrlOther != null) this.siteUrlOther.Render();
			if(this.siteCategory1 != null) this.siteCategory1.Render();
			if(this.siteCategory2 != null) this.siteCategory2.Render();
			if(this.deviceCode != null) this.deviceCode.Render();
			if(this.menuDeviceCode != null) this.menuDeviceCode.Render();
			if(this.menuAdtypeCode != null) this.menuAdtypeCode.Render();
			if(this.goodsCategoryCode != null) this.goodsCategoryCode.Render();
			if(this.carrierCode1 != null) this.carrierCode1.Render();
			if(this.carrierCode2 != null) this.carrierCode2.Render();
			if(this.carrierCode3 != null) this.carrierCode3.Render();
			if(this.carrierCode4 != null) this.carrierCode4.Render();
			if(this.mediaCostRate != null) this.mediaCostRate.Render();
			if(this.agencyMarginRate != null) this.agencyMarginRate.Render();
			if(this.spOpenFlag != null) this.spOpenFlag.Render();
			if(this.pmOpenFlag != null) this.pmOpenFlag.Render();
			if(this.ioOpenFlag != null) this.ioOpenFlag.Render();
			if(this.adGuideOpenFlag != null) this.adGuideOpenFlag.Render();
			if(this.impression != null) this.impression.Render();
			if(this.impressionTerm != null) this.impressionTerm.Render();
			if(this.impressionToppage != null) this.impressionToppage.Render();
			if(this.impressionToppageTerm != null) this.impressionToppageTerm.Render();
			if(this.uniqueUser != null) this.uniqueUser.Render();
			if(this.uniqueUserTerm != null) this.uniqueUserTerm.Render();
			if(this.uniqueUserToppage != null) this.uniqueUserToppage.Render();
			if(this.uniqueUserToppageTerm != null) this.uniqueUserToppageTerm.Render();
			if(this.maleRate != null) this.maleRate.Render();
			if(this.femaleRate != null) this.femaleRate.Render();
			if(this.publishedYear != null) this.publishedYear.Render();
			if(this.publishedMonth != null) this.publishedMonth.Render();
			if(this.publishedDay != null) this.publishedDay.Render();
			if(this.publishedDataKind != null) this.publishedDataKind.Render();
			if(this.upperSiteCode != null) this.upperSiteCode.Render();
			if(this.paymentCompany != null) this.paymentCompany.Render();
			if(this.businessDirectFlag != null) this.businessDirectFlag.Render();
			if(this.adserverFlag != null) this.adserverFlag.Render();
			if(this.specialmenuFlag != null) this.specialmenuFlag.Render();
			if(this.topOpenFlag != null) this.topOpenFlag.Render();
			if(this.openMenuCount != null) this.openMenuCount.Render();
			if(this.makeDate != null) this.makeDate.Render();
			if(this.documentAddress != null) this.documentAddress.Render();
			if(this.agCompanyCode != null) this.agCompanyCode.Render();
			if(this.insideOpenLevel != null) this.insideOpenLevel.Render();
			if(this.outsideOpenLevel != null) this.outsideOpenLevel.Render();
			if(this.homeRate != null) this.homeRate.Render();
			if(this.workRate != null) this.workRate.Render();
			if(this.overlapRate != null) this.overlapRate.Render();
			if(this.businessRepDirectFlag != null) this.businessRepDirectFlag.Render();
			if(this.clientSiteFlag != null) this.clientSiteFlag.Render();
			if(this.printUpperSiteCode != null) this.printUpperSiteCode.Render();
			if(this.teamCode != null) this.teamCode.Render();
			if(this.checkName != null) this.checkName.Render();
			if(this.priceCostFromDate != null) this.priceCostFromDate.Render();
			if(this.validFlag != null) this.validFlag.Render();
			if(this.insertDateTime != null) this.insertDateTime.Render();
			if(this.insertOperatorCode != null) this.insertOperatorCode.Render();
			if(this.updateDateTime != null) this.updateDateTime.Render();
			if(this.operatorCode != null) this.operatorCode.Render();
			
        }

		/// <summary>̃A_v^[f[^ݒ
		/// </summary>
        /// <param name="dataSource">̃A_v^[f[^</param>
        public override void SetEntity(Entity entity)
        {
        	this.theEntity = (MastSiteTableRow)entity;
			if(this.siteCode != null) this.siteCode.SetValue(this.theEntity.siteCode);
			if(this.openDate != null) this.openDate.SetValue(this.theEntity.openDate);
			if(this.closeDate != null) this.closeDate.SetValue(this.theEntity.closeDate);
			if(this.sortSeq != null) this.sortSeq.SetValue(this.theEntity.sortSeq);
			if(this.name != null) this.name.SetValue(this.theEntity.name);
			if(this.ankName != null) this.ankName.SetValue(this.theEntity.ankName);
			if(this.companyCode != null) this.companyCode.SetValue(this.theEntity.companyCode);
			if(this.siteUrl != null) this.siteUrl.SetValue(this.theEntity.siteUrl);
			if(this.siteUrlOther != null) this.siteUrlOther.SetValue(this.theEntity.siteUrlOther);
			if(this.siteCategory1 != null) this.siteCategory1.SetValue(this.theEntity.siteCategory1);
			if(this.siteCategory2 != null) this.siteCategory2.SetValue(this.theEntity.siteCategory2);
			if(this.deviceCode != null) this.deviceCode.SetValue(this.theEntity.deviceCode);
			if(this.menuDeviceCode != null) this.menuDeviceCode.SetValue(this.theEntity.menuDeviceCode);
			if(this.menuAdtypeCode != null) this.menuAdtypeCode.SetValue(this.theEntity.menuAdtypeCode);
			if(this.goodsCategoryCode != null) this.goodsCategoryCode.SetValue(this.theEntity.goodsCategoryCode);
			if(this.carrierCode1 != null) this.carrierCode1.SetValue(this.theEntity.carrierCode1);
			if(this.carrierCode2 != null) this.carrierCode2.SetValue(this.theEntity.carrierCode2);
			if(this.carrierCode3 != null) this.carrierCode3.SetValue(this.theEntity.carrierCode3);
			if(this.carrierCode4 != null) this.carrierCode4.SetValue(this.theEntity.carrierCode4);
			if(this.mediaCostRate != null) this.mediaCostRate.SetValue(this.theEntity.mediaCostRate);
			if(this.agencyMarginRate != null) this.agencyMarginRate.SetValue(this.theEntity.agencyMarginRate);
			if(this.spOpenFlag != null) this.spOpenFlag.SetValue(this.theEntity.spOpenFlag);
			if(this.pmOpenFlag != null) this.pmOpenFlag.SetValue(this.theEntity.pmOpenFlag);
			if(this.ioOpenFlag != null) this.ioOpenFlag.SetValue(this.theEntity.ioOpenFlag);
			if(this.adGuideOpenFlag != null) this.adGuideOpenFlag.SetValue(this.theEntity.adGuideOpenFlag);
			if(this.impression != null) this.impression.SetValue(this.theEntity.impression);
			if(this.impressionTerm != null) this.impressionTerm.SetValue(this.theEntity.impressionTerm);
			if(this.impressionToppage != null) this.impressionToppage.SetValue(this.theEntity.impressionToppage);
			if(this.impressionToppageTerm != null) this.impressionToppageTerm.SetValue(this.theEntity.impressionToppageTerm);
			if(this.uniqueUser != null) this.uniqueUser.SetValue(this.theEntity.uniqueUser);
			if(this.uniqueUserTerm != null) this.uniqueUserTerm.SetValue(this.theEntity.uniqueUserTerm);
			if(this.uniqueUserToppage != null) this.uniqueUserToppage.SetValue(this.theEntity.uniqueUserToppage);
			if(this.uniqueUserToppageTerm != null) this.uniqueUserToppageTerm.SetValue(this.theEntity.uniqueUserToppageTerm);
			if(this.maleRate != null) this.maleRate.SetValue(this.theEntity.maleRate);
			if(this.femaleRate != null) this.femaleRate.SetValue(this.theEntity.femaleRate);
			if(this.publishedYear != null) this.publishedYear.SetValue(this.theEntity.publishedYear);
			if(this.publishedMonth != null) this.publishedMonth.SetValue(this.theEntity.publishedMonth);
			if(this.publishedDay != null) this.publishedDay.SetValue(this.theEntity.publishedDay);
			if(this.publishedDataKind != null) this.publishedDataKind.SetValue(this.theEntity.publishedDataKind);
			if(this.upperSiteCode != null) this.upperSiteCode.SetValue(this.theEntity.upperSiteCode);
			if(this.paymentCompany != null) this.paymentCompany.SetValue(this.theEntity.paymentCompany);
			if(this.businessDirectFlag != null) this.businessDirectFlag.SetValue(this.theEntity.businessDirectFlag);
			if(this.adserverFlag != null) this.adserverFlag.SetValue(this.theEntity.adserverFlag);
			if(this.specialmenuFlag != null) this.specialmenuFlag.SetValue(this.theEntity.specialmenuFlag);
			if(this.topOpenFlag != null) this.topOpenFlag.SetValue(this.theEntity.topOpenFlag);
			if(this.openMenuCount != null) this.openMenuCount.SetValue(this.theEntity.openMenuCount);
			if(this.makeDate != null) this.makeDate.SetValue(this.theEntity.makeDate);
			if(this.documentAddress != null) this.documentAddress.SetValue(this.theEntity.documentAddress);
			if(this.agCompanyCode != null) this.agCompanyCode.SetValue(this.theEntity.agCompanyCode);
			if(this.insideOpenLevel != null) this.insideOpenLevel.SetValue(this.theEntity.insideOpenLevel);
			if(this.outsideOpenLevel != null) this.outsideOpenLevel.SetValue(this.theEntity.outsideOpenLevel);
			if(this.homeRate != null) this.homeRate.SetValue(this.theEntity.homeRate);
			if(this.workRate != null) this.workRate.SetValue(this.theEntity.workRate);
			if(this.overlapRate != null) this.overlapRate.SetValue(this.theEntity.overlapRate);
			if(this.businessRepDirectFlag != null) this.businessRepDirectFlag.SetValue(this.theEntity.businessRepDirectFlag);
			if(this.clientSiteFlag != null) this.clientSiteFlag.SetValue(this.theEntity.clientSiteFlag);
			if(this.printUpperSiteCode != null) this.printUpperSiteCode.SetValue(this.theEntity.printUpperSiteCode);
			if(this.teamCode != null) this.teamCode.SetValue(this.theEntity.teamCode);
			if(this.checkName != null) this.checkName.SetValue(this.theEntity.checkName);
			if(this.priceCostFromDate != null) this.priceCostFromDate.SetValue(this.theEntity.priceCostFromDate);
			if(this.validFlag != null) this.validFlag.SetValue(this.theEntity.validFlag);
			if(this.insertDateTime != null) this.insertDateTime.SetValue(this.theEntity.insertDateTime);
			if(this.insertOperatorCode != null) this.insertOperatorCode.SetValue(this.theEntity.insertOperatorCode);
			if(this.updateDateTime != null) this.updateDateTime.SetValue(this.theEntity.updateDateTime);
			if(this.operatorCode != null) this.operatorCode.SetValue(this.theEntity.operatorCode);
			

        }

		/// <summary>UI͂ꂽef[^\[XɎ荞
		/// </summary>
        public override void UpdateEntity()
        {
			if(this.siteCode != null) this.theEntity.siteCode = StringUtil.StringValue(this.siteCode.GetValue());
			if(this.openDate != null) this.theEntity.openDate = StringUtil.StringValue(this.openDate.GetValue());
			if(this.closeDate != null) this.theEntity.closeDate = StringUtil.StringValue(this.closeDate.GetValue());
			if(this.sortSeq != null) this.theEntity.sortSeq = NumberUtil.Value<Int16?>(this.sortSeq.GetValue());
			if(this.name != null) this.theEntity.name = StringUtil.StringValue(this.name.GetValue());
			if(this.ankName != null) this.theEntity.ankName = StringUtil.StringValue(this.ankName.GetValue());
			if(this.companyCode != null) this.theEntity.companyCode = StringUtil.StringValue(this.companyCode.GetValue());
			if(this.siteUrl != null) this.theEntity.siteUrl = StringUtil.StringValue(this.siteUrl.GetValue());
			if(this.siteUrlOther != null) this.theEntity.siteUrlOther = StringUtil.StringValue(this.siteUrlOther.GetValue());
			if(this.siteCategory1 != null) this.theEntity.siteCategory1 = NumberUtil.Value<Int16?>(this.siteCategory1.GetValue());
			if(this.siteCategory2 != null) this.theEntity.siteCategory2 = NumberUtil.Value<Int16?>(this.siteCategory2.GetValue());
			if(this.deviceCode != null) this.theEntity.deviceCode = NumberUtil.Value<Int16>(this.deviceCode.GetValue());
			if(this.menuDeviceCode != null) this.theEntity.menuDeviceCode = NumberUtil.Value<Int16?>(this.menuDeviceCode.GetValue());
			if(this.menuAdtypeCode != null) this.theEntity.menuAdtypeCode = NumberUtil.Value<Int16?>(this.menuAdtypeCode.GetValue());
			if(this.goodsCategoryCode != null) this.theEntity.goodsCategoryCode = NumberUtil.Value<Int16?>(this.goodsCategoryCode.GetValue());
			if(this.carrierCode1 != null) this.theEntity.carrierCode1 = NumberUtil.Value<Int16?>(this.carrierCode1.GetValue());
			if(this.carrierCode2 != null) this.theEntity.carrierCode2 = NumberUtil.Value<Int16?>(this.carrierCode2.GetValue());
			if(this.carrierCode3 != null) this.theEntity.carrierCode3 = NumberUtil.Value<Int16?>(this.carrierCode3.GetValue());
			if(this.carrierCode4 != null) this.theEntity.carrierCode4 = NumberUtil.Value<Int16?>(this.carrierCode4.GetValue());
			if(this.mediaCostRate != null) this.theEntity.mediaCostRate = NumberUtil.Value<Decimal?>(this.mediaCostRate.GetValue());
			if(this.agencyMarginRate != null) this.theEntity.agencyMarginRate = NumberUtil.Value<Decimal?>(this.agencyMarginRate.GetValue());
			if(this.spOpenFlag != null) this.theEntity.spOpenFlag = NumberUtil.Value<Int16?>(this.spOpenFlag.GetValue());
			if(this.pmOpenFlag != null) this.theEntity.pmOpenFlag = NumberUtil.Value<Int16?>(this.pmOpenFlag.GetValue());
			if(this.ioOpenFlag != null) this.theEntity.ioOpenFlag = NumberUtil.Value<Int16?>(this.ioOpenFlag.GetValue());
			if(this.adGuideOpenFlag != null) this.theEntity.adGuideOpenFlag = NumberUtil.Value<Int16?>(this.adGuideOpenFlag.GetValue());
			if(this.impression != null) this.theEntity.impression = NumberUtil.Value<Decimal?>(this.impression.GetValue());
			if(this.impressionTerm != null) this.theEntity.impressionTerm = NumberUtil.Value<Int16?>(this.impressionTerm.GetValue());
			if(this.impressionToppage != null) this.theEntity.impressionToppage = NumberUtil.Value<Decimal?>(this.impressionToppage.GetValue());
			if(this.impressionToppageTerm != null) this.theEntity.impressionToppageTerm = NumberUtil.Value<Int16?>(this.impressionToppageTerm.GetValue());
			if(this.uniqueUser != null) this.theEntity.uniqueUser = NumberUtil.Value<Decimal?>(this.uniqueUser.GetValue());
			if(this.uniqueUserTerm != null) this.theEntity.uniqueUserTerm = NumberUtil.Value<Int16?>(this.uniqueUserTerm.GetValue());
			if(this.uniqueUserToppage != null) this.theEntity.uniqueUserToppage = NumberUtil.Value<Decimal?>(this.uniqueUserToppage.GetValue());
			if(this.uniqueUserToppageTerm != null) this.theEntity.uniqueUserToppageTerm = NumberUtil.Value<Int16?>(this.uniqueUserToppageTerm.GetValue());
			if(this.maleRate != null) this.theEntity.maleRate = NumberUtil.Value<Decimal?>(this.maleRate.GetValue());
			if(this.femaleRate != null) this.theEntity.femaleRate = NumberUtil.Value<Decimal?>(this.femaleRate.GetValue());
			if(this.publishedYear != null) this.theEntity.publishedYear = NumberUtil.Value<Int16?>(this.publishedYear.GetValue());
			if(this.publishedMonth != null) this.theEntity.publishedMonth = NumberUtil.Value<Int16?>(this.publishedMonth.GetValue());
			if(this.publishedDay != null) this.theEntity.publishedDay = NumberUtil.Value<Int16?>(this.publishedDay.GetValue());
			if(this.publishedDataKind != null) this.theEntity.publishedDataKind = NumberUtil.Value<Int16?>(this.publishedDataKind.GetValue());
			if(this.upperSiteCode != null) this.theEntity.upperSiteCode = StringUtil.StringValue(this.upperSiteCode.GetValue());
			if(this.paymentCompany != null) this.theEntity.paymentCompany = StringUtil.StringValue(this.paymentCompany.GetValue());
			if(this.businessDirectFlag != null) this.theEntity.businessDirectFlag = NumberUtil.Value<Int16?>(this.businessDirectFlag.GetValue());
			if(this.adserverFlag != null) this.theEntity.adserverFlag = NumberUtil.Value<Int16?>(this.adserverFlag.GetValue());
			if(this.specialmenuFlag != null) this.theEntity.specialmenuFlag = NumberUtil.Value<Int16?>(this.specialmenuFlag.GetValue());
			if(this.topOpenFlag != null) this.theEntity.topOpenFlag = NumberUtil.Value<Int16?>(this.topOpenFlag.GetValue());
			if(this.openMenuCount != null) this.theEntity.openMenuCount = NumberUtil.Value<Int16?>(this.openMenuCount.GetValue());
			if(this.makeDate != null) this.theEntity.makeDate = StringUtil.StringValue(this.makeDate.GetValue());
			if(this.documentAddress != null) this.theEntity.documentAddress = StringUtil.StringValue(this.documentAddress.GetValue());
			if(this.agCompanyCode != null) this.theEntity.agCompanyCode = StringUtil.StringValue(this.agCompanyCode.GetValue());
			if(this.insideOpenLevel != null) this.theEntity.insideOpenLevel = NumberUtil.Value<Int16?>(this.insideOpenLevel.GetValue());
			if(this.outsideOpenLevel != null) this.theEntity.outsideOpenLevel = NumberUtil.Value<Int16?>(this.outsideOpenLevel.GetValue());
			if(this.homeRate != null) this.theEntity.homeRate = NumberUtil.Value<Decimal?>(this.homeRate.GetValue());
			if(this.workRate != null) this.theEntity.workRate = NumberUtil.Value<Decimal?>(this.workRate.GetValue());
			if(this.overlapRate != null) this.theEntity.overlapRate = NumberUtil.Value<Decimal?>(this.overlapRate.GetValue());
			if(this.businessRepDirectFlag != null) this.theEntity.businessRepDirectFlag = NumberUtil.Value<Int16?>(this.businessRepDirectFlag.GetValue());
			if(this.clientSiteFlag != null) this.theEntity.clientSiteFlag = NumberUtil.Value<Int16?>(this.clientSiteFlag.GetValue());
			if(this.printUpperSiteCode != null) this.theEntity.printUpperSiteCode = StringUtil.StringValue(this.printUpperSiteCode.GetValue());
			if(this.teamCode != null) this.theEntity.teamCode = NumberUtil.Value<Int16?>(this.teamCode.GetValue());
			if(this.checkName != null) this.theEntity.checkName = StringUtil.StringValue(this.checkName.GetValue());
			if(this.priceCostFromDate != null) this.theEntity.priceCostFromDate = StringUtil.StringValue(this.priceCostFromDate.GetValue());
			if(this.validFlag != null) this.theEntity.validFlag = NumberUtil.Value<Int16?>(this.validFlag.GetValue());
			if(this.insertDateTime != null) this.theEntity.insertDateTime = DateUtil.DateValue(this.insertDateTime.GetValue());
			if(this.insertOperatorCode != null) this.theEntity.insertOperatorCode = StringUtil.StringValue(this.insertOperatorCode.GetValue());
			if(this.updateDateTime != null) this.theEntity.updateDateTime = DateUtil.DateValue(this.updateDateTime.GetValue());
			if(this.operatorCode != null) this.theEntity.operatorCode = StringUtil.StringValue(this.operatorCode.GetValue());
			
        }

		/// <summary>UI͂ꂽe荞
		/// </summary>
        public override void UpdateFields()
        {
			if(this.siteCode != null) this.siteCode.UpdateField();
			if(this.openDate != null) this.openDate.UpdateField();
			if(this.closeDate != null) this.closeDate.UpdateField();
			if(this.sortSeq != null) this.sortSeq.UpdateField();
			if(this.name != null) this.name.UpdateField();
			if(this.ankName != null) this.ankName.UpdateField();
			if(this.companyCode != null) this.companyCode.UpdateField();
			if(this.siteUrl != null) this.siteUrl.UpdateField();
			if(this.siteUrlOther != null) this.siteUrlOther.UpdateField();
			if(this.siteCategory1 != null) this.siteCategory1.UpdateField();
			if(this.siteCategory2 != null) this.siteCategory2.UpdateField();
			if(this.deviceCode != null) this.deviceCode.UpdateField();
			if(this.menuDeviceCode != null) this.menuDeviceCode.UpdateField();
			if(this.menuAdtypeCode != null) this.menuAdtypeCode.UpdateField();
			if(this.goodsCategoryCode != null) this.goodsCategoryCode.UpdateField();
			if(this.carrierCode1 != null) this.carrierCode1.UpdateField();
			if(this.carrierCode2 != null) this.carrierCode2.UpdateField();
			if(this.carrierCode3 != null) this.carrierCode3.UpdateField();
			if(this.carrierCode4 != null) this.carrierCode4.UpdateField();
			if(this.mediaCostRate != null) this.mediaCostRate.UpdateField();
			if(this.agencyMarginRate != null) this.agencyMarginRate.UpdateField();
			if(this.spOpenFlag != null) this.spOpenFlag.UpdateField();
			if(this.pmOpenFlag != null) this.pmOpenFlag.UpdateField();
			if(this.ioOpenFlag != null) this.ioOpenFlag.UpdateField();
			if(this.adGuideOpenFlag != null) this.adGuideOpenFlag.UpdateField();
			if(this.impression != null) this.impression.UpdateField();
			if(this.impressionTerm != null) this.impressionTerm.UpdateField();
			if(this.impressionToppage != null) this.impressionToppage.UpdateField();
			if(this.impressionToppageTerm != null) this.impressionToppageTerm.UpdateField();
			if(this.uniqueUser != null) this.uniqueUser.UpdateField();
			if(this.uniqueUserTerm != null) this.uniqueUserTerm.UpdateField();
			if(this.uniqueUserToppage != null) this.uniqueUserToppage.UpdateField();
			if(this.uniqueUserToppageTerm != null) this.uniqueUserToppageTerm.UpdateField();
			if(this.maleRate != null) this.maleRate.UpdateField();
			if(this.femaleRate != null) this.femaleRate.UpdateField();
			if(this.publishedYear != null) this.publishedYear.UpdateField();
			if(this.publishedMonth != null) this.publishedMonth.UpdateField();
			if(this.publishedDay != null) this.publishedDay.UpdateField();
			if(this.publishedDataKind != null) this.publishedDataKind.UpdateField();
			if(this.upperSiteCode != null) this.upperSiteCode.UpdateField();
			if(this.paymentCompany != null) this.paymentCompany.UpdateField();
			if(this.businessDirectFlag != null) this.businessDirectFlag.UpdateField();
			if(this.adserverFlag != null) this.adserverFlag.UpdateField();
			if(this.specialmenuFlag != null) this.specialmenuFlag.UpdateField();
			if(this.topOpenFlag != null) this.topOpenFlag.UpdateField();
			if(this.openMenuCount != null) this.openMenuCount.UpdateField();
			if(this.makeDate != null) this.makeDate.UpdateField();
			if(this.documentAddress != null) this.documentAddress.UpdateField();
			if(this.agCompanyCode != null) this.agCompanyCode.UpdateField();
			if(this.insideOpenLevel != null) this.insideOpenLevel.UpdateField();
			if(this.outsideOpenLevel != null) this.outsideOpenLevel.UpdateField();
			if(this.homeRate != null) this.homeRate.UpdateField();
			if(this.workRate != null) this.workRate.UpdateField();
			if(this.overlapRate != null) this.overlapRate.UpdateField();
			if(this.businessRepDirectFlag != null) this.businessRepDirectFlag.UpdateField();
			if(this.clientSiteFlag != null) this.clientSiteFlag.UpdateField();
			if(this.printUpperSiteCode != null) this.printUpperSiteCode.UpdateField();
			if(this.teamCode != null) this.teamCode.UpdateField();
			if(this.checkName != null) this.checkName.UpdateField();
			if(this.priceCostFromDate != null) this.priceCostFromDate.UpdateField();
			if(this.validFlag != null) this.validFlag.UpdateField();
			if(this.insertDateTime != null) this.insertDateTime.UpdateField();
			if(this.insertOperatorCode != null) this.insertOperatorCode.UpdateField();
			if(this.updateDateTime != null) this.updateDateTime.UpdateField();
			if(this.operatorCode != null) this.operatorCode.UpdateField();
			
        }

		/// <summary>͓e؂
		/// ؃G[MessagesXgɑSẴG[B
		/// </summary>
        public override bool Validate()
        {
            bool valid = true;
			
			if(this.siteCode != null){
			    if(!this.siteCode.Validate()){
				    valid = false;
				    this.messages.Add(this.siteCode.ErrorMessage);
			    }
			}
			
			if(this.openDate != null){
			    if(!this.openDate.Validate()){
				    valid = false;
				    this.messages.Add(this.openDate.ErrorMessage);
			    }
			}
			
			if(this.closeDate != null){
			    if(!this.closeDate.Validate()){
				    valid = false;
				    this.messages.Add(this.closeDate.ErrorMessage);
			    }
			}
			
			if(this.sortSeq != null){
			    if(!this.sortSeq.Validate()){
				    valid = false;
				    this.messages.Add(this.sortSeq.ErrorMessage);
			    }
			}
			
			if(this.name != null){
			    if(!this.name.Validate()){
				    valid = false;
				    this.messages.Add(this.name.ErrorMessage);
			    }
			}
			
			if(this.ankName != null){
			    if(!this.ankName.Validate()){
				    valid = false;
				    this.messages.Add(this.ankName.ErrorMessage);
			    }
			}
			
			if(this.companyCode != null){
			    if(!this.companyCode.Validate()){
				    valid = false;
				    this.messages.Add(this.companyCode.ErrorMessage);
			    }
			}
			
			if(this.siteUrl != null){
			    if(!this.siteUrl.Validate()){
				    valid = false;
				    this.messages.Add(this.siteUrl.ErrorMessage);
			    }
			}
			
			if(this.siteUrlOther != null){
			    if(!this.siteUrlOther.Validate()){
				    valid = false;
				    this.messages.Add(this.siteUrlOther.ErrorMessage);
			    }
			}
			
			if(this.siteCategory1 != null){
			    if(!this.siteCategory1.Validate()){
				    valid = false;
				    this.messages.Add(this.siteCategory1.ErrorMessage);
			    }
			}
			
			if(this.siteCategory2 != null){
			    if(!this.siteCategory2.Validate()){
				    valid = false;
				    this.messages.Add(this.siteCategory2.ErrorMessage);
			    }
			}
			
			if(this.deviceCode != null){
			    if(!this.deviceCode.Validate()){
				    valid = false;
				    this.messages.Add(this.deviceCode.ErrorMessage);
			    }
			}
			
			if(this.menuDeviceCode != null){
			    if(!this.menuDeviceCode.Validate()){
				    valid = false;
				    this.messages.Add(this.menuDeviceCode.ErrorMessage);
			    }
			}
			
			if(this.menuAdtypeCode != null){
			    if(!this.menuAdtypeCode.Validate()){
				    valid = false;
				    this.messages.Add(this.menuAdtypeCode.ErrorMessage);
			    }
			}
			
			if(this.goodsCategoryCode != null){
			    if(!this.goodsCategoryCode.Validate()){
				    valid = false;
				    this.messages.Add(this.goodsCategoryCode.ErrorMessage);
			    }
			}
			
			if(this.carrierCode1 != null){
			    if(!this.carrierCode1.Validate()){
				    valid = false;
				    this.messages.Add(this.carrierCode1.ErrorMessage);
			    }
			}
			
			if(this.carrierCode2 != null){
			    if(!this.carrierCode2.Validate()){
				    valid = false;
				    this.messages.Add(this.carrierCode2.ErrorMessage);
			    }
			}
			
			if(this.carrierCode3 != null){
			    if(!this.carrierCode3.Validate()){
				    valid = false;
				    this.messages.Add(this.carrierCode3.ErrorMessage);
			    }
			}
			
			if(this.carrierCode4 != null){
			    if(!this.carrierCode4.Validate()){
				    valid = false;
				    this.messages.Add(this.carrierCode4.ErrorMessage);
			    }
			}
			
			if(this.mediaCostRate != null){
			    if(!this.mediaCostRate.Validate()){
				    valid = false;
				    this.messages.Add(this.mediaCostRate.ErrorMessage);
			    }
			}
			
			if(this.agencyMarginRate != null){
			    if(!this.agencyMarginRate.Validate()){
				    valid = false;
				    this.messages.Add(this.agencyMarginRate.ErrorMessage);
			    }
			}
			
			if(this.spOpenFlag != null){
			    if(!this.spOpenFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.spOpenFlag.ErrorMessage);
			    }
			}
			
			if(this.pmOpenFlag != null){
			    if(!this.pmOpenFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.pmOpenFlag.ErrorMessage);
			    }
			}
			
			if(this.ioOpenFlag != null){
			    if(!this.ioOpenFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.ioOpenFlag.ErrorMessage);
			    }
			}
			
			if(this.adGuideOpenFlag != null){
			    if(!this.adGuideOpenFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.adGuideOpenFlag.ErrorMessage);
			    }
			}
			
			if(this.impression != null){
			    if(!this.impression.Validate()){
				    valid = false;
				    this.messages.Add(this.impression.ErrorMessage);
			    }
			}
			
			if(this.impressionTerm != null){
			    if(!this.impressionTerm.Validate()){
				    valid = false;
				    this.messages.Add(this.impressionTerm.ErrorMessage);
			    }
			}
			
			if(this.impressionToppage != null){
			    if(!this.impressionToppage.Validate()){
				    valid = false;
				    this.messages.Add(this.impressionToppage.ErrorMessage);
			    }
			}
			
			if(this.impressionToppageTerm != null){
			    if(!this.impressionToppageTerm.Validate()){
				    valid = false;
				    this.messages.Add(this.impressionToppageTerm.ErrorMessage);
			    }
			}
			
			if(this.uniqueUser != null){
			    if(!this.uniqueUser.Validate()){
				    valid = false;
				    this.messages.Add(this.uniqueUser.ErrorMessage);
			    }
			}
			
			if(this.uniqueUserTerm != null){
			    if(!this.uniqueUserTerm.Validate()){
				    valid = false;
				    this.messages.Add(this.uniqueUserTerm.ErrorMessage);
			    }
			}
			
			if(this.uniqueUserToppage != null){
			    if(!this.uniqueUserToppage.Validate()){
				    valid = false;
				    this.messages.Add(this.uniqueUserToppage.ErrorMessage);
			    }
			}
			
			if(this.uniqueUserToppageTerm != null){
			    if(!this.uniqueUserToppageTerm.Validate()){
				    valid = false;
				    this.messages.Add(this.uniqueUserToppageTerm.ErrorMessage);
			    }
			}
			
			if(this.maleRate != null){
			    if(!this.maleRate.Validate()){
				    valid = false;
				    this.messages.Add(this.maleRate.ErrorMessage);
			    }
			}
			
			if(this.femaleRate != null){
			    if(!this.femaleRate.Validate()){
				    valid = false;
				    this.messages.Add(this.femaleRate.ErrorMessage);
			    }
			}
			
			if(this.publishedYear != null){
			    if(!this.publishedYear.Validate()){
				    valid = false;
				    this.messages.Add(this.publishedYear.ErrorMessage);
			    }
			}
			
			if(this.publishedMonth != null){
			    if(!this.publishedMonth.Validate()){
				    valid = false;
				    this.messages.Add(this.publishedMonth.ErrorMessage);
			    }
			}
			
			if(this.publishedDay != null){
			    if(!this.publishedDay.Validate()){
				    valid = false;
				    this.messages.Add(this.publishedDay.ErrorMessage);
			    }
			}
			
			if(this.publishedDataKind != null){
			    if(!this.publishedDataKind.Validate()){
				    valid = false;
				    this.messages.Add(this.publishedDataKind.ErrorMessage);
			    }
			}
			
			if(this.upperSiteCode != null){
			    if(!this.upperSiteCode.Validate()){
				    valid = false;
				    this.messages.Add(this.upperSiteCode.ErrorMessage);
			    }
			}
			
			if(this.paymentCompany != null){
			    if(!this.paymentCompany.Validate()){
				    valid = false;
				    this.messages.Add(this.paymentCompany.ErrorMessage);
			    }
			}
			
			if(this.businessDirectFlag != null){
			    if(!this.businessDirectFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.businessDirectFlag.ErrorMessage);
			    }
			}
			
			if(this.adserverFlag != null){
			    if(!this.adserverFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.adserverFlag.ErrorMessage);
			    }
			}
			
			if(this.specialmenuFlag != null){
			    if(!this.specialmenuFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.specialmenuFlag.ErrorMessage);
			    }
			}
			
			if(this.topOpenFlag != null){
			    if(!this.topOpenFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.topOpenFlag.ErrorMessage);
			    }
			}
			
			if(this.openMenuCount != null){
			    if(!this.openMenuCount.Validate()){
				    valid = false;
				    this.messages.Add(this.openMenuCount.ErrorMessage);
			    }
			}
			
			if(this.makeDate != null){
			    if(!this.makeDate.Validate()){
				    valid = false;
				    this.messages.Add(this.makeDate.ErrorMessage);
			    }
			}
			
			if(this.documentAddress != null){
			    if(!this.documentAddress.Validate()){
				    valid = false;
				    this.messages.Add(this.documentAddress.ErrorMessage);
			    }
			}
			
			if(this.agCompanyCode != null){
			    if(!this.agCompanyCode.Validate()){
				    valid = false;
				    this.messages.Add(this.agCompanyCode.ErrorMessage);
			    }
			}
			
			if(this.insideOpenLevel != null){
			    if(!this.insideOpenLevel.Validate()){
				    valid = false;
				    this.messages.Add(this.insideOpenLevel.ErrorMessage);
			    }
			}
			
			if(this.outsideOpenLevel != null){
			    if(!this.outsideOpenLevel.Validate()){
				    valid = false;
				    this.messages.Add(this.outsideOpenLevel.ErrorMessage);
			    }
			}
			
			if(this.homeRate != null){
			    if(!this.homeRate.Validate()){
				    valid = false;
				    this.messages.Add(this.homeRate.ErrorMessage);
			    }
			}
			
			if(this.workRate != null){
			    if(!this.workRate.Validate()){
				    valid = false;
				    this.messages.Add(this.workRate.ErrorMessage);
			    }
			}
			
			if(this.overlapRate != null){
			    if(!this.overlapRate.Validate()){
				    valid = false;
				    this.messages.Add(this.overlapRate.ErrorMessage);
			    }
			}
			
			if(this.businessRepDirectFlag != null){
			    if(!this.businessRepDirectFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.businessRepDirectFlag.ErrorMessage);
			    }
			}
			
			if(this.clientSiteFlag != null){
			    if(!this.clientSiteFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.clientSiteFlag.ErrorMessage);
			    }
			}
			
			if(this.printUpperSiteCode != null){
			    if(!this.printUpperSiteCode.Validate()){
				    valid = false;
				    this.messages.Add(this.printUpperSiteCode.ErrorMessage);
			    }
			}
			
			if(this.teamCode != null){
			    if(!this.teamCode.Validate()){
				    valid = false;
				    this.messages.Add(this.teamCode.ErrorMessage);
			    }
			}
			
			if(this.checkName != null){
			    if(!this.checkName.Validate()){
				    valid = false;
				    this.messages.Add(this.checkName.ErrorMessage);
			    }
			}
			
			if(this.priceCostFromDate != null){
			    if(!this.priceCostFromDate.Validate()){
				    valid = false;
				    this.messages.Add(this.priceCostFromDate.ErrorMessage);
			    }
			}
			
			if(this.validFlag != null){
			    if(!this.validFlag.Validate()){
				    valid = false;
				    this.messages.Add(this.validFlag.ErrorMessage);
			    }
			}
			
			if(this.insertDateTime != null){
			    if(!this.insertDateTime.Validate()){
				    valid = false;
				    this.messages.Add(this.insertDateTime.ErrorMessage);
			    }
			}
			
			if(this.insertOperatorCode != null){
			    if(!this.insertOperatorCode.Validate()){
				    valid = false;
				    this.messages.Add(this.insertOperatorCode.ErrorMessage);
			    }
			}
			
			if(this.updateDateTime != null){
			    if(!this.updateDateTime.Validate()){
				    valid = false;
				    this.messages.Add(this.updateDateTime.ErrorMessage);
			    }
			}
			
			if(this.operatorCode != null){
			    if(!this.operatorCode.Validate()){
				    valid = false;
				    this.messages.Add(this.operatorCode.ErrorMessage);
			    }
			}
			

            return valid;
        }
		
	}
/* 
    // initialize code sample
    // Form̃o[ɈȉǉB
    //     private MastSiteFormAdapter formAdapter;
    //     private MastSiteProperty property;
    //     private MastSiteEntity property;
    // tB[hƓ̓Rg[킹B
    // 2(tB^[)͓KXtB[hɍ킹ĕύX
    formAdapter = new MastSiteFormAdapter();

	
    formAdapter.siteCode= new TextBoxAdapterElement(
        siteCode,
        new CFW.Forms.Filters.StringFilter(property.siteCode),
        CFW.Validators.FieldValidator.GetInstance(property.siteCode)
    );
	
    formAdapter.openDate= new TextBoxAdapterElement(
        openDate,
        new CFW.Forms.Filters.StringFilter(property.openDate),
        CFW.Validators.FieldValidator.GetInstance(property.openDate)
    );
	
    formAdapter.closeDate= new TextBoxAdapterElement(
        closeDate,
        new CFW.Forms.Filters.StringFilter(property.closeDate),
        CFW.Validators.FieldValidator.GetInstance(property.closeDate)
    );
	
    formAdapter.sortSeq= new TextBoxAdapterElement(
        sortSeq,
        new CFW.Forms.Filters.StringFilter(property.sortSeq),
        CFW.Validators.FieldValidator.GetInstance(property.sortSeq)
    );
	
    formAdapter.name= new TextBoxAdapterElement(
        name,
        new CFW.Forms.Filters.StringFilter(property.name),
        CFW.Validators.FieldValidator.GetInstance(property.name)
    );
	
    formAdapter.ankName= new TextBoxAdapterElement(
        ankName,
        new CFW.Forms.Filters.StringFilter(property.ankName),
        CFW.Validators.FieldValidator.GetInstance(property.ankName)
    );
	
    formAdapter.companyCode= new TextBoxAdapterElement(
        companyCode,
        new CFW.Forms.Filters.StringFilter(property.companyCode),
        CFW.Validators.FieldValidator.GetInstance(property.companyCode)
    );
	
    formAdapter.siteUrl= new TextBoxAdapterElement(
        siteUrl,
        new CFW.Forms.Filters.StringFilter(property.siteUrl),
        CFW.Validators.FieldValidator.GetInstance(property.siteUrl)
    );
	
    formAdapter.siteUrlOther= new TextBoxAdapterElement(
        siteUrlOther,
        new CFW.Forms.Filters.StringFilter(property.siteUrlOther),
        CFW.Validators.FieldValidator.GetInstance(property.siteUrlOther)
    );
	
    formAdapter.siteCategory1= new TextBoxAdapterElement(
        siteCategory1,
        new CFW.Forms.Filters.StringFilter(property.siteCategory1),
        CFW.Validators.FieldValidator.GetInstance(property.siteCategory1)
    );
	
    formAdapter.siteCategory2= new TextBoxAdapterElement(
        siteCategory2,
        new CFW.Forms.Filters.StringFilter(property.siteCategory2),
        CFW.Validators.FieldValidator.GetInstance(property.siteCategory2)
    );
	
    formAdapter.deviceCode= new TextBoxAdapterElement(
        deviceCode,
        new CFW.Forms.Filters.StringFilter(property.deviceCode),
        CFW.Validators.FieldValidator.GetInstance(property.deviceCode)
    );
	
    formAdapter.menuDeviceCode= new TextBoxAdapterElement(
        menuDeviceCode,
        new CFW.Forms.Filters.StringFilter(property.menuDeviceCode),
        CFW.Validators.FieldValidator.GetInstance(property.menuDeviceCode)
    );
	
    formAdapter.menuAdtypeCode= new TextBoxAdapterElement(
        menuAdtypeCode,
        new CFW.Forms.Filters.StringFilter(property.menuAdtypeCode),
        CFW.Validators.FieldValidator.GetInstance(property.menuAdtypeCode)
    );
	
    formAdapter.goodsCategoryCode= new TextBoxAdapterElement(
        goodsCategoryCode,
        new CFW.Forms.Filters.StringFilter(property.goodsCategoryCode),
        CFW.Validators.FieldValidator.GetInstance(property.goodsCategoryCode)
    );
	
    formAdapter.carrierCode1= new TextBoxAdapterElement(
        carrierCode1,
        new CFW.Forms.Filters.StringFilter(property.carrierCode1),
        CFW.Validators.FieldValidator.GetInstance(property.carrierCode1)
    );
	
    formAdapter.carrierCode2= new TextBoxAdapterElement(
        carrierCode2,
        new CFW.Forms.Filters.StringFilter(property.carrierCode2),
        CFW.Validators.FieldValidator.GetInstance(property.carrierCode2)
    );
	
    formAdapter.carrierCode3= new TextBoxAdapterElement(
        carrierCode3,
        new CFW.Forms.Filters.StringFilter(property.carrierCode3),
        CFW.Validators.FieldValidator.GetInstance(property.carrierCode3)
    );
	
    formAdapter.carrierCode4= new TextBoxAdapterElement(
        carrierCode4,
        new CFW.Forms.Filters.StringFilter(property.carrierCode4),
        CFW.Validators.FieldValidator.GetInstance(property.carrierCode4)
    );
	
    formAdapter.mediaCostRate= new TextBoxAdapterElement(
        mediaCostRate,
        new CFW.Forms.Filters.StringFilter(property.mediaCostRate),
        CFW.Validators.FieldValidator.GetInstance(property.mediaCostRate)
    );
	
    formAdapter.agencyMarginRate= new TextBoxAdapterElement(
        agencyMarginRate,
        new CFW.Forms.Filters.StringFilter(property.agencyMarginRate),
        CFW.Validators.FieldValidator.GetInstance(property.agencyMarginRate)
    );
	
    formAdapter.spOpenFlag= new TextBoxAdapterElement(
        spOpenFlag,
        new CFW.Forms.Filters.StringFilter(property.spOpenFlag),
        CFW.Validators.FieldValidator.GetInstance(property.spOpenFlag)
    );
	
    formAdapter.pmOpenFlag= new TextBoxAdapterElement(
        pmOpenFlag,
        new CFW.Forms.Filters.StringFilter(property.pmOpenFlag),
        CFW.Validators.FieldValidator.GetInstance(property.pmOpenFlag)
    );
	
    formAdapter.ioOpenFlag= new TextBoxAdapterElement(
        ioOpenFlag,
        new CFW.Forms.Filters.StringFilter(property.ioOpenFlag),
        CFW.Validators.FieldValidator.GetInstance(property.ioOpenFlag)
    );
	
    formAdapter.adGuideOpenFlag= new TextBoxAdapterElement(
        adGuideOpenFlag,
        new CFW.Forms.Filters.StringFilter(property.adGuideOpenFlag),
        CFW.Validators.FieldValidator.GetInstance(property.adGuideOpenFlag)
    );
	
    formAdapter.impression= new TextBoxAdapterElement(
        impression,
        new CFW.Forms.Filters.StringFilter(property.impression),
        CFW.Validators.FieldValidator.GetInstance(property.impression)
    );
	
    formAdapter.impressionTerm= new TextBoxAdapterElement(
        impressionTerm,
        new CFW.Forms.Filters.StringFilter(property.impressionTerm),
        CFW.Validators.FieldValidator.GetInstance(property.impressionTerm)
    );
	
    formAdapter.impressionToppage= new TextBoxAdapterElement(
        impressionToppage,
        new CFW.Forms.Filters.StringFilter(property.impressionToppage),
        CFW.Validators.FieldValidator.GetInstance(property.impressionToppage)
    );
	
    formAdapter.impressionToppageTerm= new TextBoxAdapterElement(
        impressionToppageTerm,
        new CFW.Forms.Filters.StringFilter(property.impressionToppageTerm),
        CFW.Validators.FieldValidator.GetInstance(property.impressionToppageTerm)
    );
	
    formAdapter.uniqueUser= new TextBoxAdapterElement(
        uniqueUser,
        new CFW.Forms.Filters.StringFilter(property.uniqueUser),
        CFW.Validators.FieldValidator.GetInstance(property.uniqueUser)
    );
	
    formAdapter.uniqueUserTerm= new TextBoxAdapterElement(
        uniqueUserTerm,
        new CFW.Forms.Filters.StringFilter(property.uniqueUserTerm),
        CFW.Validators.FieldValidator.GetInstance(property.uniqueUserTerm)
    );
	
    formAdapter.uniqueUserToppage= new TextBoxAdapterElement(
        uniqueUserToppage,
        new CFW.Forms.Filters.StringFilter(property.uniqueUserToppage),
        CFW.Validators.FieldValidator.GetInstance(property.uniqueUserToppage)
    );
	
    formAdapter.uniqueUserToppageTerm= new TextBoxAdapterElement(
        uniqueUserToppageTerm,
        new CFW.Forms.Filters.StringFilter(property.uniqueUserToppageTerm),
        CFW.Validators.FieldValidator.GetInstance(property.uniqueUserToppageTerm)
    );
	
    formAdapter.maleRate= new TextBoxAdapterElement(
        maleRate,
        new CFW.Forms.Filters.StringFilter(property.maleRate),
        CFW.Validators.FieldValidator.GetInstance(property.maleRate)
    );
	
    formAdapter.femaleRate= new TextBoxAdapterElement(
        femaleRate,
        new CFW.Forms.Filters.StringFilter(property.femaleRate),
        CFW.Validators.FieldValidator.GetInstance(property.femaleRate)
    );
	
    formAdapter.publishedYear= new TextBoxAdapterElement(
        publishedYear,
        new CFW.Forms.Filters.StringFilter(property.publishedYear),
        CFW.Validators.FieldValidator.GetInstance(property.publishedYear)
    );
	
    formAdapter.publishedMonth= new TextBoxAdapterElement(
        publishedMonth,
        new CFW.Forms.Filters.StringFilter(property.publishedMonth),
        CFW.Validators.FieldValidator.GetInstance(property.publishedMonth)
    );
	
    formAdapter.publishedDay= new TextBoxAdapterElement(
        publishedDay,
        new CFW.Forms.Filters.StringFilter(property.publishedDay),
        CFW.Validators.FieldValidator.GetInstance(property.publishedDay)
    );
	
    formAdapter.publishedDataKind= new TextBoxAdapterElement(
        publishedDataKind,
        new CFW.Forms.Filters.StringFilter(property.publishedDataKind),
        CFW.Validators.FieldValidator.GetInstance(property.publishedDataKind)
    );
	
    formAdapter.upperSiteCode= new TextBoxAdapterElement(
        upperSiteCode,
        new CFW.Forms.Filters.StringFilter(property.upperSiteCode),
        CFW.Validators.FieldValidator.GetInstance(property.upperSiteCode)
    );
	
    formAdapter.paymentCompany= new TextBoxAdapterElement(
        paymentCompany,
        new CFW.Forms.Filters.StringFilter(property.paymentCompany),
        CFW.Validators.FieldValidator.GetInstance(property.paymentCompany)
    );
	
    formAdapter.businessDirectFlag= new TextBoxAdapterElement(
        businessDirectFlag,
        new CFW.Forms.Filters.StringFilter(property.businessDirectFlag),
        CFW.Validators.FieldValidator.GetInstance(property.businessDirectFlag)
    );
	
    formAdapter.adserverFlag= new TextBoxAdapterElement(
        adserverFlag,
        new CFW.Forms.Filters.StringFilter(property.adserverFlag),
        CFW.Validators.FieldValidator.GetInstance(property.adserverFlag)
    );
	
    formAdapter.specialmenuFlag= new TextBoxAdapterElement(
        specialmenuFlag,
        new CFW.Forms.Filters.StringFilter(property.specialmenuFlag),
        CFW.Validators.FieldValidator.GetInstance(property.specialmenuFlag)
    );
	
    formAdapter.topOpenFlag= new TextBoxAdapterElement(
        topOpenFlag,
        new CFW.Forms.Filters.StringFilter(property.topOpenFlag),
        CFW.Validators.FieldValidator.GetInstance(property.topOpenFlag)
    );
	
    formAdapter.openMenuCount= new TextBoxAdapterElement(
        openMenuCount,
        new CFW.Forms.Filters.StringFilter(property.openMenuCount),
        CFW.Validators.FieldValidator.GetInstance(property.openMenuCount)
    );
	
    formAdapter.makeDate= new TextBoxAdapterElement(
        makeDate,
        new CFW.Forms.Filters.StringFilter(property.makeDate),
        CFW.Validators.FieldValidator.GetInstance(property.makeDate)
    );
	
    formAdapter.documentAddress= new TextBoxAdapterElement(
        documentAddress,
        new CFW.Forms.Filters.StringFilter(property.documentAddress),
        CFW.Validators.FieldValidator.GetInstance(property.documentAddress)
    );
	
    formAdapter.agCompanyCode= new TextBoxAdapterElement(
        agCompanyCode,
        new CFW.Forms.Filters.StringFilter(property.agCompanyCode),
        CFW.Validators.FieldValidator.GetInstance(property.agCompanyCode)
    );
	
    formAdapter.insideOpenLevel= new TextBoxAdapterElement(
        insideOpenLevel,
        new CFW.Forms.Filters.StringFilter(property.insideOpenLevel),
        CFW.Validators.FieldValidator.GetInstance(property.insideOpenLevel)
    );
	
    formAdapter.outsideOpenLevel= new TextBoxAdapterElement(
        outsideOpenLevel,
        new CFW.Forms.Filters.StringFilter(property.outsideOpenLevel),
        CFW.Validators.FieldValidator.GetInstance(property.outsideOpenLevel)
    );
	
    formAdapter.homeRate= new TextBoxAdapterElement(
        homeRate,
        new CFW.Forms.Filters.StringFilter(property.homeRate),
        CFW.Validators.FieldValidator.GetInstance(property.homeRate)
    );
	
    formAdapter.workRate= new TextBoxAdapterElement(
        workRate,
        new CFW.Forms.Filters.StringFilter(property.workRate),
        CFW.Validators.FieldValidator.GetInstance(property.workRate)
    );
	
    formAdapter.overlapRate= new TextBoxAdapterElement(
        overlapRate,
        new CFW.Forms.Filters.StringFilter(property.overlapRate),
        CFW.Validators.FieldValidator.GetInstance(property.overlapRate)
    );
	
    formAdapter.businessRepDirectFlag= new TextBoxAdapterElement(
        businessRepDirectFlag,
        new CFW.Forms.Filters.StringFilter(property.businessRepDirectFlag),
        CFW.Validators.FieldValidator.GetInstance(property.businessRepDirectFlag)
    );
	
    formAdapter.clientSiteFlag= new TextBoxAdapterElement(
        clientSiteFlag,
        new CFW.Forms.Filters.StringFilter(property.clientSiteFlag),
        CFW.Validators.FieldValidator.GetInstance(property.clientSiteFlag)
    );
	
    formAdapter.printUpperSiteCode= new TextBoxAdapterElement(
        printUpperSiteCode,
        new CFW.Forms.Filters.StringFilter(property.printUpperSiteCode),
        CFW.Validators.FieldValidator.GetInstance(property.printUpperSiteCode)
    );
	
    formAdapter.teamCode= new TextBoxAdapterElement(
        teamCode,
        new CFW.Forms.Filters.StringFilter(property.teamCode),
        CFW.Validators.FieldValidator.GetInstance(property.teamCode)
    );
	
    formAdapter.checkName= new TextBoxAdapterElement(
        checkName,
        new CFW.Forms.Filters.StringFilter(property.checkName),
        CFW.Validators.FieldValidator.GetInstance(property.checkName)
    );
	
    formAdapter.priceCostFromDate= new TextBoxAdapterElement(
        priceCostFromDate,
        new CFW.Forms.Filters.StringFilter(property.priceCostFromDate),
        CFW.Validators.FieldValidator.GetInstance(property.priceCostFromDate)
    );
	
    formAdapter.validFlag= new TextBoxAdapterElement(
        validFlag,
        new CFW.Forms.Filters.StringFilter(property.validFlag),
        CFW.Validators.FieldValidator.GetInstance(property.validFlag)
    );
	
    formAdapter.insertDateTime= new TextBoxAdapterElement(
        insertDateTime,
        new CFW.Forms.Filters.StringFilter(property.insertDateTime),
        CFW.Validators.FieldValidator.GetInstance(property.insertDateTime)
    );
	
    formAdapter.insertOperatorCode= new TextBoxAdapterElement(
        insertOperatorCode,
        new CFW.Forms.Filters.StringFilter(property.insertOperatorCode),
        CFW.Validators.FieldValidator.GetInstance(property.insertOperatorCode)
    );
	
    formAdapter.updateDateTime= new TextBoxAdapterElement(
        updateDateTime,
        new CFW.Forms.Filters.StringFilter(property.updateDateTime),
        CFW.Validators.FieldValidator.GetInstance(property.updateDateTime)
    );
	
    formAdapter.operatorCode= new TextBoxAdapterElement(
        operatorCode,
        new CFW.Forms.Filters.StringFilter(property.operatorCode),
        CFW.Validators.FieldValidator.GetInstance(property.operatorCode)
    );
	
    formAdapter.SetEntity(entity);
    formAdapter.RenderView();
	

*/	

}