using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Database;

namespace Truck.Core.Models.Base
{
    /// <summary>
    /// table APPLICATION_MENUɑΉtB[hvpeB
    /// </summary>
    [Serializable()]
    public class ApplicationMenuTableProperty : CFW.Models.EntityProperty
    {
        ///<summary>[ID]</summary>
        public FieldProperty id;
        ///<summary>[NAME]</summary>
        public FieldProperty name;
        ///<summary>[DISPLAY_NAME]</summary>
        public FieldProperty displayName;
        ///<summary>[TITLE]</summary>
        public FieldProperty title;
        ///<summary>[CLASS_NAME]</summary>
        public FieldProperty className;
        ///<summary>[EXECUTION_TYPE]</summary>
        public FieldProperty executionType;
        ///<summary>[ARGUMENTS]</summary>
        public FieldProperty arguments;
        ///<summary>[FORE_COLOR]</summary>
        public FieldProperty foreColor;
        ///<summary>[BACK_COLOR]</summary>
        public FieldProperty backColor;
        ///<summary>[LEFT_SIDE]</summary>
        public FieldProperty leftSide;
        ///<summary>[RIGHT_SIDE]</summary>
        public FieldProperty rightSide;
        ///<summary>[DESCRIPTION]</summary>
        public FieldProperty description;
        ///<summary>[DELETED]</summary>
        public FieldProperty deleted;
        ///<summary>[CREATED_AT]</summary>
        public FieldProperty createdAt;
        ///<summary>[MODIFIED_AT]</summary>
        public FieldProperty modifiedAt;
        

        /// <summary>
        /// default construct
        /// </summary>
        public ApplicationMenuTableProperty()
        {
            this.EntityName = "APPLICATION_MENU";
            this.ModifiedAtField = "UPDATE_DATE";
            this.CreatedAtField = "CREATE_DATE";
            
            id = FieldProperty.NewInstance("int", "APPLICATION_MENU", "ID","[ID]", 4, 10, 0, false, 0,true);
            name = FieldProperty.NewInstance("varchar", "APPLICATION_MENU", "NAME","[NAME]", 100, 100, 0, false, "",false);
            displayName = FieldProperty.NewInstance("varchar", "APPLICATION_MENU", "DISPLAY_NAME","[DISPLAY_NAME]", 100, 100, 0, false, "",false);
            title = FieldProperty.NewInstance("varchar", "APPLICATION_MENU", "TITLE","[TITLE]", 100, 100, 0, false, "",false);
            className = FieldProperty.NewInstance("varchar", "APPLICATION_MENU", "CLASS_NAME","[CLASS_NAME]", 255, 255, 0, true, "",false);
            executionType = FieldProperty.NewInstance("varchar", "APPLICATION_MENU", "EXECUTION_TYPE","[EXECUTION_TYPE]", 20, 20, 0, true, "",false);
            arguments = FieldProperty.NewInstance("varchar", "APPLICATION_MENU", "ARGUMENTS","[ARGUMENTS]", 2000, 2000, 0, true, "",false);
            foreColor = FieldProperty.NewInstance("varchar", "APPLICATION_MENU", "FORE_COLOR","[FORE_COLOR]", 7, 7, 0, true, "",false);
            backColor = FieldProperty.NewInstance("varchar", "APPLICATION_MENU", "BACK_COLOR","[BACK_COLOR]", 7, 7, 0, true, "",false);
            leftSide = FieldProperty.NewInstance("int", "APPLICATION_MENU", "LEFT_SIDE","[LEFT_SIDE]", 4, 10, 0, false, 0,false);
            rightSide = FieldProperty.NewInstance("int", "APPLICATION_MENU", "RIGHT_SIDE","[RIGHT_SIDE]", 4, 10, 0, false, 0,false);
            description = FieldProperty.NewInstance("varchar", "APPLICATION_MENU", "DESCRIPTION","[DESCRIPTION]", 500, 500, 0, true, "",false);
            deleted = FieldProperty.NewInstance("int", "APPLICATION_MENU", "DELETED","[DELETED]", 4, 10, 0, false, 0,false);
            createdAt = FieldProperty.NewInstance("datetime", "APPLICATION_MENU", "CREATED_AT","[CREATED_AT]", 16, 23, 3, false, null,false);
            modifiedAt = FieldProperty.NewInstance("datetime", "APPLICATION_MENU", "MODIFIED_AT","[MODIFIED_AT]", 16, 23, 3, false, null,false);
            
        }

        /// <summary>
        /// Ce[^\gĊOCe[^B
        /// </summary>
        /// <returns>Ce[^</returns>
        public override IEnumerable<FieldProperty> Fields()
        {
            yield return this.id;
            yield return this.name;
            yield return this.displayName;
            yield return this.title;
            yield return this.className;
            yield return this.executionType;
            yield return this.arguments;
            yield return this.foreColor;
            yield return this.backColor;
            yield return this.leftSide;
            yield return this.rightSide;
            yield return this.description;
            yield return this.deleted;
            yield return this.createdAt;
            yield return this.modifiedAt;
            
        }
                /// <summary>
        /// Ce[^\gĊOCe[^B
        /// </summary>
        /// <returns>Ce[^</returns>
        public override IEnumerable<FieldProperty> PrimaryKeys()
        {
            yield return  this.id;
            
        }
                
    }
}