using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Database;
using Konozama.Shop.Model;
using Konozama.Shop.Model.TableRow;

namespace Konozama.Shop.Model.Entity
{
    /// <summary>
    /// OrderItems GeBeB`
    /// </summary>
    [Serializable()]
	public class OrderItemsEntity : OrderItemsTableRow,ICloneable
	{
        ProductsEntity product;
        /// <summary>
        /// ĩV[gJbg
        /// </summary>
        public ProductsEntity Product
        {
            get { return product; }
            set { 
                product = value;
                this.ProductId = value.Id;
                this.UnitPrice = product.UnitPrice;
                this.Price = this.UnitPrice * this.Quantity;
            }
        }

        /// <summary>
        /// ĩV[gJbg
        /// </summary>
        public string ProductName
        {
            get {
                if (this.product == null)
                {
                    return "";
                }
                else
                {
                    return this.product.Name;
                }
            }
        }
        /// <summary>
        /// 
        /// </summary>
        public new  decimal? Quantity
        {
            get { return base.Quantity; }
            set
            {
                base.Quantity = value;
                this.Price = base.UnitPrice * base.Quantity;

            }
        }


        /// <summary>
        /// ftHg\z
        /// </summary>
        public OrderItemsEntity() : base()
        {
            this.product = null;
        }
	
        /// <summary>
        /// N[
        /// </summary>
        /// <return >̃IuWFNg̃N[</return>
        public override object Clone()
        {
            OrderItemsEntity clone = new OrderItemsEntity();
            clone.CopyFrom(this);
			
			//TODO: ɂ̃NX̓Ǝ̃N[

            return clone;
        }
        /// <summary>
        /// Rs[
        /// </summary>
        public virtual void CopyFrom(OrderItemsEntity source)
        {
        	base.CopyFrom(source);

			//TODO: ɂ̃NX̓Ǝ̃Rs[
        }
        
	}

}