using System;
using System.Collections.Generic;
using System.Text;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Validators;
using CFW.Database;
using CFW.Database.TableCommand;

using Konozama.Shop.Model;
using Konozama.Shop.Model.TableRow;
using Konozama.Shop.Model.TableProperty;

namespace Konozama.Shop.Model.TableValidator
{
    /// <summary>
    /// table[orders]ɑ΂錟
    /// </summary>
    public class OrdersTableValidator : CFW.Validators.ValidatorBase
    {
        protected OrdersTableRow target;
        protected OrdersTableProperty property;
        
        /// <summary>
        /// \z
        /// </summary>
        public OrdersTableValidator()
            : base()
        {
        }
        /// <summary>
        /// \z
        /// </summary>
        /// <param name="target"></param>
        public OrdersTableValidator(OrdersTableRow target)
            : base()
        {
            this.target = target;
            this.property = new OrdersTableProperty();
        }
        /// <summary>
        /// \z
        /// </summary>
        /// <param name="target"></param>
        /// <param name="property"></param>
        public OrdersTableValidator(OrdersTableRow target, OrdersTableProperty property) : base()
        {
            
            this.target = target;
            this.property = property;
        }
        /// <summary>
        /// Orders
        /// 1łvalidłȂȂfalseԂBG[e͔ErrorMessagesɊi[B
        /// </summary>
        /// <returns></returns>
        public override bool Validate()
        {
            bool valid = true; //not validfalseɐg𗎂Ƃ
            FieldValidator validator = null;
            validator = FieldValidator.GetInstance(this.property.Id);
            if (!validator.Validate(this.target.Id))
            {
                this.ErrorMessages.Add(validator.ErrorMessage);
                valid = false;
            }
            validator = FieldValidator.GetInstance(this.property.CustomerId);
            if (!validator.Validate(this.target.CustomerId))
            {
                this.ErrorMessages.Add(validator.ErrorMessage);
                valid = false;
            }
            validator = FieldValidator.GetInstance(this.property.OrderDate);
            if (!validator.Validate(this.target.OrderDate))
            {
                this.ErrorMessages.Add(validator.ErrorMessage);
                valid = false;
            }
            validator = FieldValidator.GetInstance(this.property.PaymentMethod);
            if (!validator.Validate(this.target.PaymentMethod))
            {
                this.ErrorMessages.Add(validator.ErrorMessage);
                valid = false;
            }
            validator = FieldValidator.GetInstance(this.property.DeliveryPlace);
            if (!validator.Validate(this.target.DeliveryPlace))
            {
                this.ErrorMessages.Add(validator.ErrorMessage);
                valid = false;
            }
            

            return valid;
        }
    }
}
