using System;
using System.Collections.Generic;
using System.Text;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Validators;
using CFW.Database;
using CFW.Database.TableCommand;

using Konozama.Shop.Model;
using Konozama.Shop.Model.TableRow;
using Konozama.Shop.Model.TableProperty;

namespace Konozama.Shop.Model.TableValidator
{
    /// <summary>
    /// table[products]ɑ΂錟
    /// </summary>
    public class ProductsTableValidator : CFW.Validators.ValidatorBase
    {
        protected ProductsTableRow target;
        protected ProductsTableProperty property;
        
        /// <summary>
        /// \z
        /// </summary>
        public ProductsTableValidator()
            : base()
        {
        }
        /// <summary>
        /// \z
        /// </summary>
        /// <param name="target"></param>
        public ProductsTableValidator(ProductsTableRow target)
            : base()
        {
            this.target = target;
            this.property = new ProductsTableProperty();
        }
        /// <summary>
        /// \z
        /// </summary>
        /// <param name="target"></param>
        /// <param name="property"></param>
        public ProductsTableValidator(ProductsTableRow target, ProductsTableProperty property) : base()
        {
            
            this.target = target;
            this.property = property;
        }
        /// <summary>
        /// Products
        /// 1łvalidłȂȂfalseԂBG[e͔ErrorMessagesɊi[B
        /// </summary>
        /// <returns></returns>
        public override bool Validate()
        {
            bool valid = true; //not validfalseɐg𗎂Ƃ
            FieldValidator validator = null;
            validator = FieldValidator.GetInstance(this.property.Id);
            if (!validator.Validate(this.target.Id))
            {
                this.ErrorMessages.Add(validator.ErrorMessage);
                valid = false;
            }
            validator = FieldValidator.GetInstance(this.property.Name);
            if (!validator.Validate(this.target.Name))
            {
                this.ErrorMessages.Add(validator.ErrorMessage);
                valid = false;
            }
            validator = FieldValidator.GetInstance(this.property.UnitPrice);
            if (!validator.Validate(this.target.UnitPrice))
            {
                this.ErrorMessages.Add(validator.ErrorMessage);
                valid = false;
            }
            validator = FieldValidator.GetInstance(this.property.Description);
            if (!validator.Validate(this.target.Description))
            {
                this.ErrorMessages.Add(validator.ErrorMessage);
                valid = false;
            }
            validator = FieldValidator.GetInstance(this.property.CategoryId);
            if (!validator.Validate(this.target.CategoryId))
            {
                this.ErrorMessages.Add(validator.ErrorMessage);
                valid = false;
            }
            

            return valid;
        }
    }
}
