using System;
using System.Collections.Generic;
using System.Text;
using CFW.Forms;
using CFW.Forms.Filters;
using CFW.Util;
using CFW.Models;
using Taskman2.Oracle.Models.Base;

namespace Taskman2.Oracle.Windows.Forms.Adapters.Base
{
    /// <summary>
    /// table sample1 Field`
    /// </summary>
    public class Sample1TableFormAdapter : CFW.Forms.FormAdapter
	{
		private Sample1TableRow theEntity;

		///<summary>[id]</summary>
		public FormAdapterElement id;
		///<summary>[short_field]</summary>
		public FormAdapterElement shortField;
		///<summary>[date_field]</summary>
		public FormAdapterElement dateField;
		///<summary>[timestamp_field]</summary>
		public FormAdapterElement timestampField;
		///<summary>[string_field1]</summary>
		public FormAdapterElement stringField1;
		///<summary>[string_field2]</summary>
		public FormAdapterElement stringField2;
		///<summary>[string_field3]</summary>
		public FormAdapterElement stringField3;
		///<summary>[number_field1]</summary>
		public FormAdapterElement numberField1;
		///<summary>[number_field2]</summary>
		public FormAdapterElement numberField2;
		///<summary>[number_field3]</summary>
		public FormAdapterElement numberField3;
		

		/// <summary>݂̃f[^\[X擾
		/// </summary>
        public override Entity GetEntity()
        {
            return this.theEntity;
        }
		/// <summary>\̍XV
		/// </summary>
        public override void RenderView()
        {
			if(this.id != null) this.id.Render();
			if(this.shortField != null) this.shortField.Render();
			if(this.dateField != null) this.dateField.Render();
			if(this.timestampField != null) this.timestampField.Render();
			if(this.stringField1 != null) this.stringField1.Render();
			if(this.stringField2 != null) this.stringField2.Render();
			if(this.stringField3 != null) this.stringField3.Render();
			if(this.numberField1 != null) this.numberField1.Render();
			if(this.numberField2 != null) this.numberField2.Render();
			if(this.numberField3 != null) this.numberField3.Render();
			
        }

		/// <summary>̃A_v^[f[^ݒ
		/// </summary>
        /// <param name="dataSource">̃A_v^[f[^</param>
        public override void SetEntity(Entity entity)
        {
        	this.theEntity = (Sample1TableRow)entity;
			if(this.id != null) this.id.SetValue(this.theEntity.id);
			if(this.shortField != null) this.shortField.SetValue(this.theEntity.shortField);
			if(this.dateField != null) this.dateField.SetValue(this.theEntity.dateField);
			if(this.timestampField != null) this.timestampField.SetValue(this.theEntity.timestampField);
			if(this.stringField1 != null) this.stringField1.SetValue(this.theEntity.stringField1);
			if(this.stringField2 != null) this.stringField2.SetValue(this.theEntity.stringField2);
			if(this.stringField3 != null) this.stringField3.SetValue(this.theEntity.stringField3);
			if(this.numberField1 != null) this.numberField1.SetValue(this.theEntity.numberField1);
			if(this.numberField2 != null) this.numberField2.SetValue(this.theEntity.numberField2);
			if(this.numberField3 != null) this.numberField3.SetValue(this.theEntity.numberField3);
			

        }

		/// <summary>UI͂ꂽef[^\[XɎ荞
		/// </summary>
        public override void UpdateEntity()
        {
			if(this.id != null) this.theEntity.id = NumberUtil.Value<Int32>(this.id.GetValue());
			if(this.shortField != null) this.theEntity.shortField = NumberUtil.Value<Int16?>(this.shortField.GetValue());
			if(this.dateField != null) this.theEntity.dateField = DateUtil.DateValue(this.dateField.GetValue());
			if(this.timestampField != null) this.theEntity.timestampField = DateUtil.DateValue(this.timestampField.GetValue());
			if(this.stringField1 != null) this.theEntity.stringField1 = StringUtil.StringValue(this.stringField1.GetValue());
			if(this.stringField2 != null) this.theEntity.stringField2 = StringUtil.StringValue(this.stringField2.GetValue());
			if(this.stringField3 != null) this.theEntity.stringField3 = StringUtil.StringValue(this.stringField3.GetValue());
			if(this.numberField1 != null) this.theEntity.numberField1 = NumberUtil.Value<Decimal?>(this.numberField1.GetValue());
			if(this.numberField2 != null) this.theEntity.numberField2 = NumberUtil.Value<Decimal?>(this.numberField2.GetValue());
			if(this.numberField3 != null) this.theEntity.numberField3 = NumberUtil.Value<Decimal?>(this.numberField3.GetValue());
			
        }

		/// <summary>UI͂ꂽe荞
		/// </summary>
        public override void UpdateFields()
        {
			if(this.id != null) this.id.UpdateField();
			if(this.shortField != null) this.shortField.UpdateField();
			if(this.dateField != null) this.dateField.UpdateField();
			if(this.timestampField != null) this.timestampField.UpdateField();
			if(this.stringField1 != null) this.stringField1.UpdateField();
			if(this.stringField2 != null) this.stringField2.UpdateField();
			if(this.stringField3 != null) this.stringField3.UpdateField();
			if(this.numberField1 != null) this.numberField1.UpdateField();
			if(this.numberField2 != null) this.numberField2.UpdateField();
			if(this.numberField3 != null) this.numberField3.UpdateField();
			
        }

		/// <summary>͓e؂
		/// ؃G[MessagesXgɑSẴG[B
		/// </summary>
        public override bool Validate()
        {
            bool valid = true;
			
			if(this.id != null){
			    if(!this.id.Validate()){
				    valid = false;
				    this.messages.Add(this.id.ErrorMessage);
			    }
			}
			
			if(this.shortField != null){
			    if(!this.shortField.Validate()){
				    valid = false;
				    this.messages.Add(this.shortField.ErrorMessage);
			    }
			}
			
			if(this.dateField != null){
			    if(!this.dateField.Validate()){
				    valid = false;
				    this.messages.Add(this.dateField.ErrorMessage);
			    }
			}
			
			if(this.timestampField != null){
			    if(!this.timestampField.Validate()){
				    valid = false;
				    this.messages.Add(this.timestampField.ErrorMessage);
			    }
			}
			
			if(this.stringField1 != null){
			    if(!this.stringField1.Validate()){
				    valid = false;
				    this.messages.Add(this.stringField1.ErrorMessage);
			    }
			}
			
			if(this.stringField2 != null){
			    if(!this.stringField2.Validate()){
				    valid = false;
				    this.messages.Add(this.stringField2.ErrorMessage);
			    }
			}
			
			if(this.stringField3 != null){
			    if(!this.stringField3.Validate()){
				    valid = false;
				    this.messages.Add(this.stringField3.ErrorMessage);
			    }
			}
			
			if(this.numberField1 != null){
			    if(!this.numberField1.Validate()){
				    valid = false;
				    this.messages.Add(this.numberField1.ErrorMessage);
			    }
			}
			
			if(this.numberField2 != null){
			    if(!this.numberField2.Validate()){
				    valid = false;
				    this.messages.Add(this.numberField2.ErrorMessage);
			    }
			}
			
			if(this.numberField3 != null){
			    if(!this.numberField3.Validate()){
				    valid = false;
				    this.messages.Add(this.numberField3.ErrorMessage);
			    }
			}
			

            return valid;
        }
		
	}
/* 
    // initialize code sample
    // Form̃o[ɈȉǉB
    //     private Sample1FormAdapter formAdapter;
    //     private Sample1Property property;
    //     private Sample1Entity property;
    // tB[hƓ̓Rg[킹B
    // 2(tB^[)͓KXtB[hɍ킹ĕύX
    formAdapter = new Sample1FormAdapter();

	
    formAdapter.id= new TextBoxAdapterElement(
        id,
        new CFW.Forms.Filters.StringFilter(property.id),
        CFW.Validators.FieldValidator.GetInstance(property.id)
    );
	
    formAdapter.shortField= new TextBoxAdapterElement(
        shortField,
        new CFW.Forms.Filters.StringFilter(property.shortField),
        CFW.Validators.FieldValidator.GetInstance(property.shortField)
    );
	
    formAdapter.dateField= new TextBoxAdapterElement(
        dateField,
        new CFW.Forms.Filters.StringFilter(property.dateField),
        CFW.Validators.FieldValidator.GetInstance(property.dateField)
    );
	
    formAdapter.timestampField= new TextBoxAdapterElement(
        timestampField,
        new CFW.Forms.Filters.StringFilter(property.timestampField),
        CFW.Validators.FieldValidator.GetInstance(property.timestampField)
    );
	
    formAdapter.stringField1= new TextBoxAdapterElement(
        stringField1,
        new CFW.Forms.Filters.StringFilter(property.stringField1),
        CFW.Validators.FieldValidator.GetInstance(property.stringField1)
    );
	
    formAdapter.stringField2= new TextBoxAdapterElement(
        stringField2,
        new CFW.Forms.Filters.StringFilter(property.stringField2),
        CFW.Validators.FieldValidator.GetInstance(property.stringField2)
    );
	
    formAdapter.stringField3= new TextBoxAdapterElement(
        stringField3,
        new CFW.Forms.Filters.StringFilter(property.stringField3),
        CFW.Validators.FieldValidator.GetInstance(property.stringField3)
    );
	
    formAdapter.numberField1= new TextBoxAdapterElement(
        numberField1,
        new CFW.Forms.Filters.StringFilter(property.numberField1),
        CFW.Validators.FieldValidator.GetInstance(property.numberField1)
    );
	
    formAdapter.numberField2= new TextBoxAdapterElement(
        numberField2,
        new CFW.Forms.Filters.StringFilter(property.numberField2),
        CFW.Validators.FieldValidator.GetInstance(property.numberField2)
    );
	
    formAdapter.numberField3= new TextBoxAdapterElement(
        numberField3,
        new CFW.Forms.Filters.StringFilter(property.numberField3),
        CFW.Validators.FieldValidator.GetInstance(property.numberField3)
    );
	
    formAdapter.SetEntity(entity);
    formAdapter.RenderView();
	

*/	

}