using System;
using System.Collections.Generic;
using System.Text;
using CFW.Forms;
using CFW.Forms.Filters;
using CFW.Util;
using CFW.Models;
using Taskman2.Oracle.Models.Base;

namespace Taskman2.Oracle.Windows.Forms.Adapters.Base
{
    /// <summary>
    /// table STATUSES Field`
    /// </summary>
    public class StatusesTableFormAdapter : CFW.Forms.FormAdapter
	{
		private StatusesTableRow theEntity;

		///<summary>[STATUS_ID]</summary>
		public FormAdapterElement statusId;
		///<summary>[STATUS_NAME]</summary>
		public FormAdapterElement statusName;
		///<summary>[CLOSED]</summary>
		public FormAdapterElement closed;
		///<summary>[CREATED_BY]</summary>
		public FormAdapterElement createdBy;
		///<summary>[CREATED_AT]</summary>
		public FormAdapterElement createdAt;
		///<summary>[MODIFIED_BY]</summary>
		public FormAdapterElement modifiedBy;
		///<summary>[MODIFIED_AT]</summary>
		public FormAdapterElement modifiedAt;
		///<summary>[DELETED]</summary>
		public FormAdapterElement deleted;
		

		/// <summary>݂̃f[^\[X擾
		/// </summary>
        public override Entity GetEntity()
        {
            return this.theEntity;
        }
		/// <summary>\̍XV
		/// </summary>
        public override void RenderView()
        {
			if(this.statusId != null) this.statusId.Render();
			if(this.statusName != null) this.statusName.Render();
			if(this.closed != null) this.closed.Render();
			if(this.createdBy != null) this.createdBy.Render();
			if(this.createdAt != null) this.createdAt.Render();
			if(this.modifiedBy != null) this.modifiedBy.Render();
			if(this.modifiedAt != null) this.modifiedAt.Render();
			if(this.deleted != null) this.deleted.Render();
			
        }

		/// <summary>̃A_v^[f[^ݒ
		/// </summary>
        /// <param name="dataSource">̃A_v^[f[^</param>
        public override void SetEntity(Entity entity)
        {
        	this.theEntity = (StatusesTableRow)entity;
			if(this.statusId != null) this.statusId.SetValue(this.theEntity.statusId);
			if(this.statusName != null) this.statusName.SetValue(this.theEntity.statusName);
			if(this.closed != null) this.closed.SetValue(this.theEntity.closed);
			if(this.createdBy != null) this.createdBy.SetValue(this.theEntity.createdBy);
			if(this.createdAt != null) this.createdAt.SetValue(this.theEntity.createdAt);
			if(this.modifiedBy != null) this.modifiedBy.SetValue(this.theEntity.modifiedBy);
			if(this.modifiedAt != null) this.modifiedAt.SetValue(this.theEntity.modifiedAt);
			if(this.deleted != null) this.deleted.SetValue(this.theEntity.deleted);
			

        }

		/// <summary>UI͂ꂽef[^\[XɎ荞
		/// </summary>
        public override void UpdateEntity()
        {
			if(this.statusId != null) this.theEntity.statusId = NumberUtil.Value<Int32>(this.statusId.GetValue());
			if(this.statusName != null) this.theEntity.statusName = StringUtil.StringValue(this.statusName.GetValue());
			if(this.closed != null) this.theEntity.closed = NumberUtil.Value<Int32>(this.closed.GetValue());
			if(this.createdBy != null) this.theEntity.createdBy = StringUtil.StringValue(this.createdBy.GetValue());
			if(this.createdAt != null) this.theEntity.createdAt = DateUtil.DateValue(this.createdAt.GetValue());
			if(this.modifiedBy != null) this.theEntity.modifiedBy = StringUtil.StringValue(this.modifiedBy.GetValue());
			if(this.modifiedAt != null) this.theEntity.modifiedAt = DateUtil.DateValue(this.modifiedAt.GetValue());
			if(this.deleted != null) this.theEntity.deleted = NumberUtil.Value<Int32>(this.deleted.GetValue());
			
        }

		/// <summary>UI͂ꂽe荞
		/// </summary>
        public override void UpdateFields()
        {
			if(this.statusId != null) this.statusId.UpdateField();
			if(this.statusName != null) this.statusName.UpdateField();
			if(this.closed != null) this.closed.UpdateField();
			if(this.createdBy != null) this.createdBy.UpdateField();
			if(this.createdAt != null) this.createdAt.UpdateField();
			if(this.modifiedBy != null) this.modifiedBy.UpdateField();
			if(this.modifiedAt != null) this.modifiedAt.UpdateField();
			if(this.deleted != null) this.deleted.UpdateField();
			
        }

		/// <summary>͓e؂
		/// ؃G[MessagesXgɑSẴG[B
		/// </summary>
        public override bool Validate()
        {
            bool valid = true;
			
			if(this.statusId != null){
			    if(!this.statusId.Validate()){
				    valid = false;
				    this.messages.Add(this.statusId.ErrorMessage);
			    }
			}
			
			if(this.statusName != null){
			    if(!this.statusName.Validate()){
				    valid = false;
				    this.messages.Add(this.statusName.ErrorMessage);
			    }
			}
			
			if(this.closed != null){
			    if(!this.closed.Validate()){
				    valid = false;
				    this.messages.Add(this.closed.ErrorMessage);
			    }
			}
			
			if(this.createdBy != null){
			    if(!this.createdBy.Validate()){
				    valid = false;
				    this.messages.Add(this.createdBy.ErrorMessage);
			    }
			}
			
			if(this.createdAt != null){
			    if(!this.createdAt.Validate()){
				    valid = false;
				    this.messages.Add(this.createdAt.ErrorMessage);
			    }
			}
			
			if(this.modifiedBy != null){
			    if(!this.modifiedBy.Validate()){
				    valid = false;
				    this.messages.Add(this.modifiedBy.ErrorMessage);
			    }
			}
			
			if(this.modifiedAt != null){
			    if(!this.modifiedAt.Validate()){
				    valid = false;
				    this.messages.Add(this.modifiedAt.ErrorMessage);
			    }
			}
			
			if(this.deleted != null){
			    if(!this.deleted.Validate()){
				    valid = false;
				    this.messages.Add(this.deleted.ErrorMessage);
			    }
			}
			

            return valid;
        }
		
	}
/* 
    // initialize code sample
    // Form̃o[ɈȉǉB
    //     private StatusesFormAdapter formAdapter;
    //     private StatusesProperty property;
    //     private StatusesEntity property;
    // tB[hƓ̓Rg[킹B
    // 2(tB^[)͓KXtB[hɍ킹ĕύX
    formAdapter = new StatusesFormAdapter();

	
    formAdapter.statusId= new TextBoxAdapterElement(
        statusId,
        new CFW.Forms.Filters.StringFilter(property.statusId),
        CFW.Validators.FieldValidator.GetInstance(property.statusId)
    );
	
    formAdapter.statusName= new TextBoxAdapterElement(
        statusName,
        new CFW.Forms.Filters.StringFilter(property.statusName),
        CFW.Validators.FieldValidator.GetInstance(property.statusName)
    );
	
    formAdapter.closed= new TextBoxAdapterElement(
        closed,
        new CFW.Forms.Filters.StringFilter(property.closed),
        CFW.Validators.FieldValidator.GetInstance(property.closed)
    );
	
    formAdapter.createdBy= new TextBoxAdapterElement(
        createdBy,
        new CFW.Forms.Filters.StringFilter(property.createdBy),
        CFW.Validators.FieldValidator.GetInstance(property.createdBy)
    );
	
    formAdapter.createdAt= new TextBoxAdapterElement(
        createdAt,
        new CFW.Forms.Filters.StringFilter(property.createdAt),
        CFW.Validators.FieldValidator.GetInstance(property.createdAt)
    );
	
    formAdapter.modifiedBy= new TextBoxAdapterElement(
        modifiedBy,
        new CFW.Forms.Filters.StringFilter(property.modifiedBy),
        CFW.Validators.FieldValidator.GetInstance(property.modifiedBy)
    );
	
    formAdapter.modifiedAt= new TextBoxAdapterElement(
        modifiedAt,
        new CFW.Forms.Filters.StringFilter(property.modifiedAt),
        CFW.Validators.FieldValidator.GetInstance(property.modifiedAt)
    );
	
    formAdapter.deleted= new TextBoxAdapterElement(
        deleted,
        new CFW.Forms.Filters.StringFilter(property.deleted),
        CFW.Validators.FieldValidator.GetInstance(property.deleted)
    );
	
    formAdapter.SetEntity(entity);
    formAdapter.RenderView();
	

*/	

}