using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Database;

namespace Taskman2.Oracle.Models.Base
{
    /// <summary>
    /// table CATEGORIES Field`
    /// </summary>
    [Serializable()]
    public class CategoriesTableRow : CFW.Models.Entity,ICloneable
    {
        ///<summary>[CATEGORY_ID]</summary>
        protected decimal _categoryId;
        ///<summary>[CATEGORY_ID]</summary>
        public decimal categoryId
        {
            get{return _categoryId;}
            set{_categoryId = value;}
        }
        ///<summary>[CATEGORY_NAME]</summary>
        protected string _categoryName;
        ///<summary>[CATEGORY_NAME]</summary>
        public string categoryName{
            get{return _categoryName;}
            set{_categoryName = value;}
        }
        ///<summary>[CREATED_BY]</summary>
        protected string _createdBy;
        ///<summary>[CREATED_BY]</summary>
        public string createdBy{
            get{return _createdBy;}
            set{_createdBy = value;}
        }
        ///<summary>[CREATED_AT]</summary>
        protected DateTime? _createdAt;
        ///<summary>[CREATED_AT]</summary>
        public DateTime? createdAt{
            get{return _createdAt;}
            set{_createdAt = value;}
        }
        ///<summary>[MODIFIED_BY]</summary>
        protected string _modifiedBy;
        ///<summary>[MODIFIED_BY]</summary>
        public string modifiedBy{
            get{return _modifiedBy;}
            set{_modifiedBy = value;}
        }
        ///<summary>[MODIFIED_AT]</summary>
        protected DateTime? _modifiedAt;
        ///<summary>[MODIFIED_AT]</summary>
        public DateTime? modifiedAt{
            get{return _modifiedAt;}
            set{_modifiedAt = value;}
        }
        ///<summary>[DELETED]</summary>
        protected decimal _deleted;
        ///<summary>[DELETED]</summary>
        public decimal deleted
        {
            get{return _deleted;}
            set{_deleted = value;}
        }
        
        /// <summary>
        /// default construct 
        /// </summary>
        public CategoriesTableRow() : base()
        {
            this._categoryId = 0;
            this._categoryName = "";
            this._createdBy = "system";
            this._createdAt = null;
            this._modifiedBy = "system";
            this._modifiedAt = null;
            this._deleted = 0;
            
        }
        
        /// <summary>
        /// 񖼂w肵Ēlݒ
        /// </summary>
        /// <param name="name"></param>
        /// <param name="value">l</param>
        public override void SetValue(string name,object value)
        {
            if (name == "CATEGORY_ID") { this._categoryId = NumberUtil.Value<decimal>(value); return; }
            if(name ==  "CATEGORY_NAME"){ this._categoryName = StringUtil.StringValue( value );return; }
            if(name ==  "CREATED_BY"){ this._createdBy = StringUtil.StringValue( value );return; }
            if(name ==  "CREATED_AT"){ this._createdAt = DateUtil.DateValue( value );return; }
            if(name ==  "MODIFIED_BY"){ this._modifiedBy = StringUtil.StringValue( value );return; }
            if(name ==  "MODIFIED_AT"){ this._modifiedAt = DateUtil.DateValue( value );return; }
            if (name == "DELETED") { this._deleted = NumberUtil.Value<decimal>(value); return; }
            
        }
        /// <summary>
        /// 񖼂w肵Ēl擾
        /// </summary>
        /// <param name="name"></param>
        public override object GetValue(string name)
        {
            if(name ==  "CATEGORY_ID") return this._categoryId;
            if(name ==  "CATEGORY_NAME") return this._categoryName;
            if(name ==  "CREATED_BY") return this._createdBy;
            if(name ==  "CREATED_AT") return this._createdAt;
            if(name ==  "MODIFIED_BY") return this._modifiedBy;
            if(name ==  "MODIFIED_AT") return this._modifiedAt;
            if(name ==  "DELETED") return this._deleted;
            
            return null;
        }
        
        /// <summary>
        /// N[
        /// </summary>
        /// <return >̃IuWFNg̃N[</return>
        public virtual object Clone()
        {
            CategoriesTableRow clone = new CategoriesTableRow();
            clone.CopyFrom(this);
            return clone;
        }
        /// <summary>
        /// N[
        /// </summary>
        /// <return >̃IuWFNg̃N[</return>
        public virtual void CopyFrom(CategoriesTableRow source)
        {
            this.categoryId = source.categoryId;
            this.categoryName = source.categoryName;
            this.createdBy = source.createdBy;
            this.createdAt = source.createdAt;
            this.modifiedBy = source.modifiedBy;
            this.modifiedAt = source.modifiedAt;
            this.deleted = source.deleted;
            
            
            this.IsNew = source.IsNew;
            this.IsModified = source.IsModified;
            this.IsDeleted = source.IsDeleted;
            
        }
        /// <summary>
        /// DataRow炱̃IuWFNg̒lݒ肷B
        /// </summary>
        /// <param name="row">ǂݍDataRow</param>
        public override void Map(DataRow row)
        {
            DataColumnCollection cols = row.Table.Columns;
            if (cols.Contains("CATEGORY_ID")) { this._categoryId = NumberUtil.Value<decimal>(row["CATEGORY_ID"]); }
            if (cols.Contains("CATEGORY_NAME")){ this._categoryName = StringUtil.StringValue(row["CATEGORY_NAME"]); }
            if (cols.Contains("CREATED_BY")){ this._createdBy = StringUtil.StringValue(row["CREATED_BY"]); }
            if (cols.Contains("CREATED_AT")){ this._createdAt = DateUtil.DateValue(row["CREATED_AT"]); }
            if (cols.Contains("MODIFIED_BY")){ this._modifiedBy = StringUtil.StringValue(row["MODIFIED_BY"]); }
            if (cols.Contains("MODIFIED_AT")){ this._modifiedAt = DateUtil.DateValue(row["MODIFIED_AT"]); }
            if (cols.Contains("DELETED")) { this._deleted = NumberUtil.Value<decimal>(row["DELETED"]); }
            
            this.IsNew = false;
        }
        /// <summary>
        /// DataRow炱̃IuWFNg̒lݒ肷B
        /// </summary>
        /// <param name="row">ǂݍDataRow</param>
        /// <param name="alias">Iɂʖ̃vtBbNX</param>
        public override void Map(DataRow row,string alias)
        {
            DataColumnCollection cols = row.Table.Columns;
            string columnName = "";
            columnName = BuildColumnName(alias, "CATEGORY_ID"); if (cols.Contains(columnName)) { this._categoryId = NumberUtil.Value<decimal>(row[columnName]); }
            columnName = BuildColumnName(alias, "CATEGORY_NAME");if (cols.Contains(columnName)){ this._categoryName = StringUtil.StringValue(row[columnName]); }
            columnName = BuildColumnName(alias, "CREATED_BY");if (cols.Contains(columnName)){ this._createdBy = StringUtil.StringValue(row[columnName]); }
            columnName = BuildColumnName(alias, "CREATED_AT");if (cols.Contains(columnName)){ this._createdAt = DateUtil.DateValue(row[columnName]); }
            columnName = BuildColumnName(alias, "MODIFIED_BY");if (cols.Contains(columnName)){ this._modifiedBy = StringUtil.StringValue(row[columnName]); }
            columnName = BuildColumnName(alias, "MODIFIED_AT");if (cols.Contains(columnName)){ this._modifiedAt = DateUtil.DateValue(row[columnName]); }
            columnName = BuildColumnName(alias, "DELETED"); if (cols.Contains(columnName)) { this._deleted = NumberUtil.Value<decimal>(row[columnName]); }
            
            this.IsNew = false;
        }
        /// <summary>
        /// DataReader炱̃IuWFNg̒lݒ肷B
        /// </summary>
        /// <param name="reader">ǂݍ񂾃[_[</param>
        /// <remarks>DataReader̐Ãe[uŝ̗݂̒`ƓőÎݗL</remarks>
        public override void Map(IDataReader reader)
        {
            this._categoryId = NumberUtil.Value<decimal>(reader[0]);
            this._categoryName = StringUtil.StringValue(reader[1]);
            this._createdBy = StringUtil.StringValue(reader[2]);
            this._createdAt = DateUtil.DateValue(reader[3]);
            this._modifiedBy = StringUtil.StringValue(reader[4]);
            this._modifiedAt = DateUtil.DateValue(reader[5]);
            this._deleted = NumberUtil.Value<decimal>(reader[6]);
            
            this.IsNew = false;
        }
    }

}