using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Database;

namespace CFW.Test.Models.Base
{
    /// <summary>
    /// table test_table4 Field`
    /// </summary>
    [Serializable()]
    public class TestTable4TableRow : CFW.Models.Entity,ICloneable
    {
        ///<summary>[id]</summary>
        protected Int32 _id;
        ///<summary>[id]</summary>
        public Int32 id{
            get{return _id;}
            set{_id = value;}
        }
        ///<summary>[int_field]</summary>
        protected System.Nullable<Int32> _intField;
        ///<summary>[int_field]</summary>
        public System.Nullable<Int32> intField{
            get{return _intField;}
            set{_intField = value;}
        }
        ///<summary>[smallint_field]</summary>
        protected System.Nullable<Int16> _smallintField;
        ///<summary>[smallint_field]</summary>
        public System.Nullable<Int16> smallintField{
            get{return _smallintField;}
            set{_smallintField = value;}
        }
        ///<summary>[long_field]</summary>
        protected System.Nullable<Int64> _longField;
        ///<summary>[long_field]</summary>
        public System.Nullable<Int64> longField{
            get{return _longField;}
            set{_longField = value;}
        }
        ///<summary>[tinyint_field]</summary>
        protected System.Nullable<Byte> _tinyintField;
        ///<summary>[tinyint_field]</summary>
        public System.Nullable<Byte> tinyintField{
            get{return _tinyintField;}
            set{_tinyintField = value;}
        }
        ///<summary>[char_field]</summary>
        protected string _charField;
        ///<summary>[char_field]</summary>
        public string charField{
            get{return _charField;}
            set{_charField = value;}
        }
        ///<summary>[varchar_field]</summary>
        protected string _varcharField;
        ///<summary>[varchar_field]</summary>
        public string varcharField{
            get{return _varcharField;}
            set{_varcharField = value;}
        }
        ///<summary>[nchar_field]</summary>
        protected string _ncharField;
        ///<summary>[nchar_field]</summary>
        public string ncharField{
            get{return _ncharField;}
            set{_ncharField = value;}
        }
        ///<summary>[nvarchar_Field]</summary>
        protected string _nvarcharField;
        ///<summary>[nvarchar_Field]</summary>
        public string nvarcharField{
            get{return _nvarcharField;}
            set{_nvarcharField = value;}
        }
        ///<summary>[datetime_field]</summary>
        protected object _datetimeField;
        ///<summary>[datetime_field]</summary>
        public object datetimeField{
            get{return _datetimeField;}
            set{_datetimeField = value;}
        }
        ///<summary>[smalldatetime_field]</summary>
        protected object _smalldatetimeField;
        ///<summary>[smalldatetime_field]</summary>
        public object smalldatetimeField{
            get{return _smalldatetimeField;}
            set{_smalldatetimeField = value;}
        }
        
        /// <summary>
        /// default construct 
        /// </summary>
        public TestTable4TableRow() : base()
        {
            this._id = 0;
            this._intField = null;
            this._smallintField = null;
            this._longField = null;
            this._tinyintField = null;
            this._charField = "";
            this._varcharField = "";
            this._ncharField = "";
            this._nvarcharField = "";
            this._datetimeField = null;
            this._smalldatetimeField = null;
            
        }
        
        /// <summary>
        /// 񖼂w肵Ēlݒ
        /// </summary>
        /// <param name="name"></param>
        /// <param name="value">l</param>
        public override void SetValue(string name,object value)
        {
            if(name ==  "id") this._id = NumberUtil.Value<Int32>( value );
            if(name ==  "int_field") this._intField = NumberUtil.Value<Int32?>( value );
            if(name ==  "smallint_field") this._smallintField = NumberUtil.Value<Int16?>( value );
            if(name ==  "long_field") this._longField = NumberUtil.Value<Int64?>( value );
            if(name ==  "tinyint_field") this._tinyintField = NumberUtil.Value<Byte?>( value );
            if(name ==  "char_field") this._charField = StringUtil.StringValue( value );
            if(name ==  "varchar_field") this._varcharField = StringUtil.StringValue( value );
            if(name ==  "nchar_field") this._ncharField = StringUtil.StringValue( value );
            if(name ==  "nvarchar_Field") this._nvarcharField = StringUtil.StringValue( value );
            if(name ==  "datetime_field") this._datetimeField = DateUtil.DateValue( value );
            if(name ==  "smalldatetime_field") this._smalldatetimeField = DateUtil.DateValue( value );
            
        }
        /// <summary>
        /// 񖼂w肵Ēl擾
        /// </summary>
        /// <param name="name"></param>
        public override object GetValue(string name)
        {
            if(name ==  "id") return this._id;
            if(name ==  "int_field") return this._intField;
            if(name ==  "smallint_field") return this._smallintField;
            if(name ==  "long_field") return this._longField;
            if(name ==  "tinyint_field") return this._tinyintField;
            if(name ==  "char_field") return this._charField;
            if(name ==  "varchar_field") return this._varcharField;
            if(name ==  "nchar_field") return this._ncharField;
            if(name ==  "nvarchar_Field") return this._nvarcharField;
            if(name ==  "datetime_field") return this._datetimeField;
            if(name ==  "smalldatetime_field") return this._smalldatetimeField;
            
            return null;
        }
        
        /// <summary>
        /// N[
        /// </summary>
        /// <return >̃IuWFNg̃N[</return>
        public virtual object Clone()
        {
            TestTable4TableRow clone = new TestTable4TableRow();
            clone.CopyFrom(this);
            return clone;
        }
        /// <summary>
        /// N[
        /// </summary>
        /// <return >̃IuWFNg̃N[</return>
        public virtual void CopyFrom(TestTable4TableRow source)
        {
            this.id = source.id;
            this.intField = source.intField;
            this.smallintField = source.smallintField;
            this.longField = source.longField;
            this.tinyintField = source.tinyintField;
            this.charField = source.charField;
            this.varcharField = source.varcharField;
            this.ncharField = source.ncharField;
            this.nvarcharField = source.nvarcharField;
            this.datetimeField = source.datetimeField;
            this.smalldatetimeField = source.smalldatetimeField;
            
        }
    }

}