using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Xml;
using System.Xml.Serialization;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Database;
using CFW.Database.TableCommand;
using CFW.Sample.Test4;
using CFW.Sample.Test4.TableRow;
using CFW.Sample.Test4.TableProperty;


namespace CFW.Sample.Test4.TableAccess
{
    /// <summary>
    /// table[test_table4]ɑ΂鑀
    /// </summary>
    [Serializable()]
    public class TestTable4TableAccess
    {
        /// <summary>
        /// f[^\[Xւ̐ڑ
        /// </summary>
        private Connection connection;
        /// <summary>
        /// test_table4ɑΉvpeB
        /// </summary>
        private TestTable4TableProperty property;



#region constructors
        /// <summary>
        /// default construct  gps
        /// </summary>
        private TestTable4TableAccess()
        {
            this.connection = ConnectionFactory.GetConnectionByName("default");
            this.property = new TestTable4TableProperty();
        }
        /// <summary>
        /// ̐ڑgp\z
        /// </summary>
        public TestTable4TableAccess(Connection db)
        {
            this.connection = db;
            this.property = new  TestTable4TableProperty();
        }
        /// <summary>
        /// ̐ڑAvpeBgp\z
        /// </summary>
        /// <param name="db">̐ڑBJĂO</param>
        /// <param name="property">̃vpeB</param>
        public TestTable4TableAccess(Connection db, TestTable4TableProperty property)
        {
            this.connection = db;
            this.property = property;
        }
#endregion

#region public interface
        /// <summary>
        /// test_table4֍s̑}
        /// </summary>
        /// <param name="data">}sf[^</param>
        public int Insert(TestTable4TableRow data)
        {
            TableInsertCommand command = BuildInsertCommand(data);
            int ret = connection.ExecuteUpdate(command.GetCommand());
            return ret;
        }

        /// <summary>
        /// test_table4֍s̍XV
        /// </summary>
        /// <param name="data">XVsf[^</param>
        public int Update(TestTable4TableRow data)
        {
            TableUpdateCommand command = BuildUpdateCommand(data);
            int ret = connection.ExecuteUpdate(command.GetCommand());
            return ret;
        }
        /// <summary>
        /// test_table4֍s̍XV
        /// </summary>
        /// <remarks>where͌ĂяogݗāAp[^Ăяo</remarks>
        /// <param name="data">XVsf[^</param>
        /// <param name="condition"></param>
        public int Update(TestTable4TableRow data,  TableCommandCondition condition)
        {
            TableUpdateCommand command = BuildUpdateCommand(data,condition);
            int ret = connection.ExecuteUpdate(command.GetCommand());
            return ret;
        }
        /// <summary>
        /// test_table4s̍폜
        /// </summary>
        /// <param name="data">폜sf[^BL[̂݃ZbgłĂOK</param>
        public int Delete(TestTable4TableRow data)
        {
            TableDeleteCommand command = BuildDeleteCommand(data);
            int ret = connection.ExecuteUpdate(command.GetCommand());
            return ret;
        }
        /// <summary>
        /// test_table4s̍폜
        /// </summary>
        /// <remarks>where͌ĂяogݗāAp[^Ăяo</remarks>
        /// <param name="condition"></param>
        public int Delete(TableCommandCondition condition)
        {
            TableDeleteCommand command = BuildDeleteCommand(condition);
            int ret = connection.ExecuteUpdate(command.GetCommand());
            return ret;
        }
        /// <summary>
        /// test_table4̍s݊mF
        /// </summary>
        /// <param name="data">L[ݒ肵f[^</param>
        /// <return>ݒ肵L[ɊYs݂鎞true</return>
        public bool Exists(TestTable4TableRow data)
        {
            TableSelectCommand command = BuildExistsCommand(data);
            DataSet result = connection.ExecuteQuery(command.GetCommand());

            int cnt = NumberUtil.IntValue(result.Tables[0].Rows[0][0]);
            if(cnt > 0) return true;
            else return false;
        }
        /// <summary>
        /// test_table4̍s擾
        /// L[1s擾B
        /// قƂǂ̃NCAg͎gpȂ͂AeXgpƂĎgp\
        /// </summary>
        /// <param name="condition">L[ݒ肵f[^</param>
        public TestTable4TableRow Get(TestTable4TableRow condition)
        {
            TableSelectCommand command = BuildSelectCommand(condition);
            DataSet result = connection.ExecuteQuery(command.GetCommand());

            TestTable4TableRow data = null;

            if(result.Tables[0].Rows.Count>0){
                data = new TestTable4TableRow();
                data.Map(result.Tables[0].Rows[0],"test_table4");
                data.IsNew = false;
            }
            return data;
        }
        /// <summary>
        /// test_table4̍s擾
        /// [U[ݒɊYsׂĎ擾B
        /// قƂǂ̃NCAg͎gpȂ͂AeXgpƂĎgp\
        /// </summary>
        /// <param name="condition">WHERE</param>
        /// <param name="order">\[g</param>
        public List<TestTable4TableRow> GetList( TableCommandCondition condition,List<TableCommandColumn> order)
        {
            TestTable4TableRow data = null;

            TableSelectCommand command = BuildSelectCommand(condition,order);

            DataSet result = connection.ExecuteQuery(command.GetCommand());

			List<TestTable4TableRow> list = new List<TestTable4TableRow>();
            if(result.Tables[0].Rows.Count>0){
                for (int i = 0; i < result.Tables[0].Rows.Count; i++)
                {
	                data = new TestTable4TableRow();
	                data.Map(result.Tables[0].Rows[0],"test_table4");
                    data.IsNew = false;
                    list.Add(data);
                }
            }
            return list;
        }
#endregion
        /// <summary>
        /// test_table4ւinsert sqlR}h
        /// </summary>
        /// <param name="data">ǉf[^</param>
        public TableInsertCommand BuildInsertCommand(TestTable4TableRow data)
        {
            TableInsertCommand command = new TableInsertCommand("test_table4");

            if (property.Id.DoUpdate) command.AddInsert(property.Id, data.Id);
            if (property.IntField.DoUpdate) command.AddInsert(property.IntField, data.IntField);
            if (property.SmallintField.DoUpdate) command.AddInsert(property.SmallintField, data.SmallintField);
            if (property.LongField.DoUpdate) command.AddInsert(property.LongField, data.LongField);
            if (property.TinyintField.DoUpdate) command.AddInsert(property.TinyintField, data.TinyintField);
            if (property.CharField.DoUpdate) command.AddInsert(property.CharField, data.CharField);
            if (property.VarcharField.DoUpdate) command.AddInsert(property.VarcharField, data.VarcharField);
            if (property.NcharField.DoUpdate) command.AddInsert(property.NcharField, data.NcharField);
            if (property.NvarcharField.DoUpdate) command.AddInsert(property.NvarcharField, data.NvarcharField);
            if (property.DatetimeField.DoUpdate) command.AddInsert(property.DatetimeField, data.DatetimeField);
            if (property.SmalldatetimeField.DoUpdate) command.AddInsert(property.SmalldatetimeField, data.SmalldatetimeField);
            
            return command;
        }
        /// <summary>
        /// test_table4ւupdate sqlR}h(WHERE͎L[g)
        /// </summary>
        /// <param name="data">ύXf[^</param>
        public TableUpdateCommand BuildUpdateCommand(TestTable4TableRow data)
        {
            TableUpdateCommand command = new TableUpdateCommand("test_table4");

            //XV`
            if (property.Id.DoUpdate) command.AddUpdate(property.Id, data.Id);
            if (property.IntField.DoUpdate) command.AddUpdate(property.IntField, data.IntField);
            if (property.SmallintField.DoUpdate) command.AddUpdate(property.SmallintField, data.SmallintField);
            if (property.LongField.DoUpdate) command.AddUpdate(property.LongField, data.LongField);
            if (property.TinyintField.DoUpdate) command.AddUpdate(property.TinyintField, data.TinyintField);
            if (property.CharField.DoUpdate) command.AddUpdate(property.CharField, data.CharField);
            if (property.VarcharField.DoUpdate) command.AddUpdate(property.VarcharField, data.VarcharField);
            if (property.NcharField.DoUpdate) command.AddUpdate(property.NcharField, data.NcharField);
            if (property.NvarcharField.DoUpdate) command.AddUpdate(property.NvarcharField, data.NvarcharField);
            if (property.DatetimeField.DoUpdate) command.AddUpdate(property.DatetimeField, data.DatetimeField);
            if (property.SmalldatetimeField.DoUpdate) command.AddUpdate(property.SmalldatetimeField, data.SmalldatetimeField);
            

            //XV`
            command.AddWhere(new ColumnValueCondition( property.Id,"@PK_Id", data.Id,"="));
            
            return command;
        }

        /// <summary>
        /// test_table4ւ̍XVSqlR}h(WHERE͊O炤)
        /// </summary>
        /// <param name="data">ύXf[^</param>
        /// <param name="condition">Ώۏ</param>
        public TableUpdateCommand BuildUpdateCommand(TestTable4TableRow data, TableCommandCondition condition)
        {
            TableUpdateCommand command = new TableUpdateCommand("test_table4");

            //XV`
            if (property.Id.DoUpdate) command.AddUpdate(property.Id, data.Id);
            if (property.IntField.DoUpdate) command.AddUpdate(property.IntField, data.IntField);
            if (property.SmallintField.DoUpdate) command.AddUpdate(property.SmallintField, data.SmallintField);
            if (property.LongField.DoUpdate) command.AddUpdate(property.LongField, data.LongField);
            if (property.TinyintField.DoUpdate) command.AddUpdate(property.TinyintField, data.TinyintField);
            if (property.CharField.DoUpdate) command.AddUpdate(property.CharField, data.CharField);
            if (property.VarcharField.DoUpdate) command.AddUpdate(property.VarcharField, data.VarcharField);
            if (property.NcharField.DoUpdate) command.AddUpdate(property.NcharField, data.NcharField);
            if (property.NvarcharField.DoUpdate) command.AddUpdate(property.NvarcharField, data.NvarcharField);
            if (property.DatetimeField.DoUpdate) command.AddUpdate(property.DatetimeField, data.DatetimeField);
            if (property.SmalldatetimeField.DoUpdate) command.AddUpdate(property.SmalldatetimeField, data.SmalldatetimeField);
            

            //XV`
            command.AddWhere(condition);

            return command;
        }

        /// <summary>
        /// test_table4ւselect sqlR}h(WHERE͊O炤
        /// </summary>
        /// <param name="condition">Ώۏ</param>
        public TableDeleteCommand BuildDeleteCommand(TableCommandCondition condition)
        {
            TableDeleteCommand command = new TableDeleteCommand("test_table4");


            //XV`
            command.AddWhere(condition);

            return command;
        }
        /// <summary>
        /// test_table4ւdelete sqlR}h(WHERE͎L[g)
        /// </summary>
        /// <param name="data">Ώۏ</param>
        public TableDeleteCommand BuildDeleteCommand(TestTable4TableRow data)
        {
            TableDeleteCommand command = new TableDeleteCommand("test_table4");

            //XV`
            command.AddWhere(new ColumnValueCondition( property.Id,"@PK_Id", data.Id,"="));
            

            return command;
        }

        /// <summary>
        /// test_table4ւselect count(*)(WHERE͎L[g)
        /// </summary>
        /// <param name="data">Ώۏ</param>
        public TableSelectCommand BuildExistsCommand(TestTable4TableRow data)
        {
            TableSelectCommand command = new TableSelectCommand("test_table4");

            //XV`
            command.AddSelect(new TableCommandColumn("CNT","COUNT(*)"));

            //XV`
            command.AddWhere(new ColumnValueCondition( property.Id,"@PK_Id", data.Id,"="));
            

            return command;
        }

        /// <summary>
        /// test_table4ւselect sqlR}h(WHERE͎L[g)
        /// </summary>
        /// <param name="data">Ώۏ</param>
        public TableSelectCommand BuildSelectCommand(TestTable4TableRow data)
        {
            TableSelectCommand command = new TableSelectCommand("test_table4");

            //XV`
            command.AddSelect(property.Id);
            command.AddSelect(property.IntField);
            command.AddSelect(property.SmallintField);
            command.AddSelect(property.LongField);
            command.AddSelect(property.TinyintField);
            command.AddSelect(property.CharField);
            command.AddSelect(property.VarcharField);
            command.AddSelect(property.NcharField);
            command.AddSelect(property.NvarcharField);
            command.AddSelect(property.DatetimeField);
            command.AddSelect(property.SmalldatetimeField);
            

            //XV`
            command.AddWhere(new ColumnValueCondition( property.Id,"@PK_Id", data.Id,"="));
            

            return command;
        }

        /// <summary>
        /// test_table4ւselect sqlR}h(WHERE͊O炤)
        /// </summary>
        /// <param name="condition">Ώۏ</param>
        /// <param name="order">\[g</param>
        public TableSelectCommand BuildSelectCommand(TableCommandCondition condition,List<TableCommandColumn> order)
        {
            TableSelectCommand command = new TableSelectCommand("test_table4");

            //XV`
            command.AddSelect(property.Id);
            command.AddSelect(property.IntField);
            command.AddSelect(property.SmallintField);
            command.AddSelect(property.LongField);
            command.AddSelect(property.TinyintField);
            command.AddSelect(property.CharField);
            command.AddSelect(property.VarcharField);
            command.AddSelect(property.NcharField);
            command.AddSelect(property.NvarcharField);
            command.AddSelect(property.DatetimeField);
            command.AddSelect(property.SmalldatetimeField);
            

            //XV`
            if(condition != null)   command.AddWhere(condition);
            //
            if (order != null) command.OrderBy.AddRange(order);

            return command;
        }
        /// <summary>
        /// test_table4select list
        /// </summary>
        /// <param name="tableAlias">e[uɕtʖ</param>
        /// <param name="columnAliasPrefix">ɕtʖ̐ړ</param>
        public string  GetSelectListString(string tableAlias , string columnAliasPrefix)
        {
        	StringBuilder builder = new StringBuilder();

            //XV`
            builder.AppendLine(", "+ tableAlias + ".id AS " + columnAliasPrefix + "id" );
            builder.AppendLine(", "+ tableAlias + ".int_field AS " + columnAliasPrefix + "int_field" );
            builder.AppendLine(", "+ tableAlias + ".smallint_field AS " + columnAliasPrefix + "smallint_field" );
            builder.AppendLine(", "+ tableAlias + ".long_field AS " + columnAliasPrefix + "long_field" );
            builder.AppendLine(", "+ tableAlias + ".tinyint_field AS " + columnAliasPrefix + "tinyint_field" );
            builder.AppendLine(", "+ tableAlias + ".char_field AS " + columnAliasPrefix + "char_field" );
            builder.AppendLine(", "+ tableAlias + ".varchar_field AS " + columnAliasPrefix + "varchar_field" );
            builder.AppendLine(", "+ tableAlias + ".nchar_field AS " + columnAliasPrefix + "nchar_field" );
            builder.AppendLine(", "+ tableAlias + ".nvarchar_Field AS " + columnAliasPrefix + "nvarchar_Field" );
            builder.AppendLine(", "+ tableAlias + ".datetime_field AS " + columnAliasPrefix + "datetime_field" );
            builder.AppendLine(", "+ tableAlias + ".smalldatetime_field AS " + columnAliasPrefix + "smalldatetime_field" );
            

            return builder.ToString().Substring(1);
        }
    }
}
