using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Sample.Test4;
using CFW.Sample.Test4.TableRow;

namespace CFW.Sample.Test4.TableProperty
{
    /// <summary>
    /// table test_table4ɑΉtB[hvpeB
    /// </summary>
    [Serializable()]
    public class TestTable4TableProperty : FieldPropertiesBase
    {
    	///<summary>ftHg̃e[u</summary>
    	string DefaultTableName;
		///<summary>[id]</summary>
		public FieldProperty Id;
		///<summary>[int_field]</summary>
		public FieldProperty IntField;
		///<summary>[smallint_field]</summary>
		public FieldProperty SmallintField;
		///<summary>[long_field]</summary>
		public FieldProperty LongField;
		///<summary>[tinyint_field]</summary>
		public FieldProperty TinyintField;
		///<summary>[char_field]</summary>
		public FieldProperty CharField;
		///<summary>[varchar_field]</summary>
		public FieldProperty VarcharField;
		///<summary>[nchar_field]</summary>
		public FieldProperty NcharField;
		///<summary>[nvarchar_Field]</summary>
		public FieldProperty NvarcharField;
		///<summary>[datetime_field]</summary>
		public FieldProperty DatetimeField;
		///<summary>[smalldatetime_field]</summary>
		public FieldProperty SmalldatetimeField;
		

	    /// <summary>
	    /// default construct
	    /// </summary>
        public TestTable4TableProperty()
        {
        	this.DefaultTableName = "test_table4";
			Id = FieldProperty.NewInstance("int", "test_table4", "id","[id]", 4, 10, 0, false, 0,true);
			IntField = FieldProperty.NewInstance("int", "test_table4", "int_field","[int_field]", 4, 10, 0, true, null,false);
			SmallintField = FieldProperty.NewInstance("smallint", "test_table4", "smallint_field","[smallint_field]", 2, 5, 0, true, null,false);
			LongField = FieldProperty.NewInstance("bigint", "test_table4", "long_field","[long_field]", 8, 19, 0, true, null,false);
			TinyintField = FieldProperty.NewInstance("tinyint", "test_table4", "tinyint_field","[tinyint_field]", 1, 3, 0, true, null,false);
			CharField = FieldProperty.NewInstance("char", "test_table4", "char_field","[char_field]", 1000, 1000, 0, true, "",false);
			VarcharField = FieldProperty.NewInstance("varchar", "test_table4", "varchar_field","[varchar_field]", 1000, 1000, 0, true, "",false);
			NcharField = FieldProperty.NewInstance("nchar", "test_table4", "nchar_field","[nchar_field]", 2000, 1000, 0, true, "",false);
			NvarcharField = FieldProperty.NewInstance("nvarchar", "test_table4", "nvarchar_Field","[nvarchar_Field]", 2000, 1000, 0, true, "",false);
			DatetimeField = FieldProperty.NewInstance("datetime", "test_table4", "datetime_field","[datetime_field]", 16, 23, 3, true, null,false);
			SmalldatetimeField = FieldProperty.NewInstance("smalldatetime", "test_table4", "smalldatetime_field","[smalldatetime_field]", 16, 16, 0, true, null,false);
			
        }

	    /// <summary>
	    /// DoUpdateꊇݒ
	    /// </summary>
        public void SetUpdate()
        {
        	this.SetUpdate(true);
        }
	    /// <summary>
	    /// DoUpdateꊇݒ
	    /// </summary>
	    /// <param name="doUpdate">ݒl</param>
        public void SetUpdate(bool doUpdate)
        {
			Id.DoUpdate = doUpdate;
			IntField.DoUpdate = doUpdate;
			SmallintField.DoUpdate = doUpdate;
			LongField.DoUpdate = doUpdate;
			TinyintField.DoUpdate = doUpdate;
			CharField.DoUpdate = doUpdate;
			VarcharField.DoUpdate = doUpdate;
			NcharField.DoUpdate = doUpdate;
			NvarcharField.DoUpdate = doUpdate;
			DatetimeField.DoUpdate = doUpdate;
			SmalldatetimeField.DoUpdate = doUpdate;
			
        }
	    /// <summary>
	    /// TableNameꊇݒ
	    /// TableCommandgꍇAliasꊇݒ肷B
	    /// </summary>
	    /// <param name="alias">Vɐݒ肷e[u</param>
        public void SetTableName(string alias)
        {
			Id.TableName = alias;
			IntField.TableName = alias;
			SmallintField.TableName = alias;
			LongField.TableName = alias;
			TinyintField.TableName = alias;
			CharField.TableName = alias;
			VarcharField.TableName = alias;
			NcharField.TableName = alias;
			NvarcharField.TableName = alias;
			DatetimeField.TableName = alias;
			SmalldatetimeField.TableName = alias;
			
        }
	    /// <summary>
	    /// TableName߂
	    /// </summary>
        public void ResetTableName()
        {
        	this.SetTableName(this.DefaultTableName);
        }
	    /// <summary>
	    /// e[uIR}hɑSĂ̗I悤Ɏw
	    /// </summary>
        public void SetSelectTo(ref CFW.Database.TableCommand.TableSelectCommand command)
        {
			command.AddSelect(this.Id);
			command.AddSelect(this.IntField);
			command.AddSelect(this.SmallintField);
			command.AddSelect(this.LongField);
			command.AddSelect(this.TinyintField);
			command.AddSelect(this.CharField);
			command.AddSelect(this.VarcharField);
			command.AddSelect(this.NcharField);
			command.AddSelect(this.NvarcharField);
			command.AddSelect(this.DatetimeField);
			command.AddSelect(this.SmalldatetimeField);
			
        }
    }
}