using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using CFW.Util;
using CFW.FieldProperties;
using SQLiteSample.Model;
using SQLiteSample.Model.TableRow;

namespace SQLiteSample.Model.TableProperty
{
    /// <summary>
    /// table postaldataɑΉtB[hvpeB
    /// </summary>
    [Serializable()]
    public class PostaldataTableProperty : FieldPropertiesBase
    {
    	///<summary>ftHg̃e[u</summary>
    	string DefaultTableName;
		///<summary>[id]</summary>
		public FieldProperty Id;
		///<summary>[local_code]</summary>
		public FieldProperty LocalCode;
		///<summary>[postal_code_5]</summary>
		public FieldProperty PostalCode5;
		///<summary>[postal_code]</summary>
		public FieldProperty PostalCode;
		///<summary>[prefecture_k]</summary>
		public FieldProperty Prefecturek;
		///<summary>[city_k]</summary>
		public FieldProperty Cityk;
		///<summary>[area_k]</summary>
		public FieldProperty Areak;
		///<summary>[prefecture]</summary>
		public FieldProperty Prefecture;
		///<summary>[city]</summary>
		public FieldProperty City;
		///<summary>[area]</summary>
		public FieldProperty Area;
		///<summary>[flag1]</summary>
		public FieldProperty Flag1;
		///<summary>[flag2]</summary>
		public FieldProperty Flag2;
		///<summary>[flag3]</summary>
		public FieldProperty Flag3;
		///<summary>[flag4]</summary>
		public FieldProperty Flag4;
		///<summary>[flag5]</summary>
		public FieldProperty Flag5;
		///<summary>[flag6]</summary>
		public FieldProperty Flag6;
		

	    /// <summary>
	    /// default construct
	    /// </summary>
        public PostaldataTableProperty()
        {
        	this.DefaultTableName = "postaldata";
			Id = FieldProperty.NewInstance("int identity", "postaldata", "id","[id]", 4, 10, 0, false, 0,true);
			LocalCode = FieldProperty.NewInstance("varchar", "postaldata", "local_code","[local_code]", 10, 0, 0, false, "",false);
			PostalCode5 = FieldProperty.NewInstance("varchar", "postaldata", "postal_code_5","[postal_code_5]", 5, 0, 0, true, "",false);
			PostalCode = FieldProperty.NewInstance("varchar", "postaldata", "postal_code","[postal_code]", 11, 0, 0, false, "",false);
			Prefecturek = FieldProperty.NewInstance("varchar", "postaldata", "prefecture_k","[prefecture_k]", 50, 0, 0, false, "",false);
			Cityk = FieldProperty.NewInstance("varchar", "postaldata", "city_k","[city_k]", 50, 0, 0, false, "",false);
			Areak = FieldProperty.NewInstance("varchar", "postaldata", "area_k","[area_k]", 255, 0, 0, false, "",false);
			Prefecture = FieldProperty.NewInstance("varchar", "postaldata", "prefecture","[prefecture]", 50, 0, 0, false, "",false);
			City = FieldProperty.NewInstance("varchar", "postaldata", "city","[city]", 50, 0, 0, false, "",false);
			Area = FieldProperty.NewInstance("varchar", "postaldata", "area","[area]", 255, 0, 0, false, "",false);
			Flag1 = FieldProperty.NewInstance("int", "postaldata", "flag1","[flag1]", 4, 10, 0, false, 0,false);
			Flag2 = FieldProperty.NewInstance("int", "postaldata", "flag2","[flag2]", 4, 10, 0, false, 0,false);
			Flag3 = FieldProperty.NewInstance("int", "postaldata", "flag3","[flag3]", 4, 10, 0, false, 0,false);
			Flag4 = FieldProperty.NewInstance("int", "postaldata", "flag4","[flag4]", 4, 10, 0, false, 0,false);
			Flag5 = FieldProperty.NewInstance("int", "postaldata", "flag5","[flag5]", 4, 10, 0, false, 0,false);
			Flag6 = FieldProperty.NewInstance("int", "postaldata", "flag6","[flag6]", 4, 10, 0, false, 0,false);
			
        }

	    /// <summary>
	    /// DoUpdateꊇݒ
	    /// </summary>
	    /// <param name="doUpdate">ݒl</param>
        public void SetUpdate()
        {
        	this.SetUpdate(true);
        }
	    /// <summary>
	    /// DoUpdateꊇݒ
	    /// </summary>
	    /// <param name="doUpdate">ݒl</param>
        public void SetUpdate(bool doUpdate)
        {
			Id.DoUpdate = doUpdate;
			LocalCode.DoUpdate = doUpdate;
			PostalCode5.DoUpdate = doUpdate;
			PostalCode.DoUpdate = doUpdate;
			Prefecturek.DoUpdate = doUpdate;
			Cityk.DoUpdate = doUpdate;
			Areak.DoUpdate = doUpdate;
			Prefecture.DoUpdate = doUpdate;
			City.DoUpdate = doUpdate;
			Area.DoUpdate = doUpdate;
			Flag1.DoUpdate = doUpdate;
			Flag2.DoUpdate = doUpdate;
			Flag3.DoUpdate = doUpdate;
			Flag4.DoUpdate = doUpdate;
			Flag5.DoUpdate = doUpdate;
			Flag6.DoUpdate = doUpdate;
			
        }
	    /// <summary>
	    /// TableNameꊇݒ
	    /// TableCommandgꍇAliasꊇݒ肷B
	    /// </summary>
	    /// <param name="alias">Vɐݒ肷e[u</param>
        public void SetTableName(string alias)
        {
			Id.TableName = alias;
			LocalCode.TableName = alias;
			PostalCode5.TableName = alias;
			PostalCode.TableName = alias;
			Prefecturek.TableName = alias;
			Cityk.TableName = alias;
			Areak.TableName = alias;
			Prefecture.TableName = alias;
			City.TableName = alias;
			Area.TableName = alias;
			Flag1.TableName = alias;
			Flag2.TableName = alias;
			Flag3.TableName = alias;
			Flag4.TableName = alias;
			Flag5.TableName = alias;
			Flag6.TableName = alias;
			
        }
	    /// <summary>
	    /// TableName߂
	    /// </summary>
        public void ResetTableName()
        {
        	this.SetTableName(this.DefaultTableName);
        }
	    /// <summary>
	    /// e[uIR}hɑSĂ̗I悤Ɏw
	    /// </summary>
        public void SetSelectTo(ref CFW.Database.TableCommand.TableSelectCommand command)
        {
			command.AddSelect(this.Id);
			command.AddSelect(this.LocalCode);
			command.AddSelect(this.PostalCode5);
			command.AddSelect(this.PostalCode);
			command.AddSelect(this.Prefecturek);
			command.AddSelect(this.Cityk);
			command.AddSelect(this.Areak);
			command.AddSelect(this.Prefecture);
			command.AddSelect(this.City);
			command.AddSelect(this.Area);
			command.AddSelect(this.Flag1);
			command.AddSelect(this.Flag2);
			command.AddSelect(this.Flag3);
			command.AddSelect(this.Flag4);
			command.AddSelect(this.Flag5);
			command.AddSelect(this.Flag6);
			
        }
    }
}