using System;
using System.Collections.Generic;
using System.Text;
using CFW.Forms;
using CFW.Forms.Filters;
using CFW.Util;
using CFW.Sample.Model;
using CFW.Sample.Model.TableRow;
using CFW.Sample.Model.TableProperty;
using CFW.Sample.Model.TableValidator;


namespace CFW.Sample.Model.TableFormAdapter
{
    /// <summary>
    /// table MAST_MENU Field`
    /// </summary>
    public class MastMenuTableFormAdapter : CFW.Forms.FormAdapter
	{
		private MastMenuTableRow table;

		///<summary>[SITE_CODE]</summary>
		public FormAdapterElement SiteCode;
		///<summary>[MENU_CODE]</summary>
		public FormAdapterElement MenuCode;
		///<summary>[SORT_SEQ]</summary>
		public FormAdapterElement SortSeq;
		///<summary>[OPEN_DATE]</summary>
		public FormAdapterElement OpenDate;
		///<summary>[CLOSE_DATE]</summary>
		public FormAdapterElement CloseDate;
		///<summary>[MENU_GROUP_CODE]</summary>
		public FormAdapterElement MenuGroupCode;
		///<summary>[NAME]</summary>
		public FormAdapterElement Name;
		///<summary>[ANK_NAME]</summary>
		public FormAdapterElement AnkName;
		///<summary>[DEVICE_CODE]</summary>
		public FormAdapterElement DeviceCode;
		///<summary>[MENU_DEVICE_CODE]</summary>
		public FormAdapterElement MenuDeviceCode;
		///<summary>[MENU_ADTYPE_CODE]</summary>
		public FormAdapterElement MenuAdtypeCode;
		///<summary>[OPTIN_TYPE]</summary>
		public FormAdapterElement OptinType;
		///<summary>[MANAGEMENT_CODE]</summary>
		public FormAdapterElement ManagementCode;
		///<summary>[GUARANTEE_CODE]</summary>
		public FormAdapterElement GuaranteeCode;
		///<summary>[MENU_CATEGORY1]</summary>
		public FormAdapterElement MenuCategory1;
		///<summary>[MENU_CATEGORY2]</summary>
		public FormAdapterElement MenuCategory2;
		///<summary>[LIST_CODE]</summary>
		public FormAdapterElement ListCode;
		///<summary>[FLAME_COUNT]</summary>
		public FormAdapterElement FlameCount;
		///<summary>[FLAME_COUNT_KIND]</summary>
		public FormAdapterElement FlameCountKind;
		///<summary>[ROTATION_FLAME_COUNT]</summary>
		public FormAdapterElement RotationFlameCount;
		///<summary>[FLAME_SELECT_FLAG]</summary>
		public FormAdapterElement FlameSelectFlag;
		///<summary>[GOODS_CATEGORY_CODE]</summary>
		public FormAdapterElement GoodsCategoryCode;
		///<summary>[PAYMENT_COMPANY]</summary>
		public FormAdapterElement PaymentCompany;
		///<summary>[SP_OPEN_FLAG]</summary>
		public FormAdapterElement SpOpenFlag;
		///<summary>[PM_OPEN_FLAG]</summary>
		public FormAdapterElement PmOpenFlag;
		///<summary>[AD_GUIDE_OPEN_FLAG]</summary>
		public FormAdapterElement AdGuideOpenFlag;
		///<summary>[REGULATION_GUIDE_FLAG]</summary>
		public FormAdapterElement RegulationGuideFlag;
		///<summary>[IO_OPEN_FLAG]</summary>
		public FormAdapterElement IoOpenFlag;
		///<summary>[ES_AUDIENCE_FLAG]</summary>
		public FormAdapterElement EsAudienceFlag;
		///<summary>[ES_PERFORMANCE_FLAG]</summary>
		public FormAdapterElement EsPerformanceFlag;
		///<summary>[ES_REACH_FLAG]</summary>
		public FormAdapterElement EsReachFlag;
		///<summary>[SEARCH_URL_FLAG]</summary>
		public FormAdapterElement SearchUrlFlag;
		///<summary>[PACKAGE_FLAG]</summary>
		public FormAdapterElement PackageFlag;
		///<summary>[MENU_SELECTION_COUNT]</summary>
		public FormAdapterElement MenuSelectionCount;
		///<summary>[CARRIER_CODE1]</summary>
		public FormAdapterElement CarrierCode1;
		///<summary>[CARRIER_CODE2]</summary>
		public FormAdapterElement CarrierCode2;
		///<summary>[CARRIER_CODE3]</summary>
		public FormAdapterElement CarrierCode3;
		///<summary>[CARRIER_CODE4]</summary>
		public FormAdapterElement CarrierCode4;
		///<summary>[PAGE_REMARKS]</summary>
		public FormAdapterElement PageRemarks;
		///<summary>[REMARKS]</summary>
		public FormAdapterElement Remarks;
		///<summary>[DAC_REMARKS]</summary>
		public FormAdapterElement DacRemarks;
		///<summary>[B_STATUS]</summary>
		public FormAdapterElement BStatus;
		///<summary>[D_STATUS]</summary>
		public FormAdapterElement DStatus;
		///<summary>[P_STATUS]</summary>
		public FormAdapterElement PStatus;
		///<summary>[P_CAMPAIGN_STATUS_FROM]</summary>
		public FormAdapterElement PCampaignStatusFrom;
		///<summary>[P_CAMPAIGN_STATUS_TO]</summary>
		public FormAdapterElement PCampaignStatusTo;
		///<summary>[M_STATUS]</summary>
		public FormAdapterElement MStatus;
		///<summary>[T_STATUS]</summary>
		public FormAdapterElement TStatus;
		///<summary>[TOTAL_STATUS]</summary>
		public FormAdapterElement TotalStatus;
		///<summary>[TOTAL_STATUS_TO]</summary>
		public FormAdapterElement TotalStatusTo;
		///<summary>[COUNT_URL_KIND]</summary>
		public FormAdapterElement CountUrlKind;
		///<summary>[COUNT_URL]</summary>
		public FormAdapterElement CountUrl;
		///<summary>[REPORT_KIND]</summary>
		public FormAdapterElement ReportKind;
		///<summary>[REPORT_DETAIL]</summary>
		public FormAdapterElement ReportDetail;
		///<summary>[REPORT_RECEIVE]</summary>
		public FormAdapterElement ReportReceive;
		///<summary>[SEGMENT_EQUAL_FLAG]</summary>
		public FormAdapterElement SegmentEqualFlag;
		///<summary>[STOCK_FLAG]</summary>
		public FormAdapterElement StockFlag;
		///<summary>[STOCK_COUNT]</summary>
		public FormAdapterElement StockCount;
		///<summary>[CAPTURE_SEQ]</summary>
		public FormAdapterElement CaptureSeq;
		///<summary>[AG_COMPANY_CODE]</summary>
		public FormAdapterElement AgCompanyCode;
		///<summary>[INSIDE_OPEN_LEVEL]</summary>
		public FormAdapterElement InsideOpenLevel;
		///<summary>[OUTSIDE_OPEN_LEVEL]</summary>
		public FormAdapterElement OutsideOpenLevel;
		///<summary>[LIMIT_OPEN_REMARKS]</summary>
		public FormAdapterElement LimitOpenRemarks;
		///<summary>[PUBLISH_PAGE_FLAG]</summary>
		public FormAdapterElement PublishPageFlag;
		///<summary>[ES_REMARKS]</summary>
		public FormAdapterElement EsRemarks;
		///<summary>[MENU_FRAME_CODE]</summary>
		public FormAdapterElement MenuFrameCode;
		///<summary>[FRAME_NAME_REFRECT_FLAG]</summary>
		public FormAdapterElement FrameNameRefrectFlag;
		///<summary>[DELIVERY_OPTION_NAME]</summary>
		public FormAdapterElement DeliveryOptionName;
		///<summary>[GET_REPORT_DESTINATION]</summary>
		public FormAdapterElement GetReportDestination;
		///<summary>[REPORT_TREAT_KIND_SEQ]</summary>
		public FormAdapterElement ReportTreatKindSeq;
		///<summary>[USE_SITE_LIMIT_OPEN_FLAG]</summary>
		public FormAdapterElement UseSiteLimitOpenFlag;
		///<summary>[USE_SITE_CARRIER_FLAG]</summary>
		public FormAdapterElement UseSiteCarrierFlag;
		///<summary>[COST_MENU_FLAG]</summary>
		public FormAdapterElement CostMenuFlag;
		///<summary>[CHECK_NAME]</summary>
		public FormAdapterElement CheckName;
		///<summary>[PRICE_GROUP_FROM_DATE]</summary>
		public FormAdapterElement PriceGroupFromDate;
		///<summary>[MANUSCRIPT_FROM_DATE]</summary>
		public FormAdapterElement ManuscriptFromDate;
		///<summary>[PRICE_COST_FROM_DATE]</summary>
		public FormAdapterElement PriceCostFromDate;
		///<summary>[TRANSMIT_FROM_DATE]</summary>
		public FormAdapterElement TransmitFromDate;
		///<summary>[VALID_FLAG]</summary>
		public FormAdapterElement ValidFlag;
		///<summary>[BASE_UPDATE_DATE_TIME]</summary>
		public FormAdapterElement BaseUpdateDateTime;
		///<summary>[INSERT_DATE_TIME]</summary>
		public FormAdapterElement InsertDateTime;
		///<summary>[INSERT_OPERATOR_CODE]</summary>
		public FormAdapterElement InsertOperatorCode;
		///<summary>[UPDATE_DATE_TIME]</summary>
		public FormAdapterElement UpdateDateTime;
		///<summary>[OPERATOR_CODE]</summary>
		public FormAdapterElement OperatorCode;
		

		/// <summary>݂̃f[^\[X擾
		/// </summary>
        public override CFW.Models.Entity GetEntity()
        {
            return this.table;
        }
		/// <summary>\̍XV
		/// </summary>
        public override void RenderView()
        {
			this.SiteCode.Render();
			this.MenuCode.Render();
			this.SortSeq.Render();
			this.OpenDate.Render();
			this.CloseDate.Render();
			this.MenuGroupCode.Render();
			this.Name.Render();
			this.AnkName.Render();
			this.DeviceCode.Render();
			this.MenuDeviceCode.Render();
			this.MenuAdtypeCode.Render();
			this.OptinType.Render();
			this.ManagementCode.Render();
			this.GuaranteeCode.Render();
			this.MenuCategory1.Render();
			this.MenuCategory2.Render();
			this.ListCode.Render();
			this.FlameCount.Render();
			this.FlameCountKind.Render();
			this.RotationFlameCount.Render();
			this.FlameSelectFlag.Render();
			this.GoodsCategoryCode.Render();
			this.PaymentCompany.Render();
			this.SpOpenFlag.Render();
			this.PmOpenFlag.Render();
			this.AdGuideOpenFlag.Render();
			this.RegulationGuideFlag.Render();
			this.IoOpenFlag.Render();
			this.EsAudienceFlag.Render();
			this.EsPerformanceFlag.Render();
			this.EsReachFlag.Render();
			this.SearchUrlFlag.Render();
			this.PackageFlag.Render();
			this.MenuSelectionCount.Render();
			this.CarrierCode1.Render();
			this.CarrierCode2.Render();
			this.CarrierCode3.Render();
			this.CarrierCode4.Render();
			this.PageRemarks.Render();
			this.Remarks.Render();
			this.DacRemarks.Render();
			this.BStatus.Render();
			this.DStatus.Render();
			this.PStatus.Render();
			this.PCampaignStatusFrom.Render();
			this.PCampaignStatusTo.Render();
			this.MStatus.Render();
			this.TStatus.Render();
			this.TotalStatus.Render();
			this.TotalStatusTo.Render();
			this.CountUrlKind.Render();
			this.CountUrl.Render();
			this.ReportKind.Render();
			this.ReportDetail.Render();
			this.ReportReceive.Render();
			this.SegmentEqualFlag.Render();
			this.StockFlag.Render();
			this.StockCount.Render();
			this.CaptureSeq.Render();
			this.AgCompanyCode.Render();
			this.InsideOpenLevel.Render();
			this.OutsideOpenLevel.Render();
			this.LimitOpenRemarks.Render();
			this.PublishPageFlag.Render();
			this.EsRemarks.Render();
			this.MenuFrameCode.Render();
			this.FrameNameRefrectFlag.Render();
			this.DeliveryOptionName.Render();
			this.GetReportDestination.Render();
			this.ReportTreatKindSeq.Render();
			this.UseSiteLimitOpenFlag.Render();
			this.UseSiteCarrierFlag.Render();
			this.CostMenuFlag.Render();
			this.CheckName.Render();
			this.PriceGroupFromDate.Render();
			this.ManuscriptFromDate.Render();
			this.PriceCostFromDate.Render();
			this.TransmitFromDate.Render();
			this.ValidFlag.Render();
			this.BaseUpdateDateTime.Render();
			this.InsertDateTime.Render();
			this.InsertOperatorCode.Render();
			this.UpdateDateTime.Render();
			this.OperatorCode.Render();
			
        }

		/// <summary>̃A_v^[f[^ݒ
		/// </summary>
        /// <param name="entity">̃A_v^[f[^</param>
        public override void SetEntity(CFW.Models.Entity entity)
        {
            this.table = (MastMenuTableRow)entity;
			this.SiteCode.SetValue(this.table.SiteCode);
			this.MenuCode.SetValue(this.table.MenuCode);
			this.SortSeq.SetValue(this.table.SortSeq);
			this.OpenDate.SetValue(this.table.OpenDate);
			this.CloseDate.SetValue(this.table.CloseDate);
			this.MenuGroupCode.SetValue(this.table.MenuGroupCode);
			this.Name.SetValue(this.table.Name);
			this.AnkName.SetValue(this.table.AnkName);
			this.DeviceCode.SetValue(this.table.DeviceCode);
			this.MenuDeviceCode.SetValue(this.table.MenuDeviceCode);
			this.MenuAdtypeCode.SetValue(this.table.MenuAdtypeCode);
			this.OptinType.SetValue(this.table.OptinType);
			this.ManagementCode.SetValue(this.table.ManagementCode);
			this.GuaranteeCode.SetValue(this.table.GuaranteeCode);
			this.MenuCategory1.SetValue(this.table.MenuCategory1);
			this.MenuCategory2.SetValue(this.table.MenuCategory2);
			this.ListCode.SetValue(this.table.ListCode);
			this.FlameCount.SetValue(this.table.FlameCount);
			this.FlameCountKind.SetValue(this.table.FlameCountKind);
			this.RotationFlameCount.SetValue(this.table.RotationFlameCount);
			this.FlameSelectFlag.SetValue(this.table.FlameSelectFlag);
			this.GoodsCategoryCode.SetValue(this.table.GoodsCategoryCode);
			this.PaymentCompany.SetValue(this.table.PaymentCompany);
			this.SpOpenFlag.SetValue(this.table.SpOpenFlag);
			this.PmOpenFlag.SetValue(this.table.PmOpenFlag);
			this.AdGuideOpenFlag.SetValue(this.table.AdGuideOpenFlag);
			this.RegulationGuideFlag.SetValue(this.table.RegulationGuideFlag);
			this.IoOpenFlag.SetValue(this.table.IoOpenFlag);
			this.EsAudienceFlag.SetValue(this.table.EsAudienceFlag);
			this.EsPerformanceFlag.SetValue(this.table.EsPerformanceFlag);
			this.EsReachFlag.SetValue(this.table.EsReachFlag);
			this.SearchUrlFlag.SetValue(this.table.SearchUrlFlag);
			this.PackageFlag.SetValue(this.table.PackageFlag);
			this.MenuSelectionCount.SetValue(this.table.MenuSelectionCount);
			this.CarrierCode1.SetValue(this.table.CarrierCode1);
			this.CarrierCode2.SetValue(this.table.CarrierCode2);
			this.CarrierCode3.SetValue(this.table.CarrierCode3);
			this.CarrierCode4.SetValue(this.table.CarrierCode4);
			this.PageRemarks.SetValue(this.table.PageRemarks);
			this.Remarks.SetValue(this.table.Remarks);
			this.DacRemarks.SetValue(this.table.DacRemarks);
			this.BStatus.SetValue(this.table.BStatus);
			this.DStatus.SetValue(this.table.DStatus);
			this.PStatus.SetValue(this.table.PStatus);
			this.PCampaignStatusFrom.SetValue(this.table.PCampaignStatusFrom);
			this.PCampaignStatusTo.SetValue(this.table.PCampaignStatusTo);
			this.MStatus.SetValue(this.table.MStatus);
			this.TStatus.SetValue(this.table.TStatus);
			this.TotalStatus.SetValue(this.table.TotalStatus);
			this.TotalStatusTo.SetValue(this.table.TotalStatusTo);
			this.CountUrlKind.SetValue(this.table.CountUrlKind);
			this.CountUrl.SetValue(this.table.CountUrl);
			this.ReportKind.SetValue(this.table.ReportKind);
			this.ReportDetail.SetValue(this.table.ReportDetail);
			this.ReportReceive.SetValue(this.table.ReportReceive);
			this.SegmentEqualFlag.SetValue(this.table.SegmentEqualFlag);
			this.StockFlag.SetValue(this.table.StockFlag);
			this.StockCount.SetValue(this.table.StockCount);
			this.CaptureSeq.SetValue(this.table.CaptureSeq);
			this.AgCompanyCode.SetValue(this.table.AgCompanyCode);
			this.InsideOpenLevel.SetValue(this.table.InsideOpenLevel);
			this.OutsideOpenLevel.SetValue(this.table.OutsideOpenLevel);
			this.LimitOpenRemarks.SetValue(this.table.LimitOpenRemarks);
			this.PublishPageFlag.SetValue(this.table.PublishPageFlag);
			this.EsRemarks.SetValue(this.table.EsRemarks);
			this.MenuFrameCode.SetValue(this.table.MenuFrameCode);
			this.FrameNameRefrectFlag.SetValue(this.table.FrameNameRefrectFlag);
			this.DeliveryOptionName.SetValue(this.table.DeliveryOptionName);
			this.GetReportDestination.SetValue(this.table.GetReportDestination);
			this.ReportTreatKindSeq.SetValue(this.table.ReportTreatKindSeq);
			this.UseSiteLimitOpenFlag.SetValue(this.table.UseSiteLimitOpenFlag);
			this.UseSiteCarrierFlag.SetValue(this.table.UseSiteCarrierFlag);
			this.CostMenuFlag.SetValue(this.table.CostMenuFlag);
			this.CheckName.SetValue(this.table.CheckName);
			this.PriceGroupFromDate.SetValue(this.table.PriceGroupFromDate);
			this.ManuscriptFromDate.SetValue(this.table.ManuscriptFromDate);
			this.PriceCostFromDate.SetValue(this.table.PriceCostFromDate);
			this.TransmitFromDate.SetValue(this.table.TransmitFromDate);
			this.ValidFlag.SetValue(this.table.ValidFlag);
			this.BaseUpdateDateTime.SetValue(this.table.BaseUpdateDateTime);
			this.InsertDateTime.SetValue(this.table.InsertDateTime);
			this.InsertOperatorCode.SetValue(this.table.InsertOperatorCode);
			this.UpdateDateTime.SetValue(this.table.UpdateDateTime);
			this.OperatorCode.SetValue(this.table.OperatorCode);
			

        }

		/// <summary>UI͂ꂽef[^\[XɎ荞
		/// </summary>
        public override void UpdateEntity()
        {
			this.table.SiteCode = StringUtil.StringValue(this.SiteCode.GetValue());
			this.table.MenuCode = StringUtil.StringValue(this.MenuCode.GetValue());
			this.table.SortSeq = NumberUtil.Value<Int16?>(this.SortSeq.GetValue());
			this.table.OpenDate = StringUtil.StringValue(this.OpenDate.GetValue());
			this.table.CloseDate = StringUtil.StringValue(this.CloseDate.GetValue());
			this.table.MenuGroupCode = NumberUtil.Value<Int16?>(this.MenuGroupCode.GetValue());
			this.table.Name = StringUtil.StringValue(this.Name.GetValue());
			this.table.AnkName = StringUtil.StringValue(this.AnkName.GetValue());
			this.table.DeviceCode = NumberUtil.Value<Int16>(this.DeviceCode.GetValue());
			this.table.MenuDeviceCode = NumberUtil.Value<Int16?>(this.MenuDeviceCode.GetValue());
			this.table.MenuAdtypeCode = NumberUtil.Value<Int16?>(this.MenuAdtypeCode.GetValue());
			this.table.OptinType = NumberUtil.Value<Int16?>(this.OptinType.GetValue());
			this.table.ManagementCode = NumberUtil.Value<Int16>(this.ManagementCode.GetValue());
			this.table.GuaranteeCode = NumberUtil.Value<Int16>(this.GuaranteeCode.GetValue());
			this.table.MenuCategory1 = NumberUtil.Value<Int16?>(this.MenuCategory1.GetValue());
			this.table.MenuCategory2 = NumberUtil.Value<Int16?>(this.MenuCategory2.GetValue());
			this.table.ListCode = NumberUtil.Value<Int16?>(this.ListCode.GetValue());
			this.table.FlameCount = NumberUtil.Value<Int16?>(this.FlameCount.GetValue());
			this.table.FlameCountKind = NumberUtil.Value<Int16>(this.FlameCountKind.GetValue());
			this.table.RotationFlameCount = NumberUtil.Value<Int16?>(this.RotationFlameCount.GetValue());
			this.table.FlameSelectFlag = NumberUtil.Value<Int16?>(this.FlameSelectFlag.GetValue());
			this.table.GoodsCategoryCode = NumberUtil.Value<Int16?>(this.GoodsCategoryCode.GetValue());
			this.table.PaymentCompany = StringUtil.StringValue(this.PaymentCompany.GetValue());
			this.table.SpOpenFlag = NumberUtil.Value<Int16?>(this.SpOpenFlag.GetValue());
			this.table.PmOpenFlag = NumberUtil.Value<Int16?>(this.PmOpenFlag.GetValue());
			this.table.AdGuideOpenFlag = NumberUtil.Value<Int16?>(this.AdGuideOpenFlag.GetValue());
			this.table.RegulationGuideFlag = NumberUtil.Value<Int16?>(this.RegulationGuideFlag.GetValue());
			this.table.IoOpenFlag = NumberUtil.Value<Int16?>(this.IoOpenFlag.GetValue());
			this.table.EsAudienceFlag = NumberUtil.Value<Int16?>(this.EsAudienceFlag.GetValue());
			this.table.EsPerformanceFlag = NumberUtil.Value<Int16?>(this.EsPerformanceFlag.GetValue());
			this.table.EsReachFlag = NumberUtil.Value<Int16?>(this.EsReachFlag.GetValue());
			this.table.SearchUrlFlag = NumberUtil.Value<Int16?>(this.SearchUrlFlag.GetValue());
			this.table.PackageFlag = NumberUtil.Value<Int16?>(this.PackageFlag.GetValue());
			this.table.MenuSelectionCount = NumberUtil.Value<Int16?>(this.MenuSelectionCount.GetValue());
			this.table.CarrierCode1 = NumberUtil.Value<Int16?>(this.CarrierCode1.GetValue());
			this.table.CarrierCode2 = NumberUtil.Value<Int16?>(this.CarrierCode2.GetValue());
			this.table.CarrierCode3 = NumberUtil.Value<Int16?>(this.CarrierCode3.GetValue());
			this.table.CarrierCode4 = NumberUtil.Value<Int16?>(this.CarrierCode4.GetValue());
			this.table.PageRemarks = StringUtil.StringValue(this.PageRemarks.GetValue());
			this.table.Remarks = StringUtil.StringValue(this.Remarks.GetValue());
			this.table.DacRemarks = StringUtil.StringValue(this.DacRemarks.GetValue());
			this.table.BStatus = StringUtil.StringValue(this.BStatus.GetValue());
			this.table.DStatus = StringUtil.StringValue(this.DStatus.GetValue());
			this.table.PStatus = StringUtil.StringValue(this.PStatus.GetValue());
			this.table.PCampaignStatusFrom = StringUtil.StringValue(this.PCampaignStatusFrom.GetValue());
			this.table.PCampaignStatusTo = StringUtil.StringValue(this.PCampaignStatusTo.GetValue());
			this.table.MStatus = StringUtil.StringValue(this.MStatus.GetValue());
			this.table.TStatus = StringUtil.StringValue(this.TStatus.GetValue());
			this.table.TotalStatus = StringUtil.StringValue(this.TotalStatus.GetValue());
			this.table.TotalStatusTo = StringUtil.StringValue(this.TotalStatusTo.GetValue());
			this.table.CountUrlKind = NumberUtil.Value<Int16?>(this.CountUrlKind.GetValue());
			this.table.CountUrl = StringUtil.StringValue(this.CountUrl.GetValue());
			this.table.ReportKind = NumberUtil.Value<Int16>(this.ReportKind.GetValue());
			this.table.ReportDetail = StringUtil.StringValue(this.ReportDetail.GetValue());
			this.table.ReportReceive = StringUtil.StringValue(this.ReportReceive.GetValue());
			this.table.SegmentEqualFlag = NumberUtil.Value<Int16?>(this.SegmentEqualFlag.GetValue());
			this.table.StockFlag = NumberUtil.Value<Int16?>(this.StockFlag.GetValue());
			this.table.StockCount = NumberUtil.Value<Int16?>(this.StockCount.GetValue());
			this.table.CaptureSeq = StringUtil.StringValue(this.CaptureSeq.GetValue());
			this.table.AgCompanyCode = StringUtil.StringValue(this.AgCompanyCode.GetValue());
			this.table.InsideOpenLevel = NumberUtil.Value<Int16?>(this.InsideOpenLevel.GetValue());
			this.table.OutsideOpenLevel = NumberUtil.Value<Int16?>(this.OutsideOpenLevel.GetValue());
			this.table.LimitOpenRemarks = StringUtil.StringValue(this.LimitOpenRemarks.GetValue());
			this.table.PublishPageFlag = NumberUtil.Value<Int16?>(this.PublishPageFlag.GetValue());
			this.table.EsRemarks = StringUtil.StringValue(this.EsRemarks.GetValue());
			this.table.MenuFrameCode = StringUtil.StringValue(this.MenuFrameCode.GetValue());
			this.table.FrameNameRefrectFlag = NumberUtil.Value<Int16?>(this.FrameNameRefrectFlag.GetValue());
			this.table.DeliveryOptionName = StringUtil.StringValue(this.DeliveryOptionName.GetValue());
			this.table.GetReportDestination = StringUtil.StringValue(this.GetReportDestination.GetValue());
			this.table.ReportTreatKindSeq = NumberUtil.Value<Int16?>(this.ReportTreatKindSeq.GetValue());
			this.table.UseSiteLimitOpenFlag = NumberUtil.Value<Int16?>(this.UseSiteLimitOpenFlag.GetValue());
			this.table.UseSiteCarrierFlag = NumberUtil.Value<Int16?>(this.UseSiteCarrierFlag.GetValue());
			this.table.CostMenuFlag = NumberUtil.Value<Int16?>(this.CostMenuFlag.GetValue());
			this.table.CheckName = StringUtil.StringValue(this.CheckName.GetValue());
			this.table.PriceGroupFromDate = StringUtil.StringValue(this.PriceGroupFromDate.GetValue());
			this.table.ManuscriptFromDate = StringUtil.StringValue(this.ManuscriptFromDate.GetValue());
			this.table.PriceCostFromDate = StringUtil.StringValue(this.PriceCostFromDate.GetValue());
			this.table.TransmitFromDate = StringUtil.StringValue(this.TransmitFromDate.GetValue());
			this.table.ValidFlag = NumberUtil.Value<Int16?>(this.ValidFlag.GetValue());
			this.table.BaseUpdateDateTime = DateUtil.DateValue(this.BaseUpdateDateTime.GetValue());
			this.table.InsertDateTime = DateUtil.DateValue(this.InsertDateTime.GetValue());
			this.table.InsertOperatorCode = StringUtil.StringValue(this.InsertOperatorCode.GetValue());
			this.table.UpdateDateTime = DateUtil.DateValue(this.UpdateDateTime.GetValue());
			this.table.OperatorCode = StringUtil.StringValue(this.OperatorCode.GetValue());
			
        }

		/// <summary>UI͂ꂽe荞
		/// </summary>
        public override void UpdateFields()
        {
			this.SiteCode.UpdateField();
			this.MenuCode.UpdateField();
			this.SortSeq.UpdateField();
			this.OpenDate.UpdateField();
			this.CloseDate.UpdateField();
			this.MenuGroupCode.UpdateField();
			this.Name.UpdateField();
			this.AnkName.UpdateField();
			this.DeviceCode.UpdateField();
			this.MenuDeviceCode.UpdateField();
			this.MenuAdtypeCode.UpdateField();
			this.OptinType.UpdateField();
			this.ManagementCode.UpdateField();
			this.GuaranteeCode.UpdateField();
			this.MenuCategory1.UpdateField();
			this.MenuCategory2.UpdateField();
			this.ListCode.UpdateField();
			this.FlameCount.UpdateField();
			this.FlameCountKind.UpdateField();
			this.RotationFlameCount.UpdateField();
			this.FlameSelectFlag.UpdateField();
			this.GoodsCategoryCode.UpdateField();
			this.PaymentCompany.UpdateField();
			this.SpOpenFlag.UpdateField();
			this.PmOpenFlag.UpdateField();
			this.AdGuideOpenFlag.UpdateField();
			this.RegulationGuideFlag.UpdateField();
			this.IoOpenFlag.UpdateField();
			this.EsAudienceFlag.UpdateField();
			this.EsPerformanceFlag.UpdateField();
			this.EsReachFlag.UpdateField();
			this.SearchUrlFlag.UpdateField();
			this.PackageFlag.UpdateField();
			this.MenuSelectionCount.UpdateField();
			this.CarrierCode1.UpdateField();
			this.CarrierCode2.UpdateField();
			this.CarrierCode3.UpdateField();
			this.CarrierCode4.UpdateField();
			this.PageRemarks.UpdateField();
			this.Remarks.UpdateField();
			this.DacRemarks.UpdateField();
			this.BStatus.UpdateField();
			this.DStatus.UpdateField();
			this.PStatus.UpdateField();
			this.PCampaignStatusFrom.UpdateField();
			this.PCampaignStatusTo.UpdateField();
			this.MStatus.UpdateField();
			this.TStatus.UpdateField();
			this.TotalStatus.UpdateField();
			this.TotalStatusTo.UpdateField();
			this.CountUrlKind.UpdateField();
			this.CountUrl.UpdateField();
			this.ReportKind.UpdateField();
			this.ReportDetail.UpdateField();
			this.ReportReceive.UpdateField();
			this.SegmentEqualFlag.UpdateField();
			this.StockFlag.UpdateField();
			this.StockCount.UpdateField();
			this.CaptureSeq.UpdateField();
			this.AgCompanyCode.UpdateField();
			this.InsideOpenLevel.UpdateField();
			this.OutsideOpenLevel.UpdateField();
			this.LimitOpenRemarks.UpdateField();
			this.PublishPageFlag.UpdateField();
			this.EsRemarks.UpdateField();
			this.MenuFrameCode.UpdateField();
			this.FrameNameRefrectFlag.UpdateField();
			this.DeliveryOptionName.UpdateField();
			this.GetReportDestination.UpdateField();
			this.ReportTreatKindSeq.UpdateField();
			this.UseSiteLimitOpenFlag.UpdateField();
			this.UseSiteCarrierFlag.UpdateField();
			this.CostMenuFlag.UpdateField();
			this.CheckName.UpdateField();
			this.PriceGroupFromDate.UpdateField();
			this.ManuscriptFromDate.UpdateField();
			this.PriceCostFromDate.UpdateField();
			this.TransmitFromDate.UpdateField();
			this.ValidFlag.UpdateField();
			this.BaseUpdateDateTime.UpdateField();
			this.InsertDateTime.UpdateField();
			this.InsertOperatorCode.UpdateField();
			this.UpdateDateTime.UpdateField();
			this.OperatorCode.UpdateField();
			
        }

		/// <summary>͓e؂
		/// ؃G[MessagesXgɑSẴG[B
		/// </summary>
        public override bool Validate()
        {
            bool valid = true;
			if(!this.SiteCode.Validate()){
				valid = false;
				this.messages.Add(this.SiteCode.ErrorMessage);
			}
			if(!this.MenuCode.Validate()){
				valid = false;
				this.messages.Add(this.MenuCode.ErrorMessage);
			}
			if(!this.SortSeq.Validate()){
				valid = false;
				this.messages.Add(this.SortSeq.ErrorMessage);
			}
			if(!this.OpenDate.Validate()){
				valid = false;
				this.messages.Add(this.OpenDate.ErrorMessage);
			}
			if(!this.CloseDate.Validate()){
				valid = false;
				this.messages.Add(this.CloseDate.ErrorMessage);
			}
			if(!this.MenuGroupCode.Validate()){
				valid = false;
				this.messages.Add(this.MenuGroupCode.ErrorMessage);
			}
			if(!this.Name.Validate()){
				valid = false;
				this.messages.Add(this.Name.ErrorMessage);
			}
			if(!this.AnkName.Validate()){
				valid = false;
				this.messages.Add(this.AnkName.ErrorMessage);
			}
			if(!this.DeviceCode.Validate()){
				valid = false;
				this.messages.Add(this.DeviceCode.ErrorMessage);
			}
			if(!this.MenuDeviceCode.Validate()){
				valid = false;
				this.messages.Add(this.MenuDeviceCode.ErrorMessage);
			}
			if(!this.MenuAdtypeCode.Validate()){
				valid = false;
				this.messages.Add(this.MenuAdtypeCode.ErrorMessage);
			}
			if(!this.OptinType.Validate()){
				valid = false;
				this.messages.Add(this.OptinType.ErrorMessage);
			}
			if(!this.ManagementCode.Validate()){
				valid = false;
				this.messages.Add(this.ManagementCode.ErrorMessage);
			}
			if(!this.GuaranteeCode.Validate()){
				valid = false;
				this.messages.Add(this.GuaranteeCode.ErrorMessage);
			}
			if(!this.MenuCategory1.Validate()){
				valid = false;
				this.messages.Add(this.MenuCategory1.ErrorMessage);
			}
			if(!this.MenuCategory2.Validate()){
				valid = false;
				this.messages.Add(this.MenuCategory2.ErrorMessage);
			}
			if(!this.ListCode.Validate()){
				valid = false;
				this.messages.Add(this.ListCode.ErrorMessage);
			}
			if(!this.FlameCount.Validate()){
				valid = false;
				this.messages.Add(this.FlameCount.ErrorMessage);
			}
			if(!this.FlameCountKind.Validate()){
				valid = false;
				this.messages.Add(this.FlameCountKind.ErrorMessage);
			}
			if(!this.RotationFlameCount.Validate()){
				valid = false;
				this.messages.Add(this.RotationFlameCount.ErrorMessage);
			}
			if(!this.FlameSelectFlag.Validate()){
				valid = false;
				this.messages.Add(this.FlameSelectFlag.ErrorMessage);
			}
			if(!this.GoodsCategoryCode.Validate()){
				valid = false;
				this.messages.Add(this.GoodsCategoryCode.ErrorMessage);
			}
			if(!this.PaymentCompany.Validate()){
				valid = false;
				this.messages.Add(this.PaymentCompany.ErrorMessage);
			}
			if(!this.SpOpenFlag.Validate()){
				valid = false;
				this.messages.Add(this.SpOpenFlag.ErrorMessage);
			}
			if(!this.PmOpenFlag.Validate()){
				valid = false;
				this.messages.Add(this.PmOpenFlag.ErrorMessage);
			}
			if(!this.AdGuideOpenFlag.Validate()){
				valid = false;
				this.messages.Add(this.AdGuideOpenFlag.ErrorMessage);
			}
			if(!this.RegulationGuideFlag.Validate()){
				valid = false;
				this.messages.Add(this.RegulationGuideFlag.ErrorMessage);
			}
			if(!this.IoOpenFlag.Validate()){
				valid = false;
				this.messages.Add(this.IoOpenFlag.ErrorMessage);
			}
			if(!this.EsAudienceFlag.Validate()){
				valid = false;
				this.messages.Add(this.EsAudienceFlag.ErrorMessage);
			}
			if(!this.EsPerformanceFlag.Validate()){
				valid = false;
				this.messages.Add(this.EsPerformanceFlag.ErrorMessage);
			}
			if(!this.EsReachFlag.Validate()){
				valid = false;
				this.messages.Add(this.EsReachFlag.ErrorMessage);
			}
			if(!this.SearchUrlFlag.Validate()){
				valid = false;
				this.messages.Add(this.SearchUrlFlag.ErrorMessage);
			}
			if(!this.PackageFlag.Validate()){
				valid = false;
				this.messages.Add(this.PackageFlag.ErrorMessage);
			}
			if(!this.MenuSelectionCount.Validate()){
				valid = false;
				this.messages.Add(this.MenuSelectionCount.ErrorMessage);
			}
			if(!this.CarrierCode1.Validate()){
				valid = false;
				this.messages.Add(this.CarrierCode1.ErrorMessage);
			}
			if(!this.CarrierCode2.Validate()){
				valid = false;
				this.messages.Add(this.CarrierCode2.ErrorMessage);
			}
			if(!this.CarrierCode3.Validate()){
				valid = false;
				this.messages.Add(this.CarrierCode3.ErrorMessage);
			}
			if(!this.CarrierCode4.Validate()){
				valid = false;
				this.messages.Add(this.CarrierCode4.ErrorMessage);
			}
			if(!this.PageRemarks.Validate()){
				valid = false;
				this.messages.Add(this.PageRemarks.ErrorMessage);
			}
			if(!this.Remarks.Validate()){
				valid = false;
				this.messages.Add(this.Remarks.ErrorMessage);
			}
			if(!this.DacRemarks.Validate()){
				valid = false;
				this.messages.Add(this.DacRemarks.ErrorMessage);
			}
			if(!this.BStatus.Validate()){
				valid = false;
				this.messages.Add(this.BStatus.ErrorMessage);
			}
			if(!this.DStatus.Validate()){
				valid = false;
				this.messages.Add(this.DStatus.ErrorMessage);
			}
			if(!this.PStatus.Validate()){
				valid = false;
				this.messages.Add(this.PStatus.ErrorMessage);
			}
			if(!this.PCampaignStatusFrom.Validate()){
				valid = false;
				this.messages.Add(this.PCampaignStatusFrom.ErrorMessage);
			}
			if(!this.PCampaignStatusTo.Validate()){
				valid = false;
				this.messages.Add(this.PCampaignStatusTo.ErrorMessage);
			}
			if(!this.MStatus.Validate()){
				valid = false;
				this.messages.Add(this.MStatus.ErrorMessage);
			}
			if(!this.TStatus.Validate()){
				valid = false;
				this.messages.Add(this.TStatus.ErrorMessage);
			}
			if(!this.TotalStatus.Validate()){
				valid = false;
				this.messages.Add(this.TotalStatus.ErrorMessage);
			}
			if(!this.TotalStatusTo.Validate()){
				valid = false;
				this.messages.Add(this.TotalStatusTo.ErrorMessage);
			}
			if(!this.CountUrlKind.Validate()){
				valid = false;
				this.messages.Add(this.CountUrlKind.ErrorMessage);
			}
			if(!this.CountUrl.Validate()){
				valid = false;
				this.messages.Add(this.CountUrl.ErrorMessage);
			}
			if(!this.ReportKind.Validate()){
				valid = false;
				this.messages.Add(this.ReportKind.ErrorMessage);
			}
			if(!this.ReportDetail.Validate()){
				valid = false;
				this.messages.Add(this.ReportDetail.ErrorMessage);
			}
			if(!this.ReportReceive.Validate()){
				valid = false;
				this.messages.Add(this.ReportReceive.ErrorMessage);
			}
			if(!this.SegmentEqualFlag.Validate()){
				valid = false;
				this.messages.Add(this.SegmentEqualFlag.ErrorMessage);
			}
			if(!this.StockFlag.Validate()){
				valid = false;
				this.messages.Add(this.StockFlag.ErrorMessage);
			}
			if(!this.StockCount.Validate()){
				valid = false;
				this.messages.Add(this.StockCount.ErrorMessage);
			}
			if(!this.CaptureSeq.Validate()){
				valid = false;
				this.messages.Add(this.CaptureSeq.ErrorMessage);
			}
			if(!this.AgCompanyCode.Validate()){
				valid = false;
				this.messages.Add(this.AgCompanyCode.ErrorMessage);
			}
			if(!this.InsideOpenLevel.Validate()){
				valid = false;
				this.messages.Add(this.InsideOpenLevel.ErrorMessage);
			}
			if(!this.OutsideOpenLevel.Validate()){
				valid = false;
				this.messages.Add(this.OutsideOpenLevel.ErrorMessage);
			}
			if(!this.LimitOpenRemarks.Validate()){
				valid = false;
				this.messages.Add(this.LimitOpenRemarks.ErrorMessage);
			}
			if(!this.PublishPageFlag.Validate()){
				valid = false;
				this.messages.Add(this.PublishPageFlag.ErrorMessage);
			}
			if(!this.EsRemarks.Validate()){
				valid = false;
				this.messages.Add(this.EsRemarks.ErrorMessage);
			}
			if(!this.MenuFrameCode.Validate()){
				valid = false;
				this.messages.Add(this.MenuFrameCode.ErrorMessage);
			}
			if(!this.FrameNameRefrectFlag.Validate()){
				valid = false;
				this.messages.Add(this.FrameNameRefrectFlag.ErrorMessage);
			}
			if(!this.DeliveryOptionName.Validate()){
				valid = false;
				this.messages.Add(this.DeliveryOptionName.ErrorMessage);
			}
			if(!this.GetReportDestination.Validate()){
				valid = false;
				this.messages.Add(this.GetReportDestination.ErrorMessage);
			}
			if(!this.ReportTreatKindSeq.Validate()){
				valid = false;
				this.messages.Add(this.ReportTreatKindSeq.ErrorMessage);
			}
			if(!this.UseSiteLimitOpenFlag.Validate()){
				valid = false;
				this.messages.Add(this.UseSiteLimitOpenFlag.ErrorMessage);
			}
			if(!this.UseSiteCarrierFlag.Validate()){
				valid = false;
				this.messages.Add(this.UseSiteCarrierFlag.ErrorMessage);
			}
			if(!this.CostMenuFlag.Validate()){
				valid = false;
				this.messages.Add(this.CostMenuFlag.ErrorMessage);
			}
			if(!this.CheckName.Validate()){
				valid = false;
				this.messages.Add(this.CheckName.ErrorMessage);
			}
			if(!this.PriceGroupFromDate.Validate()){
				valid = false;
				this.messages.Add(this.PriceGroupFromDate.ErrorMessage);
			}
			if(!this.ManuscriptFromDate.Validate()){
				valid = false;
				this.messages.Add(this.ManuscriptFromDate.ErrorMessage);
			}
			if(!this.PriceCostFromDate.Validate()){
				valid = false;
				this.messages.Add(this.PriceCostFromDate.ErrorMessage);
			}
			if(!this.TransmitFromDate.Validate()){
				valid = false;
				this.messages.Add(this.TransmitFromDate.ErrorMessage);
			}
			if(!this.ValidFlag.Validate()){
				valid = false;
				this.messages.Add(this.ValidFlag.ErrorMessage);
			}
			if(!this.BaseUpdateDateTime.Validate()){
				valid = false;
				this.messages.Add(this.BaseUpdateDateTime.ErrorMessage);
			}
			if(!this.InsertDateTime.Validate()){
				valid = false;
				this.messages.Add(this.InsertDateTime.ErrorMessage);
			}
			if(!this.InsertOperatorCode.Validate()){
				valid = false;
				this.messages.Add(this.InsertOperatorCode.ErrorMessage);
			}
			if(!this.UpdateDateTime.Validate()){
				valid = false;
				this.messages.Add(this.UpdateDateTime.ErrorMessage);
			}
			if(!this.OperatorCode.Validate()){
				valid = false;
				this.messages.Add(this.OperatorCode.ErrorMessage);
			}
			

            return valid;
        }
		
	}

}