using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Xml;
using System.Xml.Serialization;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Database;
using CFW.Database.TableCommand;
using CFW.Sample.Model;
using CFW.Sample.Model.StoredProcedureParameter;
using CFW.Sample.Model.StoredProcedureProperty;


namespace CFW.Sample.Model.StoredProcedureCommand
{
    /// <summary>
    /// table[test_update]ɑ΂鑀
    /// </summary>
    [Serializable()]
    public class TestUpdateCommand
    {
        /// <summary>
        /// f[^\[Xւ̐ڑ
        /// </summary>
        private Connection connection;

        /// <summary>
        /// test_updateɑΉvpeB
        /// </summary>
        private TestUpdateProperty property;


#region constructors
        /// <summary>
        /// default construct  gps
        /// </summary>
        private TestUpdateCommand()
        {
            this.connection = ConnectionFactory.GetConnectionByName("default");
            this.property = new TestUpdateProperty();
        }
        /// <summary>
        /// ̐ڑgp\z
        /// </summary>
        public TestUpdateCommand(Connection db)
        {
            this.connection = db;
            this.property = new TestUpdateProperty();
        }
        /// <summary>
        /// ̐ڑAvpeBgp\z
        /// </summary>
        /// <param name="db">̐ڑBJĂO</param>
        public TestUpdateCommand(Connection db, TestUpdateProperty property)
        {
            this.connection = db;
            this.property = property;
        }
#endregion

#region public interface
        /// <summary>
        /// test_updates(̖߂l𓾂)
        /// </summary>
        /// <param name="parameter">XgAhvV[W̃p[^</param>
        public int ExecuteUpdate(TestUpdateParameter parameter)
        {
            Command command = BuildCommand(parameter);
            int ret = this.connection.ExecuteUpdate(command);
            return ret;
        }
        /// <summary>
        /// test_updates(DataSet𓾂)
        /// </summary>
        /// <param name="parameter">XgAhvV[W̃p[^</param>
        public DataSet ExecuteQuery(TestUpdateParameter parameter)
        {
            Command command = BuildCommand(parameter);
            DataSet ret = this.connection.ExecuteQuery(command);
            return ret;
        }

#endregion
        /// <summary>
        /// test_updatet sqlR}h
        /// </summary>
        /// <param name="parameter">p[^</param>
        public Command BuildCommand(TestUpdateParameter parameter)
        {
            Command command = new Command("test_update",CommandType.StoredProcedure);

            Parameter ReturnValuePparameter = new Parameter(this.property.ReturnValue,parameter.ReturnValue);
            if(this.property.ReturnValue.FieldName == "RETURN_VALUE") ReturnValuePparameter.ParameterDirection = ParameterDirection.ReturnValue;
            else  ReturnValuePparameter.ParameterDirection = ParameterDirection.Input;
            command.SetParameter(ReturnValuePparameter);
            Parameter F3Pparameter = new Parameter(this.property.F3,parameter.F3);
            if(this.property.F3.FieldName == "RETURN_VALUE") F3Pparameter.ParameterDirection = ParameterDirection.ReturnValue;
            else  F3Pparameter.ParameterDirection = ParameterDirection.Input;
            command.SetParameter(F3Pparameter);
            
            return command;
        }
    }
}
