using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Xml;
using System.Xml.Serialization;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Database;
using CFW.Database.TableCommand;
using CFW.Sample.Model;
using CFW.Sample.Model.TableRow;
using CFW.Sample.Model.TableProperty;


namespace CFW.Sample.Model.TableAccess
{
    /// <summary>
    /// table[test_table3]ɑ΂鑀
    /// </summary>
    [Serializable()]
    public class TestTable3TableAccess
    {
        /// <summary>
        /// f[^\[Xւ̐ڑ
        /// </summary>
        private Connection connection;
        /// <summary>
        /// test_table3ɑΉvpeB
        /// </summary>
        private TestTable3TableProperty property;



#region constructors
        /// <summary>
        /// default construct  gps
        /// </summary>
        private TestTable3TableAccess()
        {
            this.connection = ConnectionFactory.GetConnectionByName("default");
            this.property = new TestTable3TableProperty();
        }
        /// <summary>
        /// ̐ڑgp\z
        /// </summary>
        public TestTable3TableAccess(Connection db)
        {
            this.connection = db;
            this.property = new  TestTable3TableProperty();
        }
        /// <summary>
        /// ̐ڑAvpeBgp\z
        /// </summary>
        /// <param name="db">̐ڑBJĂO</param>
        /// <param name="property">̃vpeB</param>
        public TestTable3TableAccess(Connection db, TestTable3TableProperty property)
        {
            this.connection = db;
            this.property = property;
        }
#endregion

#region public interface
        /// <summary>
        /// test_table3֍s̑}
        /// </summary>
        /// <param name="data">}sf[^</param>
        public int Insert(TestTable3TableRow data)
        {
            TableInsertCommand command = BuildInsertCommand(data);
            int ret = connection.ExecuteUpdate(command.GetCommand());
            return ret;
        }

        /// <summary>
        /// test_table3֍s̍XV
        /// </summary>
        /// <param name="data">XVsf[^</param>
        public int Update(TestTable3TableRow data)
        {
            TableUpdateCommand command = BuildUpdateCommand(data);
            int ret = connection.ExecuteUpdate(command.GetCommand());
            return ret;
        }
        /// <summary>
        /// test_table3֍s̍XV
        /// </summary>
        /// <remarks>where͌ĂяogݗāAp[^Ăяo</remarks>
        /// <param name="data">XVsf[^</param>
        /// <param name="condition"></param>
        public int Update(TestTable3TableRow data,  TableCommandCondition condition)
        {
            TableUpdateCommand command = BuildUpdateCommand(data,condition);
            int ret = connection.ExecuteUpdate(command.GetCommand());
            return ret;
        }
        /// <summary>
        /// test_table3s̍폜
        /// </summary>
        /// <param name="data">폜sf[^BL[̂݃ZbgłĂOK</param>
        public int Delete(TestTable3TableRow data)
        {
            TableDeleteCommand command = BuildDeleteCommand(data);
            int ret = connection.ExecuteUpdate(command.GetCommand());
            return ret;
        }
        /// <summary>
        /// test_table3s̍폜
        /// </summary>
        /// <remarks>where͌ĂяogݗāAp[^Ăяo</remarks>
        /// <param name="condition"></param>
        public int Delete(TableCommandCondition condition)
        {
            TableDeleteCommand command = BuildDeleteCommand(condition);
            int ret = connection.ExecuteUpdate(command.GetCommand());
            return ret;
        }
        /// <summary>
        /// test_table3̍s݊mF
        /// </summary>
        /// <param name="data">L[ݒ肵f[^</param>
        /// <return>ݒ肵L[ɊYs݂鎞true</return>
        public bool Exists(TestTable3TableRow data)
        {
            TableSelectCommand command = BuildExistsCommand(data);
            DataSet result = connection.ExecuteQuery(command.GetCommand());

            int cnt = NumberUtil.IntValue(result.Tables[0].Rows[0][0]);
            if(cnt > 0) return true;
            else return false;
        }
        /// <summary>
        /// test_table3̍s擾
        /// L[1s擾B
        /// قƂǂ̃NCAg͎gpȂ͂AeXgpƂĎgp\
        /// </summary>
        /// <param name="condition">L[ݒ肵f[^</param>
        public TestTable3TableRow Get(TestTable3TableRow condition)
        {
            TableSelectCommand command = BuildSelectCommand(condition);
            DataSet result = connection.ExecuteQuery(command.GetCommand());

            TestTable3TableRow data = null;

            if(result.Tables[0].Rows.Count>0){
                data = new TestTable3TableRow();
                data.FromDataRow(result.Tables[0].Rows[0],"test_table3");
                data.IsNew = false;
            }
            return data;
        }
        /// <summary>
        /// test_table3̍s擾
        /// [U[ݒɊYsׂĎ擾B
        /// قƂǂ̃NCAg͎gpȂ͂AeXgpƂĎgp\
        /// </summary>
        /// <param name="condition">WHERE</param>
        /// <param name="order">\[g</param>
        public List<TestTable3TableRow> GetList( TableCommandCondition condition,List<TableCommandColumn> order)
        {
            TestTable3TableRow data = null;

            TableSelectCommand command = BuildSelectCommand(condition,order);

            DataSet result = connection.ExecuteQuery(command.GetCommand());

			List<TestTable3TableRow> list = new List<TestTable3TableRow>();
            if(result.Tables[0].Rows.Count>0){
                for (int i = 0; i < result.Tables[0].Rows.Count; i++)
                {
	                data = new TestTable3TableRow();
	                data.FromDataRow(result.Tables[0].Rows[0],"test_table3");
                    data.IsNew = false;
                    list.Add(data);
                }
            }
            return list;
        }
#endregion
        /// <summary>
        /// test_table3ւinsert sqlR}h
        /// </summary>
        /// <param name="data">ǉf[^</param>
        public TableInsertCommand BuildInsertCommand(TestTable3TableRow data)
        {
            TableInsertCommand command = new TableInsertCommand("test_table3");

            if (property.Field1.DoUpdate) command.AddInsert(property.Field1, data.Field1);
            if (property.Field2.DoUpdate) command.AddInsert(property.Field2, data.Field2);
            if (property.Field3.DoUpdate) command.AddInsert(property.Field3, data.Field3);
            if (property.Field4.DoUpdate) command.AddInsert(property.Field4, data.Field4);
            if (property.Field5.DoUpdate) command.AddInsert(property.Field5, data.Field5);
            if (property.Field6Sub1.DoUpdate) command.AddInsert(property.Field6Sub1, data.Field6Sub1);
            if (property.Field6Sub2.DoUpdate) command.AddInsert(property.Field6Sub2, data.Field6Sub2);
            
            return command;
        }
        /// <summary>
        /// test_table3ւupdate sqlR}h(WHERE͎L[g)
        /// </summary>
        /// <param name="data">ύXf[^</param>
        public TableUpdateCommand BuildUpdateCommand(TestTable3TableRow data)
        {
            TableUpdateCommand command = new TableUpdateCommand("test_table3");

            //XV`
            if (property.Field1.DoUpdate) command.AddUpdate(property.Field1, data.Field1);
            if (property.Field2.DoUpdate) command.AddUpdate(property.Field2, data.Field2);
            if (property.Field3.DoUpdate) command.AddUpdate(property.Field3, data.Field3);
            if (property.Field4.DoUpdate) command.AddUpdate(property.Field4, data.Field4);
            if (property.Field5.DoUpdate) command.AddUpdate(property.Field5, data.Field5);
            if (property.Field6Sub1.DoUpdate) command.AddUpdate(property.Field6Sub1, data.Field6Sub1);
            if (property.Field6Sub2.DoUpdate) command.AddUpdate(property.Field6Sub2, data.Field6Sub2);
            

            //XV`
            command.AddWhere(new ColumnValueCondition( property.Field1,"@PK_Field1", data.Field1,"="));
            
            return command;
        }

        /// <summary>
        /// test_table3ւ̍XVSqlR}h(WHERE͊O炤)
        /// </summary>
        /// <param name="data">ύXf[^</param>
        /// <param name="condition">Ώۏ</param>
        public TableUpdateCommand BuildUpdateCommand(TestTable3TableRow data, TableCommandCondition condition)
        {
            TableUpdateCommand command = new TableUpdateCommand("test_table3");

            //XV`
            if (property.Field1.DoUpdate) command.AddUpdate(property.Field1, data.Field1);
            if (property.Field2.DoUpdate) command.AddUpdate(property.Field2, data.Field2);
            if (property.Field3.DoUpdate) command.AddUpdate(property.Field3, data.Field3);
            if (property.Field4.DoUpdate) command.AddUpdate(property.Field4, data.Field4);
            if (property.Field5.DoUpdate) command.AddUpdate(property.Field5, data.Field5);
            if (property.Field6Sub1.DoUpdate) command.AddUpdate(property.Field6Sub1, data.Field6Sub1);
            if (property.Field6Sub2.DoUpdate) command.AddUpdate(property.Field6Sub2, data.Field6Sub2);
            

            //XV`
            command.AddWhere(condition);

            return command;
        }

        /// <summary>
        /// test_table3ւselect sqlR}h(WHERE͊O炤
        /// </summary>
        /// <param name="condition">Ώۏ</param>
        public TableDeleteCommand BuildDeleteCommand(TableCommandCondition condition)
        {
            TableDeleteCommand command = new TableDeleteCommand("test_table3");


            //XV`
            command.AddWhere(condition);

            return command;
        }
        /// <summary>
        /// test_table3ւdelete sqlR}h(WHERE͎L[g)
        /// </summary>
        /// <param name="data">Ώۏ</param>
        public TableDeleteCommand BuildDeleteCommand(TestTable3TableRow data)
        {
            TableDeleteCommand command = new TableDeleteCommand("test_table3");

            //XV`
            command.AddWhere(new ColumnValueCondition( property.Field1,"@PK_Field1", data.Field1,"="));
            

            return command;
        }

        /// <summary>
        /// test_table3ւselect count(*)(WHERE͎L[g)
        /// </summary>
        /// <param name="data">Ώۏ</param>
        public TableSelectCommand BuildExistsCommand(TestTable3TableRow data)
        {
            TableSelectCommand command = new TableSelectCommand("test_table3");

            //XV`
            command.AddSelect(new TableCommandColumn("CNT","COUNT(*)"));

            //XV`
            command.AddWhere(new ColumnValueCondition( property.Field1,"@PK_Field1", data.Field1,"="));
            

            return command;
        }

        /// <summary>
        /// test_table3ւselect sqlR}h(WHERE͎L[g)
        /// </summary>
        /// <param name="data">Ώۏ</param>
        public TableSelectCommand BuildSelectCommand(TestTable3TableRow data)
        {
            TableSelectCommand command = new TableSelectCommand("test_table3");

            //XV`
            command.AddSelect(property.Field1);
            command.AddSelect(property.Field2);
            command.AddSelect(property.Field3);
            command.AddSelect(property.Field4);
            command.AddSelect(property.Field5);
            command.AddSelect(property.Field6Sub1);
            command.AddSelect(property.Field6Sub2);
            

            //XV`
            command.AddWhere(new ColumnValueCondition( property.Field1,"@PK_Field1", data.Field1,"="));
            

            return command;
        }

        /// <summary>
        /// test_table3ւselect sqlR}h(WHERE͊O炤)
        /// </summary>
        /// <param name="condition">Ώۏ</param>
        /// <param name="order">\[g</param>
        public TableSelectCommand BuildSelectCommand(TableCommandCondition condition,List<TableCommandColumn> order)
        {
            TableSelectCommand command = new TableSelectCommand("test_table3");

            //XV`
            command.AddSelect(property.Field1);
            command.AddSelect(property.Field2);
            command.AddSelect(property.Field3);
            command.AddSelect(property.Field4);
            command.AddSelect(property.Field5);
            command.AddSelect(property.Field6Sub1);
            command.AddSelect(property.Field6Sub2);
            

            //XV`
            if(condition != null)   command.AddWhere(condition);
            //
            if (order != null) command.OrderBy.AddRange(order);

            return command;
        }
        /// <summary>
        /// test_table3select list
        /// </summary>
        /// <param name="tableAlias">e[uɕtʖ</param>
        /// <param name="columnAliasPrefix">ɕtʖ̐ړ</param>
        public string  GetSelectListString(string tableAlias , string columnAliasPrefix)
        {
        	StringBuilder builder = new StringBuilder();

            //XV`
            builder.AppendLine(", "+ tableAlias + ".field1 AS " + columnAliasPrefix + "field1" );
            builder.AppendLine(", "+ tableAlias + ".field2 AS " + columnAliasPrefix + "field2" );
            builder.AppendLine(", "+ tableAlias + ".field3 AS " + columnAliasPrefix + "field3" );
            builder.AppendLine(", "+ tableAlias + ".field4 AS " + columnAliasPrefix + "field4" );
            builder.AppendLine(", "+ tableAlias + ".field5 AS " + columnAliasPrefix + "field5" );
            builder.AppendLine(", "+ tableAlias + ".field6_sub1 AS " + columnAliasPrefix + "field6_sub1" );
            builder.AppendLine(", "+ tableAlias + ".field6_sub2 AS " + columnAliasPrefix + "field6_sub2" );
            

            return builder.ToString().Substring(1);
        }
    }
}
