using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Database;
using CFW.Sample.Model;
using CFW.Sample.Model.TableRow;
using CFW.Sample.Model.TableProperty;

namespace CFW.Sample.Model.TableRow
{
    /// <summary>
    /// table test_table3 Field`
    /// </summary>
    [Serializable()]
    public class TestTable3TableRow : AbstractTableRow,ICloneable
    {
        ///<summary>[field1]</summary>
        protected Int32 _Field1;
        ///<summary>[field1]</summary>
        public Int32 Field1{
            get{return _Field1;}
            set{_Field1 = value;}
        }
        ///<summary>[field2]</summary>
        protected string _Field2;
        ///<summary>[field2]</summary>
        public string Field2{
            get{return _Field2;}
            set{_Field2 = value;}
        }
        ///<summary>[field3]</summary>
        protected object _Field3;
        ///<summary>[field3]</summary>
        public object Field3{
            get{return _Field3;}
            set{_Field3 = value;}
        }
        ///<summary>[field4]</summary>
        protected System.Nullable<Decimal> _Field4;
        ///<summary>[field4]</summary>
        public System.Nullable<Decimal> Field4{
            get{return _Field4;}
            set{_Field4 = value;}
        }
        ///<summary>[field5]</summary>
        protected System.Nullable<Int16> _Field5;
        ///<summary>[field5]</summary>
        public System.Nullable<Int16> Field5{
            get{return _Field5;}
            set{_Field5 = value;}
        }
        ///<summary>[field6_sub1]</summary>
        protected System.Nullable<Int32> _Field6Sub1;
        ///<summary>[field6_sub1]</summary>
        public System.Nullable<Int32> Field6Sub1{
            get{return _Field6Sub1;}
            set{_Field6Sub1 = value;}
        }
        ///<summary>[field6_sub2]</summary>
        protected System.Nullable<Int32> _Field6Sub2;
        ///<summary>[field6_sub2]</summary>
        public System.Nullable<Int32> Field6Sub2{
            get{return _Field6Sub2;}
            set{_Field6Sub2 = value;}
        }
        
        /// <summary>
        /// default construct 
        /// </summary>
        public TestTable3TableRow() : base()
        {
            _Field1 = 0;
            _Field2 = "";
            _Field3 = null;
            _Field4 = null;
            _Field5 = null;
            _Field6Sub1 = null;
            _Field6Sub2 = null;
            
        }
        
        /// <summary>
        /// DataRowWJč\z
        /// </summary>
        public override void FromDataRow(DataRow row,string alias)
        {
            string columnName = "";
            columnName = BuildColumnName(alias, "field1");if(ColumnExists(row,columnName)) _Field1 = NumberUtil.Value<Int32>( row[columnName] );
            columnName = BuildColumnName(alias, "field2");if(ColumnExists(row,columnName)) _Field2 = StringUtil.StringValue( row[columnName] );
            columnName = BuildColumnName(alias, "field3");if(ColumnExists(row,columnName)) _Field3 = DateUtil.DateValue( row[columnName] );
            columnName = BuildColumnName(alias, "field4");if(ColumnExists(row,columnName)) _Field4 = NumberUtil.Value<Decimal?>( row[columnName] );
            columnName = BuildColumnName(alias, "field5");if(ColumnExists(row,columnName)) _Field5 = NumberUtil.Value<Int16?>( row[columnName] );
            columnName = BuildColumnName(alias, "field6_sub1");if(ColumnExists(row,columnName)) _Field6Sub1 = NumberUtil.Value<Int32?>( row[columnName] );
            columnName = BuildColumnName(alias, "field6_sub2");if(ColumnExists(row,columnName)) _Field6Sub2 = NumberUtil.Value<Int32?>( row[columnName] );
            
        }
        /// <summary>
        /// 񖼂w肵Ēlݒ
        /// </summary>
        /// <param name="name"></param>
        /// <param name="value"></param>
        public override void SetValue(string name,object value)
        {
            if(name ==  "field1") _Field1 = NumberUtil.Value<Int32>( value );
            if(name ==  "field2") _Field2 = StringUtil.StringValue( value );
            if(name ==  "field3") _Field3 = DateUtil.DateValue( value );
            if(name ==  "field4") _Field4 = NumberUtil.Value<Decimal?>( value );
            if(name ==  "field5") _Field5 = NumberUtil.Value<Int16?>( value );
            if(name ==  "field6_sub1") _Field6Sub1 = NumberUtil.Value<Int32?>( value );
            if(name ==  "field6_sub2") _Field6Sub2 = NumberUtil.Value<Int32?>( value );
            
        }
        
        /// <summary>
        /// N[
        /// </summary>
        /// <return >̃IuWFNg̃N[</return>
        public virtual object Clone()
        {
            TestTable3TableRow clone = new TestTable3TableRow();
            clone.CopyFrom(this);
            return clone;
        }
        /// <summary>
        /// N[
        /// </summary>
        /// <return >̃IuWFNg̃N[</return>
        public virtual void CopyFrom(TestTable3TableRow source)
        {
            this.Field1 = source.Field1;
            this.Field2 = source.Field2;
            this.Field3 = source.Field3;
            this.Field4 = source.Field4;
            this.Field5 = source.Field5;
            this.Field6Sub1 = source.Field6Sub1;
            this.Field6Sub2 = source.Field6Sub2;
            
        }
    }

}