using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using CFW.Util;
using CFW.FieldProperties;
using CFW.Database;

namespace CFW.Sample.Test1.Model.Base
{
    /// <summary>
    /// table test_table3 Field`
    /// </summary>
    [Serializable()]
    public class TestTable3TableRow : AbstractTableRow,ICloneable
    {
        ///<summary>[field1]</summary>
        protected Int32 _Field1;
        ///<summary>[field1]</summary>
        public Int32 Field1{
            get{return _Field1;}
            set{_Field1 = value;}
        }
        ///<summary>[field2]</summary>
        protected string _Field2;
        ///<summary>[field2]</summary>
        public string Field2{
            get{return _Field2;}
            set{_Field2 = value;}
        }
        ///<summary>[field3]</summary>
        protected object _Field3;
        ///<summary>[field3]</summary>
        public object Field3{
            get{return _Field3;}
            set{_Field3 = value;}
        }
        ///<summary>[field4]</summary>
        protected System.Nullable<Decimal> _Field4;
        ///<summary>[field4]</summary>
        public System.Nullable<Decimal> Field4{
            get{return _Field4;}
            set{_Field4 = value;}
        }
        ///<summary>[field5]</summary>
        protected System.Nullable<Int16> _Field5;
        ///<summary>[field5]</summary>
        public System.Nullable<Int16> Field5{
            get{return _Field5;}
            set{_Field5 = value;}
        }
        ///<summary>[field6_sub1]</summary>
        protected System.Nullable<Int32> _Field6Sub1;
        ///<summary>[field6_sub1]</summary>
        public System.Nullable<Int32> Field6Sub1{
            get{return _Field6Sub1;}
            set{_Field6Sub1 = value;}
        }
        ///<summary>[field6_sub2]</summary>
        protected System.Nullable<Int32> _Field6Sub2;
        ///<summary>[field6_sub2]</summary>
        public System.Nullable<Int32> Field6Sub2{
            get{return _Field6Sub2;}
            set{_Field6Sub2 = value;}
        }
        
        /// <summary>
        /// default construct 
        /// </summary>
        public TestTable3TableRow() : base()
        {
            this._Field1 = 0;
            this._Field2 = "";
            this._Field3 = null;
            this._Field4 = null;
            this._Field5 = null;
            this._Field6Sub1 = null;
            this._Field6Sub2 = null;
            
        }
        
        /// <summary>
        /// 񖼂w肵Ēlݒ
        /// </summary>
        /// <param name="name"></param>
        /// <param name="value">l</param>
        public override void SetValue(string name,object value)
        {
            if(name ==  "field1") this._Field1 = NumberUtil.Value<Int32>( value );
            if(name ==  "field2") this._Field2 = StringUtil.StringValue( value );
            if(name ==  "field3") this._Field3 = DateUtil.DateValue( value );
            if(name ==  "field4") this._Field4 = NumberUtil.Value<Decimal?>( value );
            if(name ==  "field5") this._Field5 = NumberUtil.Value<Int16?>( value );
            if(name ==  "field6_sub1") this._Field6Sub1 = NumberUtil.Value<Int32?>( value );
            if(name ==  "field6_sub2") this._Field6Sub2 = NumberUtil.Value<Int32?>( value );
            
        }
        /// <summary>
        /// 񖼂w肵Ēl擾
        /// </summary>
        /// <param name="name"></param>
        public override object GetValue(string name)
        {
            if(name ==  "field1") return this._Field1;
            if(name ==  "field2") return this._Field2;
            if(name ==  "field3") return this._Field3;
            if(name ==  "field4") return this._Field4;
            if(name ==  "field5") return this._Field5;
            if(name ==  "field6_sub1") return this._Field6Sub1;
            if(name ==  "field6_sub2") return this._Field6Sub2;
            
            return null;
        }
        
        /// <summary>
        /// N[
        /// </summary>
        /// <return >̃IuWFNg̃N[</return>
        public virtual object Clone()
        {
            TestTable3TableRow clone = new TestTable3TableRow();
            clone.CopyFrom(this);
            return clone;
        }
        /// <summary>
        /// N[
        /// </summary>
        /// <return >̃IuWFNg̃N[</return>
        public virtual void CopyFrom(TestTable3TableRow source)
        {
            this.Field1 = source.Field1;
            this.Field2 = source.Field2;
            this.Field3 = source.Field3;
            this.Field4 = source.Field4;
            this.Field5 = source.Field5;
            this.Field6Sub1 = source.Field6Sub1;
            this.Field6Sub2 = source.Field6Sub2;
            
        }
    }

}