<?php
/**
 * 全てのモデルのベース
 * @author okada
 *
 */
abstract class CFW_Model_AbstractModel{
    /**
     * エンティティ状態の保存
     * @param CFW_Data_Entity $entity 保存するエンティティ
     * @return unknown_type
     */
	public abstract function save(CFW_Model_Entity $entity);
	/**
	 * エンティティ取得
	 * @param CFW_Data_Criteria $criteria 取得条件
	 * @return CFW_Data_Entity
	 */
	public abstract function get(CFW_Model_Criteria $criteria = null);
	/**
	 * エンティティの削除
	 * @param CFW_Data_Entity $entity 削除するエンティティ
	 * @return unknown_type
	 */
    public abstract function remove(CFW_Model_Entity $entity);
}
?>