<?php
require_once "../../startup.php";
Zend_Loader::loadClass("CFW_Data_ConnectionFactory");
Zend_Loader::loadClass("CFW_Data_Connection");
Zend_Loader::loadClass("CFW_Data_Command");
Zend_Loader::loadClass("CFW_Data_Parameter");
Zend_Loader::loadClass("CFW_Config_Configuration");
Zend_Loader::loadClass("CFW_Util_StopWatch");

$sw = new CFW_Util_StopWatch();
$sw->start();

$config = CFW_Config_Configuration::getInstance("connection")->connection;
$connection = new CFW_Data_Connection($config->default);
$connection->connect();

$command = new CFW_Data_Command("delete TEST_Table1");
$command->setConnection($connection);
$result = $command->executeUpdate();

$command = new CFW_Data_Command("
INSERT INTO [CFW].[dbo].[TEST_Table1]
           ([string_column]
           ,[int_column]
           ,[t4]
           ,[byte_column]
           ,[string_column2])
     VALUES
           (?
           ,?
           ,?
           ,?
           ,? )");
$command->setConnection($connection);
$command->addParameter(new CFW_Data_Parameter(":string_column","S0002"));
$command->addParameter(new CFW_Data_Parameter(":int_column",100));
$command->addParameter(new CFW_Data_Parameter(":t4","S0002"));
$command->addParameter(new CFW_Data_Parameter(":byte_column",127));
$command->addParameter(new CFW_Data_Parameter(":string_column2","一覧表申請書"));

$result = $command->executeUpdate();
$connection->disconnect();
$sw->stop();
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<body>
<div class="searchResult">
<?php var_dump($result);?>
</div>
<div>ellapsed<?php echo $sw->ellapsed();?></div>

</body>
</html>