<?php
Zend_Loader::loadClass("CFW_FieldProperties_Abstract");
Zend_Loader::loadClass("CFW_Models_EntityProperty");

/**
* table usersに対応するフィールドプロパティ
*/
class CFW_Sample_Models_Base_UsersTableProperty extends  CFW_Models_EntityProperty
{
    /* var CFW_FieldProperties_Abstract [user_id] */
    public $userId;
    /* var CFW_FieldProperties_Abstract [password] */
    public $password;
    /* var CFW_FieldProperties_Abstract [user_name] */
    public $userName;
    /* var CFW_FieldProperties_Abstract [num_fields] */
    public $numFields;
    /* var CFW_FieldProperties_Abstract [birthday] */
    public $birthday;
    /* var CFW_FieldProperties_Abstract [created_at] */
    public $createdAt;
    /* var CFW_FieldProperties_Abstract [modified_at] */
    public $modifiedAt;
    

    /**
    * default construct
    */
    public function __construct()
    {
        $this->entityName = "users";
        $this->userId =  CFW_FieldProperties_Abstract::newInstance("varchar", "users", "user_id","[user_id]", 50, 0, 0, false, "",true);
        $this->password =  CFW_FieldProperties_Abstract::newInstance("varchar", "users", "password","[password]", 128, 0, 0, true, "",false);
        $this->userName =  CFW_FieldProperties_Abstract::newInstance("varchar", "users", "user_name","[user_name]", 100, 0, 0, true, "",false);
        $this->numFields =  CFW_FieldProperties_Abstract::newInstance("int", "users", "num_fields","[num_fields]", 4, 10, 0, true, null,false);
        $this->birthday =  CFW_FieldProperties_Abstract::newInstance("datetime", "users", "birthday","[birthday]", 16, 23, 3, true, null,false);
        $this->createdAt =  CFW_FieldProperties_Abstract::newInstance("datetime", "users", "created_at","[created_at]", 16, 23, 3, true, null,false);
        $this->modifiedAt =  CFW_FieldProperties_Abstract::newInstance("datetime", "users", "modified_at","[modified_at]", 16, 23, 3, true, null,false);
        

        $this->entityClass = "CFW_Sample_Models_Base_UsersTableRow";
         
    }

    /**
    * 全てのフィールドを列挙
    * 
    * @returns 
    */
    public function getFields()
    {
        $fields = array();
        $fields[] = $this->userId;
        $fields[] = $this->password;
        $fields[] = $this->userName;
        $fields[] = $this->numFields;
        $fields[] = $this->birthday;
        $fields[] = $this->createdAt;
        $fields[] = $this->modifiedAt;
        
        return $fields;
    }
    /**
    * 全ての主キーを列挙
    * 
    * @returns 
    */
    public function getPrimaryKeys()
    {
        $fields = array();
        $fields[] = $this->userId;
        
        return $fields;
    }
    public function getUpdateFields(){
        $fields = array();
        if($this->userId->doUpdate && !$this->userId->isIdentity)$fields[] = $this->userId;
        if($this->password->doUpdate && !$this->password->isIdentity)$fields[] = $this->password;
        if($this->userName->doUpdate && !$this->userName->isIdentity)$fields[] = $this->userName;
        if($this->numFields->doUpdate && !$this->numFields->isIdentity)$fields[] = $this->numFields;
        if($this->birthday->doUpdate && !$this->birthday->isIdentity)$fields[] = $this->birthday;
        if($this->createdAt->doUpdate && !$this->createdAt->isIdentity)$fields[] = $this->createdAt;
        if($this->modifiedAt->doUpdate && !$this->modifiedAt->isIdentity)$fields[] = $this->modifiedAt;
        
        return $fields;
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#setDoUpdate($doUpdate)
     */
    public function setDoUpdate($doUpdate = true){
        $this->userId->doUpdate = $doUpdate;
        $this->password->doUpdate = $doUpdate;
        $this->userName->doUpdate = $doUpdate;
        $this->numFields->doUpdate = $doUpdate;
        $this->birthday->doUpdate = $doUpdate;
        $this->createdAt->doUpdate = $doUpdate;
        $this->modifiedAt->doUpdate = $doUpdate;
        
    }

    
}
