<?php
require_once "../../startup.php";
Zend_Loader::loadClass("CFW_Data_Criteria");
Zend_Loader::loadClass("CFW_Data_Criteria_Condition");
Zend_Loader::loadClass("CFW_Data_Criteria_StringCondition");
Zend_Loader::loadClass("CFW_Data_Criteria_ComplexCondition");
Zend_Loader::loadClass("CFW_Data_Criteria_ColumnValueCondition");
Zend_Loader::loadClass("CFW_Util_StopWatch");
require_once("SampleEntityPropery.php");

$sw = new CFW_Util_StopWatch();
$sw->start();

$property = new SampleEntityProperty();
$c = new CFW_Data_Criteria();

//where条件を追加していく
$c1 = new CFW_Data_Criteria_ColumnValueCondition($property->field1->fieldName,10,CFW_Data_Criteria::OPERATOR_EQ);
$c2 = new CFW_Data_Criteria_ColumnValueCondition($property->field2->fieldName,100,CFW_Data_Criteria::OPERATOR_LE);
$c3 = new CFW_Data_Criteria_ColumnValueCondition($property->field3->fieldName,"sample",CFW_Data_Criteria::OPERATOR_EQ);
$c4 = new CFW_Data_Criteria_ColumnValueCondition($property->field4->fieldName,"2001/2/3",CFW_Data_Criteria::OPERATOR_GE);
$c5 = new CFW_Data_Criteria_ColumnValueCondition($property->field1->fieldName,array(1,2,3,4,5),CFW_Data_Criteria::OPERATOR_IN);
$c6 = new CFW_Data_Criteria_ColumnValueCondition($property->field1->fieldName,array(100,200),CFW_Data_Criteria::OPERATOR_BETWEEN);

$cc = new CFW_Data_Criteria_ComplexCondition();
$cc->add($c1);
$cc->addOr($c2);
$cc->addOr($c3);

$cc2 = new CFW_Data_Criteria_ComplexCondition(CFW_Data_Criteria::OPERATOR_NOT);
$cc2->add($c1);
$cc2->addOr($c2);
$cc2->addOr($c3);

$c->addWhere($c1);
$c->addWhereAnd($c2);
$c->addWhereOr($c3);
$c->addWhereAnd($c4);
$c->addWhereAnd($c5);
$c->addWhereAnd($c6);
$c->addWhereAnd($cc);
$c->addWhereOr($cc2);

//order by
$c->addOrderBy($property->field1->fullName(),CFW_Data_Criteria::DIRECTION_ASC);
$c->addOrderBy($property->field2->fullName(),CFW_Data_Criteria::DIRECTION_ASC);
$c->addOrderBy($property->field3->fullName(),CFW_Data_Criteria::DIRECTION_DESC);
$c->addOrderBy($property->field4->fullName(),CFW_Data_Criteria::DIRECTION_ASC);

$c->addOrderBy("sum(data1)",CFW_Data_Criteria::DIRECTION_ASC);

//group by
$c->addGroupBy($property->field1->fullName(),CFW_Data_Criteria::DIRECTION_ASC);
$c->addGroupBy($property->field2->fullName(),CFW_Data_Criteria::DIRECTION_ASC);
$c->addGroupBy($property->field3->fullName(),CFW_Data_Criteria::DIRECTION_DESC);
$c->addGroupBy($property->field4->fullName(),CFW_Data_Criteria::DIRECTION_ASC);

$c->addGroupBy("sum(data1)",CFW_Data_Criteria::DIRECTION_ASC);

$c->addHaving(new CFW_Data_Criteria_StringCondition("count(a) > 0"));
$c->addHaving($cc);

$c->setLimit(20);
$c->setOffset(1001);

$c->assemble();



$sw->stop();
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<body>
<div class="searchResult">
<div>where <?php echo $c->getWhereExpression();?></div>
<div>group by <?php echo $c->getGroupByExpression();?></div>
<div>having<?php echo $c->getHavingExpression();?></div>
<div>order by <?php echo $c->getOrderByExpression();?></div>
<div>limit  <?php echo $c->getLimit();?></div>
<div>offset <?php echo $c->getOffset();?></div>
<div>offset <?php var_dump($c->getParameters());?></div>
<div>ellapsed<?php echo $sw->ellapsed();?></div>
</div>
</body>
</html>