<?php
//実行場所定義
defined('BASE_PATH')
    || define('BASE_PATH', realpath(dirname(__FILE__) ));
// Zend_Controllerを使用する場合のアプリケーションパスを定義する。
defined('APPLICATION_PATH')
    || define('APPLICATION_PATH', realpath(BASE_PATH . '/../application'));

    // 実行環境を定義する。production|staging|test|devel|...
// .htaccessや実行環境開始スクリプトで環境変数APPLICATION_ENVを定義しておく。
// このファイルを修正して環境を変更する事は避ける。
// Define application environment
defined('APPLICATION_ENV')
    || define('APPLICATION_ENV', (getenv('APPLICATION_ENV') ? getenv('APPLICATION_ENV') : 'production'));
// 設定ファイルの場所定義
// Zend_Controllerを使う場合は application/configになるように
defined('CONFIG_PATH')
    || define('CONFIG_PATH', BASE_PATH . "/../application/config");


set_include_path(implode(PATH_SEPARATOR, array(
    realpath(BASE_PATH . '/../library'),
    realpath(APPLICATION_PATH . '/models'),
    realpath(APPLICATION_PATH . '/services'),
    realpath(BASE_PATH . '/../../cfwphp/library'),
    get_include_path(),
)));

// Zend_Loader使用
require_once("Zend/Loader.php");
// エスケープ定義
defined('DS')
    || define('DS', '\\');

// オートロードの登録
Zend_Loader::loadClass('Zend_Loader_Autoloader');
$autoloader = Zend_Loader_Autoloader::getInstance();
$autoloader->setFallbackAutoloader(true);
