<?php
Zend_Loader::LoadClass("CFW_Auth_Provider");
Zend_Loader::LoadClass("CFW_Auth_Hash");
Zend_Loader::LoadClass("CFW_Auth_Identity");
Zend_Loader::LoadClass("CFW_Auth_DefaultUser");
Zend_Loader::LoadClass("CFW_Auth_IUser");
/**
 * 何もしない認証.
 *
 * 入力したid,passwordが何であってもvalidであるとみなし、CFW_Auth_DefaultUserをid.userに設定する。このときuserのid,nameは入力したidと同じものにする。
 * 通常は使わないがCFW_Auth_Providerの各システム向けの実装が完了するまでのドライバとして機能できる。
 * @author okada
 * @package CFW_Auth
 */
class CFW_Auth_NullAuthProvider extends CFW_Auth_Provider{
	/* (non-PHPdoc)
	 * @see library/CFW/Auth/CFW_Auth_Provider#loadIdentity($userId, $password)
	 */
	public function loadIdentity($userId,$password){

		$identity = new CFW_Auth_Identity();
		$identity->name = $userId;
		$user = new CFW_Auth_DefaultUser();
		$user->setId($userId);
		$user->setName($userId);
		$identity->user = $user;
		$identity->roles = array();
		return $identity;
	}
	/* (non-PHPdoc)
	 * @see library/CFW/Auth/CFW_Auth_Provider#verify($userId, $password)
	 */
	function verify($userId,$password){
		return true;
	}
}