<?php
session_start();

require_once '../startup.php';
Mini_Loader::loadClass("Mini_Data_Connection");
Mini_Loader::loadClass("Mini_Data_Command");
Mini_Loader::loadClass("Mini_Data_Parameter");
Mini_Loader::loadClass("Mini_Util_Util");

$secret = Mini_Util_Util::randomString(24);
$_SESSION["secret"] = $secret;
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>sample</title>
    <link href="../styles/smoothness/jquery-ui.css" rel="stylesheet" />
	<style type="text/css">
		body{ font-size: 75% }
		div.button {
			height: 29px;	
			width: 133px;
			background: url(button.png) 0 0;
			
			font-size: 14px; color: #C7D92C; text-align: center; padding-top: 15px;
		}
		/* 
		We can't use ":hover" preudo-class because we have
		invisible file input above, so we have to simulate
		hover effect with JavaScript. 
		 */
		div.button.hover {
			background: url(button.png) 0 56px;
			color: #95A226;	
		}
		
	</style>	
</head>
<body>
    <div id="hd"><h1>smaple</h1></div>
    <div id="bd">
		<p>You can style button as you want</p>
		<div class="wrapper">
			<div id="button1" class="button">Upload</div>
		</div>
		<p>Uploaded files:</p>
		<ol class="files"></ol>

    	<div id="result"></div>
    	<input type="hidden" id="secret" value="<?php echo htmlspecialchars($secret)  ?>" />
    </div>
    <div id="ft"></div>
		<script type="text/javascript" src="../js/jquery.js"></script> 
		<script type="text/javascript" src="../js/jquery-ui.js"></script> 
		<script type="text/javascript" src="../js/ajaxupload.js"></script> 
		<script type="text/javascript"> 
			$(function(){
				var button = $('#button1'), interval;
				
				new AjaxUpload(button, {
					action: 'target.php', 
					name: 'myfile',
					data: {secret:$("#secret").val()},
					onSubmit : function(file, ext){
						// change button text, when user selects file			
						button.text('Uploading');
										
						// If you want to allow uploading only 1 file at time,
						// you can disable upload button
						this.disable();
						
						// Uploding -> Uploading. -> Uploading...
						interval = window.setInterval(function(){
							var text = button.text();
							if (text.length < 13){
								button.text(text + '.');					
							} else {
								button.text('Uploading');				
							}
						}, 200);
					},
					onComplete: function(file, response){
						button.text('Upload');
									
						window.clearInterval(interval);
									
						// enable upload button
						this.enable();
						
						// add file to the list
						$('<li></li>').appendTo('#example1 .files').text(file);		
						$("#result").html(response);				
					}
				});
			});
		</script> 
</body>
</html>
