<?php
Zend_Loader::loadClass("CFW_FieldProperties_Abstract");
Zend_Loader::loadClass("CFW_Models_EntityProperty");

/**
* table acl_rolesに対応するフィールドEロパティ
*/
class CFW_Sample_Models_Base_AclRolesTableProperty extends  CFW_Models_EntityProperty
{
	/* var CFW_FieldProperties_Abstract [id] */
	public $id;
	/* var CFW_FieldProperties_Abstract [name] */
	public $name;
	/* var CFW_FieldProperties_Abstract [parent_id] */
	public $parentId;
	/* var CFW_FieldProperties_Abstract [left_side] */
	public $leftSide;
	/* var CFW_FieldProperties_Abstract [right_side] */
	public $rightSide;
	/* var CFW_FieldProperties_Abstract [description] */
	public $description;
	

    /**
    * default construct
    */
    public function __construct()
    {
    	$this->tableName = "acl_roles";
		$this->id =  CFW_FieldProperties_Abstract::newInstance("int", "acl_roles", "id","[id]", 4, 10, 0, false, 0,true);
		$this->name =  CFW_FieldProperties_Abstract::newInstance("varchar", "acl_roles", "name","[name]", 100, 0, 0, false, "",false);
		$this->parentId =  CFW_FieldProperties_Abstract::newInstance("int", "acl_roles", "parent_id","[parent_id]", 4, 10, 0, true, null,false);
		$this->leftSide =  CFW_FieldProperties_Abstract::newInstance("int", "acl_roles", "left_side","[left_side]", 4, 10, 0, true, null,false);
		$this->rightSide =  CFW_FieldProperties_Abstract::newInstance("int", "acl_roles", "right_side","[right_side]", 4, 10, 0, true, null,false);
		$this->description =  CFW_FieldProperties_Abstract::newInstance("varchar", "acl_roles", "description","[description]", 500, 0, 0, true, "",false);
		

		$this->entityClass = "CFW_Sample_Models_Base_AclRolesTableRow";
 		
    }

    /**
    * 全てのフィールドを列挙
    * 
    * @returns 
    */
    public function getFields()
    {
    	$fields = array();
		$fields[] = $this->id;
		$fields[] = $this->name;
		$fields[] = $this->parentId;
		$fields[] = $this->leftSide;
		$fields[] = $this->rightSide;
		$fields[] = $this->description;
		
		return $fields;
    }
    /**
    * 全ての主キーをE持E
    * 
    * @returns 
    */
    public function getPrimaryKeys()
    {
    	$fields = array();
        $fields[] = $this->id;
        
		return $fields;
    }
    public function getUpdateFields(){
    	$fields = array();
		if($this->id->doUpdate && !$this->id->isIdentity)$fields[] = $this->id;
		if($this->name->doUpdate && !$this->name->isIdentity)$fields[] = $this->name;
		if($this->parentId->doUpdate && !$this->parentId->isIdentity)$fields[] = $this->parentId;
		if($this->leftSide->doUpdate && !$this->leftSide->isIdentity)$fields[] = $this->leftSide;
		if($this->rightSide->doUpdate && !$this->rightSide->isIdentity)$fields[] = $this->rightSide;
		if($this->description->doUpdate && !$this->description->isIdentity)$fields[] = $this->description;
		
		return $fields;
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#getName()
     */
    public function getName(){
        return $this->tableName;
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#setName($value)
     */
    public function setName($value){
        $this->talbeName = $value;
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#getAlias()
     */
    public function getAlias(){
        return $this->alias;
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#setAlias($value)
     */
    public function setAlias($value){
        $this->alias= $value;
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#setDoUpdate($doUpdate)
     */
    public function setDoUpdate($doUpdate = true){
		$this->id->doUpdate = $doUpdate;
		$this->name->doUpdate = $doUpdate;
		$this->parentId->doUpdate = $doUpdate;
		$this->leftSide->doUpdate = $doUpdate;
		$this->rightSide->doUpdate = $doUpdate;
		$this->description->doUpdate = $doUpdate;
		
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#getEntityClass()
     */
    public function getEntityClass(){
        return $this->entityClass;
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#getIdentityField()
     */
    public function getIdentityField(){
        return $this->identityField;
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#getCreatedAtField()
     */
    public function getCreatedAtField(){
        return $this->createdAtField;
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#getModifiedField()
     */
    public function getModifiedAtField(){
        return $this->modofiedAtField;
    }

    
}
