<?php
/**
 * int用
 * @author okada
 * @package CFW_FieldValidators
 */
class CFW_FieldValidators_Int extends CFW_FieldValidators_Abstract{
    /* (non-PHPdoc)
     * @see library/CFW/FieldValidators/CFW_FieldValidators_Abstract#validateRange($value)
     */
    public function validateRange( $value)
        {
        $this->message = "";
        $property = $this->property;

        if ( $value < $property->minValue || $value > $property->maxValue)
        {
            $this->message = CFW_Template_SimpleFormatter::format2($this->messageResource->getString("ERROR_INVALID_RANGE"),$this->property->displayName,$this->property->minValue ,$this->property->maxValue);
            return false;
        }
        return true;
    }
    public function validateType($value){
        if($value == null) return true;
        if(!is_int( $value)){
            $this->message = CFW_Template_SimpleFormatter::format2($this->messageResource->getString("ERROR_INVALID_FORMAT"),$this->property->displayName);
            return false;
        }
        return true;
    }
    public function validateFormat($value){
        if($value == null) return true;
        $s = str_replace("-", "", strval($value));
        if(strlen($s) > $this->property->precision){
            $this->message = CFW_Template_SimpleFormatter::format2($this->messageResource->getString("ERROR_INVALID_FORMAT"),$this->property->displayName);
            return false;
        }
        return true;
    }
    
}