<?php
Zend_Loader::loadClass("CFW_FieldProperties_Abstract");
Zend_Loader::loadClass("CFW_Models_EntityProperty");

/**
* table acl_rulesに対応するフィールドプロパティ
*/
class CFW_Acl_Db_Models_Base_AclRulesTableProperty extends  CFW_Models_EntityProperty
{
    /* var CFW_FieldProperties_Abstract [id] */
    public $id;
    /* var CFW_FieldProperties_Abstract [resource_id] */
    public $resourceId;
    /* var CFW_FieldProperties_Abstract [role_id] */
    public $roleId;
    /* var CFW_FieldProperties_Abstract [allow_create] */
    public $allowCreate;
    /* var CFW_FieldProperties_Abstract [allow_read] */
    public $allowRead;
    /* var CFW_FieldProperties_Abstract [allow_update] */
    public $allowUpdate;
    /* var CFW_FieldProperties_Abstract [allow_delete] */
    public $allowDelete;
    /* var CFW_FieldProperties_Abstract [description] */
    public $description;
    /* var CFW_FieldProperties_Abstract [deleted] */
    public $deleted;
    /* var CFW_FieldProperties_Abstract [created_at] */
    public $createdAt;
    /* var CFW_FieldProperties_Abstract [modified_at] */
    public $modifiedAt;
    

    /**
    * default construct
    */
    public function __construct()
    {
        $this->entityName = "acl_rules";
        $this->id =  CFW_FieldProperties_Abstract::newInstance("int", "acl_rules", "id","[id]", 4, 10, 0, false, 0,true);
        $this->resourceId =  CFW_FieldProperties_Abstract::newInstance("int", "acl_rules", "resource_id","[resource_id]", 4, 10, 0, false, 0,false);
        $this->roleId =  CFW_FieldProperties_Abstract::newInstance("int", "acl_rules", "role_id","[role_id]", 4, 10, 0, false, 0,false);
        $this->allowCreate =  CFW_FieldProperties_Abstract::newInstance("int", "acl_rules", "allow_create","[allow_create]", 4, 10, 0, false, 0,false);
        $this->allowRead =  CFW_FieldProperties_Abstract::newInstance("int", "acl_rules", "allow_read","[allow_read]", 4, 10, 0, false, 0,false);
        $this->allowUpdate =  CFW_FieldProperties_Abstract::newInstance("int", "acl_rules", "allow_update","[allow_update]", 4, 10, 0, false, 0,false);
        $this->allowDelete =  CFW_FieldProperties_Abstract::newInstance("int", "acl_rules", "allow_delete","[allow_delete]", 4, 10, 0, false, 0,false);
        $this->description =  CFW_FieldProperties_Abstract::newInstance("varchar", "acl_rules", "description","[description]", 500, 500, 0, true, "",false);
        $this->deleted =  CFW_FieldProperties_Abstract::newInstance("int", "acl_rules", "deleted","[deleted]", 4, 10, 0, false, 0,false);
        $this->createdAt =  CFW_FieldProperties_Abstract::newInstance("datetime", "acl_rules", "created_at","[created_at]", 16, 23, 3, false, null,false);
        $this->modifiedAt =  CFW_FieldProperties_Abstract::newInstance("datetime", "acl_rules", "modified_at","[modified_at]", 16, 23, 3, false, null,false);
        

        $this->entityClass = "CFW_Acl_Db_Models_Base_AclRulesTableRow";
         
    }

    /**
    * 全てのフィールドを列挙
    * 
    * @returns 
    */
    public function getFields()
    {
        $fields = array();
        $fields[] = $this->id;
        $fields[] = $this->resourceId;
        $fields[] = $this->roleId;
        $fields[] = $this->allowCreate;
        $fields[] = $this->allowRead;
        $fields[] = $this->allowUpdate;
        $fields[] = $this->allowDelete;
        $fields[] = $this->description;
        $fields[] = $this->deleted;
        $fields[] = $this->createdAt;
        $fields[] = $this->modifiedAt;
        
        return $fields;
    }
    /**
    * 全ての主キーを列挙
    * 
    * @returns 
    */
    public function getPrimaryKeys()
    {
        $fields = array();
        $fields[] = $this->id;
        
        return $fields;
    }
    public function getUpdateFields(){
        $fields = array();
        if($this->id->doUpdate && !$this->id->isIdentity)$fields[] = $this->id;
        if($this->resourceId->doUpdate && !$this->resourceId->isIdentity)$fields[] = $this->resourceId;
        if($this->roleId->doUpdate && !$this->roleId->isIdentity)$fields[] = $this->roleId;
        if($this->allowCreate->doUpdate && !$this->allowCreate->isIdentity)$fields[] = $this->allowCreate;
        if($this->allowRead->doUpdate && !$this->allowRead->isIdentity)$fields[] = $this->allowRead;
        if($this->allowUpdate->doUpdate && !$this->allowUpdate->isIdentity)$fields[] = $this->allowUpdate;
        if($this->allowDelete->doUpdate && !$this->allowDelete->isIdentity)$fields[] = $this->allowDelete;
        if($this->description->doUpdate && !$this->description->isIdentity)$fields[] = $this->description;
        if($this->deleted->doUpdate && !$this->deleted->isIdentity)$fields[] = $this->deleted;
        if($this->createdAt->doUpdate && !$this->createdAt->isIdentity)$fields[] = $this->createdAt;
        if($this->modifiedAt->doUpdate && !$this->modifiedAt->isIdentity)$fields[] = $this->modifiedAt;
        
        return $fields;
    }
    /* (non-PHPdoc)
     * @see library/CFW/Model/CFW_Models_IEntityProperty#setDoUpdate($doUpdate)
     */
    public function setDoUpdate($doUpdate = true){
        $this->id->doUpdate = $doUpdate;
        $this->resourceId->doUpdate = $doUpdate;
        $this->roleId->doUpdate = $doUpdate;
        $this->allowCreate->doUpdate = $doUpdate;
        $this->allowRead->doUpdate = $doUpdate;
        $this->allowUpdate->doUpdate = $doUpdate;
        $this->allowDelete->doUpdate = $doUpdate;
        $this->description->doUpdate = $doUpdate;
        $this->deleted->doUpdate = $doUpdate;
        $this->createdAt->doUpdate = $doUpdate;
        $this->modifiedAt->doUpdate = $doUpdate;
        
    }

    
}
