<?php
//実行場所定義
defined('BASE_PATH')
    || define('BASE_PATH', realpath(dirname(__FILE__) ));
echo "BASE_PATH = " . BASE_PATH . PHP_EOL;
// Zend_Controllerを使用する場合のアプリケーションパスを定義する。
//defined('APPLICATION_PATH')
//    || define('APPLICATION_PATH', realpath(BASE_PATH . '/../application'));

    // 実行環境を定義する。production|staging|test|devel|...
// .htaccessや実行環境開始スクリプトで環境変数APPLICATION_ENVを定義しておく。
// このファイルを修正して環境を変更する事は避ける。
// Define application environment
defined('APPLICATION_ENV')
    || define('APPLICATION_ENV', (getenv('APPLICATION_ENV') ? getenv('APPLICATION_ENV') : 'production'));
// 設定ファイルの場所定義
// Zend_Controllerを使う場合は application/configになるように
defined('CONFIG_PATH')
    || define('CONFIG_PATH', BASE_PATH . "/../config");

echo "CONFIG_PATH = " . CONFIG_PATH . PHP_EOL;
    
// Ensure library/ is on include_path
// このアプリケーションで使用するinclude_pathを定義する。
// PEARやZend Frameworkなどアプリケーションや環境に関わり無く使うものはphp.iniに定義する。
set_include_path(implode(PATH_SEPARATOR, array(
    realpath(BASE_PATH . '/../library'),
    realpath(BASE_PATH . '/../models'),
    realpath(BASE_PATH . '/../../cfwphp/library'),
    get_include_path(),
)));

// Zend_Loader使用
require_once("Zend/Loader.php");
// エスケープ定義
defined('DS')
	|| define('DS', '\\');
