Option Explicit
''-----------------------------------------------------------
''	MAIN
''-----------------------------------------------------------
Public Sub Main()
	''Call TestLogger
	''Call TestConfiguration
	''Call TestDatabase1
	''Call TestDatabase2
	''Call TestDatabase3
	' Call TestHandleError
	''Call TestMail
	TestDirectoryClean
End Sub
Sub TestLogger()
	Logger.Debug WScript.ScriptName & " Start"
	Logger.Info WScript.ScriptName & " Start"
	Logger.Warning WScript.ScriptName & " Start"
	Logger.Error WScript.ScriptName & " Start"
End Sub
Sub TestConfiguration()
	WScript.Echo ScriptProperties.Item("database.default.connectionString")
	WScript.Echo ScriptProperties.Item("database.TINKLE_SNS.connectionString")
	WScript.Echo ScriptProperties.Item("SMTP.Server")
	WScript.Echo ScriptProperties.Item("LogFile.Path" )
	WScript.Echo ScriptProperties.Item("LogFile.BaseName" )
	
	WScript.Echo ScriptProperties.Item("errormail.from")
	WScript.Echo ScriptProperties.Item("errormail.to")
	WScript.Echo ScriptProperties.Item("errormail.subject")
	WScript.Echo ScriptProperties.Item("test.maxCount")
End Sub
Sub TestDatabase1()
	Dim db
	Set db = new DbAccess
	db.open "default"
	
	Dim rs
	Dim rowString
	Set rs = db.openRecordset("select * from MAST_CLIENT where CLIENT_CODE LIKE 'C10%'")
	Do Until rs.EOF
		rowString = ""
		rowString = rowString & rs("CLIENT_CODE") & ","
		rowString = rowString & rs("NAME") & ","
		rowString = rowString & rs("HOMEPAGE_URL") & ","
		rowString = rowString & rs("UPDATE_DATE_TIME") & ","
		
		Wscript.Echo rowString
		
		rs.MoveNext
	Loop
End Sub
Sub TestDatabase2()
	Dim db
	Set db = new DbAccess
	db.open "default"
	
	Dim id
	Dim rs
	
	Dim result
	Dim q
	Dim val
	Dim maxQuery
	maxQuery = "select isnull(max(aa),0) + 1 from test_table"
	Set rs = db.openRecordset(maxQuery)
	id =  toInteger(rs(0))
	val = "aaaa"
	q = "insert into test_table values(" & FormatNumber(id,0,vbTrue,vbFalse,vbFalse) & "," & SqlQuot(val) & ")"
	Wscript.Echo q
	result = db.execute(q)
	Wscript.Echo "result = " & result
	
	Set rs = db.openRecordset(maxQuery)
	id =  toInteger(rs(0))
	val = "a'b"
	q = "insert into test_table values(" & FormatNumber(id,0,vbTrue,vbFalse,vbFalse) & "," & SqlQuot(val) & ")"
	Wscript.Echo q
	result = db.execute(q)
	Wscript.Echo "result = " & result

	Set rs = db.openRecordset(maxQuery)
	id =  toInteger(rs(0))
	val = "a[b]"
	q = "insert into test_table values(" & FormatNumber(id,0,vbTrue,vbFalse,vbFalse) & "," & SqlQuot(val) & ")"
	Wscript.Echo q
	result = db.execute(q)
	Wscript.Echo "result = " & result
	
	Set rs = db.openRecordset(maxQuery)
	id =  toInteger(rs(0))
	val = "a[b],100%"
	q = "insert into test_table values(" & FormatNumber(id,0,vbTrue,vbFalse,vbFalse) & "," & SqlQuot(val) & ")"
	Wscript.Echo q
	result = db.execute(q)
	Wscript.Echo "result = " & result
	
	Set rs = db.openRecordset(maxQuery)
	id =  toInteger(rs(0))
	val = "a[b];100%"
	q = "insert into test_table values(" & FormatNumber(id,0,vbTrue,vbFalse,vbFalse) & "," & SqlQuot(val) & ")"
	Wscript.Echo q
	result = db.execute(q)
	Wscript.Echo "result = " & result
End Sub
Function getNextId(db)
	Dim id
	id = 0
	Dim maxQuery
	maxQuery = "select isnull(max(aa),0) + 1 from test_table"
	
	Dim command
	Set command = db.createCommand(maxQuery,adCmdText)
	
	Dim rs 
	Set rs = command.openRecordSet
	id =  toInteger(rs(0))
	rs.close
	
	getNextId = id
End Function
Sub TestDatabase3()
	Dim db
	Set db = new DbAccess
	db.open "default"
	
	Dim id
	Dim rs
	
	Dim result
	Dim q
	Dim val

	q = "insert into test_table values(?,?)"
	Dim command
	Set command = db.createCommand(q,adCmdText)
	command.addParameter "p1",adInteger,adParamInput,0,id
	command.addParameter "p2",adVarChar,adParamInput,50,val
	command.d

	id =  getNextId(db)
	val = "aaaa"
	command.setParameter "p1",id
	command.setParameter "p2",val
	result = command.execute
	Wscript.Echo "result = " & result

	id =  getNextId(db)
	val = "bbbb"
	command.setParameter "p1",id
	command.setParameter "p2",val
	result = command.execute
	Wscript.Echo "result = " & result

	id =  getNextId(db)
	val = "c'cccc"
	command.setParameter "p1",id
	command.setParameter "p2",val
	result = command.execute
	Wscript.Echo "result = " & result

	id =  getNextId(db)
	val = "c%120[aaaa]"
	command.setParameter "p1",id
	command.setParameter "p2",val
	result = command.execute
	Wscript.Echo "result = " & result
End Sub
Function TestMail()
	Dim mailer,msg
	Set msg = new MailMessage
	msg.Subject = "test"
	msg.Body = "̓eXgł"
	msg.AddFromAddress "michiakiokada@craft-net.co.jp"
	msg.AddToAddress "michiakiokada@craft-net.co.jp"
	msg.AddToAddress "okadabasso@gmail.com"
	msg.AddCcAddress "okada@tosa-ds.com"
	msg.AddCcAddress "junktosa@yahoo.co.jp"
	
	Set mailer = new Mail
	mailer.Send Array(msg)
	
End Function
Function TestHandleError()
	Dim a
	a = "aaaa"
	on error resume next
	Dim dt
	dt = cint(a)
	if Err.Number <> 0 then
		Dim handler 
		Set handler = new ScriptErrorHandler
		handler.Error "TestHandleError",true
	end if
End Function
Function TestDirectoryClean()
	Dim a
	Set a = new DirectoryCleaner
	a.TargetDirectory = "C:\devel\temp\log"
	
	Dim fso 
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set a.FileSystem  = fso
	
	a.Clean
End Function
